/* original parser id follows */
/* yysccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93" */
/* (use YYMAJOR/YYMINOR for ifdefs dependent on parser version) */

#define YYBYACC 1
#define YYMAJOR 2
#define YYMINOR 0
#define YYPATCH 20210109

#define YYEMPTY        (-1)
#define yyclearin      (yychar = YYEMPTY)
#define yyerrok        (yyerrflag = 0)
#define YYRECOVERING() (yyerrflag != 0)
#define YYENOMEM       (-2)
#define YYEOF          0
#define YYPREFIX "yy"

#define YYPURE 1

#line 121 "language.yacc"
/* This is the grammar definition of Pike. */

#include "global.h"
#ifdef HAVE_MEMORY_H
#include <memory.h>
#endif

#include "interpret.h"
#include "array.h"
#include "object.h"
#include "mapping.h"
#include "stralloc.h"
#include "las.h"
#include "interpret.h"
#include "program.h"
#include "pike_types.h"
#include "constants.h"
#include "pike_macros.h"
#include "pike_error.h"
#include "docode.h"
#include "pike_embed.h"
#include "opcodes.h"
#include "operators.h"
#include "bignum.h"

#define YYMAXDEPTH	1000

#ifdef PIKE_DEBUG
#ifndef YYDEBUG
/* May also be defined by machine.h */
#define YYDEBUG 1
#endif /* YYDEBUG */
#endif

/* Get verbose parse error reporting. */
#define YYERROR_VERBOSE	1

/* #define LAMBDA_DEBUG	1 */

static void yyerror_reserved(const char *keyword);
static struct pike_string *get_new_name(struct pike_string *prefix);
int add_local_name(struct pike_string *, struct pike_type *, node *);
int low_add_local_name(struct compiler_frame *,
		       struct pike_string *, struct pike_type *, node *);
static void mark_lvalues_as_used(node *n);
static node *lexical_islocal(struct pike_string *);
static node *safe_inc_enum(node *n);
static node *find_versioned_identifier(struct pike_string *identifier,
				       int major, int minor);
static int call_handle_import(struct pike_string *s);

static int inherit_depth;
static struct program_state *inherit_state = NULL;

/*
 * Kludge for Bison not using prototypes.
 */
#ifndef __GNUC__
#ifndef __cplusplus
static void __yy_memcpy(char *to, const char *from,
			unsigned int count);
#endif /* !__cplusplus */
#endif /* !__GNUC__ */

#ifdef YYSTYPE
#undef  YYSTYPE_IS_DECLARED
#define YYSTYPE_IS_DECLARED 1
#endif
#ifndef YYSTYPE_IS_DECLARED
#define YYSTYPE_IS_DECLARED 1
#line 187 "language.yacc"
typedef union
{
  int number;
  FLOAT_TYPE fnum;
  struct node_s *n;
  char *str;
  void *ptr;
} YYSTYPE;
#endif /* !YYSTYPE_IS_DECLARED */
#line 197 "language.yacc"
/* Need to be included after YYSTYPE is defined. */
#define INCLUDED_FROM_LANGUAGE_YACC
#include "lex.h"
#include "pike_compiler.h"
#line 204 "language.yacc"
/* Include <stdio.h> our selves, so that we can do our magic
 * without being disturbed... */
#include <stdio.h>
int yylex(YYSTYPE *yylval);
/* Bison is stupid, and tries to optimize for space... */
#ifdef YYBISON
#define short int
#endif /* YYBISON */

#line 117 "y.tab.c"

/* compatibility with bison */
#ifdef YYPARSE_PARAM
/* compatibility with FreeBSD */
# ifdef YYPARSE_PARAM_TYPE
#  define YYPARSE_DECL() yyparse(YYPARSE_PARAM_TYPE YYPARSE_PARAM)
# else
#  define YYPARSE_DECL() yyparse(void *YYPARSE_PARAM)
# endif
#else
# define YYPARSE_DECL() yyparse(void)
#endif

/* Parameters sent to lex. */
#ifdef YYLEX_PARAM
# ifdef YYLEX_PARAM_TYPE
#  define YYLEX_DECL() yylex(YYSTYPE *yylval, YYLEX_PARAM_TYPE YYLEX_PARAM)
# else
#  define YYLEX_DECL() yylex(YYSTYPE *yylval, void * YYLEX_PARAM)
# endif
# define YYLEX yylex(&yylval, YYLEX_PARAM)
#else
# define YYLEX_DECL() yylex(YYSTYPE *yylval)
# define YYLEX yylex(&yylval)
#endif

/* Parameters sent to yyerror. */
#ifndef YYERROR_DECL
#define YYERROR_DECL() yyerror(const char *s)
#endif
#ifndef YYERROR_CALL
#define YYERROR_CALL(msg) yyerror(msg)
#endif

extern int YYPARSE_DECL();

#define TOK_ARROW 257
#define TOK_CONSTANT 258
#define TOK_FLOAT 259
#define TOK_STRING 260
#define TOK_NUMBER 261
#define TOK_INC 262
#define TOK_DEC 263
#define TOK_RETURN 264
#define TOK_EQ 265
#define TOK_GE 266
#define TOK_LE 267
#define TOK_NE 268
#define TOK_NOT 269
#define TOK_LSH 270
#define TOK_RSH 271
#define TOK_LAND 272
#define TOK_LOR 273
#define TOK_SWITCH 274
#define TOK_SSCANF 275
#define TOK_CATCH 276
#define TOK_FOREACH 277
#define TOK_LEX_EOF 278
#define TOK_ADD_EQ 279
#define TOK_AND_EQ 280
#define TOK_ARRAY_ID 281
#define TOK_ATTRIBUTE_ID 282
#define TOK_BREAK 283
#define TOK_CASE 284
#define TOK_CLASS 285
#define TOK_COLON_COLON 286
#define TOK_CONTINUE 287
#define TOK_DEFAULT 288
#define TOK_DEPRECATED_ID 289
#define TOK_DIV_EQ 290
#define TOK_DO 291
#define TOK_DOT_DOT 292
#define TOK_DOT_DOT_DOT 293
#define TOK_ELSE 294
#define TOK_ENUM 295
#define TOK_EXTERN 296
#define TOK_FLOAT_ID 297
#define TOK_FOR 298
#define TOK_FUNCTION_ID 299
#define TOK_GAUGE 300
#define TOK_GLOBAL 301
#define TOK_IDENTIFIER 302
#define TOK_RESERVED 303
#define TOK_IF 304
#define TOK_IMPORT 305
#define TOK_INHERIT 306
#define TOK_INLINE 307
#define TOK_LOCAL_ID 308
#define TOK_FINAL_ID 309
#define TOK_FUNCTION_NAME 310
#define TOK_INT_ID 311
#define TOK_LAMBDA 312
#define TOK_MULTISET_ID 313
#define TOK_MULTISET_END 314
#define TOK_MULTISET_START 315
#define TOK_LSH_EQ 316
#define TOK_MAPPING_ID 317
#define TOK_MIXED_ID 318
#define TOK_MOD_EQ 319
#define TOK_MULT_EQ 320
#define TOK_NO_MASK 321
#define TOK_OBJECT_ID 322
#define TOK_OR_EQ 323
#define TOK_PRIVATE 324
#define TOK_PROGRAM_ID 325
#define TOK_PROTECTED 326
#define TOK_PREDEF 327
#define TOK_PUBLIC 328
#define TOK_RSH_EQ 329
#define TOK_STATIC 330
#define TOK_STRING_ID 331
#define TOK_SUB_EQ 332
#define TOK_TYPEDEF 333
#define TOK_TYPEOF 334
#define TOK_VARIANT 335
#define TOK_VERSION 336
#define TOK_VOID_ID 337
#define TOK_WHILE 338
#define TOK_XOR_EQ 339
#define TOK_OPTIONAL 340
#define TOK_SAFE_INDEX 341
#define TOK_SAFE_START_INDEX 342
#define TOK_BITS 343
#define YYERRCODE 256
typedef short YYINT;
static const YYINT yylhs[] = {                           -1,
    0,    0,  121,  121,  121,   32,   32,   37,   37,   37,
   37,  111,  111,  124,  125,  112,  126,  126,  126,  126,
  126,  126,  126,  127,  127,  127,  127,  127,  128,  128,
  128,  129,  129,  130,  130,  130,  130,   49,   49,   49,
   49,  131,   46,   47,   47,  132,  132,  133,  133,   48,
  134,  134,  119,   17,   17,  136,  137,  122,  122,  138,
  122,  122,  122,  122,  122,  122,  122,  122,  122,  122,
  122,  141,  122,   15,   15,   15,   38,   38,   38,  142,
    3,    1,    1,    2,    2,    2,    8,    8,    8,    8,
    8,    8,    8,    8,    8,    8,    8,   21,   21,   21,
   21,   21,   21,   21,   21,   21,   21,   21,   22,   22,
   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,
   22,   22,   22,   22,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   20,   20,   20,
  115,  115,  115,   10,    9,    9,   40,   40,   40,  135,
  135,   19,   26,   27,  145,  145,   28,   29,   30,  143,
  143,  144,  144,  147,  147,  148,  148,  148,  148,  148,
  148,  148,  148,  148,  148,  148,  148,  148,  148,  148,
  148,  146,   25,   25,   25,   24,   24,   24,  156,  156,
  150,  150,  150,  150,  149,  153,  157,  153,  154,  154,
  154,  158,  159,  152,  152,   13,   13,   14,  160,   14,
  155,  155,  161,  162,  163,  151,  151,  139,  139,  164,
  164,  165,  164,  164,  164,  164,   93,   93,   93,   93,
   93,   93,   94,   94,   94,   94,   42,  166,  167,  168,
   43,  169,  169,   45,   45,   45,   99,   84,   84,   85,
   85,  170,  170,  170,  171,  171,  172,  172,  172,  172,
  103,  103,  104,   95,   95,   95,   95,   95,   95,   95,
   95,   95,   95,   95,   95,  102,  102,  102,  102,  102,
  102,  102,  102,  102,  174,   82,   97,   97,   50,   63,
   63,   62,  120,   39,  175,  176,   83,   83,  177,  113,
  113,  178,  114,  114,    6,    6,    5,    5,    5,    4,
    4,   18,   18,  180,  179,  179,  179,  181,  182,   54,
  116,  116,   56,   56,  183,  183,   98,  184,  184,  184,
  185,  186,  187,   55,  140,  188,  189,   61,  190,  190,
  190,   96,   96,   87,   87,   65,   65,   65,  118,  118,
  117,  117,  191,  192,   78,   64,   64,   64,  173,  173,
  193,  194,   76,  195,  196,  109,   77,   77,  197,  198,
  105,   51,   51,   51,  199,  199,  199,  199,  100,  100,
  107,  107,  108,  110,  110,   57,   57,   58,   58,   58,
   58,   58,   59,   59,   66,   66,   71,   71,   71,   71,
   71,   71,   71,   71,   71,   71,   67,   67,    7,    7,
    7,    7,    7,    7,    7,    7,    7,    7,   16,   16,
   74,   74,   75,   75,   91,   91,   92,   92,   92,   41,
   41,   68,   68,   68,   68,   68,   68,   68,   68,   68,
   68,   68,   68,   68,   68,   68,   68,   68,   68,   68,
   68,   68,   68,   68,   68,   68,   68,   68,   68,   68,
   68,   68,   68,   68,   68,   68,   68,   68,   69,   69,
   69,   69,   69,   69,   69,   69,   70,   70,   70,   44,
  201,   44,   72,   72,   72,   72,   72,   11,   73,   73,
   73,   73,   73,   73,   73,   73,   73,   73,   73,   73,
   73,   73,   73,   73,   73,   73,   73,   73,   73,   73,
   73,   73,   73,   73,   73,   73,   73,   73,   73,   73,
   73,   73,   73,   73,   73,   73,   73,   73,   81,   81,
   81,   80,   80,   80,   80,   34,   34,   12,   12,   12,
   12,   86,   86,   86,   86,   86,   86,   86,   86,   86,
   86,   86,   86,   86,   60,   60,   60,   60,   60,   79,
  106,  106,  106,  106,  106,   53,   53,   53,   53,   53,
   53,   53,  202,   52,  101,  101,  101,  101,  101,  101,
  101,  101,  101,  101,  101,  101,  101,   88,   88,   88,
   88,   90,   89,   89,   35,   35,   36,   36,   33,   33,
   31,   31,   31,  123,  123,  123,  123,  123,  123,  123,
  123,  123,  123,  123,  123,  123,  123,  123,  123,  123,
  123,  123,  200,  200,  200,  200,  200,  200,  200,  200,
  200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
  200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
  200,  200,
};
static const YYINT yylen[] = {                            2,
    1,    2,    2,    2,    0,    1,    1,    2,    2,    2,
    0,    1,    1,    1,    0,    2,    5,    5,    5,    5,
    4,    4,    4,    3,    3,    3,    3,    3,    3,    3,
    3,    1,    3,    4,    4,    4,    4,    1,    1,    1,
    1,    1,    1,    1,    0,    1,    0,    1,    1,    1,
    1,    0,    0,    0,    1,    0,    0,   13,    8,    0,
   11,    6,    1,    1,    1,    2,    2,    1,    2,    2,
    2,    0,    5,    1,    1,    0,    1,    1,    0,    3,
    3,    1,    2,    1,    3,    3,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    0,    2,    5,    3,    1,    0,
    2,    0,    3,    3,    1,    1,    1,    1,    1,    3,
    1,    3,    1,    1,    1,    1,    1,    1,    2,    2,
    2,    2,    2,    2,    2,    2,    6,    5,    2,    4,
    4,    1,    0,    1,    2,    0,    1,    2,    1,    1,
    0,    3,    5,    3,    1,    0,    0,    4,    0,    3,
    3,    0,    0,    8,    0,    1,    2,    1,    0,    4,
    3,    0,    0,    0,    0,    8,    0,    1,    3,    2,
    2,    0,    5,    4,    4,    4,    2,    2,    4,    4,
    4,    4,    1,    1,    3,    3,    0,    0,    0,    0,
    7,    1,    1,    1,    1,    1,    0,    1,    4,    1,
    4,    3,    3,    3,    1,    3,    3,    3,    3,    3,
    0,    2,    2,    1,    1,    1,    1,    1,    1,    2,
    2,    2,    2,    2,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    0,    4,    1,    0,    2,    2,
    1,    2,    0,    0,    0,    0,    8,    5,    0,    5,
    3,    0,    6,    4,    5,    4,    1,    3,    3,    1,
    2,    0,    3,    0,    4,    1,    1,    0,    0,    7,
    1,    1,    0,    2,    0,    2,    0,    1,    4,    1,
    0,    0,    0,    8,    5,    0,    0,    9,    1,    1,
    1,    0,    2,    1,    1,    1,    1,    1,    0,    1,
    2,    4,    0,    0,    9,    8,    5,    4,    1,    1,
    0,    0,   12,    0,    0,    8,    0,    1,    0,    0,
    8,    3,    5,    4,    1,    1,    1,    1,    2,    3,
    0,    1,    1,    0,    1,    1,    1,    1,    2,    2,
    2,    2,    1,    3,    1,    2,    1,    3,    3,    3,
    5,    3,    3,    3,    5,    4,    1,    5,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    0,    1,
    0,    2,    1,    3,    0,    2,    1,    3,    3,    3,
    3,    1,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    1,    2,
    2,    2,    2,    2,    2,    2,    1,    2,    2,    0,
    0,    6,    5,    5,    4,    4,    4,    0,    1,    1,
    1,    1,    1,    1,    1,    1,    2,    2,    1,    1,
    4,    4,    6,    5,    7,    4,    4,    4,    4,    4,
    3,    5,    5,    4,    4,    3,    3,    3,    3,    4,
    4,    4,    4,    4,    4,    4,    4,    4,    1,    3,
    3,    1,    3,    3,    3,    1,    1,    2,    2,    3,
    3,    1,    2,    3,    1,    3,    3,    3,    3,    2,
    2,    2,    2,    2,    0,    1,    2,    1,    2,    2,
    4,    4,    4,    4,    4,    3,    3,    3,    3,    3,
    1,    1,    0,    3,    7,    7,    7,    7,    7,    5,
    5,    5,    5,    4,    4,    4,    4,    1,    3,    2,
    1,    2,    0,    3,    1,    1,    1,    2,    1,    3,
    1,    2,    3,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,
};
static const YYINT yydefred[] = {                         5,
    0,    0,    0,    2,    0,    4,    0,    0,    3,   63,
   64,   65,   68,   69,   70,   71,    0,  605,    0,    0,
    0,  555,  606,    0,    0,    0,    0,    0,  607,    0,
    0,  542,   90,   96,   93,   88,   87,   92,   95,   94,
   89,   97,   91,  156,    0,  247,  341,    0,    0,   72,
   66,   67,    0,   27,   26,   28,  647,  654,  653,  650,
  661,  615,  616,  656,  657,  617,  658,  659,  618,  645,
  646,  619,  643,  620,  660,  621,  651,  563,  632,  662,
  648,  649,  633,  634,  644,  622,  623,  652,  626,  624,
  625,  635,  627,  637,  628,  638,  636,  639,  642,  629,
  630,  655,  641,  631,  640,  564,  614,  549,    0,    0,
    0,  553,  562,    0,    0,  548,   25,  608,   24,    0,
    0,    0,    0,   32,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  176,    0,    0,    0,    0,  178,    0,
    0,    0,  177,    0,    0,    0,  175,  171,  174,    5,
    0,    0,   42,  161,    0,    0,  554,  556,  557,  558,
  559,  550,  551,  545,  543,  544,   36,    0,   35,   37,
    0,    0,   34,    0,   77,  328,   78,    0,   22,   21,
   23,    0,    0,    0,    0,    0,    0,   16,    0,  185,
  189,    0,    0,  212,  182,    0,  180,  186,  223,  181,
  183,    0,    0,  184,  179,  205,  331,    0,    0,  332,
    0,    0,    0,   55,  162,  358,  501,  500,    0,    0,
    0,    0,    0,  357,    0,    0,    0,  247,    0,    0,
    0,    0,   43,   50,    0,    0,    0,    0,    0,    0,
  502,   31,  407,    0,  442,  479,  356,  510,    0,  503,
    0,  509,  506,  505,  504,    0,   29,   30,    0,   33,
  329,  342,   19,   18,   20,   10,  611,    6,    0,    8,
    9,   17,    0,    0,    0,    0,    0,    0,    0,    0,
  197,    0,    0,    0,    0,    0,    0,    0,  170,  345,
   49,   48,   73,    0,  158,    0,    0,  228,    0,  583,
    0,    0,  247,    0,    0,    0,    0,    0,  484,    0,
    0,    0,  582,    0,  248,  581,  570,    0,  304,    0,
    0,  486,  485,  507,  508,  480,  481,    0,    0,    0,
    0,  403,    0,  173,    0,    0,    0,    0,    0,    0,
    0,  166,  601,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  247,  488,  489,  424,  419,  428,  422,  427,
  426,  420,  423,  425,  421,  247,  247,    0,  247,    0,
    0,    0,    0,    0,    0,    0,  612,    0,    0,  221,
    0,    0,  191,  190,  430,    0,    0,  216,    0,  204,
  202,  198,  199,  200,    0,    0,   14,    0,  211,  210,
    0,    0,    0,    0,   62,  162,    0,    0,    0,  584,
    0,  162,    0,    0,    0,    0,  169,  247,  540,  541,
  303,    0,    0,  433,  405,    0,    0,    0,    0,  527,
  528,  529,  526,    0,  437,    0,    0,    0,    0,    0,
    0,    0,  521,    0,  163,    0,    0,    0,  602,    0,
  164,  600,  466,    0,  469,    0,  471,    0,  467,    0,
  472,    0,  473,    0,  462,    0,  461,    0,    0,  463,
    0,  464,    0,  465,    0,  468,    0,  470,    0,  474,
    0,  475,    0,  476,  458,  477,  459,  478,  460,    0,
    0,    0,  409,  408,    0,  413,  412,    0,    0,    0,
  568,    0,    0,  566,    0,    0,  410,  414,    0,    0,
  340,    0,  338,    0,  613,  188,    0,   75,   74,    0,
    0,  217,  194,    0,    0,  224,  208,  157,    0,    0,
    0,    0,    0,  229,  595,  597,  596,  594,    0,    0,
  578,  580,  579,  577,    0,    0,  258,  402,    0,    0,
  260,  401,    0,  576,  249,    0,  532,  530,  533,  534,
  531,  406,  524,  525,    0,  432,  574,  575,  573,  572,
  571,   46,    0,    0,  388,  386,  385,  387,    0,   51,
    0,    0,  436,  404,  172,  599,    0,  416,    0,    0,
    0,  538,  136,  143,  145,  144,  131,  130,  111,  112,
  134,  135,  133,  137,  138,  113,  126,  129,  123,  101,
  121,  127,  117,  132,  147,  151,  152,  125,  139,  140,
  106,  103,   99,  118,  122,  141,  115,  114,  110,   98,
  116,  102,  119,  105,  142,  104,  100,  120,  124,  146,
  108,  109,  128,  107,  153,  148,  149,  150,  535,  536,
    0,    0,  537,  495,  496,  497,    0,    0,  517,  518,
  519,  520,  516,  569,  567,  511,    0,  512,    0,    0,
  317,    0,  320,  326,  327,    5,  330,    0,  336,  337,
    0,  187,  213,    0,  195,  203,    0,  234,  235,    0,
   59,   56,  236,    0,    0,    0,  591,  593,  592,  590,
    0,    0,    0,  257,    0,    0,  257,    0,  250,  308,
    0,  434,  522,    0,  441,  440,  523,  439,  438,  604,
  411,  415,  418,    0,  514,  247,  494,  493,    0,   44,
  323,  155,    0,  321,  162,    0,  334,    0,  253,  252,
  344,    0,    0,    0,  233,    0,    0,    0,   82,   84,
    0,    0,    0,    0,    0,    0,  162,  245,  311,    0,
  309,  162,  246,  271,  306,    0,  303,  513,  319,  318,
    0,    0,  339,    0,    0,    0,    0,    0,    0,   83,
    0,  587,  589,  588,  586,  585,  241,  242,  239,  314,
  312,  240,    0,  259,    0,    0,  261,    0,    0,  515,
  491,    0,  316,  325,  214,  226,   57,   41,   40,   39,
   38,   61,   86,   85,   80,    0,    0,   81,  255,  256,
  254,  310,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  374,  285,  279,    0,
  292,  393,  276,    0,  293,  288,  289,  290,  294,  286,
  277,  272,  274,  291,    0,  287,  275,  251,  278,  307,
  271,  315,    0,  313,  283,  282,  284,    0,    0,    0,
  265,    0,  397,  370,  369,    0,  396,  389,  247,  247,
  297,  299,    0,    0,  302,  300,    0,  247,    0,  247,
  247,  280,  281,  273,    0,   58,  269,    0,  268,  270,
    0,    0,  267,    0,  390,  380,  364,    0,  382,    0,
    0,  372,    0,  347,  375,  492,  264,  262,  263,    0,
  266,    0,    0,  395,    0,  384,  368,    0,    0,  296,
    0,    0,    0,    0,  383,  367,    0,    0,    0,    0,
    0,    0,    0,  392,    0,    0,    0,  351,  350,  349,
    0,    0,    0,    0,    0,    0,    0,    0,  381,  355,
  360,  354,    0,  361,    0,  366,  378,    0,    0,  376,
    0,  365,    0,    0,  348,  362,    0,  353,    0,  373,
};
static const YYINT yydgoto[] = {                          1,
  757,  758,  771,  679,  680,  681,  380,   44,    7,    8,
  235,   27,  396,  397,  530,  759,  215,  520,  803,  655,
  656,  657,  658,  284,  535,  236,  237,  153,  422,  423,
  269,  270,  185,   28,   29,  238,  184,  176,  431,  154,
  445,  319,  849,  737,  832,  239,  741,  240,  822,  850,
  851,  241,  317,   51,   52,  689,  954,  887,  425,  515,
  853,  854,  855,  856,  242,  434,  243,  244,  245,  246,
  332,  248,  249,  436,  437,  857,  978,  858,  250,  251,
  252,  859,  253,  556,  560,   32,  971,  338,  459,  339,
  449,  450,  557,  561,  860,  985,  892,  748,  767,  861,
  254,  862,  808,  863,  864,  255,  955,  865,  866,  935,
  188,  129,  562,  558,  659,  522,  964,  973,  540,  566,
    2,    9,  177,  408,  130,   10,  867,  124,  125,   12,
  155,  583,  293,  591,   53,  756,  873,  542,  297,   13,
  150,  760,  761,  426,  341,  427,  148,  334,  205,  197,
  200,  195,  201,  204,  190,  405,  202,  279,  752,  694,
  285,  697,  785,  298,  700,  428,  719,  774,  751,  881,
  882,  869,  888,  899,  721,  809,  806,  826,  687,  782,
  261,  385,  523,  524,  127,  386,  691,  900,  941,  961,
  890,  933,  898,  939,  901,  942,  889,  932,  589,  256,
  871,  312,
};
static const YYINT yysindex[] = {                         0,
    0,  123,  268,    0, 1065,    0, 2092, 1446,    0,    0,
    0,    0,    0,    0,    0,    0,  292,    0,10775,    4,
    0,    0,    0, -241, -213, -211,10085, -136,    0,  -41,
  543,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,10165,    0,    0,  -67, 4155,    0,
    0,    0, 7163,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, -102,10843,
10911,    0,    0,  -63,  -56,    0,    0,    0,    0,10245,
  608,  186,  227,    0,    2,10979,10979,  587,   72,   -7,
  315,    1,  319,    0,  374,  414,  315,  422,    0,    0,
  438,  414,    0, -183,  477, 9842,    0,    0,    0,    0,
  159,  458,    0,    0,  282,  539,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 4768,    0,    0,
 4768, 4768,    0,10325,    0,    0,    0,  514,    0,    0,
    0,  591,10005,  626,  654, -183,  477,    0, 4155,    0,
    0, -183, 3089,    0,    0,  -35,    0,    0,    0,    0,
    0,  653, 6180,    0,    0,    0,    0, 4155,  645,    0,
  -47, -183, 1467,    0,    0,    0,    0,    0,  619,  619,
 8584,  673,    0,    0,  128,  437,    0,    0, -241,  692,
 8584, 8584,    0,    0,  305, 8584, 8584, -183, 3691, 4664,
    0,    0,    0, 9837,    0,    0,    0,    0,  777,    0,
  477,    0,    0,    0,    0, 1064,    0,    0,  680,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   -6,    0,
    0,    0, -183,   -1,  404, -183,  698,   40, 2699,  720,
    0,  723,  505,  494, 4155,   -7,  734,  391,    0,    0,
    0,    0,    0,  726,    0,11047,  490,    0,  673,    0,
  128,  437,    0,  692, 4887,   20,   20, 1745,    0,   29,
 5367,  128,    0, 3916,    0,    0,    0,11115,    0, 4974,
 5460,    0,    0,    0,    0,    0,    0,   35, 5592, 4463,
  714,    0,  403,    0, 4664,   20,  477,  736,  706,   49,
  530,    0,    0, 7356, 7413, 7470, 7593, 7662, 7719, 7776,
 7845, 8584, 7915, 7972, 8035, 8098, 8198, 8216, 8285, 8342,
 8404, 8522,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 5685,    0, 5779,
 5074, 3363, 6071, 6071,  795,10405,    0,  579, -183,    0,
  808, 4155,    0,    0,    0,  535,  817,    0,  539,    0,
    0,    0,    0,    0,  -11,   28,    0,  826,    0,    0,
 4155,  831,  814,  821,    0,    0,   49,  113,  163,    0,
  375,    0,11183,  847,  846,  767,    0,    0,    0,    0,
    0,   -8, 6071,    0,    0,  -16,  853,  377,  857,    0,
    0,    0,    0,  774,    0, 4664,  -30,  777,  809,  867,
 1064, 6071,    0, 4155,    0,  819,  767, 4664,    0, 2739,
    0,    0,    0, 1094,    0,  978,    0,  978,    0, 1094,
    0, 1043,    0, 1043,    0, 8767,    0, 4860,  856,    0,
 7897,    0, 3897,    0, 5573,    0,  978,    0,  978,    0,
  952,    0,  952,    0,    0,    0,    0,    0,    0, 9922,
  621, 3776,    0,    0,  622,    0,    0,  460,  884,   65,
    0, 4001,  839,    0,  494,  840,    0,    0,  892,  518,
    0,  878,    0,  896,    0,    0,  452,    0,    0,  883,
    0,    0,    0,  686,  907,    0,    0,    0,  213,  173,
 6071,  911,11251,    0,    0,    0,    0,    0,  532, 6071,
    0,    0,    0,    0,11319,  910,    0,    0,  898,  916,
    0,    0,  905,    0,    0,  711,    0,    0,    0,    0,
    0,    0,    0,    0, 5592,    0,    0,    0,    0,    0,
    0,    0,  928,  880,    0,    0,    0,    0, 5884,    0,
  930, 5978,    0,    0,    0,    0,  736,    0, 6071, 6071,
 8584,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  494,  895,    0,    0,    0,    0,  854,  854,    0,    0,
    0,    0,    0,    0,    0,    0, 3776,    0,  951,  428,
    0, 4155,    0,    0,    0,    0,    0, 4768,    0,    0,
  -61,    0,    0, 4155,    0,    0, 4155,    0,    0, 6071,
    0,    0,    0, 2699,  814,  821,    0,    0,    0,    0,
  279,  932,  945,    0, 4768,  270,    0, 4768,    0,    0,
  969,    0,    0, 2739,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 3776,    0,    0,    0,    0,  923,    0,
    0,    0,    0,    0,    0,  -12,    0,11387,    0,    0,
    0, 4155,  539,  539,    0, 2699,  977,  596,    0,    0,
  -68,  603,  985, 5161,  350, 6071,    0,    0,    0, 2699,
    0,    0,    0,    0,    0,  934,    0,    0,    0,    0,
10707,  -61,    0,  462,  987,  951,  548, 4155, 4155,    0,
10979,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,11455,    0,  951,  650,    0, 3004,  650,    0,
    0,  728,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  650,  932,    0,    0,    0,
    0,    0,  625,10485, 3466,    0,    0,  731, 3588,  731,
  979,    0,    0,    0,    0, 1065,    0,    0,    0,  -36,
    0,    0,    0,  -36,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  -36,    0,    0,    0,    0,    0,
    0,    0,  548,    0,    0,    0,    0,  609,  974,  980,
    0,  652,    0,    0,    0,  -36,    0,    0,    0,    0,
    0,    0,  584, 4083,    0,    0, 3278,    0,  986,    0,
    0,    0,    0,    0, 3004,    0,    0, 4768,    0,    0,
 4768, 4768,    0,10565,    0,    0,    0, 4083,    0,  -30,
 -207,    0, 3278,    0,    0,    0,    0,    0,    0,  984,
    0,  998, 1006,    0,  -30,    0,    0,   34, 1018,    0,
 1020, 1021, 4083, 6071,    0,    0, 4083, 4083, 4083, 4083,
  118,  778,  118,    0,  -36,  118,  118,    0,    0,    0,
 3278, 4545, 4545,  118,  -36, 4083, 3278, 3278,    0,    0,
    0,    0, 1003,    0, 3278,    0,    0,  -36,  769,    0,
 4545,    0, 4083, 3278,    0,    0,  118,    0, 3278,    0,
};
static const YYINT yyrindex[] = {                         0,
    0,  864,    0,    0,    0,    0, 3161, 8628,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1165,    0,    0,    0,    0,    0,    0,    0,    0,  790,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  149,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1254, 1560,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   97,  943,    0, 1019,    0,
 6344,    0,    0,    0, 6429, 6565, 6344, 6650,    0, 4381,
 6786, 6565,    0,  790, 6871,    0,    0,    0,    0,    0,
    0, 8687,    0,    0,11523,10639,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  513,    0,    0,
  513,  513,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  430,  138,  747,    0,    0,    0,
    0,    0,    0,    0,    0,  578,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 6261,    0,    0,    0,    0,    0,    0,    0,  513,  513,
  513, 2443, 6216,    0, 7252, 7266, 1030,    0, 7274, 7321,
  513,  513,    0,    0,    0,  513,  513, 2043,  513,  513,
    0,    0,    0, 2056,    0,    0,    0,    0, 8984,    0,
 2438,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1023,    0,
    0,    0,    0,    0,    0,  488,    0,    0,  111,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1046,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  513, 9013, 9052,    0,    0, 8984,
  513,    0,    0,  513,    0,    0,    0,    0,    0,   31,
  513,    0,    0,    0,    0,    0,    0,    0,   16,   62,
    0,    0,    0,    0,  513,   26, 1649,  991,    0,  792,
    0,    0,    0,  513,  513,  513,  513,  513,  513,  513,
  513,  513,  513,  513,  513,  513,  513,  513,  513,  513,
  513,  513,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  513,    0,  513,
   81,  780,  513,  513,  659,  314,    0,    0, 1010,    0,
    0,    0,    0,    0,    0, 1034,  111,    0,  -20,    0,
    0,    0,    0,    0, 1057,    0,    0,    0,    0,    0,
 1060,    0,  796,  678,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  615,11591,    0,    0,    0,    0,
    0,    0,  513,    0,    0,    0,  -15,    0,    0,    0,
    0,    0,    0, 1063,    0,  513,    0, 9810, 1066,   41,
  141,  513,    0,    0,    0,    0,  792,  513,    0,    0,
    0,    0,    0,  718,    0, 9395,    0, 9434,    0, 9531,
    0, 9149,    0, 9366,    0,   46,    0, 6726,    0,    0,
 7265,    0, 9742,    0, 9713,    0, 9463,    0, 9502,    0,
 9081,    0, 9120,    0,    0,    0,    0,    0,    0,    0,
    0,  780,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  513,    0,    0,    0,   39,    0,    0, 1862,    0,
    0,  338,    0,  -60,    0,    0,    0,    0,    0,    0,
 2823,    0,    0,    0,    0,    0,    0,    0, 5273,    0,
  513,    0,    0,    0,    0,    0,    0,    0,    0,  513,
    0,    0,    0,    0,    0,  954,    0,    0, 2393,  990,
    0,    0, 2052,    0,    0, 1068,    0,    0,    0,    0,
    0,    0,    0,    0,   55,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  513,    0,
    0,  112,    0,    0,    0,    0,   43,    0,  513,  513,
  513,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   39,    0,    0,    0,    0, 2349, 2349,    0,    0,
    0,    0,    0,    0,    0,    0,  320,    0,  674,  470,
    0,    0,    0,    0,    0,    0,    0,  513,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  513,
    0,    0,    0, 1046,  785,  787,    0,    0,    0,    0,
 1071, 5047, 5347,    0,  513,    0,    0,  513,    0,    0,
    0,    0,    0,  143,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  320,    0,    0,    0,    0,    0,    0,
    0,    0, 4240,    0,    0, 8440,    0,  314,    0,    0,
    0,    0,   71, 1076,    0,  425,    0,  425,    0,    0,
 6964,    0,    0,  513,    0,  513,    0,    0,    0,  470,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  803,    0,    0,    0,    0,  648,    0,    0,  449,    0,
  424,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  674,    0,    0,  513,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 5739,    0,    0,    0,
    0,    0,    0,    0, 2232,  359,  534, 1336, 2264, 1732,
 2527, 2616,  685, 1955,  941, 2187,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  513,    0,    0,  513,    0,    0,    0,
    0,    0,    0,    0,  513,    0,    0,  513,    0,    0,
  513,  513,    0,    0,    0,    0,    0,  182,    0,    0,
    0,    0,  513,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  513,  513,    0,    0,  513,  145,  513,  513,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  513,   59,  513,    0,    0,  405,  513,  513,    0,    0,
    0,    0,    0,    0,  513,    0,    0,    0, 2917,    0,
  103,    0,  107,  513,    0,    0,    0,    0,  513,    0,
};
static const YYINT yygindex[] = {                         0,
  -69,    0, -354,    0,    0, -130, -245,    0,    0, -497,
    0,    0,    0,    0, -718, -259,    0,    0, -200,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  283,    0,   -9,   63,    0, -125,    0,    0,
  528,  -42, -212,  453, -643, -161, -262,  273,  253,    0,
    0,    0,  815,  893,  894,    0,  439,   75, -197, -362,
    0,    0,    0,    0, -117,  555, -333, 1284, 1008,    0,
 -119,    0,  206, -249,    0,    0,    0,    0,    0,   -5,
    0,    0,    0,    0,    0,    0,  169, -442, -535, -234,
    0,    0,  -52,    0,    0,    0,  294,    0,  418,    0,
    0,  713,  267,    0,    0,    0,  157,    0,    0,    0,
  858,    0,    0,    0,    0,  996,    0,  162,    0, -101,
 -142,    0,  -18,    0,    0,    0,    3,  983,    0,    0,
  466,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   96,  303, -209,    0,  -46, -172,  325,    0, 1016,
    0,    0,    0,    0, 1015, -498,    0,    0,    0,    0,
    0,    0,    0,  748,    0,    0,    0,    0, -321,  262,
    0,    0,  297,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  431,    0,    0,    0,    0,    0,    0,  146,
    0,    0,    0,    0,    0,    0,    0,    0,  -75,  -13,
    0,    0,
};
#define YYTABLESIZE 11931
static const YYINT yytable[] = {                         31,
  106,  178,  147,  126,   11,  107,  147,  211,  115,  283,
  384,    6,  316,  107,  296,  597,  677,  117,  479,  398,
  118,  682,  885,  218,  574,  429,  123,  587,  586,  333,
  340,  107,  571,  534,  412,  289,  388,  218,   26,  390,
  192,  331,  791,  145,  110,  174,    6,  145,  247,  109,
  569,  247,  247,  257,  258,  208,  431,  305,  305,  233,
  173,  730,  812,  750,  343,  379,  598,   30,  233,  598,
  937,  431,  111,  947,  379,  443,   18,  292,  305,  444,
  394,  429,  403,  603,  598,  536,  444,  381,  316,  444,
  112,  159,  161,  441,  588,  430,  107,  107,  417,  316,
  456,  166,  435,  444,  444,  672,  107,  331,  444,  429,
  234,  144,  107,  107,  220,  144,  570,  359,  598,  234,
  340,  431,  208,  670,  187,  457,   23,  210,  220,  183,
  938,  509,  107,  429,  118,  603,   79,  532,  444,  661,
  431,  461,  147,  359,  381,  381,  147,  391,  381,  116,
  598,  208,  430,  548,  435,  123,  147,  673,  960,  442,
  107,  147,  734,  208,  271,  870,  147,  314,  429,  107,
  444,  546,  454,  305,  381,  763,  118,  576,  609,  430,
  609,    6,  874,  145,  601,  320,  599,  145,  128,  671,
  593,  419,  186,  342,   15,  609,  609,  145,  212,  157,
  435,  439,  145,  391,  430,  384,  550,  145,    3,  435,
  447,  584,  702,   11,  600,  543,  749,  343,   18,   79,
  280,  555,  162,  528,  529,  281,  343,  359,  118,  163,
  291,  391,  147,  601,  337,  599,  340,  547,  147,  394,
  394,  884,  959,    3,  682,  682,  171,  585,  457,  533,
  315,  144,   18,  387,  276,  144,  191,    5,  504,  683,
  507,  435,  516,  517,  518,  144,  118,  733,   23,  567,
  144,  218,  218,  145,  276,  144,  363,  414,   19,  145,
  187,  595,  107,  342,  305,  363,  381,  172,  342,  108,
  364,  365,    5,   20,   21,   22,  305,  573,  429,  430,
  498,  444,   23,  598,  107,  568,  394,  282,  337,  770,
  498,  946,  440,  572,  739,  498,  451,  444,  444,   24,
  500,  343,  458,  444,  337,  498,   15,  182,   25,  337,
  403,  403,  594,  501,  502,  389,  505,  444,  444,  498,
  894,  144,  669,  498,  431,  147,  498,  144,  186,  498,
   55,  146,   79,  498,  189,  156,  498,  335,  193,  444,
  376,  377,  220,  220,  147,  498,  775,  210,  430,  376,
  377,  776,  107,  149,   79,  498,  337,  149,    3,  118,
  359,  333,  662,  313,  391,  565,  145,  498,  424,  770,
  545,  498,   16,  609,  918,  958,  498,  498,  379,  342,
    4,  498,  429,  429,  563,  145,  498,  147,   15,  107,
  801,  342,  565,  194,  191,  554,   56,  580,  549,  654,
  744,  703,  391,  547,  306,  307,  310,    5,  701,  498,
  711,  410,  343,  552,   15,  578,  310,  310,  335,  498,
  337,  310,  310,  455,  343,  336,  273,  392,  145,   15,
   15,   15,  337,  196,  144,  435,  514,  716,   15,  394,
  814,  199,  333,  377,   79,  429,  498,   79,  698,  726,
   12,  743,  447,  144,  275,   15,  498,  203,  600,  731,
  732,   79,   79,  429,   15,  742,  868,   12,   12,  430,
  699,  274,  692,  308,  294,  278,  337,  213,  790,  553,
  667,  579,  815,  308,  308,  288,  337,  430,  308,  308,
  429,  330,  335,  149,  208,  278,  144,  149,  665,  972,
  972,  382,  120,  817,  706,  769,  454,  149,  609,  107,
  609,  609,  149,  416,  762,  448,  713,  149,  972,  214,
  336,  107,  828,  746,  781,   14,   79,  429,  415,  310,
  310,  310,  310,  310,  310,  310,  310,  310,  310,  310,
  310,  310,  310,  310,  310,  310,  310,  310,  247,   54,
  747,  430,  710,  363,  821,  208,  514,  330,  382,  382,
  755,  399,  382,  926,  666,  208,  675,  406,  120,   46,
  708,  335,  429,  831,  661,  247,  831,  768,  247,   47,
  773,  119,  446,  149,  498,  800,  820,  335,  382,  149,
  765,  779,  780,  831,  498,  333,  308,  308,  308,  308,
  308,  308,  308,  308,  308,  308,  308,  308,  308,  308,
  308,  308,  308,  308,  308,  147,  262,  654,  654,  789,
  686,  587,  586,  795,  799,  180,  802,  147,  654,  264,
  147,  336,  551,  788,  577,  398,  709,  147,  233,  391,
  821,  793,  208,  336,   26,  825,  169,  909,  168,  908,
  315,  337,  398,  398,  654,  811,  145,  654,  654,   79,
  429,  654,  377,  876,  272,   12,  786,  654,  145,  498,
  654,  145,  286,  777,  527,  914,  273,  654,  145,  498,
  805,   79,  429,  290,  430,  147,   45,  398,  588,  147,
  913,  181,  311,  527,  804,  265,  149,   60,  335,  807,
  382,  231,  318,  147,  371,  429,  430,  794,  337,  210,
  335,  321,  170,  910,  107,  149,  231,  664,  393,  398,
  168,  147,  147,  609,  144,  660,  145,  429,   11,  877,
  145,  514,  457,  457,  453,  448,  144,  452,  448,  144,
  400,  448,  813,  401,  145,  402,  144,  107,  273,  411,
   45,  457,  315,  684,  409,  448,  448,  107,  149,  458,
  448,  322,  145,  145,  713,  403,  404,   13,  247,  107,
  927,  247,  247,  928,  929,  685,   45,  498,  460,  897,
  305,  305,  337,  818,   13,   13,  310,  498,  514,  707,
  448,  448,  661,  661,  144,  880,  233,  919,  144,  305,
  107,  963,  379,  661,  952,  819,  528,  529,  230,  337,
  231,  462,  144,  337,  519,   53,  962,  378,  525,  230,
   31,  448,  448,  230,  936,  231,  916,  917,  526,  661,
  144,  144,  661,  661,  230,  922,  661,  924,  925,  945,
  531,  585,  661,    1,  179,  661,  537,  234,  263,  196,
  196,  538,  661,  308,  539,  403,  404,  217,   18,  218,
  792,  541,  852,  823,  824,  167,  907,  564,  337,  452,
  454,  337,  398,  299,  300,  880,  575,  581,  582,  337,
  107,  590,  875,   45,   19,  829,  398,  398,   30,  155,
  592,  596,  337,  601,  322,  342,  342,  337,  301,   20,
   21,   22,  660,  663,  668,   45,  302,  830,   23,   45,
  303,  676,  678,  228,  342,  395,  322,  337,  688,  690,
  693,  337,  337,  337,  337,   24,  695,  696,  343,  343,
  704,   45,  304,  714,   25,  337,  337,  337,  715,  717,
  337,  337,  337,  660,  660,  718,  720,  343,  723,  337,
  727,  852,  724,  448,  660,  337,  736,  337,  337,  852,
  346,  391,  448,  337,  156,  448,  155,  735,  361,  448,
  448,  740,  764,  360,  399,  448,  753,  852,  362,  754,
  660,  662,   13,  660,  660,  766,  149,  660,  770,  448,
  448,  399,  399,  660,  361,  778,  660,  787,  149,  360,
  358,  149,  359,  660,  362,  796,  810,  816,  149,  872,
  400,  448,  891,  363,  911,  852,  896,  943,  364,  365,
  912,  852,  852,  923,  908,  944,  399,  400,  400,  852,
  610,   53,  610,  610,  784,  366,  367,  948,  852,  949,
  950,  981,  984,  852,  498,   79,  368,  610,  610,  247,
  652,  565,  565,  652,  498,  547,  149,   11,  399,  361,
  149,    7,  400,  603,  360,  358,  429,  359,  652,  362,
  652,   76,  369,  165,  149,  370,  371,  193,  965,  372,
  430,  967,  968,   47,   76,  373,   52,  305,  374,  975,
   26,  603,  149,  149,  400,  375,  225,  376,  377,  729,
  738,  155,  652,  155,  383,  906,  420,  324,  325,  722,
  361,  974,  989,  895,  772,  360,  358,  905,  359,  987,
  362,  209,  986,  407,  155,  155,  902,  745,  155,  155,
  903,  198,  155,  357,  652,  356,  260,  206,  155,  155,
  155,  904,  155,  544,  155,  155,  155,  336,  336,  155,
  155,  155,  155,  155,  155,  931,  155,    0,  783,    0,
  155,  155,  915,    0,  155,  155,  336,  155,  155,  155,
  155,  155,    0,  155,  155,    0,  155,    0,  155,  155,
  155,  552,  552,  155,  552,  552,  552,  552,  552,  552,
  552,  552,    0,    0,    0,    0,    0,    0,    0,  662,
  662,    0,  552,  552,  552,  552,  552,  552,  309,    0,
  662,  399,    0,    0,  335,  335,    0,    0,  322,  323,
    0,    0,    0,  326,  327,  399,  399,  348,  349,    0,
    0,  966,    0,  335,    0,  552,  662,  552,  552,  662,
  662,  976,    0,  662,    0,  610,    0,  400,    0,  662,
    0,    0,  662,  886,  983,    0,    0,  893,    0,  662,
    0,  400,  400,    0,    0,  247,    0,  552,  552,  552,
  560,  560,    0,  560,  560,  560,  560,  560,  560,  560,
  560,    0,    0,    0,    0,    0,    0,  652,  652,  652,
    0,  560,  560,  560,  560,  560,  560,    0,    0,  652,
   17,    0,    0,    0,   18,    0,    0,    0,    0,    0,
    0,    0,  920,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  366,  367,  560,  652,  560,  560,  652,  652,
   19,    0,  652,  368,    0,    0,  934,    0,  652,  345,
  346,  652,    0,  348,  349,   20,   21,   22,  652,    0,
    0,    0,    0,    0,   23,    0,  560,  560,  560,  369,
    0,  951,  370,  371,    0,  953,  372,  956,  957,    0,
    0,   24,  373,    0,  298,  374,  656,    0,    0,    0,
   25,    0,  375,    0,  977,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  552,  552,  552,    0,    0,    0,  552,  552,  552,  552,
  552,  552,  552,    0,  552,  552,  552,  552,  552,  552,
  552,  552,  552,  552,  552,  552,  552,  552,  552,  552,
  546,  552,  552,  552,  552,  552,  552,  552,  552,  552,
  552,  552,  552,  552,  552,    0,  552,  552,  552,  552,
  552,  552,  552,  552,  552,  552,  552,  552,  552,    0,
  552,  552,  552,  552,  552,  552,  552,  552,  552,  552,
  552,  552,  552,  552,  552,  552,  552,  552,  552,  552,
    0,  552,    0,  552,  552,  552,  552,  295,    0,  560,
  560,  560,   26,    0,    0,  560,  560,  560,  560,  560,
  560,  560,    0,  560,  560,  560,  560,  560,  560,  560,
  560,  560,  560,  560,  560,  560,  560,  560,  560,    0,
  560,  560,  560,  560,  560,  560,  560,  560,  560,  560,
  560,  560,  560,  560,    0,  560,  560,  560,  560,  560,
  560,  560,  560,  560,  560,  560,  560,  560,   50,  560,
  560,  560,  560,  560,  560,  560,  560,  560,  560,  560,
  560,  560,  560,  560,  560,  560,  560,  560,  560,    0,
  560,    0,  560,  560,  560,  560,  561,  561,    0,  561,
  561,  561,  561,  561,  561,  561,  561,    0,    0,  921,
    0,    0,    0,  298,  656,  656,    0,  561,  561,  561,
  561,  561,  561,    0,    0,  656,    0,  464,  466,  468,
  470,  472,  474,  476,  478,  940,  481,  483,  485,  487,
  489,  491,  493,  495,  497,  499,    0,    0,    0,    0,
  561,  656,  561,  561,  656,  656,    0,    0,  656,    0,
    0,    0,    0,    0,  656,    0,    0,  656,    0,    0,
    0,    0,    0,  969,  656,    0,    0,    0,    0,  979,
  980,    0,  561,  561,  561,  539,  539,  982,  539,  539,
  539,  539,  539,  539,    0,  539,  988,    0,    0,    0,
    0,  990,    0,   45,    0,    0,  539,  539,  539,  539,
  539,  539,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  277,    0,    0,    0,   18,    0,    0,    0,
   46,    0,    0,    0,    0,    0,    0,    0,    0,  539,
   47,  539,  539,    0,    0,    0,    0,  131,  132,    0,
    0,   48,   19,    0,    0,  133,    0,    0,    0,    0,
    0,    0,    0,  134,    0,  135,    0,   20,   21,   22,
    0,    0,  539,  539,    0,    0,   23,  136,   49,  137,
    0,    0,    0,  138,  139,    0,    0,    0,  140,    0,
  298,  141,  658,   24,    0,    0,    0,  142,    0,    0,
    0,    0,   25,  143,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  561,  561,  561,    0,    0,
    0,  561,  561,  561,  561,  561,  561,  561,    0,  561,
  561,  561,  561,  561,  561,  561,  561,  561,  561,  561,
  561,  561,  561,  561,  561,    0,  561,  561,  561,  561,
  561,  561,  561,  561,  561,  561,  561,  561,  561,  561,
    0,  561,  561,  561,  561,  561,  561,  561,  561,  561,
  561,  561,  561,  561,    0,  561,  561,  561,  561,  561,
  561,  561,  561,  561,  561,  561,  561,  561,  561,  561,
  561,  561,  561,  561,  561,    0,  561,    0,  561,  561,
  561,  561,  429,    0,    0,  539,    0,  155,    0,    0,
  539,  539,  192,  539,  539,  539,  539,    0,  539,  539,
  539,  539,  192,  192,  192,  192,  539,  539,  539,  192,
  192,  192,  192,  192,    0,  192,  192,  192,  539,  192,
  539,  539,  192,  192,  192,  192,  192,  192,  192,    0,
  192,  192,  192,  192,  192,  192,  192,  192,  192,  192,
  192,  192,    0,    0,  539,  192,  192,  539,  539,  192,
  192,  539,  192,  192,  192,  192,  192,  539,  192,  192,
  539,  192,  192,  192,  429,  192,    0,  539,  192,  539,
  539,  552,  552,    0,  552,    0,  552,  552,  552,  552,
  552,  552,    0,    0,    0,    0,    0,    0,    0,  298,
  658,  658,  295,  552,  552,  552,  552,  552,    0,    0,
    0,  658,    0,    0,    0,  131,  132,    0,    0,    0,
    0,    0,    0,  133,    0,    0,    0,    0,    0,    0,
    0,  134,    0,  135,    0,  552,    0,  658,  552,    0,
  658,  658,    0,    0,  658,  136,    0,  137,    0,    0,
  658,  138,  139,  658,    0,    0,  140,    0,    0,  141,
  658,    0,    0,    0,    0,  142,    0,    0,  552,  499,
  499,  143,  499,  499,  499,  499,  499,  499,  499,  499,
    0,    0,  244,    0,    0,  244,  417,    0,    0,  417,
  499,  499,  499,  499,  499,  499,    0,    0,    0,  244,
  244,    0,    0,  417,  417,    0,    0,  429,    0,    0,
    0,  155,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  499,    0,  499,  499,    0,    0,  429,
    0,    0,  155,  155,  244,    0,    0,  155,  417,    0,
  155,    0,    0,    0,    0,    0,    0,  155,  155,    0,
  155,    0,  155,  155,  155,    0,  499,  499,  155,  155,
  155,  155,  155,    0,  155,    0,  244,    0,  155,  155,
  417,    0,  155,  155,    0,  155,  155,  155,  155,  155,
    0,  155,  155,    0,    0,    0,  155,  155,  155,    0,
    0,  155,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  552,    0,    0,    0,    0,  552,  552,  552,  552,
  552,  552,  552,    0,  552,  552,  552,  552,  552,  552,
  552,  552,  552,  552,  552,  552,  552,  552,  552,  552,
  546,  552,  552,  552,  552,  552,    0,  648,  552,  552,
  552,  552,  552,  552,  552,    0,  552,  552,  552,  552,
  552,  552,  552,  552,  552,  552,  552,  552,    0,    0,
  552,  552,  552,  552,  552,  552,  552,  552,  552,  552,
  552,  552,  552,  552,  552,  552,  552,  552,  552,  552,
    0,  552,  647,  552,  552,  552,  552,    0,  499,  499,
    0,    0,    0,    0,  499,  499,    0,  499,  499,  499,
  499,  417,  499,  499,  499,  499,    0,    0,    0,    0,
  499,  499,  499,    0,  657,    0,    0,    0,  547,  244,
    0,    0,  499,  417,  499,  499,    0,    0,    0,    0,
    0,    0,    0,  244,  244,    0,    0,  417,  417,    0,
    0,    0,    0,    0,    0,    0,  499,    0,  499,    0,
    0,  499,  499,    0,    0,  499,    0,    0,    0,  417,
    0,  499,    0,    0,  499,    0,    0,    0,    0,    0,
    0,  499,    0,  499,  499,  490,  490,   33,  490,  490,
  490,  490,  490,  490,  490,  490,    0,    0,   34,   35,
   36,    0,    0,    0,    0,    0,  490,  490,  490,  490,
  490,  490,   37,    0,    0,   38,    0,   39,    0,   40,
    0,   41,    0,    0,    0,    0,   42,    0,    0,    0,
    0,   43,  303,  243,    0,    0,  243,    0,    0,  490,
    0,  490,  490,    0,    0,    0,    0,    0,    0,    0,
  243,  243,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  648,  648,    0,    0,    0,
    0,    0,  490,  490,  539,  539,  648,  539,  539,  539,
  539,  539,  539,  653,  539,  243,  653,    0,    0,    0,
    0,    0,    0,    0,    0,  539,  539,  539,  539,  539,
  539,  653,  648,  653,    0,  648,  648,    0,    0,  648,
  647,  647,    0,    0,    0,  648,  498,  243,  648,    0,
    0,  647,    0,    0,    0,  648,  498,    0,  539,    0,
  539,  539,    0,    0,    0,  653,    0,    0,    0,    0,
    0,    0,  657,  657,    0,    0,    0,  647,  498,    0,
  647,  647,    0,  657,  647,    0,    0,    0,  498,    0,
  647,  539,  539,  647,    0,    0,  301,  653,    0,    0,
  647,  301,  301,    0,    0,    0,    0,    0,    0,  657,
    0,    0,  657,  657,    0,  301,  657,  659,    0,    0,
    0,    0,  657,    0,    0,  657,    0,    0,    0,    0,
    0,    0,  657,    0,  490,  490,    0,    0,    0,    0,
  490,  490,    0,  490,  490,  490,  490,  301,  490,  490,
  490,  490,    0,    0,    0,    0,  490,  490,  490,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  490,    0,
  490,  490,    0,    0,    0,    0,    0,    0,  303,  301,
    0,  301,  301,    0,    0,  247,    0,    0,    0,    0,
  247,  247,  490,    0,  490,    0,    0,  490,  490,    0,
  243,  490,    0,    0,  247,    0,  645,  490,    0,    0,
  490,    0,    0,    0,  243,  243,    0,  490,    0,  490,
  490,    0,    0,  539,  539,    0,    0,    0,    0,  539,
  539,    0,  539,  539,  539,  539,  247,  539,  539,  539,
  539,    0,    0,    0,    0,  539,  539,  539,    0,    0,
  653,  653,  653,    0,    0,    0,    0,  539,    0,  539,
  539,    0,  653,    0,    0,    0,    0,    0,  247,    0,
    0,  247,  395,    0,   26,    0,    0,    0,    0,    0,
    0,  539,    0,  539,    0,    0,  539,  539,  653,    0,
  539,  653,  653,    0,    0,  653,  539,    0,    0,  539,
    0,  653,    0,    0,  653,    0,  539,    0,  539,  539,
    0,  653,  301,    0,  301,  301,  301,  301,  301,  301,
  301,    0,    0,    0,    0,  301,    0,    0,    0,  599,
  301,  301,  301,  301,  301,  659,  659,  301,  301,  301,
  301,  301,  301,  301,  301,  301,  659,  301,    0,    0,
  301,  301,  301,  301,  301,  301,  301,  301,  301,  301,
  301,  301,  301,  301,  301,  301,  301,  301,  301,  301,
    0,  301,  659,  301,  301,  659,  659,  301,  301,  659,
  301,  301,  301,  301,  301,  659,  301,  301,  659,    0,
  301,  301,  301,  301,  301,  659,  301,    0,  219,    0,
    0,  247,    0,  247,  247,  247,  247,  247,  247,  247,
  430,    0,    0,    0,  247,    0,    0,    0,    0,  247,
  247,  247,  247,    0,  645,  645,  247,  247,  247,  247,
  247,  247,  247,  247,  247,  645,  247,    0,    0,  247,
  247,  247,  247,  247,  247,  247,  247,  247,  247,  247,
  247,  247,  247,  247,  247,  247,  247,  247,  247,    0,
  247,  645,  247,  247,  645,  645,  247,  247,  645,  247,
  247,  247,  247,  247,  645,  247,  247,  645,    0,  247,
  247,  247,  247,  247,  645,  247,  352,    0,   18,    0,
    0,  352,  352,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  352,    0,    0,    0,  131,
  132,    0,    0,    0,   19,    0,    0,  133,    0,    0,
    0,    0,    0,    0,  598,  134,    0,  135,    0,   20,
   21,   22,    0,    0,    0,    0,    0,  352,   23,  136,
    0,  137,    0,    0,    0,  138,  139,  366,  367,    0,
  140,    0,    0,  141,    0,   24,    0,    0,  368,  142,
    0,    0,    0,    0,   25,  143,    0,    0,    0,  352,
    0,  352,  352,  233,    0,    0,    0,    0,  231,   26,
    0,    0,    0,    0,  369,    0,    0,  370,  371,    0,
    0,  372,  848,    0,    0,    0,    0,  373,    0,    0,
  374,    0,    0,    0,    0,    0,    0,  375,    0,    0,
    0,    0,  219,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  234,    0,    0,    0,    0,    0,
    0,    0,    0,  219,  219,    0,    0,    0,  219,    0,
    0,  219,    0,    0,  430,  430,    0,    0,    0,  219,
    0,  219,    0,  219,  219,  219,  315,    0,  750,  232,
    0,    0,  219,  219,   26,  219,    0,    0,    0,  219,
  219,    0,    0,    0,  219,    0,    0,  219,    0,  219,
    0,    0,    0,  219,    0,    0,    0,    0,  219,  219,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  352,    0,  352,  352,  352,  352,  352,  352,
  352,    0,    0,    0,    0,  352,    0,    0,    0,    0,
  352,  352,  352,  352,  352,    0,    0,  352,  352,  352,
  352,  352,  352,  352,  352,  352,  154,  352,    0,    0,
    0,  352,  352,  352,  352,  352,  352,  352,  352,  352,
  352,  352,  352,  352,  352,  352,  352,  352,  352,  352,
    0,  352,    0,  352,  352,    0,    0,  352,  352,    0,
  352,  352,  352,  352,  352,    0,  352,  352,    0,    0,
  352,  352,  352,  352,  352,    0,  352,    0,    0,  833,
    0,  834,  217,   18,  218,  219,  220,  835,    0,    0,
    0,    0,  221,    0,    0,    0,    0,  836,  222,  223,
  837,  749,    0,  154,  131,  132,  838,  839,    0,   19,
  840,  841,  133,    0,  842,    0,    0,   71,    0,   73,
  134,  843,  135,  225,   20,  844,   22,  845,  846,   82,
   83,  226,   85,   23,  136,  227,  137,  233,  228,    0,
  138,  139,  231,   26,   92,  140,    0,   94,  141,   96,
  229,   98,    0,   99,  142,    0,  848,  230,  103,   25,
  143,  847,    0,  105,  277,    0,    0,    0,   18,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  234,  131,
  132,    0,    0,    0,   19,    0,    0,  133,    0,    0,
    0,    0,    0,    0,    0,  134,    0,  135,    0,   20,
   21,   22,    0,    0,    0,    0,    0,    0,   23,  136,
  315,  137,  233,  232,  513,  138,  139,  231,   26,    0,
  140,    0,    0,  141,    0,   24,    0,    0,  154,  142,
  154,    0,  512,    0,   25,  143,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  154,  154,    0,    0,  154,  154,    0,    0,  154,
    0,    0,    0,  234,    0,  154,    0,  154,    0,  154,
    0,  154,  154,  154,    0,    0,  154,    0,    0,    0,
  154,  154,    0,  154,    0,    0,    0,  154,  154,    0,
    0,    0,  154,    0,    0,  154,    0,  154,  232,    0,
    0,  154,    0,  154,    0,    0,  154,  154,    0,    0,
    0,    0,    0,    0,    0,  233,    0,    0,    0,    0,
  231,   26,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  885,    0,    0,    0,    0,    0,
    0,    0,    0,  833,    0,  834,  217,   18,  218,  219,
  220,  835,    0,    0,    0,    0,  221,    0,    0,    0,
    0,  836,  222,  223,  837,    0,  234,    0,  131,  132,
  838,  839,    0,   19,  840,  841,  133,    0,  842,    0,
    0,   71,    0,   73,  134,  843,  135,  225,   20,  844,
   22,  845,  846,   82,   83,  226,   85,   23,  136,  227,
  137,  232,  228,    0,  138,  139,    0,    0,   92,  140,
    0,   94,  141,   96,  229,   98,    0,   99,  142,    0,
    0,  230,  103,   25,  143,  847,    0,  105,  510,    0,
    0,  217,   18,  218,  219,  220,   57,  233,    0,    0,
    0,  221,  231,   26,    0,    0,   58,  222,  223,   61,
  511,    0,    0,  131,  132,   64,   65,    0,   19,   67,
   68,  133,    0,   70,    0,    0,   71,    0,   73,  134,
   75,  135,  225,   20,   21,   22,   80,   81,   82,   83,
  226,   85,   23,  136,  227,  137,    0,  228,  234,  138,
  139,    0,    0,   92,  140,    0,   94,  141,   96,  229,
   98,    0,   99,  142,    0,    0,  230,  103,   25,  143,
    0,    0,  105,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  232,    0,    0,    0,    0,    0,    0,
    0,  883,    0,    0,  217,   18,  218,  219,  220,   57,
  233,    0,    0,    0,  221,  231,   26,    0,    0,   58,
  222,  223,   61,  884,    0,    0,  131,  132,   64,   65,
    0,   19,   67,   68,  133,    0,   70,    0,    0,   71,
    0,   73,  134,   75,  135,  225,   20,   21,   22,   80,
   81,   82,   83,  226,   85,   23,  136,  227,  137,    0,
  228,  234,  138,  139,    0,    0,   92,  140,    0,   94,
  141,   96,  229,   98,    0,   99,  142,    0,    0,  230,
  103,   25,  143,    0,    0,  105,    0,    0,    0,    0,
    0,    0,    0,  329,    0,  233,  232,    0,    0,    0,
  231,   26,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  512,    0,    0,    0,    0,
    0,    0,    0,  883,    0,    0,  217,   18,  218,  219,
  220,   57,    0,    0,    0,    0,  221,    0,    0,    0,
    0,   58,  222,  223,   61,    0,  234,    0,  131,  132,
   64,   65,    0,   19,   67,   68,  133,    0,   70,  403,
  404,   71,    0,   73,  134,   75,  135,  225,   20,   21,
   22,   80,   81,   82,   83,  226,   85,   23,  136,  227,
  137,  232,  228,    0,  138,  139,    0,    0,   92,  140,
    0,   94,  141,   96,  229,   98,    0,   99,  142,    0,
    0,  230,  103,   25,  143,    0,    0,  105,    0,    0,
    0,    0,    0,  361,  355,    0,    0,    0,  360,  358,
    0,  359,    0,  362,    0,    0,  328,    0,    0,  217,
   18,  218,  219,  220,   57,  233,  357,    0,  356,  221,
  231,   26,    0,    0,   58,  222,  223,   61,    0,    0,
    0,  131,  132,   64,   65,    0,   19,   67,   68,  133,
    0,   70,    0,    0,   71,    0,   73,  134,   75,  135,
  225,   20,   21,   22,   80,   81,   82,   83,  226,   85,
   23,  136,  227,  137,    0,  228,  234,  138,  139,    0,
    0,   92,  140,    0,   94,  141,   96,  229,   98,    0,
   99,  142,    0,    0,  230,  103,   25,  143,    0,    0,
  105,    0,    0,    0,  217,   18,  218,  219,  220,   57,
  233,  232,    0,    0,  221,  231,   26,    0,    0,   58,
  222,  223,   61,  511,    0,    0,  131,  132,   64,   65,
    0,   19,   67,   68,  133,    0,   70,    0,    0,   71,
    0,   73,  134,   75,  135,  225,   20,   21,   22,   80,
   81,   82,   83,  226,   85,   23,  136,  227,  137,    0,
  228,  234,  138,  139,    0,    0,   92,  140,    0,   94,
  141,   96,  229,   98,    0,   99,  142,    0,    0,  230,
  103,   25,  143,    0,    0,  105,    0,    0,    0,    0,
    0,    0,  233,    0,    0,    0,  232,  231,   26,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  344,  345,  346,  347,    0,  348,  349,    0,    0,
    0,  421,    0,  234,  217,   18,  218,  219,  220,   57,
    0,    0,    0,    0,  221,    0,    0,    0,    0,   58,
  222,  223,   61,    0,    0,    0,  131,  132,   64,   65,
   26,   19,   67,   68,  133,    0,   70,    0,  232,   71,
    0,   73,  134,   75,  135,  225,   20,   21,   22,   80,
   81,   82,   83,  226,   85,   23,  136,  227,  137,    0,
  228,    0,  138,  139,    0,    0,   92,  140,    0,   94,
  141,   96,  229,   98,    0,   99,  142,    0,    0,  230,
  103,   25,  143,    0,    0,  105,    0,    0,    0,  217,
   18,  218,  219,  220,   57,    0,    0,    0,    0,  221,
    0,    0,    0,    0,   58,  222,  223,   61,  674,    0,
  430,  131,  132,   64,   65,  155,   19,   67,   68,  133,
    0,   70,    0,    0,   71,    0,   73,  134,   75,  135,
  225,   20,   21,   22,   80,   81,   82,   83,  226,   85,
   23,  136,  227,  137,    0,  228,    0,  138,  139,    0,
    0,   92,  140,    0,   94,  141,   96,  229,   98,    0,
   99,  142,    0,    0,  230,  103,   25,  143,  883,    0,
  105,  217,   18,  218,  219,  220,   57,    0,    0,    0,
    0,  221,    0,    0,    0,    0,   58,  222,  223,   61,
    0,    0,  430,  131,  132,   64,   65,    0,   19,   67,
   68,  133,    0,   70,    0,    0,   71,    0,   73,  134,
   75,  135,  225,   20,   21,   22,   80,   81,   82,   83,
  226,   85,   23,  136,  227,  137,    0,  228,    0,  138,
  139,    0,    0,   92,  140,    0,   94,  141,   96,  229,
   98,    0,   99,  142,   18,    0,  230,  103,   25,  143,
  207,  206,  105,    0,  206,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  131,  132,    0,  206,  206,
   19,    0,    0,  133,    0,    0,    0,    0,    0,    0,
    0,  134,    0,  135,    0,   20,   21,   22,    0,    0,
    0,    0,    0,    0,   23,  136,    0,  137,    0,    0,
    0,  138,  139,  206,    0,    0,  140,    0,    0,  141,
    0,   24,    0,    0,    0,  142,    0,    0,    0,    0,
   25,  143,    0,    0,    0,  430,    0,    0,    0,  155,
    0,    0,  233,  206,  206,    0,    0,  231,   26,    0,
    0,    0,    0,    0,    0,    0,    0,  430,    0,    0,
  155,  155,    0,    0,    0,  155,    0,    0,  155,    0,
    0,    0,    0,    0,    0,  155,  155,    0,  155,    0,
  155,  155,  155,    0,    0,    0,  155,  155,  155,  155,
  155,    0,  155,  234,    0,    0,  155,  155,    0,    0,
  155,  155,    0,  155,  155,  155,  155,  155,    0,  155,
  155,    0,    0,    0,  155,  155,  155,    0,    0,  155,
    0,    0,    0,    0,  233,    0,    0,    0,  232,    0,
   26,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  234,  206,    0,  206,    0,
    0,    0,    0,    0,  206,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  206,  206,  206,  206,  206,    0,
    0,  206,  206,  206,  206,  206,    0,  206,  206,  206,
    0,  206,  206,  206,  206,  206,  206,  206,  206,  206,
  206,    0,  206,  206,  206,  206,  206,  206,  206,  206,
  206,  206,  206,  206,    0,    0,    0,  206,  206,    0,
    0,  206,  206,  233,  206,  206,  206,  206,  206,   26,
  206,  206,    0,  206,  206,  206,    0,  206,    0,    0,
  206,  217,   18,  218,  219,  220,   57,    0,    0,    0,
    0,  221,    0,    0,    0,    0,   58,  222,  223,   61,
    0,    0,    0,  131,  132,   64,   65,    0,   19,   67,
   68,  133,    0,   70,  234,    0,   71,    0,   73,  134,
   75,  135,  225,   20,   21,   22,   80,   81,   82,   83,
  226,   85,   23,  136,  227,  137,    0,  228,    0,  138,
  139,    0,    0,   92,  140,    0,   94,  141,   96,  229,
   98,    0,   99,  142,    0,    0,  230,  103,   25,  143,
  970,    0,  105,  217,   18,  218,    0,  233,   57,    0,
    0,    0,  231,   26,    0,    0,    0,    0,   58,  222,
  223,   61,    0,    0,    0,  131,  132,   64,   65,    0,
   19,   67,   68,  133,    0,   70,    0,    0,   71,    0,
   73,  134,   75,  135,  225,   20,   21,   22,   80,   81,
   82,   83,  226,   85,   23,  136,  227,  137,  234,  228,
    0,  138,  139,    0,    0,   92,  140,    0,   94,  141,
   96,  229,   98,    0,   99,  142,    0,    0,  230,  103,
   25,  143,    0,    0,  105,    0,    0,    0,    0,    0,
    0,    0,    0,  232,    0,    0,  361,  355,    0,    0,
    0,  360,  358,    0,  359,    0,  362,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  357,
    0,  356,  217,   18,  218,    0,  233,   57,    0,    0,
    0,  231,   26,    0,    0,    0,    0,   58,  222,  223,
   61,    0,    0,    0,  131,  132,   64,   65,    0,   19,
   67,   68,  133,  354,   70,    0,    0,   71,    0,   73,
  134,   75,  135,  225,   20,   21,   22,   80,   81,   82,
   83,  226,   85,   23,  136,  227,  137,  234,  228,    0,
  138,  139,    0,  353,   92,  140,    0,   94,  141,   96,
  229,   98,    0,   99,  142,    0,    0,  230,  103,   25,
  143,    0,    0,  105,    0,    0,    0,    0,    0,  329,
    0,    0,  232,  233,    0,    0,    0,    0,  231,   26,
    0,    0,    0,  216,    0,    0,  217,   18,  218,  219,
  220,   57,    0,    0,    0,    0,  221,  433,    0,    0,
    0,   58,  222,  223,   61,  224,    0,    0,    0,    0,
   64,   65,    0,   19,   67,   68,    0,    0,   70,    0,
    0,   71,    0,   73,  234,   75,    0,  225,   20,   21,
   22,   80,   81,   82,   83,  226,   85,   23,    0,  227,
    0,    0,  228,    0,    0,    0,  303,  237,   92,    0,
  237,   94,    0,   96,  229,   98,    0,   99,    0,  232,
    0,  230,  103,   25,  237,  237,    0,  105,    0,    0,
    0,    0,    0,  233,    0,    0,    0,    0,  231,   26,
    0,    0,    0,    0,  344,  345,  346,  347,    0,  348,
  349,  350,    0,    0,    0,    0,    0,  433,    0,  237,
    0,    0,  328,    0,    0,  217,   18,  218,  219,  220,
   57,    0,    0,    0,    0,  221,    0,    0,    0,    0,
   58,  222,  223,   61,  234,    0,    0,    0,    0,   64,
   65,  237,   19,   67,   68,    0,    0,   70,    0,    0,
   71,    0,   73,    0,   75,    0,  225,   20,   21,   22,
   80,   81,   82,   83,  226,   85,   23,    0,  227,  232,
  233,  228,    0,    0,    0,  231,   26,   92,    0,    0,
   94,    0,   96,  229,   98,    0,   99,    0,    0,    0,
  230,  103,   25,    0,    0,    0,  105,    0,    0,  432,
    0,    0,  217,   18,  218,  219,  220,   57,    0,    0,
    0,    0,  221,    0,    0,    0,    0,   58,  222,  223,
   61,  234,    0,    0,    0,    0,   64,   65,    0,   19,
   67,   68,    0,    0,   70,    0,    0,   71,    0,   73,
    0,   75,    0,  225,   20,   21,   22,   80,   81,   82,
   83,  226,   85,   23,    0,  227,  232,    0,  228,    0,
    0,    0,    0,    0,   92,    0,    0,   94,    0,   96,
  229,   98,  303,   99,    0,    0,    0,  230,  103,   25,
    0,    0,  232,  105,    0,    0,    0,  232,  232,    0,
    0,    0,    0,    0,  237,    0,    0,    0,    0,  508,
    0,    0,  217,   18,  218,  219,  220,   57,  237,  237,
    0,    0,  221,    0,    0,    0,    0,   58,  222,  223,
   61,    0,    0,    0,    0,    0,   64,   65,    0,   19,
   67,   68,    0,  232,   70,    0,    0,   71,    0,   73,
    0,   75,    0,  225,   20,   21,   22,   80,   81,   82,
   83,  226,   85,   23,    0,  227,    0,  238,  228,    0,
  238,    0,    0,    0,   92,    0,    0,   94,  232,   96,
  229,   98,    0,   99,  238,  238,  233,  230,  103,   25,
    0,  231,   26,  105,    0,    0,  797,    0,    0,  217,
   18,  218,  219,  220,   57,    0,    0,    0,    0,  221,
    0,    0,    0,    0,   58,  222,  223,   61,  798,  238,
    0,    0,    0,   64,   65,    0,   19,   67,   68,    0,
    0,   70,    0,    0,   71,    0,   73,  234,   75,    0,
  225,   20,   21,   22,   80,   81,   82,   83,  226,   85,
   23,  238,  227,    0,    0,  228,    0,    0,    0,    0,
    0,   92,    0,    0,   94,    0,   96,  229,   98,    0,
   99,    0,  232,    0,  230,  103,   25,    0,    0,  233,
  105,    0,    0,    0,  231,   26,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  232,  232,  232,  232,  232,  232,    0,    0,    0,
    0,  232,    0,    0,    0,    0,  232,  232,  232,  232,
  234,    0,    0,    0,    0,  232,  232,  232,  232,  232,
  232,    0,    0,  232,    0,    0,  232,  232,  232,    0,
  232,    0,  232,  232,  232,  232,  232,  232,  232,  232,
  232,  232,  232,    0,  232,  232,    0,  232,    0,    0,
    0,    0,    0,  232,    0,    0,  232,    0,  232,  232,
  232,    0,  232,    0,    0,    0,  232,  232,  232,  361,
    0,    0,  232,    0,  360,  358,    0,  359,    0,  362,
    0,    0,  418,    0,  238,  217,   18,  218,  219,  220,
   57,  233,  357,    0,  356,  221,  231,   26,  238,  238,
   58,  222,  223,   61,    0,    0,    0,    0,    0,   64,
   65,    0,   19,   67,   68,  433,    0,   70,    0,    0,
   71,    0,   73,    0,   75,    0,  225,   20,   21,   22,
   80,   81,   82,   83,  226,   85,   23,    0,  227,    0,
    0,  228,  234,    0,    0,    0,    0,   92,    0,    0,
   94,    0,   96,  229,   98,    0,   99,    0,    0,    0,
  230,  103,   25,    0,    0,    0,  105,    0,    0,    0,
    0,    0,    0,    0,    0,  438,    0,  232,  217,   18,
  218,  219,  220,   57,  233,    0,    0,    0,  221,  231,
   26,    0,    0,   58,  222,  223,   61,    0,    0,    0,
    0,    0,   64,   65,    0,   19,   67,   68,    0,    0,
   70,    0,    0,   71,    0,   73,    0,   75,    0,  225,
   20,   21,   22,   80,   81,   82,   83,  226,   85,   23,
    0,  227,    0,    0,  228,  234,    0,    0,    0,  237,
   92,    0,  237,   94,    0,   96,  229,   98,    0,   99,
    0,    0,    0,  230,  103,   25,  237,  237,    0,  105,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  232,    0,    0,    0,    0,    0,    0,    0,  233,    0,
    0,    0,    0,  231,   26,    0,    0,    0,    0,    0,
    0,  237,    0,    0,    0,    0,    0,  344,  345,  346,
  347,    0,  348,  349,    0,    0,    0,    0,    0,    0,
  217,   18,  218,  219,  220,   57,    0,    0,    0,    0,
  221,    0,    0,  237,    0,   58,  222,  223,   61,  234,
    0,    0,    0,    0,   64,   65,    0,   19,   67,   68,
    0,    0,   70,    0,    0,   71,    0,   73,    0,   75,
    0,  225,   20,   21,   22,   80,   81,   82,   83,  226,
   85,   23,    0,  227,  232,    0,  228,    0,    0,    0,
    0,    0,   92,    0,    0,   94,    0,   96,  229,   98,
    0,   99,    0,  233,    0,  230,  103,   25,  231,   26,
    0,  105,    0,    0,    0,    0,    0,    0,    0,    0,
  503,    0,    0,  217,   18,  218,  219,  220,   57,    0,
    0,    0,    0,  221,    0,    0,    0,    0,   58,  222,
  223,   61,    0,    0,    0,    0,    0,   64,   65,    0,
   19,   67,   68,    0,  234,   70,    0,    0,   71,    0,
   73,    0,   75,    0,  225,   20,   21,   22,   80,   81,
   82,   83,  226,   85,   23,    0,  227,    0,    0,  228,
    0,    0,    0,    0,    0,   92,    0,    0,   94,  232,
   96,  229,   98,    0,   99,    0,  237,  233,  230,  103,
   25,    0,  231,   26,  105,    0,    0,    0,    0,    0,
  237,  237,    0,    0,  506,    0,    0,  217,   18,  218,
  219,  220,   57,    0,    0,    0,    0,  221,    0,    0,
    0,    0,   58,  222,  223,   61,    0,    0,    0,    0,
    0,   64,   65,    0,   19,   67,   68,    0,  234,   70,
    0,    0,   71,    0,   73,    0,   75,    0,  225,   20,
   21,   22,   80,   81,   82,   83,  226,   85,   23,    0,
  227,    0,    0,  228,    0,    0,    0,    0,    0,   92,
    0,    0,   94,  232,   96,  229,   98,    0,   99,    0,
  233,    0,  230,  103,   25,  231,   26,    0,  105,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  725,
    0,    0,  217,   18,  218,  219,  220,   57,    0,    0,
    0,    0,  221,    0,    0,    0,    0,   58,  222,  223,
   61,  234,    0,    0,    0,    0,   64,   65,    0,   19,
   67,   68,    0,    0,   70,    0,    0,   71,    0,   73,
    0,   75,    0,  225,   20,   21,   22,   80,   81,   82,
   83,  226,   85,   23,    0,  227,  232,    0,  228,    0,
    0,    0,    0,    0,   92,    0,    0,   94,    0,   96,
  229,   98,    0,   99,    0,    0,    0,  230,  103,   25,
    0,    0,    0,  105,    0,   26,    0,    0,    0,    0,
    0,    0,    0,  728,    0,    0,  217,   18,  218,  219,
  220,   57,    0,    0,    0,    0,  221,    0,    0,    0,
    0,   58,  222,  223,   61,  583,  650,    0,    0,  650,
   64,   65,    0,   19,   67,   68,    0,    0,   70,    0,
    0,   71,    0,   73,  650,   75,  650,  225,   20,   21,
   22,   80,   81,   82,   83,  226,   85,   23,    0,  227,
    0,    0,  228,    0,    0,    0,    0,    0,   92,    0,
    0,   94,    0,   96,  229,   98,  155,   99,  650,    0,
    0,  230,  103,   25,    0,    0,    0,  105,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  217,
   18,  218,  219,  220,   57,    0,    0,    0,  583,  221,
  650,    0,    0,    0,   58,  222,  223,   61,    0,    0,
    0,    0,    0,   64,   65,    0,   19,   67,   68,    0,
    0,   70,    0,    0,   71,    0,   73,    0,   75,    0,
  225,   20,   21,   22,   80,   81,   82,   83,  226,   85,
   23,    0,  227,  155,  222,  228,    0,  222,    0,    0,
    0,   92,    0,    0,   94,    0,   96,  229,   98,    0,
   99,  222,  222,    0,  230,  103,   25,    0,    0,    0,
  105,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  287,  222,    0,    0,   18,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  131,  132,    0,    0,    0,   19,  222,  222,  133,  215,
    0,  583,  215,    0,    0,    0,  134,    0,  135,    0,
   20,   21,   22,    0,    0,    0,  215,  215,    0,   23,
  136,    0,  137,  650,  650,  650,  138,  139,    0,    0,
    0,  140,    0,    0,  141,  650,   24,    0,    0,    0,
  142,    0,    0,    0,    0,   25,  143,    0,  155,    0,
  155,  215,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  650,    0,    0,  650,  650,    0,    0,  650,    0,
    0,  155,  155,    0,  650,  155,  155,  650,    0,  155,
    0,  215,  215,    0,  650,  155,  155,  155,    0,  155,
    0,  155,  155,  155,    0,    0,  155,  155,  155,  155,
  155,  155,    0,  155,    0,    0,    0,  155,  155,    0,
    0,  155,  155,    0,  155,  155,  155,  155,  155,    0,
  155,  155,    0,  155,    0,  155,  155,  155,    0,  222,
  155,  222,    0,    0,    0,  201,    0,  222,  201,    0,
    0,    0,    0,    0,    0,    0,    0,  222,  222,  222,
  222,  222,  201,  201,  222,  222,  222,  222,  222,    0,
  222,  222,  222,    0,  222,  222,  222,  222,  222,  222,
  222,  222,  222,  222,    0,  222,  222,  222,  222,  222,
  222,  222,  222,  222,  222,  222,  222,  201,    0,    0,
  222,  222,    0,    0,  222,  222,    0,  222,  222,  222,
  222,  222,    0,  222,  222,    0,  222,  222,  222,    0,
  222,    0,    0,  222,  215,    0,  215,  201,  201,    0,
  227,    0,  215,  227,    0,    0,    0,    0,    0,    0,
    0,    0,  215,  215,  215,  215,  215,  227,  227,  215,
  215,  215,  215,  215,    0,  215,  215,  215,    0,  215,
  215,  215,  215,  215,  215,  215,  215,  215,  215,    0,
  215,  215,  215,  215,  215,  215,  215,  215,  215,  215,
  215,  215,  227,    0,    0,  215,  215,    0,    0,  215,
  215,    0,  215,  215,  215,  215,  215,    0,  215,  215,
    0,  215,  215,  215,    0,  215,  443,    0,  215,  443,
    0,    0,  227,  227,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  443,  443,    0,    0,    0,  443,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  443,    0,
  201,    0,  201,    0,    0,    0,  209,    0,  201,  209,
    0,    0,    0,    0,    0,    0,    0,    0,  201,  201,
  201,  201,  201,  209,  209,  201,  201,  201,  201,  201,
  443,  201,  201,  201,    0,  201,  201,  201,  201,  201,
  201,  201,  201,  201,  201,    0,  201,  201,  201,  201,
  201,  201,  201,  201,  201,  201,  201,  201,  209,    0,
    0,  201,  201,    0,    0,  201,  201,    0,  201,  201,
  201,  201,  201,    0,  201,  201,    0,  201,  201,  201,
    0,  201,    0,    0,  201,  227,    0,  227,  209,  209,
    0,  192,    0,  227,  192,    0,    0,    0,    0,    0,
    0,    0,    0,  227,  227,  227,  227,  227,  192,  192,
  227,  227,  227,  227,  227,    0,  227,  227,  227,    0,
  227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
    0,  227,  227,  227,  227,  227,  227,  227,  227,  227,
  227,  227,  227,  192,    0,    0,  227,  227,    0,    0,
  227,  227,    0,  227,  227,  227,  227,  227,    0,  227,
  227,  443,  227,  227,  227,    0,  227,    0,    0,  227,
    0,    0,    0,  192,  192,    0,    0,    0,  443,    0,
    0,    0,    0,  443,   76,    0,    0,   76,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  443,  443,    0,
    0,   76,   76,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  443,
    0,  209,    0,  209,    0,    0,    0,    0,    0,  209,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  209,
  209,  209,  209,  209,    0,    0,  209,  209,  209,  209,
  209,    0,  209,  209,  209,    0,  209,  209,  209,  209,
  209,  209,  209,  209,  209,  209,   76,  209,  209,  209,
  209,  209,  209,  209,  209,  209,  209,  209,  209,    0,
    0,    0,  209,  209,    0,    0,  209,  209,    0,  209,
  209,  209,  209,  209,    0,  209,  209,    0,  209,  209,
  209,    0,  209,    0,    0,  209,  192,    0,  192,    0,
    0,    0,    0,    0,  192,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  192,  192,  192,  192,  192,    0,
    0,  192,  192,  192,  192,  192,    0,  192,  192,  192,
    0,  192,  192,  192,  192,  192,  192,  192,  192,  192,
  192,    0,  192,  192,  192,  192,  192,  192,  192,  192,
  192,  192,  192,  192,    0,    0,    0,  192,  192,    0,
    0,  192,  192,    0,  192,  192,  192,  192,  192,    0,
  192,  192,    0,  192,  192,  192,    0,  192,   26,    0,
  192,    0,    0,    0,    0,    0,    0,    0,    0,   76,
    0,    0,    0,    0,    0,    0,    0,   76,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   76,   76,   76,
   76,   76,    0,    0,   76,   76,   76,   76,   76,    0,
   76,   76,   76,    0,   76,    0,    0,   76,   76,   76,
   76,   76,   76,   76,    0,   76,   76,   76,   76,   76,
   76,   76,   76,   76,   76,   76,   76,    0,    0,    0,
   76,   76,    0,    0,   76,   76,    0,   76,   76,   76,
   76,   76,  651,   76,   76,  651,   76,   76,   76,    0,
   76,    0,    0,   76,    0,  445,  634,    0,  445,  634,
  651,    0,  651,    0,  636,    0,    0,  636,    0,    0,
    0,    0,  445,  445,  634,    0,  634,  445,    0,    0,
    0,    0,  636,    0,  636,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  651,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  445,  634,    0,
    0,  655,    0,    0,  655,    0,  636,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  651,    0,    0,  655,
    0,  655,    0,    0,    0,    0,    0,    0,  445,  445,
  634,    0,    0,    0,    0,  233,    0,    0,  636,    0,
  231,   26,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  655,    0,    0,    0,    0,    0,    0,
    0,    0,   18,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  131,  151,  655,  234,    0,   19,    0,
    0,  152,  233,    0,    0,    0,    0,  231,   26,  134,
    0,  135,    0,   20,   21,   22,    0,    0,    0,    0,
    0,    0,   23,  136,    0,  137,    0,    0,    0,  138,
  139,  232,    0,    0,  140,    0,    0,  141,    0,   24,
    0,    0,    0,  142,    0,    0,    0,    0,   25,  143,
    0,    0,    0,  234,    0,    0,    0,    0,    0,  233,
    0,    0,    0,    0,  231,   26,    0,    0,    0,    0,
  445,    0,    0,    0,    0,    0,    0,    0,    0,  651,
  651,  651,    0,    0,    0,    0,  445,  445,  232,    0,
    0,  651,  445,  634,  634,  634,    0,    0,    0,    0,
    0,  636,  636,  636,    0,  634,  445,  445,    0,    0,
  234,    0,    0,  636,    0,    0,    0,  651,    0,    0,
  651,  651,    0,    0,  651,    0,    0,    0,  445,    0,
  651,  634,    0,  651,  634,  634,    0,    0,  634,  636,
  651,    0,  636,  636,  634,  232,  636,  634,  655,  655,
  655,    0,  636,    0,  634,  636,    0,    0,    0,    0,
  655,  463,  636,    0,  217,   18,  218,  219,  220,    0,
    0,    0,    0,    0,  221,    0,    0,    0,    0,    0,
  299,  300,  233,    0,    0,    0,  655,  231,   26,  655,
  655,   19,    0,  655,    0,    0,    0,    0,    0,  655,
    0,    0,  655,    0,    0,  301,   20,   21,   22,  655,
    0,    0,    0,  302,    0,   23,    0,  303,  465,    0,
  228,  217,   18,  218,  219,  220,    0,    0,    0,    0,
    0,  221,   24,  234,    0,    0,    0,  299,  300,  304,
    0,   25,    0,    0,    0,    0,    0,    0,   19,    0,
    0,  233,    0,    0,    0,    0,  231,   26,    0,    0,
    0,    0,  301,   20,   21,   22,    0,    0,  232,    0,
  302,    0,   23,    0,  303,  467,    0,  228,  217,   18,
  218,  219,  220,    0,    0,    0,    0,    0,  221,   24,
    0,    0,    0,    0,  299,  300,  304,    0,   25,    0,
    0,    0,  234,    0,    0,   19,    0,    0,  233,    0,
    0,    0,    0,  231,   26,    0,    0,    0,    0,  301,
   20,   21,   22,    0,    0,    0,    0,  302,    0,   23,
    0,  303,    0,    0,  228,    0,    0,  232,    0,    0,
    0,    0,    0,    0,    0,    0,   24,    0,    0,    0,
    0,    0,    0,  304,    0,   25,    0,    0,    0,  234,
    0,    0,    0,    0,    0,  233,    0,    0,    0,    0,
  231,   26,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  232,    0,    0,    0,  469,    0,
    0,  217,   18,  218,  219,  220,    0,    0,    0,    0,
    0,  221,    0,    0,    0,    0,  234,  299,  300,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   19,    0,
    0,    0,    0,    0,  233,    0,    0,    0,    0,  231,
   26,    0,  301,   20,   21,   22,    0,    0,    0,    0,
  302,  232,   23,    0,  303,    0,    0,  228,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  471,    0,   24,
  217,   18,  218,  219,  220,    0,  304,    0,   25,    0,
  221,    0,    0,  361,  355,  234,  299,  300,  360,  358,
    0,  359,    0,  362,    0,    0,    0,   19,    0,    0,
    0,    0,    0,    0,  233,    0,  357,    0,  356,  231,
   26,  301,   20,   21,   22,    0,    0,    0,    0,  302,
  232,   23,    0,  303,  473,    0,  228,  217,   18,  218,
  219,  220,    0,    0,    0,    0,    0,  221,   24,    0,
  354,    0,    0,  299,  300,  304,    0,   25,    0,    0,
    0,    0,    0,    0,   19,  234,    0,    0,    0,    0,
    0,  233,    0,    0,    0,    0,  231,   26,  301,   20,
   21,   22,    0,    0,    0,    0,  302,    0,   23,    0,
  303,  475,    0,  228,  217,   18,  218,  219,  220,    0,
  232,    0,    0,    0,  221,   24,    0,    0,    0,    0,
  299,  300,  304,    0,   25,    0,    0,    0,    0,    0,
    0,   19,  234,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  233,  301,   20,   21,   22,  231,
   26,    0,    0,  302,    0,   23,    0,  303,    0,    0,
  228,    0,    0,    0,    0,    0,    0,  232,    0,    0,
  477,    0,   24,  217,   18,  218,  219,  220,    0,  304,
    0,   25,    0,  221,    0,    0,    0,    0,    0,  299,
  300,    0,    0,    0,    0,  234,    0,    0,    0,    0,
   19,    0,    0,    0,    0,    0,    0,  233,    0,    0,
    0,    0,  231,   26,  301,   20,   21,   22,    0,    0,
    0,    0,  302,    0,   23,    0,  303,    0,    0,  228,
  232,  344,  345,  346,  347,    0,  348,  349,    0,    0,
  480,   24,    0,  217,   18,  218,  219,  220,  304,    0,
   25,    0,    0,  221,    0,    0,    0,    0,  234,  299,
  300,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   19,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  301,   20,   21,   22,    0,    0,
    0,    0,  302,  232,   23,    0,  303,  482,    0,  228,
  217,   18,  218,  219,  220,    0,    0,  233,    0,    0,
  221,   24,  231,   26,    0,    0,  299,  300,  304,    0,
   25,    0,    0,    0,    0,  233,    0,   19,    0,    0,
  231,   26,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  301,   20,   21,   22,    0,    0,    0,    0,  302,
    0,   23,    0,  303,    0,    0,  228,    0,  234,    0,
  484,    0,    0,  217,   18,  218,  219,  220,   24,    0,
    0,    0,    0,  221,    0,  304,  234,   25,    0,  299,
  300,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   19,    0,    0,  232,  233,    0,    0,    0,    0,  231,
   26,    0,    0,    0,  301,   20,   21,   22,    0,    0,
    0,  232,  302,    0,   23,    0,  303,    0,    0,  228,
    0,    0,    0,  486,    0,    0,  217,   18,  218,  219,
  220,   24,    0,    0,    0,    0,  221,    0,  304,    0,
   25,    0,  299,  300,    0,  234,    0,    0,    0,    0,
    0,  233,    0,   19,    0,    0,  231,   26,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  301,   20,   21,
   22,    0,    0,    0,    0,  302,    0,   23,    0,  303,
  232,    0,  228,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   24,    0,    0,    0,    0,    0,
    0,  304,  234,   25,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  233,    0,    0,    0,    0,  231,   26,
    0,    0,    0,  488,    0,    0,  217,   18,  218,  219,
  220,    0,    0,    0,    0,    0,  221,  232,    0,    0,
    0,  490,  299,  300,  217,   18,  218,  219,  220,    0,
    0,    0,    0,   19,  221,  155,    0,    0,    0,    0,
  299,  300,    0,    0,  234,    0,    0,  301,   20,   21,
   22,   19,    0,    0,    0,  302,    0,   23,    0,  303,
    0,    0,  228,    0,    0,  301,   20,   21,   22,    0,
    0,    0,    0,  302,   24,   23,    0,  303,    0,  232,
  228,  304,    0,   25,    0,    0,    0,    0,    0,    0,
  492,    0,   24,  217,   18,  218,  219,  220,    0,  304,
    0,   25,    0,  221,    0,    0,    0,    0,    0,  299,
  300,  233,  155,    0,  324,    0,  231,   26,    0,    0,
   19,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  301,   20,   21,   22,    0,    0,
    0,    0,  302,    0,   23,    0,  303,  494,    0,  228,
  217,   18,  218,  219,  220,    0,    0,    0,    0,    0,
  221,   24,  234,    0,    0,    0,  299,  300,  304,    0,
   25,    0,    0,  233,    0,    0,    0,   19,  231,   26,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  301,   20,   21,   22,    0,    0,  232,    0,  302,
    0,   23,    0,  303,    0,    0,  228,    0,    0,  496,
    0,    0,  217,   18,  218,  219,  220,    0,   24,    0,
    0,    0,  221,  160,  234,  304,    0,   25,  299,  300,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   19,
    0,    0,    0,    0,    0,    0,    0,  155,    0,  155,
    0,    0,    0,  301,   20,   21,   22,    0,    0,  232,
    0,  302,    0,   23,    0,  303,    0,  324,  228,    0,
  155,  155,    0,    0,  155,  155,    0,    0,  155,    0,
   24,    0,  159,    0,  155,  155,  155,  304,  155,   25,
  155,  155,  155,    0,    0,  155,  155,  155,  155,  155,
  155,    0,  155,    0,    0,    0,  155,  155,    0,    0,
  155,  155,    0,  155,  155,  155,  155,  155,    0,  155,
  155,    0,  155,    0,  155,  155,  155,  498,    0,  155,
  217,   18,  218,  219,  220,    0,    0,    0,    0,    0,
  221,    0,    0,    0,    0,    0,  299,  300,    0,    0,
    0,    0,    0,  361,  355,    0,    0,   19,  360,  358,
    0,  359,    0,  362,    0,    0,    0,    0,    0,    0,
    0,  301,   20,   21,   22,    0,  357,    0,  356,  302,
    0,   23,    0,  303,    0,    0,  228,    0,    0,    0,
    0,    0,  217,   18,  218,  219,  220,    0,   24,    0,
    0,    0,  221,    0,    0,  304,    0,   25,  299,  300,
  354,    0,    0,    0,    0,    0,    0,    0,    0,   19,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  301,   20,   21,   22,  160,    0,    0,
  353,  302,    0,   23,    0,  303,    0,    0,  228,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  160,  160,
   24,    0,    0,  160,    0,    0,  160,  304,    0,   25,
    0,    0,    0,    0,  160,    0,  160,    0,  160,  160,
  160,    0,    0,    0,    0,    0,    0,  160,  160,    0,
  160,    0,    0,    0,  160,  160,  159,    0,    0,  160,
    0,    0,  160,    0,  160,    0,    0,    0,  160,    0,
    0,    0,    0,  160,  160,    0,    0,  159,  159,    0,
    0,    0,  159,    0,    0,  159,    0,    0,    0,    0,
    0,    0,    0,  159,    0,  159,    0,  159,  159,  159,
    0,    0,    0,    0,    0,    0,  159,  159,    0,  159,
    0,    0,    0,  159,  159,    0,    0,    0,  159,    0,
    0,  159,    0,  159,    0,    0,    0,  159,    0,    0,
  487,  487,  159,  159,  487,  487,  487,  487,  487,    0,
  487,  344,  345,  346,  347,    0,  348,  349,    0,    0,
    0,  487,  487,  487,    0,  487,  487,    0,    0,  482,
  482,    0,    0,  482,  482,  482,  482,  482,    0,  482,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  482,  482,  482,    0,  482,  482,  487,  487,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  483,  483,
    0,    0,  483,  483,  483,  483,  483,    0,  483,    0,
    0,    0,    0,    0,    0,  482,  482,  487,  487,  483,
  483,  483,    0,  483,  483,    0,    0,    0,  456,    0,
    0,  456,    0,  456,  456,  456,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  482,  482,  456,  456,
  456,    0,  456,  456,  483,  483,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  457,    0,    0,
  457,    0,  457,  457,  457,    0,    0,    0,    0,    0,
    0,    0,    0,  456,  456,  483,  483,  457,  457,  457,
    0,  457,  457,    0,    0,    0,  454,    0,    0,  454,
    0,    0,  454,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  456,  456,  454,  454,  454,    0,
  454,  454,  457,  457,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  487,
    0,  454,  454,  457,  457,    0,    0,    0,  487,  487,
  487,  487,    0,  487,  487,  487,  487,    0,    0,    0,
    0,  487,    0,    0,    0,    0,    0,    0,  482,    0,
    0,    0,  454,  454,    0,  487,  487,  482,  482,  482,
  482,    0,  482,  482,  482,  482,    0,    0,    0,    0,
  482,    0,    0,    0,    0,    0,    0,  487,    0,    0,
    0,    0,    0,    0,  482,  482,    0,  483,    0,    0,
    0,    0,    0,    0,    0,    0,  483,  483,  483,  483,
    0,  483,  483,  483,  483,    0,  482,    0,    0,  483,
    0,    0,    0,    0,    0,    0,  456,    0,    0,    0,
    0,    0,    0,  483,  483,  456,  456,  456,  456,    0,
  456,  456,  456,  456,    0,    0,    0,    0,  456,    0,
    0,    0,    0,    0,    0,  483,    0,    0,    0,    0,
    0,    0,  456,  456,    0,  457,    0,    0,    0,    0,
    0,    0,    0,    0,  457,  457,  457,  457,    0,  457,
  457,  457,  457,    0,  456,    0,    0,  457,    0,    0,
    0,    0,    0,  455,  454,    0,  455,    0,    0,  455,
    0,  457,  457,  454,  454,  454,  454,    0,  454,  454,
  454,  454,    0,  455,  455,  455,  454,  455,  455,    0,
    0,    0,  451,  457,    0,  451,    0,    0,  451,    0,
  454,  454,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  451,  451,  451,    0,  451,  451,  455,  455,
    0,    0,  454,    0,    0,    0,    0,    0,    0,    0,
    0,  453,    0,    0,  453,    0,    0,  453,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  451,  451,  455,
  455,  453,  453,  453,    0,  453,  453,    0,    0,    0,
  450,    0,    0,  450,    0,    0,  450,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  451,  451,
  450,  450,  450,    0,  450,  450,  453,  453,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  452,
    0,    0,  452,    0,    0,  452,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  450,  450,  453,  453,  452,
  452,  452,    0,  452,  452,    0,    0,    0,  449,    0,
    0,  449,    0,    0,  449,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  450,  450,  449,  449,
    0,    0,    0,  449,  452,  452,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  455,    0,  449,  449,  452,  452,    0,    0,    0,
  455,  455,  455,  455,    0,  455,  455,  455,  455,    0,
    0,    0,    0,  455,    0,    0,    0,    0,    0,    0,
  451,    0,    0,    0,  449,  449,    0,  455,  455,  451,
  451,  451,  451,    0,    0,    0,  451,  451,    0,    0,
    0,    0,  451,    0,    0,    0,    0,    0,    0,  455,
    0,    0,    0,    0,    0,    0,  451,  451,    0,  453,
    0,    0,    0,    0,    0,    0,    0,    0,  453,  453,
  453,  453,    0,    0,    0,  453,  453,    0,  451,    0,
    0,  453,    0,    0,    0,    0,    0,    0,  450,    0,
    0,    0,    0,    0,    0,  453,  453,  450,  450,  450,
  450,    0,    0,    0,  450,  450,    0,    0,    0,    0,
  450,    0,    0,    0,    0,    0,    0,  453,    0,    0,
  447,    0,    0,  447,  450,  450,  447,  452,    0,    0,
    0,    0,    0,    0,    0,    0,  452,  452,  452,  452,
  447,  447,    0,  452,  452,  447,  450,    0,    0,  452,
    0,    0,  446,    0,    0,  446,  449,    0,    0,    0,
    0,    0,    0,  452,  452,  449,    0,    0,  449,  446,
  446,    0,  449,  449,  446,  447,  447,    0,  449,    0,
    0,    0,    0,    0,    0,  452,    0,    0,    0,    0,
    0,    0,  449,  449,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  446,  446,  447,  447,    0,    0,
    0,    0,    0,    0,  449,    0,  487,  487,    0,    0,
    0,  487,  487,  598,  487,    0,  487,    0,    0,    0,
    0,    0,    0,    0,    0,  446,  446,  487,  487,  487,
    0,  487,  487,  361,  355,    0,    0,    0,  360,  358,
    0,  359,    0,  362,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  357,    0,  356,  352,
    0,    0,  598,  487,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  354,    0,    0,  487,  487,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  353,    0,    0,    0,    0,  208,    0,    0,  447,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  447,  447,    0,    0,    0,    0,
  447,    0,    0,    0,    0,    0,    0,  446,    0,    0,
    0,    0,    0,    0,  447,  447,    0,    0,    0,    0,
    0,    0,    0,  446,  446,    0,    0,    0,    0,  446,
    0,    0,    0,    0,    0,    0,  447,    0,    0,    0,
    0,    0,    0,  446,  446,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  446,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  487,  487,  487,  487,    0,  487,
  487,  487,  487,    0,    0,    0,    0,  487,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  344,  345,  346,  347,   57,  348,  349,  350,  351,
    0,    0,    0,    0,    0,   58,   59,   60,   61,    0,
    0,    0,   62,   63,   64,   65,   66,    0,   67,   68,
   69,    0,   70,    0,    0,   71,   72,   73,   74,   75,
   76,   77,    0,  207,   79,   80,   81,   82,   83,   84,
   85,   86,   87,   88,   89,    0,    0,    0,   90,   91,
    0,    0,   92,   93,    0,   94,   95,   96,   97,   98,
    0,   99,  100,    0,  101,  102,  103,  602,  104,  603,
    0,  105,    0,    0,    0,  604,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  605,  606,  607,  608,    0,
    0,    0,  609,  610,  611,  612,  613,    0,  614,  615,
  616,    0,  617,    0,    0,  618,  619,  620,  621,  622,
  623,  624,  625,  626,  627,  628,  629,  630,  631,  632,
  633,  634,  635,  636,  637,    0,    0,    0,  638,  639,
    0,    0,  640,  641,    0,  642,  643,  644,  645,  646,
    0,  647,  648,    0,  649,  650,  651,    0,  652,  653,
  266,  654,    0,    0,  267,    0,    0,    0,   57,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   58,   59,
   60,   61,    0,    0,    0,   62,   63,   64,   65,   66,
    0,   67,   68,   69,    0,   70,    0,    0,   71,   72,
   73,   74,   75,   76,   77,    0,  268,   79,   80,   81,
   82,   83,   84,   85,   86,   87,   88,   89,    0,    0,
    0,   90,   91,    0,    0,   92,   93,    0,   94,   95,
   96,   97,   98,    0,   99,  100,    0,  101,  102,  103,
  113,  104,    0,    0,  105,    0,    0,    0,   57,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   58,   59,
   60,   61,    0,    0,    0,   62,   63,   64,   65,   66,
    0,   67,   68,   69,    0,   70,    0,    0,   71,   72,
   73,   74,   75,   76,   77,    0,  114,   79,   80,   81,
   82,   83,   84,   85,   86,   87,   88,   89,    0,    0,
    0,   90,   91,    0,    0,   92,   93,    0,   94,   95,
   96,   97,   98,    0,   99,  100,    0,  101,  102,  103,
  121,  104,    0,    0,  105,    0,    0,    0,   57,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   58,   59,
   60,   61,    0,    0,    0,   62,   63,   64,   65,   66,
    0,   67,   68,   69,    0,   70,    0,    0,   71,   72,
   73,   74,   75,   76,   77,    0,  122,   79,   80,   81,
   82,   83,   84,   85,   86,   87,   88,   89,    0,    0,
    0,   90,   91,    0,    0,   92,   93,    0,   94,   95,
   96,   97,   98,    0,   99,  100,    0,  101,  102,  103,
  164,  104,    0,    0,  105,    0,    0,    0,   57,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   58,   59,
   60,   61,    0,    0,    0,   62,   63,   64,   65,   66,
    0,   67,   68,   69,    0,   70,    0,    0,   71,   72,
   73,   74,   75,   76,   77,    0,  165,   79,   80,   81,
   82,   83,   84,   85,   86,   87,   88,   89,    0,    0,
    0,   90,   91,    0,    0,   92,   93,    0,   94,   95,
   96,   97,   98,    0,   99,  100,    0,  101,  102,  103,
  259,  104,    0,    0,  105,    0,    0,    0,   57,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   58,   59,
   60,   61,    0,    0,    0,   62,   63,   64,   65,   66,
    0,   67,   68,   69,    0,   70,    0,    0,   71,   72,
   73,   74,   75,   76,   77,    0,  122,   79,   80,   81,
   82,   83,   84,   85,   86,   87,   88,   89,    0,    0,
    0,   90,   91,    0,    0,   92,   93,    0,   94,   95,
   96,   97,   98,    0,   99,  100,    0,  101,  102,  103,
  521,  104,    0,    0,  105,    0,    0,    0,   57,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   58,   59,
   60,   61,    0,    0,    0,   62,   63,   64,   65,   66,
    0,   67,   68,   69,    0,   70,    0,    0,   71,   72,
   73,   74,   75,   76,   77,    0,  207,   79,   80,   81,
   82,   83,   84,   85,   86,   87,   88,   89,    0,    0,
    0,   90,   91,    0,    0,   92,   93,    0,   94,   95,
   96,   97,   98,    0,   99,  100,    0,  101,  102,  103,
  878,  104,    0,    0,  105,    0,    0,    0,   57,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   58,   59,
   60,   61,    0,    0,    0,   62,   63,   64,   65,   66,
    0,   67,   68,   69,    0,   70,    0,    0,   71,   72,
   73,   74,   75,   76,   77,    0,  879,   79,   80,   81,
   82,   83,   84,   85,   86,   87,   88,   89,    0,    0,
    0,   90,   91,    0,    0,   92,   93,    0,   94,   95,
   96,   97,   98,    0,   99,  100,    0,  101,  102,  103,
  930,  104,    0,    0,  105,    0,    0,    0,   57,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   58,   59,
   60,   61,    0,    0,    0,   62,   63,   64,   65,   66,
    0,   67,   68,   69,    0,   70,    0,    0,   71,   72,
   73,   74,   75,   76,   77,    0,  879,   79,   80,   81,
   82,   83,   84,   85,   86,   87,   88,   89,    0,    0,
    0,   90,   91,    0,    0,   92,   93,    0,   94,   95,
   96,   97,   98,    0,   99,  100,  167,  101,  102,  103,
    0,  104,  167,    0,  105,    0,    0,    0,    0,    0,
    0,    0,  167,  167,  167,  167,    0,    0,    0,  167,
  167,  167,  167,  167,    0,  167,  167,  167,    0,  167,
  167,  167,  167,  167,  167,  167,  167,  167,  167,    0,
  167,  167,  167,  167,  167,  167,  167,  167,  167,  167,
  167,  167,    0,    0,    0,  167,  167,    0,    0,  167,
  167,    0,  167,  167,  167,  167,  167,    0,  167,  167,
   57,  167,  167,  167,    0,  167,    0,    0,  167,    0,
   58,   59,   60,   61,    0,    0,    0,   62,   63,   64,
   65,   66,    0,   67,   68,   69,    0,   70,  528,  529,
   71,   72,   73,   74,   75,   76,   77,    0,    0,   79,
   80,   81,   82,   83,   84,   85,   86,   87,   88,   89,
    0,    0,    0,   90,   91,    0,    0,   92,   93,    0,
   94,   95,   96,   97,   98,    0,   99,  100,   57,  101,
  102,  103,    0,  104,    0,    0,  105,    0,   58,   59,
   60,   61,    0,    0,    0,   62,   63,   64,   65,   66,
    0,   67,   68,   69,    0,   70,    0,    0,   71,   72,
   73,   74,   75,   76,   77,    0,   78,   79,   80,   81,
   82,   83,   84,   85,   86,   87,   88,   89,    0,    0,
    0,   90,   91,    0,    0,   92,   93,    0,   94,   95,
   96,   97,   98,    0,   99,  100,   57,  101,  102,  103,
    0,  104,    0,    0,  105,    0,   58,   59,   60,   61,
    0,    0,    0,   62,   63,   64,   65,   66,    0,   67,
   68,   69,    0,   70,    0,    0,   71,   72,   73,   74,
   75,   76,   77,    0,  158,   79,   80,   81,   82,   83,
   84,   85,   86,   87,   88,   89,    0,    0,    0,   90,
   91,    0,    0,   92,   93,    0,   94,   95,   96,   97,
   98,    0,   99,  100,   57,  101,  102,  103,    0,  104,
    0,    0,  105,    0,   58,   59,   60,   61,    0,    0,
    0,   62,   63,   64,   65,   66,    0,   67,   68,   69,
    0,   70,    0,    0,   71,   72,   73,   74,   75,   76,
   77,    0,  160,   79,   80,   81,   82,   83,   84,   85,
   86,   87,   88,   89,    0,    0,    0,   90,   91,    0,
    0,   92,   93,    0,   94,   95,   96,   97,   98,    0,
   99,  100,   57,  101,  102,  103,    0,  104,    0,    0,
  105,    0,   58,   59,   60,   61,    0,    0,    0,   62,
   63,   64,   65,   66,    0,   67,   68,   69,    0,   70,
    0,    0,   71,   72,   73,   74,   75,   76,   77,    0,
  175,   79,   80,   81,   82,   83,   84,   85,   86,   87,
   88,   89,    0,    0,    0,   90,   91,    0,    0,   92,
   93,    0,   94,   95,   96,   97,   98,    0,   99,  100,
   57,  101,  102,  103,    0,  104,    0,    0,  105,    0,
   58,   59,   60,   61,    0,    0,    0,   62,   63,   64,
   65,   66,    0,   67,   68,   69,    0,   70,    0,    0,
   71,   72,   73,   74,   75,   76,   77,    0,  413,   79,
   80,   81,   82,   83,   84,   85,   86,   87,   88,   89,
    0,    0,    0,   90,   91,    0,    0,   92,   93,    0,
   94,   95,   96,   97,   98,    0,   99,  100,   57,  101,
  102,  103,    0,  104,    0,    0,  105,    0,   58,   59,
   60,   61,    0,    0,    0,   62,   63,   64,   65,   66,
    0,   67,   68,   69,    0,   70,    0,    0,   71,   72,
   73,   74,   75,   76,   77,    0,  429,   79,   80,   81,
   82,   83,   84,   85,   86,   87,   88,   89,    0,    0,
    0,   90,   91,    0,    0,   92,   93,    0,   94,   95,
   96,   97,   98,    0,   99,  100,   57,  101,  102,  103,
    0,  104,    0,    0,  105,    0,   58,   59,   60,   61,
    0,    0,    0,   62,   63,   64,   65,   66,    0,   67,
   68,   69,    0,   70,    0,    0,   71,   72,   73,   74,
   75,   76,   77,    0,  559,   79,   80,   81,   82,   83,
   84,   85,   86,   87,   88,   89,    0,    0,    0,   90,
   91,    0,    0,   92,   93,    0,   94,   95,   96,   97,
   98,    0,   99,  100,   57,  101,  102,  103,    0,  104,
    0,    0,  105,    0,   58,   59,   60,   61,    0,    0,
    0,   62,   63,   64,   65,   66,    0,   67,   68,   69,
    0,   70,    0,    0,   71,   72,   73,   74,   75,   76,
   77,    0,  705,   79,   80,   81,   82,   83,   84,   85,
   86,   87,   88,   89,    0,    0,    0,   90,   91,    0,
    0,   92,   93,    0,   94,   95,   96,   97,   98,    0,
   99,  100,   57,  101,  102,  103,    0,  104,    0,    0,
  105,    0,   58,   59,   60,   61,    0,    0,    0,   62,
   63,   64,   65,   66,    0,   67,   68,   69,    0,   70,
    0,    0,   71,   72,   73,   74,   75,   76,   77,    0,
  712,   79,   80,   81,   82,   83,   84,   85,   86,   87,
   88,   89,    0,    0,    0,   90,   91,    0,    0,   92,
   93,    0,   94,   95,   96,   97,   98,    0,   99,  100,
   57,  101,  102,  103,    0,  104,    0,    0,  105,    0,
   58,   59,   60,   61,    0,    0,    0,   62,   63,   64,
   65,   66,    0,   67,   68,   69,    0,   70,    0,    0,
   71,   72,   73,   74,   75,   76,   77,    0,  207,   79,
   80,   81,   82,   83,   84,   85,   86,   87,   88,   89,
    0,    0,    0,   90,   91,    0,    0,   92,   93,    0,
   94,   95,   96,   97,   98,    0,   99,  100,   57,  101,
  102,  103,    0,  104,    0,    0,  105,    0,   58,   59,
   60,   61,    0,    0,    0,   62,   63,   64,   65,   66,
    0,   67,   68,   69,    0,   70,    0,    0,   71,   72,
   73,   74,   75,   76,   77,    0,  827,   79,   80,   81,
   82,   83,   84,   85,   86,   87,   88,   89,    0,    0,
    0,   90,   91,    0,    0,   92,   93,    0,   94,   95,
   96,   97,   98,    0,   99,  100,   54,  101,  102,  103,
    0,  104,    0,    0,  105,    0,   54,   54,   54,   54,
    0,    0,    0,   54,   54,   54,   54,   54,    0,   54,
   54,   54,    0,   54,    0,    0,   54,   54,   54,   54,
   54,   54,   54,    0,   54,   54,   54,   54,   54,   54,
   54,   54,   54,   54,   54,   54,    0,    0,    0,   54,
   54,    0,    0,   54,   54,    0,   54,   54,   54,   54,
   54,    0,   54,   54,  168,   54,   54,   54,    0,   54,
    0,    0,   54,    0,  168,  168,  168,  168,    0,    0,
    0,  168,  168,  168,  168,  168,    0,  168,  168,  168,
    0,  168,    0,    0,  168,  168,  168,  168,  168,  168,
  168,    0,  168,  168,  168,  168,  168,  168,  168,  168,
  168,  168,  168,  168,    0,    0,    0,  168,  168,    0,
    0,  168,  168,    0,  168,  168,  168,  168,  168,    0,
  168,  168,    0,  168,  168,  168,    0,  168,    0,    0,
  168,
};
static const YYINT yycheck[] = {                          5,
   19,  127,   49,   46,    2,   19,   53,  150,   27,   45,
  256,   59,  225,   27,  215,  458,  515,   59,  352,  279,
   30,  519,   59,   44,   41,   41,   45,   58,   59,  239,
  240,   45,   41,   45,  294,  208,   43,   58,   46,   41,
   40,  239,  761,   49,  286,   44,   59,   53,  168,   46,
   59,  171,  172,  171,  172,  124,   41,  219,  220,   40,
   59,  597,  781,  125,  125,   46,   41,    5,   40,   44,
  278,   41,  286,   40,   46,   41,  260,  125,  240,  329,
   41,   41,   44,   41,   59,   58,   41,  249,  301,   44,
  302,  110,  111,   59,  125,   41,  110,  111,  308,  312,
  335,  120,   41,   58,   59,   41,  120,  305,   63,  125,
   91,   49,  126,  127,   44,   53,  125,   59,   93,   91,
  330,   41,  124,   59,  130,  335,  310,  146,   58,   58,
  338,  381,  146,   93,  144,   93,   40,  397,   93,  502,
  125,   93,  189,   41,  306,  307,  193,   41,  310,  286,
  125,  124,   41,   41,   93,  174,  203,   93,   41,  125,
  174,  208,  661,  124,  183,  809,  213,   40,   58,  183,
  125,   59,  124,  335,  336,  711,  186,  437,   41,  125,
   43,   59,  826,  189,   44,  228,   44,  193,  256,  125,
  450,  311,  130,  240,   46,   58,   59,  203,   40,  302,
  320,  321,  208,   59,   93,  451,   44,  213,  256,  329,
  330,  446,   40,  211,  460,  416,  278,  278,  260,  123,
  256,  422,  286,  292,  293,  261,  240,  125,  238,  286,
  278,  125,  279,   93,  240,   93,  446,  125,  285,   58,
   59,  278,  125,  256,  742,  743,   61,  278,  458,  261,
  123,  189,  260,  260,  192,  193,  256,  305,  378,  519,
  380,  381,  382,  383,  384,  203,  276,  601,  310,  278,
  208,  292,  293,  279,  212,  213,  257,  296,  286,  285,
  286,  454,  296,  330,  446,  257,  448,   61,  335,  286,
  262,  263,  305,  301,  302,  303,  458,  314,  314,  318,
  285,  256,  310,  278,  318,  314,  125,  343,  314,   40,
  295,  278,  278,  433,  677,  285,  330,  272,  273,  327,
  363,  335,   44,  278,  330,  295,   59,  256,  336,  335,
  292,  293,  452,  376,  377,  273,  379,  292,  293,  285,
  839,  279,  278,  285,  314,  392,  285,  285,  286,  295,
   59,   49,  256,  295,   40,   53,  295,   44,   40,  314,
  341,  342,  292,  293,  411,  285,  721,  386,  314,  341,
  342,  734,  386,   49,  278,  295,  382,   53,  256,  389,
  278,   44,  502,  256,  278,  428,  392,  285,  314,   40,
  278,  285,  125,  256,  893,  278,  285,  295,   40,  446,
  278,  295,  292,  293,  423,  411,  295,  454,  260,  423,
  765,  458,   93,   40,  256,   41,  125,   41,  256,   61,
  680,  541,  278,  286,  219,  220,  221,  305,  256,  285,
  550,   41,  446,   59,  286,   59,  231,  232,  125,  295,
  446,  236,  237,   41,  458,  240,   43,   44,  454,  301,
  302,  303,  458,   40,  392,  575,  382,  559,  310,  278,
  782,   40,  125,   59,   41,   41,  285,   44,  256,  589,
   41,   44,  592,  411,  192,  327,  295,   40,  724,  599,
  600,   58,   59,   59,  336,   58,  808,   58,   59,   41,
  278,  189,   41,  221,  212,  193,  502,   40,  758,  125,
   41,  125,   41,  231,  232,  203,  512,   59,  236,  237,
   41,  239,  240,  189,  124,  213,  454,  193,   59,  962,
  963,  249,   46,  786,  543,  256,  124,  203,   41,  543,
   43,   44,  208,   44,  256,  330,  555,  213,  981,  258,
  335,  555,  805,  686,  745,  278,  123,  123,   59,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  688,  278,
  688,  123,   41,   40,  787,  124,  502,  305,  306,  307,
  700,  279,  310,  905,  125,  124,  512,  285,   46,  285,
   59,  278,  123,  806,   61,  715,  809,  715,  718,  295,
  718,   59,  330,  279,  285,  256,   59,  335,  336,  285,
  712,  742,  743,  826,  295,  278,  344,  345,  346,  347,
  348,  349,  350,  351,  352,  353,  354,  355,  356,  357,
  358,  359,  360,  361,  362,  682,  123,  279,  280,   44,
  123,   58,   59,   41,  764,   59,  766,  694,  290,   59,
  697,  446,  278,   58,  278,   41,  125,  704,   40,  256,
  873,   59,  124,  458,   46,  791,   59,   59,   61,   61,
  123,  677,   58,   59,  316,  777,  682,  319,  320,  256,
  256,  323,  278,   59,   59,  256,  756,  329,  694,  285,
  332,  697,   40,  736,  392,   44,   43,  339,  704,  295,
  770,  278,  278,   59,  256,  752,   59,   93,  125,  756,
   59,  125,   40,  411,  767,  125,  392,   40,  446,  772,
  448,   44,  286,  770,   40,  256,  278,  125,  734,  748,
  458,   40,  125,  125,  748,  411,   59,  278,   41,  125,
   61,  788,  789,  256,  682,   61,  752,  278,  746,  125,
  756,  677,  962,  963,   41,   38,  694,   44,   41,  697,
   41,   44,  781,   41,  770,  261,  704,  781,   43,   44,
  123,  981,  123,  256,   41,   58,   59,  791,  454,   44,
   63,  123,  788,  789,  803,  292,  293,   41,  908,  803,
  908,  911,  912,  911,  912,  278,  123,  285,   93,  842,
  962,  963,  808,  256,   58,   59,  601,  295,  734,  278,
   93,   94,  279,  280,  752,  834,   40,  893,  756,  981,
  834,   44,   46,  290,  944,  278,  292,  293,   44,  835,
   44,  302,  770,  839,   40,   40,   59,   61,  260,   44,
  846,  124,  125,   59,  920,   59,  889,  890,   41,  316,
  788,  789,  319,  320,   59,  898,  323,  900,  901,  935,
   44,  278,  329,    0,  278,  332,   41,   91,  278,  292,
  293,   41,  339,  601,   61,  292,  293,  259,  260,  261,
  278,   61,  808,  788,  789,  278,  278,   41,  894,   44,
  124,  897,  278,  275,  276,  914,   44,   41,  125,  905,
  914,   93,  278,  256,  286,  256,  292,  293,  846,   46,
   44,   93,  918,   58,  256,  962,  963,  923,  300,  301,
  302,  303,  302,  302,   41,  278,  308,  278,  310,  256,
  312,   93,   93,  315,  981,   44,  278,  943,   61,   44,
   58,  947,  948,  949,  950,  327,  261,   41,  962,  963,
   40,  278,  334,   44,  336,  961,  962,  963,   61,   44,
  966,  967,  968,  279,  280,   61,  256,  981,   41,  975,
   41,  897,   93,  256,  290,  981,  123,  983,  984,  905,
   40,  256,  265,  989,  682,  268,  123,   93,   37,  272,
  273,   41,   61,   42,   41,  278,  694,  923,   47,  697,
  316,   61,  256,  319,  320,   61,  682,  323,   40,  292,
  293,   58,   59,  329,   37,   93,  332,   41,  694,   42,
   43,  697,   45,  339,   47,   41,   93,   41,  704,  302,
   41,  314,  302,  257,   61,  961,   58,   40,  262,  263,
   61,  967,  968,   58,   61,   40,   93,   58,   59,  975,
   41,  256,   43,   44,  752,  279,  280,   40,  984,   40,
   40,   59,  294,  989,  285,  123,  290,   58,   59,   40,
   41,  292,  293,   44,  295,  286,  752,   59,  125,   37,
  756,   59,   93,   93,   42,   43,   41,   45,   59,   47,
   61,   58,  316,  302,  770,  319,  320,   41,  953,  323,
   41,  956,  957,   41,  302,  329,   41,   40,  332,  964,
   46,   41,  788,  789,  125,  339,   41,  341,  342,  592,
  668,  258,   93,  260,   61,  873,  312,  235,  235,  575,
   37,  963,  987,  840,  717,   42,   43,  871,   45,  983,
   47,  146,  981,  286,  281,  282,  850,  682,  285,  286,
  854,  137,  289,   60,  125,   62,  174,  142,  295,  296,
  297,  865,  299,  416,  301,  302,  303,  962,  963,  306,
  307,  308,  309,  310,  311,  914,  313,   -1,  748,   -1,
  317,  318,  886,   -1,  321,  322,  981,  324,  325,  326,
  327,  328,   -1,  330,  331,   -1,  333,   -1,  335,  336,
  337,   37,   38,  340,   40,   41,   42,   43,   44,   45,
   46,   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  279,
  280,   -1,   58,   59,   60,   61,   62,   63,  221,   -1,
  290,  278,   -1,   -1,  962,  963,   -1,   -1,  231,  232,
   -1,   -1,   -1,  236,  237,  292,  293,  270,  271,   -1,
   -1,  955,   -1,  981,   -1,   91,  316,   93,   94,  319,
  320,  965,   -1,  323,   -1,  256,   -1,  278,   -1,  329,
   -1,   -1,  332,  835,  978,   -1,   -1,  839,   -1,  339,
   -1,  292,  293,   -1,   -1,  256,   -1,  123,  124,  125,
   37,   38,   -1,   40,   41,   42,   43,   44,   45,   46,
   47,   -1,   -1,   -1,   -1,   -1,   -1,  278,  279,  280,
   -1,   58,   59,   60,   61,   62,   63,   -1,   -1,  290,
  256,   -1,   -1,   -1,  260,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  894,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  279,  280,   91,  316,   93,   94,  319,  320,
  286,   -1,  323,  290,   -1,   -1,  918,   -1,  329,  266,
  267,  332,   -1,  270,  271,  301,  302,  303,  339,   -1,
   -1,   -1,   -1,   -1,  310,   -1,  123,  124,  125,  316,
   -1,  943,  319,  320,   -1,  947,  323,  949,  950,   -1,
   -1,  327,  329,   -1,   59,  332,   61,   -1,   -1,   -1,
  336,   -1,  339,   -1,  966,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  256,  257,  258,   -1,   -1,   -1,  262,  263,  264,  265,
  266,  267,  268,   -1,  270,  271,  272,  273,  274,  275,
  276,  277,  278,  279,  280,  281,  282,  283,  284,  285,
  286,  287,  288,  289,  290,  291,  292,  293,  294,  295,
  296,  297,  298,  299,  300,   -1,  302,  303,  304,  305,
  306,  307,  308,  309,  310,  311,  312,  313,  314,   -1,
  316,  317,  318,  319,  320,  321,  322,  323,  324,  325,
  326,  327,  328,  329,  330,  331,  332,  333,  334,  335,
   -1,  337,   -1,  339,  340,  341,  342,   41,   -1,  256,
  257,  258,   46,   -1,   -1,  262,  263,  264,  265,  266,
  267,  268,   -1,  270,  271,  272,  273,  274,  275,  276,
  277,  278,  279,  280,  281,  282,  283,  284,  285,   -1,
  287,  288,  289,  290,  291,  292,  293,  294,  295,  296,
  297,  298,  299,  300,   -1,  302,  303,  304,  305,  306,
  307,  308,  309,  310,  311,  312,  313,  314,  123,  316,
  317,  318,  319,  320,  321,  322,  323,  324,  325,  326,
  327,  328,  329,  330,  331,  332,  333,  334,  335,   -1,
  337,   -1,  339,  340,  341,  342,   37,   38,   -1,   40,
   41,   42,   43,   44,   45,   46,   47,   -1,   -1,  897,
   -1,   -1,   -1,  278,  279,  280,   -1,   58,   59,   60,
   61,   62,   63,   -1,   -1,  290,   -1,  344,  345,  346,
  347,  348,  349,  350,  351,  923,  353,  354,  355,  356,
  357,  358,  359,  360,  361,  362,   -1,   -1,   -1,   -1,
   91,  316,   93,   94,  319,  320,   -1,   -1,  323,   -1,
   -1,   -1,   -1,   -1,  329,   -1,   -1,  332,   -1,   -1,
   -1,   -1,   -1,  961,  339,   -1,   -1,   -1,   -1,  967,
  968,   -1,  123,  124,  125,   37,   38,  975,   40,   41,
   42,   43,   44,   45,   -1,   47,  984,   -1,   -1,   -1,
   -1,  989,   -1,  258,   -1,   -1,   58,   59,   60,   61,
   62,   63,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  256,   -1,   -1,   -1,  260,   -1,   -1,   -1,
  285,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   91,
  295,   93,   94,   -1,   -1,   -1,   -1,  281,  282,   -1,
   -1,  306,  286,   -1,   -1,  289,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  297,   -1,  299,   -1,  301,  302,  303,
   -1,   -1,  124,  125,   -1,   -1,  310,  311,  333,  313,
   -1,   -1,   -1,  317,  318,   -1,   -1,   -1,  322,   -1,
   59,  325,   61,  327,   -1,   -1,   -1,  331,   -1,   -1,
   -1,   -1,  336,  337,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  256,  257,  258,   -1,   -1,
   -1,  262,  263,  264,  265,  266,  267,  268,   -1,  270,
  271,  272,  273,  274,  275,  276,  277,  278,  279,  280,
  281,  282,  283,  284,  285,   -1,  287,  288,  289,  290,
  291,  292,  293,  294,  295,  296,  297,  298,  299,  300,
   -1,  302,  303,  304,  305,  306,  307,  308,  309,  310,
  311,  312,  313,  314,   -1,  316,  317,  318,  319,  320,
  321,  322,  323,  324,  325,  326,  327,  328,  329,  330,
  331,  332,  333,  334,  335,   -1,  337,   -1,  339,  340,
  341,  342,   41,   -1,   -1,  257,   -1,   46,   -1,   -1,
  262,  263,  264,  265,  266,  267,  268,   -1,  270,  271,
  272,  273,  274,  275,  276,  277,  278,  279,  280,  281,
  282,  283,  284,  285,   -1,  287,  288,  289,  290,  291,
  292,  293,  294,  295,  296,  297,  298,  299,  300,   -1,
  302,  303,  304,  305,  306,  307,  308,  309,  310,  311,
  312,  313,   -1,   -1,  316,  317,  318,  319,  320,  321,
  322,  323,  324,  325,  326,  327,  328,  329,  330,  331,
  332,  333,  334,  335,  123,  337,   -1,  339,  340,  341,
  342,   37,   38,   -1,   40,   -1,   42,   43,   44,   45,
   46,   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  278,
  279,  280,   58,   59,   60,   61,   62,   63,   -1,   -1,
   -1,  290,   -1,   -1,   -1,  281,  282,   -1,   -1,   -1,
   -1,   -1,   -1,  289,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  297,   -1,  299,   -1,   91,   -1,  316,   94,   -1,
  319,  320,   -1,   -1,  323,  311,   -1,  313,   -1,   -1,
  329,  317,  318,  332,   -1,   -1,  322,   -1,   -1,  325,
  339,   -1,   -1,   -1,   -1,  331,   -1,   -1,  124,   37,
   38,  337,   40,   41,   42,   43,   44,   45,   46,   47,
   -1,   -1,   41,   -1,   -1,   44,   41,   -1,   -1,   44,
   58,   59,   60,   61,   62,   63,   -1,   -1,   -1,   58,
   59,   -1,   -1,   58,   59,   -1,   -1,  256,   -1,   -1,
   -1,  260,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   91,   -1,   93,   94,   -1,   -1,  278,
   -1,   -1,  281,  282,   93,   -1,   -1,  286,   93,   -1,
  289,   -1,   -1,   -1,   -1,   -1,   -1,  296,  297,   -1,
  299,   -1,  301,  302,  303,   -1,  124,  125,  307,  308,
  309,  310,  311,   -1,  313,   -1,  125,   -1,  317,  318,
  125,   -1,  321,  322,   -1,  324,  325,  326,  327,  328,
   -1,  330,  331,   -1,   -1,   -1,  335,  336,  337,   -1,
   -1,  340,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  257,   -1,   -1,   -1,   -1,  262,  263,  264,  265,
  266,  267,  268,   -1,  270,  271,  272,  273,  274,  275,
  276,  277,  278,  279,  280,  281,  282,  283,  284,  285,
  286,  287,  288,  289,  290,  291,   -1,   61,  294,  295,
  296,  297,  298,  299,  300,   -1,  302,  303,  304,  305,
  306,  307,  308,  309,  310,  311,  312,  313,   -1,   -1,
  316,  317,  318,  319,  320,  321,  322,  323,  324,  325,
  326,  327,  328,  329,  330,  331,  332,  333,  334,  335,
   -1,  337,   61,  339,  340,  341,  342,   -1,  256,  257,
   -1,   -1,   -1,   -1,  262,  263,   -1,  265,  266,  267,
  268,  256,  270,  271,  272,  273,   -1,   -1,   -1,   -1,
  278,  279,  280,   -1,   61,   -1,   -1,   -1,  286,  278,
   -1,   -1,  290,  278,  292,  293,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  292,  293,   -1,   -1,  292,  293,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  314,   -1,  316,   -1,
   -1,  319,  320,   -1,   -1,  323,   -1,   -1,   -1,  314,
   -1,  329,   -1,   -1,  332,   -1,   -1,   -1,   -1,   -1,
   -1,  339,   -1,  341,  342,   37,   38,  296,   40,   41,
   42,   43,   44,   45,   46,   47,   -1,   -1,  307,  308,
  309,   -1,   -1,   -1,   -1,   -1,   58,   59,   60,   61,
   62,   63,  321,   -1,   -1,  324,   -1,  326,   -1,  328,
   -1,  330,   -1,   -1,   -1,   -1,  335,   -1,   -1,   -1,
   -1,  340,   40,   41,   -1,   -1,   44,   -1,   -1,   91,
   -1,   93,   94,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   58,   59,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  279,  280,   -1,   -1,   -1,
   -1,   -1,  124,  125,   37,   38,  290,   40,   41,   42,
   43,   44,   45,   41,   47,   93,   44,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   58,   59,   60,   61,   62,
   63,   59,  316,   61,   -1,  319,  320,   -1,   -1,  323,
  279,  280,   -1,   -1,   -1,  329,  285,  125,  332,   -1,
   -1,  290,   -1,   -1,   -1,  339,  295,   -1,   91,   -1,
   93,   94,   -1,   -1,   -1,   93,   -1,   -1,   -1,   -1,
   -1,   -1,  279,  280,   -1,   -1,   -1,  316,  285,   -1,
  319,  320,   -1,  290,  323,   -1,   -1,   -1,  295,   -1,
  329,  124,  125,  332,   -1,   -1,   40,  125,   -1,   -1,
  339,   45,   46,   -1,   -1,   -1,   -1,   -1,   -1,  316,
   -1,   -1,  319,  320,   -1,   59,  323,   61,   -1,   -1,
   -1,   -1,  329,   -1,   -1,  332,   -1,   -1,   -1,   -1,
   -1,   -1,  339,   -1,  256,  257,   -1,   -1,   -1,   -1,
  262,  263,   -1,  265,  266,  267,  268,   91,  270,  271,
  272,  273,   -1,   -1,   -1,   -1,  278,  279,  280,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  290,   -1,
  292,  293,   -1,   -1,   -1,   -1,   -1,   -1,  256,  123,
   -1,  125,  126,   -1,   -1,   40,   -1,   -1,   -1,   -1,
   45,   46,  314,   -1,  316,   -1,   -1,  319,  320,   -1,
  278,  323,   -1,   -1,   59,   -1,   61,  329,   -1,   -1,
  332,   -1,   -1,   -1,  292,  293,   -1,  339,   -1,  341,
  342,   -1,   -1,  256,  257,   -1,   -1,   -1,   -1,  262,
  263,   -1,  265,  266,  267,  268,   91,  270,  271,  272,
  273,   -1,   -1,   -1,   -1,  278,  279,  280,   -1,   -1,
  278,  279,  280,   -1,   -1,   -1,   -1,  290,   -1,  292,
  293,   -1,  290,   -1,   -1,   -1,   -1,   -1,  123,   -1,
   -1,  126,   44,   -1,   46,   -1,   -1,   -1,   -1,   -1,
   -1,  314,   -1,  316,   -1,   -1,  319,  320,  316,   -1,
  323,  319,  320,   -1,   -1,  323,  329,   -1,   -1,  332,
   -1,  329,   -1,   -1,  332,   -1,  339,   -1,  341,  342,
   -1,  339,  256,   -1,  258,  259,  260,  261,  262,  263,
  264,   -1,   -1,   -1,   -1,  269,   -1,   -1,   -1,   61,
  274,  275,  276,  277,  278,  279,  280,  281,  282,  283,
  284,  285,  286,  287,  288,  289,  290,  291,   -1,   -1,
  294,  295,  296,  297,  298,  299,  300,  301,  302,  303,
  304,  305,  306,  307,  308,  309,  310,  311,  312,  313,
   -1,  315,  316,  317,  318,  319,  320,  321,  322,  323,
  324,  325,  326,  327,  328,  329,  330,  331,  332,   -1,
  334,  335,  336,  337,  338,  339,  340,   -1,   46,   -1,
   -1,  256,   -1,  258,  259,  260,  261,  262,  263,  264,
   58,   -1,   -1,   -1,  269,   -1,   -1,   -1,   -1,  274,
  275,  276,  277,   -1,  279,  280,  281,  282,  283,  284,
  285,  286,  287,  288,  289,  290,  291,   -1,   -1,  294,
  295,  296,  297,  298,  299,  300,  301,  302,  303,  304,
  305,  306,  307,  308,  309,  310,  311,  312,  313,   -1,
  315,  316,  317,  318,  319,  320,  321,  322,  323,  324,
  325,  326,  327,  328,  329,  330,  331,  332,   -1,  334,
  335,  336,  337,  338,  339,  340,   40,   -1,  260,   -1,
   -1,   45,   46,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   59,   -1,   -1,   -1,  281,
  282,   -1,   -1,   -1,  286,   -1,   -1,  289,   -1,   -1,
   -1,   -1,   -1,   -1,  256,  297,   -1,  299,   -1,  301,
  302,  303,   -1,   -1,   -1,   -1,   -1,   91,  310,  311,
   -1,  313,   -1,   -1,   -1,  317,  318,  279,  280,   -1,
  322,   -1,   -1,  325,   -1,  327,   -1,   -1,  290,  331,
   -1,   -1,   -1,   -1,  336,  337,   -1,   -1,   -1,  123,
   -1,  125,  126,   40,   -1,   -1,   -1,   -1,   45,   46,
   -1,   -1,   -1,   -1,  316,   -1,   -1,  319,  320,   -1,
   -1,  323,   59,   -1,   -1,   -1,   -1,  329,   -1,   -1,
  332,   -1,   -1,   -1,   -1,   -1,   -1,  339,   -1,   -1,
   -1,   -1,  260,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   91,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  281,  282,   -1,   -1,   -1,  286,   -1,
   -1,  289,   -1,   -1,  292,  293,   -1,   -1,   -1,  297,
   -1,  299,   -1,  301,  302,  303,  123,   -1,  125,  126,
   -1,   -1,  310,  311,   46,  313,   -1,   -1,   -1,  317,
  318,   -1,   -1,   -1,  322,   -1,   -1,  325,   -1,  327,
   -1,   -1,   -1,  331,   -1,   -1,   -1,   -1,  336,  337,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  256,   -1,  258,  259,  260,  261,  262,  263,
  264,   -1,   -1,   -1,   -1,  269,   -1,   -1,   -1,   -1,
  274,  275,  276,  277,  278,   -1,   -1,  281,  282,  283,
  284,  285,  286,  287,  288,  289,   46,  291,   -1,   -1,
   -1,  295,  296,  297,  298,  299,  300,  301,  302,  303,
  304,  305,  306,  307,  308,  309,  310,  311,  312,  313,
   -1,  315,   -1,  317,  318,   -1,   -1,  321,  322,   -1,
  324,  325,  326,  327,  328,   -1,  330,  331,   -1,   -1,
  334,  335,  336,  337,  338,   -1,  340,   -1,   -1,  256,
   -1,  258,  259,  260,  261,  262,  263,  264,   -1,   -1,
   -1,   -1,  269,   -1,   -1,   -1,   -1,  274,  275,  276,
  277,  278,   -1,  123,  281,  282,  283,  284,   -1,  286,
  287,  288,  289,   -1,  291,   -1,   -1,  294,   -1,  296,
  297,  298,  299,  300,  301,  302,  303,  304,  305,  306,
  307,  308,  309,  310,  311,  312,  313,   40,  315,   -1,
  317,  318,   45,   46,  321,  322,   -1,  324,  325,  326,
  327,  328,   -1,  330,  331,   -1,   59,  334,  335,  336,
  337,  338,   -1,  340,  256,   -1,   -1,   -1,  260,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   91,  281,
  282,   -1,   -1,   -1,  286,   -1,   -1,  289,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  297,   -1,  299,   -1,  301,
  302,  303,   -1,   -1,   -1,   -1,   -1,   -1,  310,  311,
  123,  313,   40,  126,   42,  317,  318,   45,   46,   -1,
  322,   -1,   -1,  325,   -1,  327,   -1,   -1,  258,  331,
  260,   -1,   60,   -1,  336,  337,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  281,  282,   -1,   -1,  285,  286,   -1,   -1,  289,
   -1,   -1,   -1,   91,   -1,  295,   -1,  297,   -1,  299,
   -1,  301,  302,  303,   -1,   -1,  306,   -1,   -1,   -1,
  310,  311,   -1,  313,   -1,   -1,   -1,  317,  318,   -1,
   -1,   -1,  322,   -1,   -1,  325,   -1,  327,  126,   -1,
   -1,  331,   -1,  333,   -1,   -1,  336,  337,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   40,   -1,   -1,   -1,   -1,
   45,   46,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   59,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  256,   -1,  258,  259,  260,  261,  262,
  263,  264,   -1,   -1,   -1,   -1,  269,   -1,   -1,   -1,
   -1,  274,  275,  276,  277,   -1,   91,   -1,  281,  282,
  283,  284,   -1,  286,  287,  288,  289,   -1,  291,   -1,
   -1,  294,   -1,  296,  297,  298,  299,  300,  301,  302,
  303,  304,  305,  306,  307,  308,  309,  310,  311,  312,
  313,  126,  315,   -1,  317,  318,   -1,   -1,  321,  322,
   -1,  324,  325,  326,  327,  328,   -1,  330,  331,   -1,
   -1,  334,  335,  336,  337,  338,   -1,  340,  256,   -1,
   -1,  259,  260,  261,  262,  263,  264,   40,   -1,   -1,
   -1,  269,   45,   46,   -1,   -1,  274,  275,  276,  277,
  278,   -1,   -1,  281,  282,  283,  284,   -1,  286,  287,
  288,  289,   -1,  291,   -1,   -1,  294,   -1,  296,  297,
  298,  299,  300,  301,  302,  303,  304,  305,  306,  307,
  308,  309,  310,  311,  312,  313,   -1,  315,   91,  317,
  318,   -1,   -1,  321,  322,   -1,  324,  325,  326,  327,
  328,   -1,  330,  331,   -1,   -1,  334,  335,  336,  337,
   -1,   -1,  340,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  126,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  256,   -1,   -1,  259,  260,  261,  262,  263,  264,
   40,   -1,   -1,   -1,  269,   45,   46,   -1,   -1,  274,
  275,  276,  277,  278,   -1,   -1,  281,  282,  283,  284,
   -1,  286,  287,  288,  289,   -1,  291,   -1,   -1,  294,
   -1,  296,  297,  298,  299,  300,  301,  302,  303,  304,
  305,  306,  307,  308,  309,  310,  311,  312,  313,   -1,
  315,   91,  317,  318,   -1,   -1,  321,  322,   -1,  324,
  325,  326,  327,  328,   -1,  330,  331,   -1,   -1,  334,
  335,  336,  337,   -1,   -1,  340,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  123,   -1,   40,  126,   -1,   -1,   -1,
   45,   46,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   60,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  256,   -1,   -1,  259,  260,  261,  262,
  263,  264,   -1,   -1,   -1,   -1,  269,   -1,   -1,   -1,
   -1,  274,  275,  276,  277,   -1,   91,   -1,  281,  282,
  283,  284,   -1,  286,  287,  288,  289,   -1,  291,  292,
  293,  294,   -1,  296,  297,  298,  299,  300,  301,  302,
  303,  304,  305,  306,  307,  308,  309,  310,  311,  312,
  313,  126,  315,   -1,  317,  318,   -1,   -1,  321,  322,
   -1,  324,  325,  326,  327,  328,   -1,  330,  331,   -1,
   -1,  334,  335,  336,  337,   -1,   -1,  340,   -1,   -1,
   -1,   -1,   -1,   37,   38,   -1,   -1,   -1,   42,   43,
   -1,   45,   -1,   47,   -1,   -1,  256,   -1,   -1,  259,
  260,  261,  262,  263,  264,   40,   60,   -1,   62,  269,
   45,   46,   -1,   -1,  274,  275,  276,  277,   -1,   -1,
   -1,  281,  282,  283,  284,   -1,  286,  287,  288,  289,
   -1,  291,   -1,   -1,  294,   -1,  296,  297,  298,  299,
  300,  301,  302,  303,  304,  305,  306,  307,  308,  309,
  310,  311,  312,  313,   -1,  315,   91,  317,  318,   -1,
   -1,  321,  322,   -1,  324,  325,  326,  327,  328,   -1,
  330,  331,   -1,   -1,  334,  335,  336,  337,   -1,   -1,
  340,   -1,   -1,   -1,  259,  260,  261,  262,  263,  264,
   40,  126,   -1,   -1,  269,   45,   46,   -1,   -1,  274,
  275,  276,  277,  278,   -1,   -1,  281,  282,  283,  284,
   -1,  286,  287,  288,  289,   -1,  291,   -1,   -1,  294,
   -1,  296,  297,  298,  299,  300,  301,  302,  303,  304,
  305,  306,  307,  308,  309,  310,  311,  312,  313,   -1,
  315,   91,  317,  318,   -1,   -1,  321,  322,   -1,  324,
  325,  326,  327,  328,   -1,  330,  331,   -1,   -1,  334,
  335,  336,  337,   -1,   -1,  340,   -1,   -1,   -1,   -1,
   -1,   -1,   40,   -1,   -1,   -1,  126,   45,   46,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  265,  266,  267,  268,   -1,  270,  271,   -1,   -1,
   -1,  256,   -1,   91,  259,  260,  261,  262,  263,  264,
   -1,   -1,   -1,   -1,  269,   -1,   -1,   -1,   -1,  274,
  275,  276,  277,   -1,   -1,   -1,  281,  282,  283,  284,
   46,  286,  287,  288,  289,   -1,  291,   -1,  126,  294,
   -1,  296,  297,  298,  299,  300,  301,  302,  303,  304,
  305,  306,  307,  308,  309,  310,  311,  312,  313,   -1,
  315,   -1,  317,  318,   -1,   -1,  321,  322,   -1,  324,
  325,  326,  327,  328,   -1,  330,  331,   -1,   -1,  334,
  335,  336,  337,   -1,   -1,  340,   -1,   -1,   -1,  259,
  260,  261,  262,  263,  264,   -1,   -1,   -1,   -1,  269,
   -1,   -1,   -1,   -1,  274,  275,  276,  277,  278,   -1,
   41,  281,  282,  283,  284,   46,  286,  287,  288,  289,
   -1,  291,   -1,   -1,  294,   -1,  296,  297,  298,  299,
  300,  301,  302,  303,  304,  305,  306,  307,  308,  309,
  310,  311,  312,  313,   -1,  315,   -1,  317,  318,   -1,
   -1,  321,  322,   -1,  324,  325,  326,  327,  328,   -1,
  330,  331,   -1,   -1,  334,  335,  336,  337,  256,   -1,
  340,  259,  260,  261,  262,  263,  264,   -1,   -1,   -1,
   -1,  269,   -1,   -1,   -1,   -1,  274,  275,  276,  277,
   -1,   -1,  123,  281,  282,  283,  284,   -1,  286,  287,
  288,  289,   -1,  291,   -1,   -1,  294,   -1,  296,  297,
  298,  299,  300,  301,  302,  303,  304,  305,  306,  307,
  308,  309,  310,  311,  312,  313,   -1,  315,   -1,  317,
  318,   -1,   -1,  321,  322,   -1,  324,  325,  326,  327,
  328,   -1,  330,  331,  260,   -1,  334,  335,  336,  337,
   40,   41,  340,   -1,   44,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  281,  282,   -1,   58,   59,
  286,   -1,   -1,  289,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  297,   -1,  299,   -1,  301,  302,  303,   -1,   -1,
   -1,   -1,   -1,   -1,  310,  311,   -1,  313,   -1,   -1,
   -1,  317,  318,   93,   -1,   -1,  322,   -1,   -1,  325,
   -1,  327,   -1,   -1,   -1,  331,   -1,   -1,   -1,   -1,
  336,  337,   -1,   -1,   -1,  256,   -1,   -1,   -1,  260,
   -1,   -1,   40,  123,  124,   -1,   -1,   45,   46,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  278,   -1,   -1,
  281,  282,   -1,   -1,   -1,  286,   -1,   -1,  289,   -1,
   -1,   -1,   -1,   -1,   -1,  296,  297,   -1,  299,   -1,
  301,  302,  303,   -1,   -1,   -1,  307,  308,  309,  310,
  311,   -1,  313,   91,   -1,   -1,  317,  318,   -1,   -1,
  321,  322,   -1,  324,  325,  326,  327,  328,   -1,  330,
  331,   -1,   -1,   -1,  335,  336,  337,   -1,   -1,  340,
   -1,   -1,   -1,   -1,   40,   -1,   -1,   -1,  126,   -1,
   46,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   91,  256,   -1,  258,   -1,
   -1,   -1,   -1,   -1,  264,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  274,  275,  276,  277,  278,   -1,
   -1,  281,  282,  283,  284,  285,   -1,  287,  288,  289,
   -1,  291,  292,  293,  294,  295,  296,  297,  298,  299,
  300,   -1,  302,  303,  304,  305,  306,  307,  308,  309,
  310,  311,  312,  313,   -1,   -1,   -1,  317,  318,   -1,
   -1,  321,  322,   40,  324,  325,  326,  327,  328,   46,
  330,  331,   -1,  333,  334,  335,   -1,  337,   -1,   -1,
  340,  259,  260,  261,  262,  263,  264,   -1,   -1,   -1,
   -1,  269,   -1,   -1,   -1,   -1,  274,  275,  276,  277,
   -1,   -1,   -1,  281,  282,  283,  284,   -1,  286,  287,
  288,  289,   -1,  291,   91,   -1,  294,   -1,  296,  297,
  298,  299,  300,  301,  302,  303,  304,  305,  306,  307,
  308,  309,  310,  311,  312,  313,   -1,  315,   -1,  317,
  318,   -1,   -1,  321,  322,   -1,  324,  325,  326,  327,
  328,   -1,  330,  331,   -1,   -1,  334,  335,  336,  337,
  256,   -1,  340,  259,  260,  261,   -1,   40,  264,   -1,
   -1,   -1,   45,   46,   -1,   -1,   -1,   -1,  274,  275,
  276,  277,   -1,   -1,   -1,  281,  282,  283,  284,   -1,
  286,  287,  288,  289,   -1,  291,   -1,   -1,  294,   -1,
  296,  297,  298,  299,  300,  301,  302,  303,  304,  305,
  306,  307,  308,  309,  310,  311,  312,  313,   91,  315,
   -1,  317,  318,   -1,   -1,  321,  322,   -1,  324,  325,
  326,  327,  328,   -1,  330,  331,   -1,   -1,  334,  335,
  336,  337,   -1,   -1,  340,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  126,   -1,   -1,   37,   38,   -1,   -1,
   -1,   42,   43,   -1,   45,   -1,   47,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   60,
   -1,   62,  259,  260,  261,   -1,   40,  264,   -1,   -1,
   -1,   45,   46,   -1,   -1,   -1,   -1,  274,  275,  276,
  277,   -1,   -1,   -1,  281,  282,  283,  284,   -1,  286,
  287,  288,  289,   94,  291,   -1,   -1,  294,   -1,  296,
  297,  298,  299,  300,  301,  302,  303,  304,  305,  306,
  307,  308,  309,  310,  311,  312,  313,   91,  315,   -1,
  317,  318,   -1,  124,  321,  322,   -1,  324,  325,  326,
  327,  328,   -1,  330,  331,   -1,   -1,  334,  335,  336,
  337,   -1,   -1,  340,   -1,   -1,   -1,   -1,   -1,  123,
   -1,   -1,  126,   40,   -1,   -1,   -1,   -1,   45,   46,
   -1,   -1,   -1,  256,   -1,   -1,  259,  260,  261,  262,
  263,  264,   -1,   -1,   -1,   -1,  269,   64,   -1,   -1,
   -1,  274,  275,  276,  277,  278,   -1,   -1,   -1,   -1,
  283,  284,   -1,  286,  287,  288,   -1,   -1,  291,   -1,
   -1,  294,   -1,  296,   91,  298,   -1,  300,  301,  302,
  303,  304,  305,  306,  307,  308,  309,  310,   -1,  312,
   -1,   -1,  315,   -1,   -1,   -1,   40,   41,  321,   -1,
   44,  324,   -1,  326,  327,  328,   -1,  330,   -1,  126,
   -1,  334,  335,  336,   58,   59,   -1,  340,   -1,   -1,
   -1,   -1,   -1,   40,   -1,   -1,   -1,   -1,   45,   46,
   -1,   -1,   -1,   -1,  265,  266,  267,  268,   -1,  270,
  271,  272,   -1,   -1,   -1,   -1,   -1,   64,   -1,   93,
   -1,   -1,  256,   -1,   -1,  259,  260,  261,  262,  263,
  264,   -1,   -1,   -1,   -1,  269,   -1,   -1,   -1,   -1,
  274,  275,  276,  277,   91,   -1,   -1,   -1,   -1,  283,
  284,  125,  286,  287,  288,   -1,   -1,  291,   -1,   -1,
  294,   -1,  296,   -1,  298,   -1,  300,  301,  302,  303,
  304,  305,  306,  307,  308,  309,  310,   -1,  312,  126,
   40,  315,   -1,   -1,   -1,   45,   46,  321,   -1,   -1,
  324,   -1,  326,  327,  328,   -1,  330,   -1,   -1,   -1,
  334,  335,  336,   -1,   -1,   -1,  340,   -1,   -1,  256,
   -1,   -1,  259,  260,  261,  262,  263,  264,   -1,   -1,
   -1,   -1,  269,   -1,   -1,   -1,   -1,  274,  275,  276,
  277,   91,   -1,   -1,   -1,   -1,  283,  284,   -1,  286,
  287,  288,   -1,   -1,  291,   -1,   -1,  294,   -1,  296,
   -1,  298,   -1,  300,  301,  302,  303,  304,  305,  306,
  307,  308,  309,  310,   -1,  312,  126,   -1,  315,   -1,
   -1,   -1,   -1,   -1,  321,   -1,   -1,  324,   -1,  326,
  327,  328,  256,  330,   -1,   -1,   -1,  334,  335,  336,
   -1,   -1,   40,  340,   -1,   -1,   -1,   45,   46,   -1,
   -1,   -1,   -1,   -1,  278,   -1,   -1,   -1,   -1,  256,
   -1,   -1,  259,  260,  261,  262,  263,  264,  292,  293,
   -1,   -1,  269,   -1,   -1,   -1,   -1,  274,  275,  276,
  277,   -1,   -1,   -1,   -1,   -1,  283,  284,   -1,  286,
  287,  288,   -1,   91,  291,   -1,   -1,  294,   -1,  296,
   -1,  298,   -1,  300,  301,  302,  303,  304,  305,  306,
  307,  308,  309,  310,   -1,  312,   -1,   41,  315,   -1,
   44,   -1,   -1,   -1,  321,   -1,   -1,  324,  126,  326,
  327,  328,   -1,  330,   58,   59,   40,  334,  335,  336,
   -1,   45,   46,  340,   -1,   -1,  256,   -1,   -1,  259,
  260,  261,  262,  263,  264,   -1,   -1,   -1,   -1,  269,
   -1,   -1,   -1,   -1,  274,  275,  276,  277,  278,   93,
   -1,   -1,   -1,  283,  284,   -1,  286,  287,  288,   -1,
   -1,  291,   -1,   -1,  294,   -1,  296,   91,  298,   -1,
  300,  301,  302,  303,  304,  305,  306,  307,  308,  309,
  310,  125,  312,   -1,   -1,  315,   -1,   -1,   -1,   -1,
   -1,  321,   -1,   -1,  324,   -1,  326,  327,  328,   -1,
  330,   -1,  126,   -1,  334,  335,  336,   -1,   -1,   40,
  340,   -1,   -1,   -1,   45,   46,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  259,  260,  261,  262,  263,  264,   -1,   -1,   -1,
   -1,  269,   -1,   -1,   -1,   -1,  274,  275,  276,  277,
   91,   -1,   -1,   -1,   -1,  283,  284,  285,  286,  287,
  288,   -1,   -1,  291,   -1,   -1,  294,  295,  296,   -1,
  298,   -1,  300,  301,  302,  303,  304,  305,  306,  307,
  308,  309,  310,   -1,  312,  126,   -1,  315,   -1,   -1,
   -1,   -1,   -1,  321,   -1,   -1,  324,   -1,  326,  327,
  328,   -1,  330,   -1,   -1,   -1,  334,  335,  336,   37,
   -1,   -1,  340,   -1,   42,   43,   -1,   45,   -1,   47,
   -1,   -1,  256,   -1,  278,  259,  260,  261,  262,  263,
  264,   40,   60,   -1,   62,  269,   45,   46,  292,  293,
  274,  275,  276,  277,   -1,   -1,   -1,   -1,   -1,  283,
  284,   -1,  286,  287,  288,   64,   -1,  291,   -1,   -1,
  294,   -1,  296,   -1,  298,   -1,  300,  301,  302,  303,
  304,  305,  306,  307,  308,  309,  310,   -1,  312,   -1,
   -1,  315,   91,   -1,   -1,   -1,   -1,  321,   -1,   -1,
  324,   -1,  326,  327,  328,   -1,  330,   -1,   -1,   -1,
  334,  335,  336,   -1,   -1,   -1,  340,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  256,   -1,  126,  259,  260,
  261,  262,  263,  264,   40,   -1,   -1,   -1,  269,   45,
   46,   -1,   -1,  274,  275,  276,  277,   -1,   -1,   -1,
   -1,   -1,  283,  284,   -1,  286,  287,  288,   -1,   -1,
  291,   -1,   -1,  294,   -1,  296,   -1,  298,   -1,  300,
  301,  302,  303,  304,  305,  306,  307,  308,  309,  310,
   -1,  312,   -1,   -1,  315,   91,   -1,   -1,   -1,   41,
  321,   -1,   44,  324,   -1,  326,  327,  328,   -1,  330,
   -1,   -1,   -1,  334,  335,  336,   58,   59,   -1,  340,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  126,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   40,   -1,
   -1,   -1,   -1,   45,   46,   -1,   -1,   -1,   -1,   -1,
   -1,   93,   -1,   -1,   -1,   -1,   -1,  265,  266,  267,
  268,   -1,  270,  271,   -1,   -1,   -1,   -1,   -1,   -1,
  259,  260,  261,  262,  263,  264,   -1,   -1,   -1,   -1,
  269,   -1,   -1,  125,   -1,  274,  275,  276,  277,   91,
   -1,   -1,   -1,   -1,  283,  284,   -1,  286,  287,  288,
   -1,   -1,  291,   -1,   -1,  294,   -1,  296,   -1,  298,
   -1,  300,  301,  302,  303,  304,  305,  306,  307,  308,
  309,  310,   -1,  312,  126,   -1,  315,   -1,   -1,   -1,
   -1,   -1,  321,   -1,   -1,  324,   -1,  326,  327,  328,
   -1,  330,   -1,   40,   -1,  334,  335,  336,   45,   46,
   -1,  340,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  256,   -1,   -1,  259,  260,  261,  262,  263,  264,   -1,
   -1,   -1,   -1,  269,   -1,   -1,   -1,   -1,  274,  275,
  276,  277,   -1,   -1,   -1,   -1,   -1,  283,  284,   -1,
  286,  287,  288,   -1,   91,  291,   -1,   -1,  294,   -1,
  296,   -1,  298,   -1,  300,  301,  302,  303,  304,  305,
  306,  307,  308,  309,  310,   -1,  312,   -1,   -1,  315,
   -1,   -1,   -1,   -1,   -1,  321,   -1,   -1,  324,  126,
  326,  327,  328,   -1,  330,   -1,  278,   40,  334,  335,
  336,   -1,   45,   46,  340,   -1,   -1,   -1,   -1,   -1,
  292,  293,   -1,   -1,  256,   -1,   -1,  259,  260,  261,
  262,  263,  264,   -1,   -1,   -1,   -1,  269,   -1,   -1,
   -1,   -1,  274,  275,  276,  277,   -1,   -1,   -1,   -1,
   -1,  283,  284,   -1,  286,  287,  288,   -1,   91,  291,
   -1,   -1,  294,   -1,  296,   -1,  298,   -1,  300,  301,
  302,  303,  304,  305,  306,  307,  308,  309,  310,   -1,
  312,   -1,   -1,  315,   -1,   -1,   -1,   -1,   -1,  321,
   -1,   -1,  324,  126,  326,  327,  328,   -1,  330,   -1,
   40,   -1,  334,  335,  336,   45,   46,   -1,  340,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  256,
   -1,   -1,  259,  260,  261,  262,  263,  264,   -1,   -1,
   -1,   -1,  269,   -1,   -1,   -1,   -1,  274,  275,  276,
  277,   91,   -1,   -1,   -1,   -1,  283,  284,   -1,  286,
  287,  288,   -1,   -1,  291,   -1,   -1,  294,   -1,  296,
   -1,  298,   -1,  300,  301,  302,  303,  304,  305,  306,
  307,  308,  309,  310,   -1,  312,  126,   -1,  315,   -1,
   -1,   -1,   -1,   -1,  321,   -1,   -1,  324,   -1,  326,
  327,  328,   -1,  330,   -1,   -1,   -1,  334,  335,  336,
   -1,   -1,   -1,  340,   -1,   46,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  256,   -1,   -1,  259,  260,  261,  262,
  263,  264,   -1,   -1,   -1,   -1,  269,   -1,   -1,   -1,
   -1,  274,  275,  276,  277,   40,   41,   -1,   -1,   44,
  283,  284,   -1,  286,  287,  288,   -1,   -1,  291,   -1,
   -1,  294,   -1,  296,   59,  298,   61,  300,  301,  302,
  303,  304,  305,  306,  307,  308,  309,  310,   -1,  312,
   -1,   -1,  315,   -1,   -1,   -1,   -1,   -1,  321,   -1,
   -1,  324,   -1,  326,  327,  328,   46,  330,   93,   -1,
   -1,  334,  335,  336,   -1,   -1,   -1,  340,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  259,
  260,  261,  262,  263,  264,   -1,   -1,   -1,  123,  269,
  125,   -1,   -1,   -1,  274,  275,  276,  277,   -1,   -1,
   -1,   -1,   -1,  283,  284,   -1,  286,  287,  288,   -1,
   -1,  291,   -1,   -1,  294,   -1,  296,   -1,  298,   -1,
  300,  301,  302,  303,  304,  305,  306,  307,  308,  309,
  310,   -1,  312,  123,   41,  315,   -1,   44,   -1,   -1,
   -1,  321,   -1,   -1,  324,   -1,  326,  327,  328,   -1,
  330,   58,   59,   -1,  334,  335,  336,   -1,   -1,   -1,
  340,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  256,   93,   -1,   -1,  260,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  281,  282,   -1,   -1,   -1,  286,  123,  124,  289,   41,
   -1,  256,   44,   -1,   -1,   -1,  297,   -1,  299,   -1,
  301,  302,  303,   -1,   -1,   -1,   58,   59,   -1,  310,
  311,   -1,  313,  278,  279,  280,  317,  318,   -1,   -1,
   -1,  322,   -1,   -1,  325,  290,  327,   -1,   -1,   -1,
  331,   -1,   -1,   -1,   -1,  336,  337,   -1,  258,   -1,
  260,   93,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  316,   -1,   -1,  319,  320,   -1,   -1,  323,   -1,
   -1,  281,  282,   -1,  329,  285,  286,  332,   -1,  289,
   -1,  123,  124,   -1,  339,  295,  296,  297,   -1,  299,
   -1,  301,  302,  303,   -1,   -1,  306,  307,  308,  309,
  310,  311,   -1,  313,   -1,   -1,   -1,  317,  318,   -1,
   -1,  321,  322,   -1,  324,  325,  326,  327,  328,   -1,
  330,  331,   -1,  333,   -1,  335,  336,  337,   -1,  256,
  340,  258,   -1,   -1,   -1,   41,   -1,  264,   44,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  274,  275,  276,
  277,  278,   58,   59,  281,  282,  283,  284,  285,   -1,
  287,  288,  289,   -1,  291,  292,  293,  294,  295,  296,
  297,  298,  299,  300,   -1,  302,  303,  304,  305,  306,
  307,  308,  309,  310,  311,  312,  313,   93,   -1,   -1,
  317,  318,   -1,   -1,  321,  322,   -1,  324,  325,  326,
  327,  328,   -1,  330,  331,   -1,  333,  334,  335,   -1,
  337,   -1,   -1,  340,  256,   -1,  258,  123,  124,   -1,
   41,   -1,  264,   44,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  274,  275,  276,  277,  278,   58,   59,  281,
  282,  283,  284,  285,   -1,  287,  288,  289,   -1,  291,
  292,  293,  294,  295,  296,  297,  298,  299,  300,   -1,
  302,  303,  304,  305,  306,  307,  308,  309,  310,  311,
  312,  313,   93,   -1,   -1,  317,  318,   -1,   -1,  321,
  322,   -1,  324,  325,  326,  327,  328,   -1,  330,  331,
   -1,  333,  334,  335,   -1,  337,   41,   -1,  340,   44,
   -1,   -1,  123,  124,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   58,   59,   -1,   -1,   -1,   63,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   93,   -1,
  256,   -1,  258,   -1,   -1,   -1,   41,   -1,  264,   44,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  274,  275,
  276,  277,  278,   58,   59,  281,  282,  283,  284,  285,
  125,  287,  288,  289,   -1,  291,  292,  293,  294,  295,
  296,  297,  298,  299,  300,   -1,  302,  303,  304,  305,
  306,  307,  308,  309,  310,  311,  312,  313,   93,   -1,
   -1,  317,  318,   -1,   -1,  321,  322,   -1,  324,  325,
  326,  327,  328,   -1,  330,  331,   -1,  333,  334,  335,
   -1,  337,   -1,   -1,  340,  256,   -1,  258,  123,  124,
   -1,   41,   -1,  264,   44,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  274,  275,  276,  277,  278,   58,   59,
  281,  282,  283,  284,  285,   -1,  287,  288,  289,   -1,
  291,  292,  293,  294,  295,  296,  297,  298,  299,  300,
   -1,  302,  303,  304,  305,  306,  307,  308,  309,  310,
  311,  312,  313,   93,   -1,   -1,  317,  318,   -1,   -1,
  321,  322,   -1,  324,  325,  326,  327,  328,   -1,  330,
  331,  256,  333,  334,  335,   -1,  337,   -1,   -1,  340,
   -1,   -1,   -1,  123,  124,   -1,   -1,   -1,  273,   -1,
   -1,   -1,   -1,  278,   41,   -1,   -1,   44,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  292,  293,   -1,
   -1,   58,   59,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  314,
   -1,  256,   -1,  258,   -1,   -1,   -1,   -1,   -1,  264,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  274,
  275,  276,  277,  278,   -1,   -1,  281,  282,  283,  284,
  285,   -1,  287,  288,  289,   -1,  291,  292,  293,  294,
  295,  296,  297,  298,  299,  300,  123,  302,  303,  304,
  305,  306,  307,  308,  309,  310,  311,  312,  313,   -1,
   -1,   -1,  317,  318,   -1,   -1,  321,  322,   -1,  324,
  325,  326,  327,  328,   -1,  330,  331,   -1,  333,  334,
  335,   -1,  337,   -1,   -1,  340,  256,   -1,  258,   -1,
   -1,   -1,   -1,   -1,  264,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  274,  275,  276,  277,  278,   -1,
   -1,  281,  282,  283,  284,  285,   -1,  287,  288,  289,
   -1,  291,  292,  293,  294,  295,  296,  297,  298,  299,
  300,   -1,  302,  303,  304,  305,  306,  307,  308,  309,
  310,  311,  312,  313,   -1,   -1,   -1,  317,  318,   -1,
   -1,  321,  322,   -1,  324,  325,  326,  327,  328,   -1,
  330,  331,   -1,  333,  334,  335,   -1,  337,   46,   -1,
  340,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  256,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  264,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  274,  275,  276,
  277,  278,   -1,   -1,  281,  282,  283,  284,  285,   -1,
  287,  288,  289,   -1,  291,   -1,   -1,  294,  295,  296,
  297,  298,  299,  300,   -1,  302,  303,  304,  305,  306,
  307,  308,  309,  310,  311,  312,  313,   -1,   -1,   -1,
  317,  318,   -1,   -1,  321,  322,   -1,  324,  325,  326,
  327,  328,   41,  330,  331,   44,  333,  334,  335,   -1,
  337,   -1,   -1,  340,   -1,   41,   41,   -1,   44,   44,
   59,   -1,   61,   -1,   41,   -1,   -1,   44,   -1,   -1,
   -1,   -1,   58,   59,   59,   -1,   61,   63,   -1,   -1,
   -1,   -1,   59,   -1,   61,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   93,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   93,   93,   -1,
   -1,   41,   -1,   -1,   44,   -1,   93,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  125,   -1,   -1,   59,
   -1,   61,   -1,   -1,   -1,   -1,   -1,   -1,  124,  125,
  125,   -1,   -1,   -1,   -1,   40,   -1,   -1,  125,   -1,
   45,   46,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   93,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  260,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  281,  282,  125,   91,   -1,  286,   -1,
   -1,  289,   40,   -1,   -1,   -1,   -1,   45,   46,  297,
   -1,  299,   -1,  301,  302,  303,   -1,   -1,   -1,   -1,
   -1,   -1,  310,  311,   -1,  313,   -1,   -1,   -1,  317,
  318,  126,   -1,   -1,  322,   -1,   -1,  325,   -1,  327,
   -1,   -1,   -1,  331,   -1,   -1,   -1,   -1,  336,  337,
   -1,   -1,   -1,   91,   -1,   -1,   -1,   -1,   -1,   40,
   -1,   -1,   -1,   -1,   45,   46,   -1,   -1,   -1,   -1,
  256,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  278,
  279,  280,   -1,   -1,   -1,   -1,  272,  273,  126,   -1,
   -1,  290,  278,  278,  279,  280,   -1,   -1,   -1,   -1,
   -1,  278,  279,  280,   -1,  290,  292,  293,   -1,   -1,
   91,   -1,   -1,  290,   -1,   -1,   -1,  316,   -1,   -1,
  319,  320,   -1,   -1,  323,   -1,   -1,   -1,  314,   -1,
  329,  316,   -1,  332,  319,  320,   -1,   -1,  323,  316,
  339,   -1,  319,  320,  329,  126,  323,  332,  278,  279,
  280,   -1,  329,   -1,  339,  332,   -1,   -1,   -1,   -1,
  290,  256,  339,   -1,  259,  260,  261,  262,  263,   -1,
   -1,   -1,   -1,   -1,  269,   -1,   -1,   -1,   -1,   -1,
  275,  276,   40,   -1,   -1,   -1,  316,   45,   46,  319,
  320,  286,   -1,  323,   -1,   -1,   -1,   -1,   -1,  329,
   -1,   -1,  332,   -1,   -1,  300,  301,  302,  303,  339,
   -1,   -1,   -1,  308,   -1,  310,   -1,  312,  256,   -1,
  315,  259,  260,  261,  262,  263,   -1,   -1,   -1,   -1,
   -1,  269,  327,   91,   -1,   -1,   -1,  275,  276,  334,
   -1,  336,   -1,   -1,   -1,   -1,   -1,   -1,  286,   -1,
   -1,   40,   -1,   -1,   -1,   -1,   45,   46,   -1,   -1,
   -1,   -1,  300,  301,  302,  303,   -1,   -1,  126,   -1,
  308,   -1,  310,   -1,  312,  256,   -1,  315,  259,  260,
  261,  262,  263,   -1,   -1,   -1,   -1,   -1,  269,  327,
   -1,   -1,   -1,   -1,  275,  276,  334,   -1,  336,   -1,
   -1,   -1,   91,   -1,   -1,  286,   -1,   -1,   40,   -1,
   -1,   -1,   -1,   45,   46,   -1,   -1,   -1,   -1,  300,
  301,  302,  303,   -1,   -1,   -1,   -1,  308,   -1,  310,
   -1,  312,   -1,   -1,  315,   -1,   -1,  126,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  327,   -1,   -1,   -1,
   -1,   -1,   -1,  334,   -1,  336,   -1,   -1,   -1,   91,
   -1,   -1,   -1,   -1,   -1,   40,   -1,   -1,   -1,   -1,
   45,   46,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  126,   -1,   -1,   -1,  256,   -1,
   -1,  259,  260,  261,  262,  263,   -1,   -1,   -1,   -1,
   -1,  269,   -1,   -1,   -1,   -1,   91,  275,  276,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  286,   -1,
   -1,   -1,   -1,   -1,   40,   -1,   -1,   -1,   -1,   45,
   46,   -1,  300,  301,  302,  303,   -1,   -1,   -1,   -1,
  308,  126,  310,   -1,  312,   -1,   -1,  315,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  256,   -1,  327,
  259,  260,  261,  262,  263,   -1,  334,   -1,  336,   -1,
  269,   -1,   -1,   37,   38,   91,  275,  276,   42,   43,
   -1,   45,   -1,   47,   -1,   -1,   -1,  286,   -1,   -1,
   -1,   -1,   -1,   -1,   40,   -1,   60,   -1,   62,   45,
   46,  300,  301,  302,  303,   -1,   -1,   -1,   -1,  308,
  126,  310,   -1,  312,  256,   -1,  315,  259,  260,  261,
  262,  263,   -1,   -1,   -1,   -1,   -1,  269,  327,   -1,
   94,   -1,   -1,  275,  276,  334,   -1,  336,   -1,   -1,
   -1,   -1,   -1,   -1,  286,   91,   -1,   -1,   -1,   -1,
   -1,   40,   -1,   -1,   -1,   -1,   45,   46,  300,  301,
  302,  303,   -1,   -1,   -1,   -1,  308,   -1,  310,   -1,
  312,  256,   -1,  315,  259,  260,  261,  262,  263,   -1,
  126,   -1,   -1,   -1,  269,  327,   -1,   -1,   -1,   -1,
  275,  276,  334,   -1,  336,   -1,   -1,   -1,   -1,   -1,
   -1,  286,   91,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   40,  300,  301,  302,  303,   45,
   46,   -1,   -1,  308,   -1,  310,   -1,  312,   -1,   -1,
  315,   -1,   -1,   -1,   -1,   -1,   -1,  126,   -1,   -1,
  256,   -1,  327,  259,  260,  261,  262,  263,   -1,  334,
   -1,  336,   -1,  269,   -1,   -1,   -1,   -1,   -1,  275,
  276,   -1,   -1,   -1,   -1,   91,   -1,   -1,   -1,   -1,
  286,   -1,   -1,   -1,   -1,   -1,   -1,   40,   -1,   -1,
   -1,   -1,   45,   46,  300,  301,  302,  303,   -1,   -1,
   -1,   -1,  308,   -1,  310,   -1,  312,   -1,   -1,  315,
  126,  265,  266,  267,  268,   -1,  270,  271,   -1,   -1,
  256,  327,   -1,  259,  260,  261,  262,  263,  334,   -1,
  336,   -1,   -1,  269,   -1,   -1,   -1,   -1,   91,  275,
  276,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  286,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  300,  301,  302,  303,   -1,   -1,
   -1,   -1,  308,  126,  310,   -1,  312,  256,   -1,  315,
  259,  260,  261,  262,  263,   -1,   -1,   40,   -1,   -1,
  269,  327,   45,   46,   -1,   -1,  275,  276,  334,   -1,
  336,   -1,   -1,   -1,   -1,   40,   -1,  286,   -1,   -1,
   45,   46,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  300,  301,  302,  303,   -1,   -1,   -1,   -1,  308,
   -1,  310,   -1,  312,   -1,   -1,  315,   -1,   91,   -1,
  256,   -1,   -1,  259,  260,  261,  262,  263,  327,   -1,
   -1,   -1,   -1,  269,   -1,  334,   91,  336,   -1,  275,
  276,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  286,   -1,   -1,  126,   40,   -1,   -1,   -1,   -1,   45,
   46,   -1,   -1,   -1,  300,  301,  302,  303,   -1,   -1,
   -1,  126,  308,   -1,  310,   -1,  312,   -1,   -1,  315,
   -1,   -1,   -1,  256,   -1,   -1,  259,  260,  261,  262,
  263,  327,   -1,   -1,   -1,   -1,  269,   -1,  334,   -1,
  336,   -1,  275,  276,   -1,   91,   -1,   -1,   -1,   -1,
   -1,   40,   -1,  286,   -1,   -1,   45,   46,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  300,  301,  302,
  303,   -1,   -1,   -1,   -1,  308,   -1,  310,   -1,  312,
  126,   -1,  315,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  327,   -1,   -1,   -1,   -1,   -1,
   -1,  334,   91,  336,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   40,   -1,   -1,   -1,   -1,   45,   46,
   -1,   -1,   -1,  256,   -1,   -1,  259,  260,  261,  262,
  263,   -1,   -1,   -1,   -1,   -1,  269,  126,   -1,   -1,
   -1,  256,  275,  276,  259,  260,  261,  262,  263,   -1,
   -1,   -1,   -1,  286,  269,   46,   -1,   -1,   -1,   -1,
  275,  276,   -1,   -1,   91,   -1,   -1,  300,  301,  302,
  303,  286,   -1,   -1,   -1,  308,   -1,  310,   -1,  312,
   -1,   -1,  315,   -1,   -1,  300,  301,  302,  303,   -1,
   -1,   -1,   -1,  308,  327,  310,   -1,  312,   -1,  126,
  315,  334,   -1,  336,   -1,   -1,   -1,   -1,   -1,   -1,
  256,   -1,  327,  259,  260,  261,  262,  263,   -1,  334,
   -1,  336,   -1,  269,   -1,   -1,   -1,   -1,   -1,  275,
  276,   40,  123,   -1,  125,   -1,   45,   46,   -1,   -1,
  286,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  300,  301,  302,  303,   -1,   -1,
   -1,   -1,  308,   -1,  310,   -1,  312,  256,   -1,  315,
  259,  260,  261,  262,  263,   -1,   -1,   -1,   -1,   -1,
  269,  327,   91,   -1,   -1,   -1,  275,  276,  334,   -1,
  336,   -1,   -1,   40,   -1,   -1,   -1,  286,   45,   46,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  300,  301,  302,  303,   -1,   -1,  126,   -1,  308,
   -1,  310,   -1,  312,   -1,   -1,  315,   -1,   -1,  256,
   -1,   -1,  259,  260,  261,  262,  263,   -1,  327,   -1,
   -1,   -1,  269,   46,   91,  334,   -1,  336,  275,  276,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  286,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  258,   -1,  260,
   -1,   -1,   -1,  300,  301,  302,  303,   -1,   -1,  126,
   -1,  308,   -1,  310,   -1,  312,   -1,  278,  315,   -1,
  281,  282,   -1,   -1,  285,  286,   -1,   -1,  289,   -1,
  327,   -1,   46,   -1,  295,  296,  297,  334,  299,  336,
  301,  302,  303,   -1,   -1,  306,  307,  308,  309,  310,
  311,   -1,  313,   -1,   -1,   -1,  317,  318,   -1,   -1,
  321,  322,   -1,  324,  325,  326,  327,  328,   -1,  330,
  331,   -1,  333,   -1,  335,  336,  337,  256,   -1,  340,
  259,  260,  261,  262,  263,   -1,   -1,   -1,   -1,   -1,
  269,   -1,   -1,   -1,   -1,   -1,  275,  276,   -1,   -1,
   -1,   -1,   -1,   37,   38,   -1,   -1,  286,   42,   43,
   -1,   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  300,  301,  302,  303,   -1,   60,   -1,   62,  308,
   -1,  310,   -1,  312,   -1,   -1,  315,   -1,   -1,   -1,
   -1,   -1,  259,  260,  261,  262,  263,   -1,  327,   -1,
   -1,   -1,  269,   -1,   -1,  334,   -1,  336,  275,  276,
   94,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  286,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  300,  301,  302,  303,  260,   -1,   -1,
  124,  308,   -1,  310,   -1,  312,   -1,   -1,  315,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  281,  282,
  327,   -1,   -1,  286,   -1,   -1,  289,  334,   -1,  336,
   -1,   -1,   -1,   -1,  297,   -1,  299,   -1,  301,  302,
  303,   -1,   -1,   -1,   -1,   -1,   -1,  310,  311,   -1,
  313,   -1,   -1,   -1,  317,  318,  260,   -1,   -1,  322,
   -1,   -1,  325,   -1,  327,   -1,   -1,   -1,  331,   -1,
   -1,   -1,   -1,  336,  337,   -1,   -1,  281,  282,   -1,
   -1,   -1,  286,   -1,   -1,  289,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  297,   -1,  299,   -1,  301,  302,  303,
   -1,   -1,   -1,   -1,   -1,   -1,  310,  311,   -1,  313,
   -1,   -1,   -1,  317,  318,   -1,   -1,   -1,  322,   -1,
   -1,  325,   -1,  327,   -1,   -1,   -1,  331,   -1,   -1,
   37,   38,  336,  337,   41,   42,   43,   44,   45,   -1,
   47,  265,  266,  267,  268,   -1,  270,  271,   -1,   -1,
   -1,   58,   59,   60,   -1,   62,   63,   -1,   -1,   37,
   38,   -1,   -1,   41,   42,   43,   44,   45,   -1,   47,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   58,   59,   60,   -1,   62,   63,   93,   94,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   37,   38,
   -1,   -1,   41,   42,   43,   44,   45,   -1,   47,   -1,
   -1,   -1,   -1,   -1,   -1,   93,   94,  124,  125,   58,
   59,   60,   -1,   62,   63,   -1,   -1,   -1,   38,   -1,
   -1,   41,   -1,   43,   44,   45,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  124,  125,   58,   59,
   60,   -1,   62,   63,   93,   94,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   38,   -1,   -1,
   41,   -1,   43,   44,   45,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   93,   94,  124,  125,   58,   59,   60,
   -1,   62,   63,   -1,   -1,   -1,   38,   -1,   -1,   41,
   -1,   -1,   44,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  124,  125,   58,   59,   60,   -1,
   62,   63,   93,   94,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  256,
   -1,   93,   94,  124,  125,   -1,   -1,   -1,  265,  266,
  267,  268,   -1,  270,  271,  272,  273,   -1,   -1,   -1,
   -1,  278,   -1,   -1,   -1,   -1,   -1,   -1,  256,   -1,
   -1,   -1,  124,  125,   -1,  292,  293,  265,  266,  267,
  268,   -1,  270,  271,  272,  273,   -1,   -1,   -1,   -1,
  278,   -1,   -1,   -1,   -1,   -1,   -1,  314,   -1,   -1,
   -1,   -1,   -1,   -1,  292,  293,   -1,  256,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  265,  266,  267,  268,
   -1,  270,  271,  272,  273,   -1,  314,   -1,   -1,  278,
   -1,   -1,   -1,   -1,   -1,   -1,  256,   -1,   -1,   -1,
   -1,   -1,   -1,  292,  293,  265,  266,  267,  268,   -1,
  270,  271,  272,  273,   -1,   -1,   -1,   -1,  278,   -1,
   -1,   -1,   -1,   -1,   -1,  314,   -1,   -1,   -1,   -1,
   -1,   -1,  292,  293,   -1,  256,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  265,  266,  267,  268,   -1,  270,
  271,  272,  273,   -1,  314,   -1,   -1,  278,   -1,   -1,
   -1,   -1,   -1,   38,  256,   -1,   41,   -1,   -1,   44,
   -1,  292,  293,  265,  266,  267,  268,   -1,  270,  271,
  272,  273,   -1,   58,   59,   60,  278,   62,   63,   -1,
   -1,   -1,   38,  314,   -1,   41,   -1,   -1,   44,   -1,
  292,  293,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   58,   59,   60,   -1,   62,   63,   93,   94,
   -1,   -1,  314,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   38,   -1,   -1,   41,   -1,   -1,   44,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   93,   94,  124,
  125,   58,   59,   60,   -1,   62,   63,   -1,   -1,   -1,
   38,   -1,   -1,   41,   -1,   -1,   44,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  124,  125,
   58,   59,   60,   -1,   62,   63,   93,   94,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   38,
   -1,   -1,   41,   -1,   -1,   44,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   93,   94,  124,  125,   58,
   59,   60,   -1,   62,   63,   -1,   -1,   -1,   38,   -1,
   -1,   41,   -1,   -1,   44,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  124,  125,   58,   59,
   -1,   -1,   -1,   63,   93,   94,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  256,   -1,   93,   94,  124,  125,   -1,   -1,   -1,
  265,  266,  267,  268,   -1,  270,  271,  272,  273,   -1,
   -1,   -1,   -1,  278,   -1,   -1,   -1,   -1,   -1,   -1,
  256,   -1,   -1,   -1,  124,  125,   -1,  292,  293,  265,
  266,  267,  268,   -1,   -1,   -1,  272,  273,   -1,   -1,
   -1,   -1,  278,   -1,   -1,   -1,   -1,   -1,   -1,  314,
   -1,   -1,   -1,   -1,   -1,   -1,  292,  293,   -1,  256,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  265,  266,
  267,  268,   -1,   -1,   -1,  272,  273,   -1,  314,   -1,
   -1,  278,   -1,   -1,   -1,   -1,   -1,   -1,  256,   -1,
   -1,   -1,   -1,   -1,   -1,  292,  293,  265,  266,  267,
  268,   -1,   -1,   -1,  272,  273,   -1,   -1,   -1,   -1,
  278,   -1,   -1,   -1,   -1,   -1,   -1,  314,   -1,   -1,
   38,   -1,   -1,   41,  292,  293,   44,  256,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  265,  266,  267,  268,
   58,   59,   -1,  272,  273,   63,  314,   -1,   -1,  278,
   -1,   -1,   41,   -1,   -1,   44,  256,   -1,   -1,   -1,
   -1,   -1,   -1,  292,  293,  265,   -1,   -1,  268,   58,
   59,   -1,  272,  273,   63,   93,   94,   -1,  278,   -1,
   -1,   -1,   -1,   -1,   -1,  314,   -1,   -1,   -1,   -1,
   -1,   -1,  292,  293,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   93,   94,  124,  125,   -1,   -1,
   -1,   -1,   -1,   -1,  314,   -1,   37,   38,   -1,   -1,
   -1,   42,   43,   44,   45,   -1,   47,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  124,  125,   58,   59,   60,
   -1,   62,   63,   37,   38,   -1,   -1,   -1,   42,   43,
   -1,   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   60,   -1,   62,   63,
   -1,   -1,   93,   94,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   94,   -1,   -1,  124,  125,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  124,   -1,   -1,   -1,   -1,  124,   -1,   -1,  256,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  272,  273,   -1,   -1,   -1,   -1,
  278,   -1,   -1,   -1,   -1,   -1,   -1,  256,   -1,   -1,
   -1,   -1,   -1,   -1,  292,  293,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  272,  273,   -1,   -1,   -1,   -1,  278,
   -1,   -1,   -1,   -1,   -1,   -1,  314,   -1,   -1,   -1,
   -1,   -1,   -1,  292,  293,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  314,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  265,  266,  267,  268,   -1,  270,
  271,  272,  273,   -1,   -1,   -1,   -1,  278,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  265,  266,  267,  268,  264,  270,  271,  272,  273,
   -1,   -1,   -1,   -1,   -1,  274,  275,  276,  277,   -1,
   -1,   -1,  281,  282,  283,  284,  285,   -1,  287,  288,
  289,   -1,  291,   -1,   -1,  294,  295,  296,  297,  298,
  299,  300,   -1,  302,  303,  304,  305,  306,  307,  308,
  309,  310,  311,  312,  313,   -1,   -1,   -1,  317,  318,
   -1,   -1,  321,  322,   -1,  324,  325,  326,  327,  328,
   -1,  330,  331,   -1,  333,  334,  335,  256,  337,  258,
   -1,  340,   -1,   -1,   -1,  264,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  274,  275,  276,  277,   -1,
   -1,   -1,  281,  282,  283,  284,  285,   -1,  287,  288,
  289,   -1,  291,   -1,   -1,  294,  295,  296,  297,  298,
  299,  300,  301,  302,  303,  304,  305,  306,  307,  308,
  309,  310,  311,  312,  313,   -1,   -1,   -1,  317,  318,
   -1,   -1,  321,  322,   -1,  324,  325,  326,  327,  328,
   -1,  330,  331,   -1,  333,  334,  335,   -1,  337,  338,
  256,  340,   -1,   -1,  260,   -1,   -1,   -1,  264,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  274,  275,
  276,  277,   -1,   -1,   -1,  281,  282,  283,  284,  285,
   -1,  287,  288,  289,   -1,  291,   -1,   -1,  294,  295,
  296,  297,  298,  299,  300,   -1,  302,  303,  304,  305,
  306,  307,  308,  309,  310,  311,  312,  313,   -1,   -1,
   -1,  317,  318,   -1,   -1,  321,  322,   -1,  324,  325,
  326,  327,  328,   -1,  330,  331,   -1,  333,  334,  335,
  256,  337,   -1,   -1,  340,   -1,   -1,   -1,  264,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  274,  275,
  276,  277,   -1,   -1,   -1,  281,  282,  283,  284,  285,
   -1,  287,  288,  289,   -1,  291,   -1,   -1,  294,  295,
  296,  297,  298,  299,  300,   -1,  302,  303,  304,  305,
  306,  307,  308,  309,  310,  311,  312,  313,   -1,   -1,
   -1,  317,  318,   -1,   -1,  321,  322,   -1,  324,  325,
  326,  327,  328,   -1,  330,  331,   -1,  333,  334,  335,
  256,  337,   -1,   -1,  340,   -1,   -1,   -1,  264,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  274,  275,
  276,  277,   -1,   -1,   -1,  281,  282,  283,  284,  285,
   -1,  287,  288,  289,   -1,  291,   -1,   -1,  294,  295,
  296,  297,  298,  299,  300,   -1,  302,  303,  304,  305,
  306,  307,  308,  309,  310,  311,  312,  313,   -1,   -1,
   -1,  317,  318,   -1,   -1,  321,  322,   -1,  324,  325,
  326,  327,  328,   -1,  330,  331,   -1,  333,  334,  335,
  256,  337,   -1,   -1,  340,   -1,   -1,   -1,  264,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  274,  275,
  276,  277,   -1,   -1,   -1,  281,  282,  283,  284,  285,
   -1,  287,  288,  289,   -1,  291,   -1,   -1,  294,  295,
  296,  297,  298,  299,  300,   -1,  302,  303,  304,  305,
  306,  307,  308,  309,  310,  311,  312,  313,   -1,   -1,
   -1,  317,  318,   -1,   -1,  321,  322,   -1,  324,  325,
  326,  327,  328,   -1,  330,  331,   -1,  333,  334,  335,
  256,  337,   -1,   -1,  340,   -1,   -1,   -1,  264,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  274,  275,
  276,  277,   -1,   -1,   -1,  281,  282,  283,  284,  285,
   -1,  287,  288,  289,   -1,  291,   -1,   -1,  294,  295,
  296,  297,  298,  299,  300,   -1,  302,  303,  304,  305,
  306,  307,  308,  309,  310,  311,  312,  313,   -1,   -1,
   -1,  317,  318,   -1,   -1,  321,  322,   -1,  324,  325,
  326,  327,  328,   -1,  330,  331,   -1,  333,  334,  335,
  256,  337,   -1,   -1,  340,   -1,   -1,   -1,  264,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  274,  275,
  276,  277,   -1,   -1,   -1,  281,  282,  283,  284,  285,
   -1,  287,  288,  289,   -1,  291,   -1,   -1,  294,  295,
  296,  297,  298,  299,  300,   -1,  302,  303,  304,  305,
  306,  307,  308,  309,  310,  311,  312,  313,   -1,   -1,
   -1,  317,  318,   -1,   -1,  321,  322,   -1,  324,  325,
  326,  327,  328,   -1,  330,  331,   -1,  333,  334,  335,
  256,  337,   -1,   -1,  340,   -1,   -1,   -1,  264,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  274,  275,
  276,  277,   -1,   -1,   -1,  281,  282,  283,  284,  285,
   -1,  287,  288,  289,   -1,  291,   -1,   -1,  294,  295,
  296,  297,  298,  299,  300,   -1,  302,  303,  304,  305,
  306,  307,  308,  309,  310,  311,  312,  313,   -1,   -1,
   -1,  317,  318,   -1,   -1,  321,  322,   -1,  324,  325,
  326,  327,  328,   -1,  330,  331,   -1,  333,  334,  335,
  256,  337,   -1,   -1,  340,   -1,   -1,   -1,  264,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  274,  275,
  276,  277,   -1,   -1,   -1,  281,  282,  283,  284,  285,
   -1,  287,  288,  289,   -1,  291,   -1,   -1,  294,  295,
  296,  297,  298,  299,  300,   -1,  302,  303,  304,  305,
  306,  307,  308,  309,  310,  311,  312,  313,   -1,   -1,
   -1,  317,  318,   -1,   -1,  321,  322,   -1,  324,  325,
  326,  327,  328,   -1,  330,  331,  258,  333,  334,  335,
   -1,  337,  264,   -1,  340,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  274,  275,  276,  277,   -1,   -1,   -1,  281,
  282,  283,  284,  285,   -1,  287,  288,  289,   -1,  291,
  292,  293,  294,  295,  296,  297,  298,  299,  300,   -1,
  302,  303,  304,  305,  306,  307,  308,  309,  310,  311,
  312,  313,   -1,   -1,   -1,  317,  318,   -1,   -1,  321,
  322,   -1,  324,  325,  326,  327,  328,   -1,  330,  331,
  264,  333,  334,  335,   -1,  337,   -1,   -1,  340,   -1,
  274,  275,  276,  277,   -1,   -1,   -1,  281,  282,  283,
  284,  285,   -1,  287,  288,  289,   -1,  291,  292,  293,
  294,  295,  296,  297,  298,  299,  300,   -1,   -1,  303,
  304,  305,  306,  307,  308,  309,  310,  311,  312,  313,
   -1,   -1,   -1,  317,  318,   -1,   -1,  321,  322,   -1,
  324,  325,  326,  327,  328,   -1,  330,  331,  264,  333,
  334,  335,   -1,  337,   -1,   -1,  340,   -1,  274,  275,
  276,  277,   -1,   -1,   -1,  281,  282,  283,  284,  285,
   -1,  287,  288,  289,   -1,  291,   -1,   -1,  294,  295,
  296,  297,  298,  299,  300,   -1,  302,  303,  304,  305,
  306,  307,  308,  309,  310,  311,  312,  313,   -1,   -1,
   -1,  317,  318,   -1,   -1,  321,  322,   -1,  324,  325,
  326,  327,  328,   -1,  330,  331,  264,  333,  334,  335,
   -1,  337,   -1,   -1,  340,   -1,  274,  275,  276,  277,
   -1,   -1,   -1,  281,  282,  283,  284,  285,   -1,  287,
  288,  289,   -1,  291,   -1,   -1,  294,  295,  296,  297,
  298,  299,  300,   -1,  302,  303,  304,  305,  306,  307,
  308,  309,  310,  311,  312,  313,   -1,   -1,   -1,  317,
  318,   -1,   -1,  321,  322,   -1,  324,  325,  326,  327,
  328,   -1,  330,  331,  264,  333,  334,  335,   -1,  337,
   -1,   -1,  340,   -1,  274,  275,  276,  277,   -1,   -1,
   -1,  281,  282,  283,  284,  285,   -1,  287,  288,  289,
   -1,  291,   -1,   -1,  294,  295,  296,  297,  298,  299,
  300,   -1,  302,  303,  304,  305,  306,  307,  308,  309,
  310,  311,  312,  313,   -1,   -1,   -1,  317,  318,   -1,
   -1,  321,  322,   -1,  324,  325,  326,  327,  328,   -1,
  330,  331,  264,  333,  334,  335,   -1,  337,   -1,   -1,
  340,   -1,  274,  275,  276,  277,   -1,   -1,   -1,  281,
  282,  283,  284,  285,   -1,  287,  288,  289,   -1,  291,
   -1,   -1,  294,  295,  296,  297,  298,  299,  300,   -1,
  302,  303,  304,  305,  306,  307,  308,  309,  310,  311,
  312,  313,   -1,   -1,   -1,  317,  318,   -1,   -1,  321,
  322,   -1,  324,  325,  326,  327,  328,   -1,  330,  331,
  264,  333,  334,  335,   -1,  337,   -1,   -1,  340,   -1,
  274,  275,  276,  277,   -1,   -1,   -1,  281,  282,  283,
  284,  285,   -1,  287,  288,  289,   -1,  291,   -1,   -1,
  294,  295,  296,  297,  298,  299,  300,   -1,  302,  303,
  304,  305,  306,  307,  308,  309,  310,  311,  312,  313,
   -1,   -1,   -1,  317,  318,   -1,   -1,  321,  322,   -1,
  324,  325,  326,  327,  328,   -1,  330,  331,  264,  333,
  334,  335,   -1,  337,   -1,   -1,  340,   -1,  274,  275,
  276,  277,   -1,   -1,   -1,  281,  282,  283,  284,  285,
   -1,  287,  288,  289,   -1,  291,   -1,   -1,  294,  295,
  296,  297,  298,  299,  300,   -1,  302,  303,  304,  305,
  306,  307,  308,  309,  310,  311,  312,  313,   -1,   -1,
   -1,  317,  318,   -1,   -1,  321,  322,   -1,  324,  325,
  326,  327,  328,   -1,  330,  331,  264,  333,  334,  335,
   -1,  337,   -1,   -1,  340,   -1,  274,  275,  276,  277,
   -1,   -1,   -1,  281,  282,  283,  284,  285,   -1,  287,
  288,  289,   -1,  291,   -1,   -1,  294,  295,  296,  297,
  298,  299,  300,   -1,  302,  303,  304,  305,  306,  307,
  308,  309,  310,  311,  312,  313,   -1,   -1,   -1,  317,
  318,   -1,   -1,  321,  322,   -1,  324,  325,  326,  327,
  328,   -1,  330,  331,  264,  333,  334,  335,   -1,  337,
   -1,   -1,  340,   -1,  274,  275,  276,  277,   -1,   -1,
   -1,  281,  282,  283,  284,  285,   -1,  287,  288,  289,
   -1,  291,   -1,   -1,  294,  295,  296,  297,  298,  299,
  300,   -1,  302,  303,  304,  305,  306,  307,  308,  309,
  310,  311,  312,  313,   -1,   -1,   -1,  317,  318,   -1,
   -1,  321,  322,   -1,  324,  325,  326,  327,  328,   -1,
  330,  331,  264,  333,  334,  335,   -1,  337,   -1,   -1,
  340,   -1,  274,  275,  276,  277,   -1,   -1,   -1,  281,
  282,  283,  284,  285,   -1,  287,  288,  289,   -1,  291,
   -1,   -1,  294,  295,  296,  297,  298,  299,  300,   -1,
  302,  303,  304,  305,  306,  307,  308,  309,  310,  311,
  312,  313,   -1,   -1,   -1,  317,  318,   -1,   -1,  321,
  322,   -1,  324,  325,  326,  327,  328,   -1,  330,  331,
  264,  333,  334,  335,   -1,  337,   -1,   -1,  340,   -1,
  274,  275,  276,  277,   -1,   -1,   -1,  281,  282,  283,
  284,  285,   -1,  287,  288,  289,   -1,  291,   -1,   -1,
  294,  295,  296,  297,  298,  299,  300,   -1,  302,  303,
  304,  305,  306,  307,  308,  309,  310,  311,  312,  313,
   -1,   -1,   -1,  317,  318,   -1,   -1,  321,  322,   -1,
  324,  325,  326,  327,  328,   -1,  330,  331,  264,  333,
  334,  335,   -1,  337,   -1,   -1,  340,   -1,  274,  275,
  276,  277,   -1,   -1,   -1,  281,  282,  283,  284,  285,
   -1,  287,  288,  289,   -1,  291,   -1,   -1,  294,  295,
  296,  297,  298,  299,  300,   -1,  302,  303,  304,  305,
  306,  307,  308,  309,  310,  311,  312,  313,   -1,   -1,
   -1,  317,  318,   -1,   -1,  321,  322,   -1,  324,  325,
  326,  327,  328,   -1,  330,  331,  264,  333,  334,  335,
   -1,  337,   -1,   -1,  340,   -1,  274,  275,  276,  277,
   -1,   -1,   -1,  281,  282,  283,  284,  285,   -1,  287,
  288,  289,   -1,  291,   -1,   -1,  294,  295,  296,  297,
  298,  299,  300,   -1,  302,  303,  304,  305,  306,  307,
  308,  309,  310,  311,  312,  313,   -1,   -1,   -1,  317,
  318,   -1,   -1,  321,  322,   -1,  324,  325,  326,  327,
  328,   -1,  330,  331,  264,  333,  334,  335,   -1,  337,
   -1,   -1,  340,   -1,  274,  275,  276,  277,   -1,   -1,
   -1,  281,  282,  283,  284,  285,   -1,  287,  288,  289,
   -1,  291,   -1,   -1,  294,  295,  296,  297,  298,  299,
  300,   -1,  302,  303,  304,  305,  306,  307,  308,  309,
  310,  311,  312,  313,   -1,   -1,   -1,  317,  318,   -1,
   -1,  321,  322,   -1,  324,  325,  326,  327,  328,   -1,
  330,  331,   -1,  333,  334,  335,   -1,  337,   -1,   -1,
  340,
};
#define YYFINAL 1
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 343
#define YYUNDFTOKEN 548
#define YYTRANSLATE(a) ((a) > YYMAXTOKEN ? YYUNDFTOKEN : (a))
#if YYDEBUG
static const char *const yyname[] = {

"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,"'%'","'&'",0,"'('","')'","'*'","'+'","','","'-'","'.'","'/'",0,0,0,0,0,0,
0,0,0,0,"':'","';'","'<'","'='","'>'","'?'","'@'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,"'['",0,"']'","'^'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,"'{'","'|'","'}'","'~'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"TOK_ARROW",
"TOK_CONSTANT","TOK_FLOAT","TOK_STRING","TOK_NUMBER","TOK_INC","TOK_DEC",
"TOK_RETURN","TOK_EQ","TOK_GE","TOK_LE","TOK_NE","TOK_NOT","TOK_LSH","TOK_RSH",
"TOK_LAND","TOK_LOR","TOK_SWITCH","TOK_SSCANF","TOK_CATCH","TOK_FOREACH",
"TOK_LEX_EOF","TOK_ADD_EQ","TOK_AND_EQ","TOK_ARRAY_ID","TOK_ATTRIBUTE_ID",
"TOK_BREAK","TOK_CASE","TOK_CLASS","TOK_COLON_COLON","TOK_CONTINUE",
"TOK_DEFAULT","TOK_DEPRECATED_ID","TOK_DIV_EQ","TOK_DO","TOK_DOT_DOT",
"TOK_DOT_DOT_DOT","TOK_ELSE","TOK_ENUM","TOK_EXTERN","TOK_FLOAT_ID","TOK_FOR",
"TOK_FUNCTION_ID","TOK_GAUGE","TOK_GLOBAL","TOK_IDENTIFIER","TOK_RESERVED",
"TOK_IF","TOK_IMPORT","TOK_INHERIT","TOK_INLINE","TOK_LOCAL_ID","TOK_FINAL_ID",
"TOK_FUNCTION_NAME","TOK_INT_ID","TOK_LAMBDA","TOK_MULTISET_ID",
"TOK_MULTISET_END","TOK_MULTISET_START","TOK_LSH_EQ","TOK_MAPPING_ID",
"TOK_MIXED_ID","TOK_MOD_EQ","TOK_MULT_EQ","TOK_NO_MASK","TOK_OBJECT_ID",
"TOK_OR_EQ","TOK_PRIVATE","TOK_PROGRAM_ID","TOK_PROTECTED","TOK_PREDEF",
"TOK_PUBLIC","TOK_RSH_EQ","TOK_STATIC","TOK_STRING_ID","TOK_SUB_EQ",
"TOK_TYPEDEF","TOK_TYPEOF","TOK_VARIANT","TOK_VERSION","TOK_VOID_ID",
"TOK_WHILE","TOK_XOR_EQ","TOK_OPTIONAL","TOK_SAFE_INDEX","TOK_SAFE_START_INDEX",
"TOK_BITS",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,"illegal-symbol",
};
static const char *const yyrule[] = {
"$accept : all",
"all : program",
"all : program TOK_LEX_EOF",
"program : program def",
"program : program ';'",
"program :",
"real_string_or_identifier : TOK_IDENTIFIER",
"real_string_or_identifier : real_string_constant",
"optional_rename_inherit : ':' real_string_or_identifier",
"optional_rename_inherit : ':' bad_identifier",
"optional_rename_inherit : ':' error",
"optional_rename_inherit :",
"low_program_ref : string_constant",
"low_program_ref : idents",
"program_ref : low_program_ref",
"$$1 :",
"inherit_ref : $$1 low_program_ref",
"inheritance : modifiers TOK_INHERIT inherit_ref optional_rename_inherit ';'",
"inheritance : modifiers TOK_INHERIT inherit_ref error ';'",
"inheritance : modifiers TOK_INHERIT inherit_ref error TOK_LEX_EOF",
"inheritance : modifiers TOK_INHERIT inherit_ref error '}'",
"inheritance : modifiers TOK_INHERIT error ';'",
"inheritance : modifiers TOK_INHERIT error TOK_LEX_EOF",
"inheritance : modifiers TOK_INHERIT error '}'",
"import : TOK_IMPORT idents ';'",
"import : TOK_IMPORT string ';'",
"import : TOK_IMPORT error ';'",
"import : TOK_IMPORT error TOK_LEX_EOF",
"import : TOK_IMPORT error '}'",
"constant_name : TOK_IDENTIFIER '=' safe_expr0",
"constant_name : bad_identifier '=' safe_expr0",
"constant_name : error '=' safe_expr0",
"constant_list : constant_name",
"constant_list : constant_list ',' constant_name",
"constant : modifiers TOK_CONSTANT constant_list ';'",
"constant : modifiers TOK_CONSTANT error ';'",
"constant : modifiers TOK_CONSTANT error TOK_LEX_EOF",
"constant : modifiers TOK_CONSTANT error '}'",
"block_or_semi : block",
"block_or_semi : ';'",
"block_or_semi : TOK_LEX_EOF",
"block_or_semi : error",
"type_or_error : simple_type",
"open_paren_with_line_info : '('",
"close_paren_or_missing : ')'",
"close_paren_or_missing :",
"close_brace_or_missing : '}'",
"close_brace_or_missing :",
"close_brace_or_eof : '}'",
"close_brace_or_eof : TOK_LEX_EOF",
"open_bracket_with_line_info : '['",
"close_bracket_or_missing : ']'",
"close_bracket_or_missing :",
"push_compiler_frame0 :",
"optional_constant :",
"optional_constant : TOK_CONSTANT",
"$$2 :",
"$$3 :",
"def : modifiers optional_attributes type_or_error optional_constant optional_stars TOK_IDENTIFIER push_compiler_frame0 '(' $$2 arguments close_paren_or_missing $$3 block_or_semi",
"def : modifiers optional_attributes type_or_error optional_constant optional_stars TOK_IDENTIFIER push_compiler_frame0 error",
"$$4 :",
"def : modifiers optional_attributes type_or_error optional_constant optional_stars bad_identifier $$4 '(' arguments ')' block_or_semi",
"def : modifiers optional_attributes type_or_error optional_constant name_list ';'",
"def : inheritance",
"def : import",
"def : constant",
"def : modifiers class",
"def : modifiers enum",
"def : typedef",
"def : error TOK_LEX_EOF",
"def : error ';'",
"def : error '}'",
"$$5 :",
"def : modifiers '{' $$5 program close_brace_or_eof",
"optional_dot_dot_dot : TOK_DOT_DOT_DOT",
"optional_dot_dot_dot : TOK_DOT_DOT",
"optional_dot_dot_dot :",
"optional_identifier : TOK_IDENTIFIER",
"optional_identifier : bad_identifier",
"optional_identifier :",
"new_arg_name : full_type optional_dot_dot_dot optional_identifier",
"func_args : '(' arguments close_paren_or_missing",
"arguments : optional_comma",
"arguments : arguments2 optional_comma",
"arguments2 : new_arg_name",
"arguments2 : arguments2 ',' new_arg_name",
"arguments2 : arguments2 ':' new_arg_name",
"modifier : TOK_NO_MASK",
"modifier : TOK_FINAL_ID",
"modifier : TOK_STATIC",
"modifier : TOK_EXTERN",
"modifier : TOK_OPTIONAL",
"modifier : TOK_PRIVATE",
"modifier : TOK_LOCAL_ID",
"modifier : TOK_PUBLIC",
"modifier : TOK_PROTECTED",
"modifier : TOK_INLINE",
"modifier : TOK_VARIANT",
"magic_identifiers1 : TOK_NO_MASK",
"magic_identifiers1 : TOK_FINAL_ID",
"magic_identifiers1 : TOK_STATIC",
"magic_identifiers1 : TOK_EXTERN",
"magic_identifiers1 : TOK_PRIVATE",
"magic_identifiers1 : TOK_LOCAL_ID",
"magic_identifiers1 : TOK_PUBLIC",
"magic_identifiers1 : TOK_PROTECTED",
"magic_identifiers1 : TOK_INLINE",
"magic_identifiers1 : TOK_OPTIONAL",
"magic_identifiers1 : TOK_VARIANT",
"magic_identifiers2 : TOK_VOID_ID",
"magic_identifiers2 : TOK_MIXED_ID",
"magic_identifiers2 : TOK_ARRAY_ID",
"magic_identifiers2 : TOK_ATTRIBUTE_ID",
"magic_identifiers2 : TOK_DEPRECATED_ID",
"magic_identifiers2 : TOK_MAPPING_ID",
"magic_identifiers2 : TOK_MULTISET_ID",
"magic_identifiers2 : TOK_OBJECT_ID",
"magic_identifiers2 : TOK_FUNCTION_ID",
"magic_identifiers2 : TOK_FUNCTION_NAME",
"magic_identifiers2 : TOK_PROGRAM_ID",
"magic_identifiers2 : TOK_STRING_ID",
"magic_identifiers2 : TOK_FLOAT_ID",
"magic_identifiers2 : TOK_INT_ID",
"magic_identifiers2 : TOK_ENUM",
"magic_identifiers2 : TOK_TYPEDEF",
"magic_identifiers3 : TOK_IF",
"magic_identifiers3 : TOK_DO",
"magic_identifiers3 : TOK_FOR",
"magic_identifiers3 : TOK_WHILE",
"magic_identifiers3 : TOK_ELSE",
"magic_identifiers3 : TOK_FOREACH",
"magic_identifiers3 : TOK_CATCH",
"magic_identifiers3 : TOK_GAUGE",
"magic_identifiers3 : TOK_CLASS",
"magic_identifiers3 : TOK_BREAK",
"magic_identifiers3 : TOK_CASE",
"magic_identifiers3 : TOK_CONSTANT",
"magic_identifiers3 : TOK_CONTINUE",
"magic_identifiers3 : TOK_DEFAULT",
"magic_identifiers3 : TOK_IMPORT",
"magic_identifiers3 : TOK_INHERIT",
"magic_identifiers3 : TOK_LAMBDA",
"magic_identifiers3 : TOK_PREDEF",
"magic_identifiers3 : TOK_RETURN",
"magic_identifiers3 : TOK_SSCANF",
"magic_identifiers3 : TOK_SWITCH",
"magic_identifiers3 : TOK_TYPEOF",
"magic_identifiers3 : TOK_GLOBAL",
"magic_identifiers : magic_identifiers1",
"magic_identifiers : magic_identifiers2",
"magic_identifiers : magic_identifiers3",
"magic_identifier : TOK_IDENTIFIER",
"magic_identifier : TOK_RESERVED",
"magic_identifier : magic_identifiers",
"modifiers : modifier_list",
"modifier_list :",
"modifier_list : modifier_list modifier",
"attribute : TOK_ATTRIBUTE_ID '(' string_constant optional_comma ')'",
"attribute : TOK_DEPRECATED_ID '(' ')'",
"attribute : TOK_DEPRECATED_ID",
"optional_attributes :",
"optional_attributes : optional_attributes attribute",
"optional_stars :",
"cast : open_paren_with_line_info type ')'",
"soft_cast : open_bracket_with_line_info type ']'",
"type2 : type",
"type2 : identifier_type",
"simple_type : full_type",
"simple_type2 : type",
"simple_identifier_type : identifier_type",
"full_type : full_type '|' type3",
"full_type : type3",
"type : type '|' type3",
"type : basic_type",
"type3 : basic_type",
"type3 : identifier_type",
"basic_type : TOK_FLOAT_ID",
"basic_type : TOK_VOID_ID",
"basic_type : TOK_MIXED_ID",
"basic_type : TOK_STRING_ID opt_string_width",
"basic_type : TOK_INT_ID opt_int_range",
"basic_type : TOK_MAPPING_ID opt_mapping_type",
"basic_type : TOK_FUNCTION_ID opt_function_type",
"basic_type : TOK_OBJECT_ID opt_object_type",
"basic_type : TOK_PROGRAM_ID opt_program_type",
"basic_type : TOK_ARRAY_ID opt_array_type",
"basic_type : TOK_MULTISET_ID opt_array_type",
"basic_type : TOK_ATTRIBUTE_ID '(' string_constant ',' full_type ')'",
"basic_type : TOK_ATTRIBUTE_ID '(' string_constant error ')'",
"basic_type : TOK_ATTRIBUTE_ID error",
"basic_type : TOK_DEPRECATED_ID '(' full_type ')'",
"basic_type : TOK_DEPRECATED_ID '(' error ')'",
"identifier_type : idents",
"number_or_maxint :",
"number_or_maxint : TOK_NUMBER",
"number_or_maxint : '-' TOK_NUMBER",
"number_or_minint :",
"number_or_minint : TOK_NUMBER",
"number_or_minint : '-' TOK_NUMBER",
"expected_dot_dot : TOK_DOT_DOT",
"expected_dot_dot : TOK_DOT_DOT_DOT",
"opt_int_range :",
"opt_int_range : '(' TOK_BITS ')'",
"opt_int_range : '(' number_or_minint expected_dot_dot number_or_maxint ')'",
"opt_int_range : '(' error ')'",
"opt_string_width : opt_int_range",
"opt_object_type :",
"$$6 :",
"opt_object_type : $$6 '(' program_ref ')'",
"opt_program_type :",
"opt_program_type : '(' full_type ')'",
"opt_program_type : '(' error ')'",
"$$7 :",
"$$8 :",
"opt_function_type : '(' $$7 function_type_list optional_dot_dot_dot ':' $$8 full_type ')'",
"opt_function_type :",
"function_type_list : optional_comma",
"function_type_list : function_type_list2 optional_comma",
"function_type_list2 : full_type",
"$$9 :",
"function_type_list2 : function_type_list2 ',' $$9 full_type",
"opt_array_type : '(' full_type ')'",
"opt_array_type :",
"$$10 :",
"$$11 :",
"$$12 :",
"opt_mapping_type : '(' $$10 full_type ':' $$11 full_type $$12 ')'",
"opt_mapping_type :",
"name_list : new_name",
"name_list : name_list ',' new_name",
"new_name : optional_stars TOK_IDENTIFIER",
"new_name : optional_stars bad_identifier",
"$$13 :",
"new_name : optional_stars TOK_IDENTIFIER '=' $$13 expr0",
"new_name : optional_stars TOK_IDENTIFIER '=' error",
"new_name : optional_stars TOK_IDENTIFIER '=' TOK_LEX_EOF",
"new_name : optional_stars bad_identifier '=' expr0",
"new_local_name : optional_stars TOK_IDENTIFIER",
"new_local_name : optional_stars bad_identifier",
"new_local_name : optional_stars TOK_IDENTIFIER '=' expr0",
"new_local_name : optional_stars bad_identifier '=' expr0",
"new_local_name : optional_stars TOK_IDENTIFIER '=' error",
"new_local_name : optional_stars TOK_IDENTIFIER '=' TOK_LEX_EOF",
"new_local_name2 : TOK_IDENTIFIER",
"new_local_name2 : bad_identifier",
"new_local_name2 : TOK_IDENTIFIER '=' safe_expr0",
"new_local_name2 : bad_identifier '=' safe_expr0",
"line_number_info :",
"$$14 :",
"$$15 :",
"$$16 :",
"block : '{' $$14 line_number_info $$15 $$16 statements end_block",
"end_block : '}'",
"end_block : TOK_LEX_EOF",
"failsafe_block : block",
"failsafe_block : error",
"failsafe_block : TOK_LEX_EOF",
"propagated_type :",
"local_name_list : new_local_name",
"local_name_list : local_name_list ',' propagated_type new_local_name",
"local_name_list2 : new_local_name2",
"local_name_list2 : local_name_list2 ',' propagated_type new_local_name",
"local_constant_name : TOK_IDENTIFIER '=' safe_expr0",
"local_constant_name : bad_identifier '=' safe_expr0",
"local_constant_name : error '=' safe_expr0",
"local_constant_list : local_constant_name",
"local_constant_list : local_constant_list ',' local_constant_name",
"local_constant : TOK_CONSTANT local_constant_list ';'",
"local_constant : TOK_CONSTANT error ';'",
"local_constant : TOK_CONSTANT error TOK_LEX_EOF",
"local_constant : TOK_CONSTANT error '}'",
"statements :",
"statements : statements statement",
"statement_with_semicolon : unused2 expected_semicolon",
"normal_label_statement : statement_with_semicolon",
"normal_label_statement : import",
"normal_label_statement : cond",
"normal_label_statement : return",
"normal_label_statement : local_constant",
"normal_label_statement : block",
"normal_label_statement : break expected_semicolon",
"normal_label_statement : continue expected_semicolon",
"normal_label_statement : error ';'",
"normal_label_statement : error TOK_LEX_EOF",
"normal_label_statement : error '}'",
"normal_label_statement : ';'",
"statement : normal_label_statement",
"statement : while",
"statement : do",
"statement : for",
"statement : foreach",
"statement : switch",
"statement : case",
"statement : default",
"statement : labeled_statement",
"$$17 :",
"labeled_statement : TOK_IDENTIFIER $$17 ':' statement",
"optional_label : TOK_IDENTIFIER",
"optional_label :",
"break : TOK_BREAK optional_label",
"default : TOK_DEFAULT ':'",
"default : TOK_DEFAULT",
"continue : TOK_CONTINUE optional_label",
"push_compiler_frame1 :",
"implicit_identifier :",
"$$18 :",
"$$19 :",
"lambda : TOK_LAMBDA line_number_info implicit_identifier push_compiler_frame1 $$18 func_args $$19 failsafe_block",
"lambda : TOK_LAMBDA line_number_info implicit_identifier push_compiler_frame1 error",
"$$20 :",
"local_function : TOK_IDENTIFIER push_compiler_frame1 func_args $$20 failsafe_block",
"local_function : TOK_IDENTIFIER push_compiler_frame1 error",
"$$21 :",
"local_function2 : optional_stars TOK_IDENTIFIER push_compiler_frame1 func_args $$21 failsafe_block",
"local_function2 : optional_stars TOK_IDENTIFIER push_compiler_frame1 error",
"create_arg : modifiers type_or_error optional_stars optional_dot_dot_dot TOK_IDENTIFIER",
"create_arg : modifiers type_or_error optional_stars bad_identifier",
"create_arguments2 : create_arg",
"create_arguments2 : create_arguments2 ',' create_arg",
"create_arguments2 : create_arguments2 ':' create_arg",
"create_arguments : optional_comma",
"create_arguments : create_arguments2 optional_comma",
"optional_create_arguments :",
"optional_create_arguments : '(' create_arguments close_paren_or_missing",
"$$22 :",
"failsafe_program : '{' program $$22 end_block",
"failsafe_program : error",
"failsafe_program : TOK_LEX_EOF",
"$$23 :",
"$$24 :",
"class : TOK_CLASS line_number_info optional_identifier $$23 $$24 optional_create_arguments failsafe_program",
"simple_identifier : TOK_IDENTIFIER",
"simple_identifier : bad_identifier",
"enum_value :",
"enum_value : '=' safe_expr0",
"enum_def :",
"enum_def : simple_identifier enum_value",
"propagated_enum_value :",
"enum_list : enum_def",
"enum_list : enum_list ',' propagated_enum_value enum_def",
"enum_list : error",
"$$25 :",
"$$26 :",
"$$27 :",
"enum : TOK_ENUM $$25 optional_identifier '{' $$26 enum_list $$27 end_block",
"typedef : modifiers TOK_TYPEDEF full_type simple_identifier ';'",
"$$28 :",
"$$29 :",
"cond : TOK_IF $$28 line_number_info $$29 '(' safe_comma_expr end_cond statement optional_else_part",
"end_cond : ')'",
"end_cond : '}'",
"end_cond : TOK_LEX_EOF",
"optional_else_part :",
"optional_else_part : TOK_ELSE statement",
"safe_lvalue : lvalue",
"safe_lvalue : error",
"safe_expr0 : expr0",
"safe_expr0 : TOK_LEX_EOF",
"safe_expr0 : error",
"foreach_optional_lvalue :",
"foreach_optional_lvalue : safe_lvalue",
"foreach_lvalues : ',' safe_lvalue",
"foreach_lvalues : ';' foreach_optional_lvalue ';' foreach_optional_lvalue",
"$$30 :",
"$$31 :",
"foreach : TOK_FOREACH $$30 line_number_info $$31 '(' expr0 foreach_lvalues end_cond statement",
"do : TOK_DO line_number_info statement TOK_WHILE '(' safe_comma_expr end_cond expected_semicolon",
"do : TOK_DO line_number_info statement TOK_WHILE TOK_LEX_EOF",
"do : TOK_DO line_number_info statement TOK_LEX_EOF",
"expected_semicolon : ';'",
"expected_semicolon : TOK_LEX_EOF",
"$$32 :",
"$$33 :",
"for : TOK_FOR $$32 line_number_info $$33 '(' unused expected_semicolon for_expr expected_semicolon unused end_cond statement",
"$$34 :",
"$$35 :",
"while : TOK_WHILE $$34 line_number_info $$35 '(' safe_comma_expr end_cond statement",
"for_expr :",
"for_expr : safe_comma_expr",
"$$36 :",
"$$37 :",
"switch : TOK_SWITCH $$36 line_number_info $$37 '(' safe_comma_expr end_cond statement",
"case : TOK_CASE safe_comma_expr expected_colon",
"case : TOK_CASE safe_comma_expr expected_dot_dot optional_comma_expr expected_colon",
"case : TOK_CASE expected_dot_dot safe_comma_expr expected_colon",
"expected_colon : ':'",
"expected_colon : ';'",
"expected_colon : '}'",
"expected_colon : TOK_LEX_EOF",
"return : TOK_RETURN expected_semicolon",
"return : TOK_RETURN safe_comma_expr expected_semicolon",
"unused :",
"unused : safe_comma_expr",
"unused2 : comma_expr",
"optional_comma_expr :",
"optional_comma_expr : safe_comma_expr",
"safe_comma_expr : comma_expr",
"safe_comma_expr : error",
"comma_expr : comma_expr2",
"comma_expr : simple_type2 local_name_list",
"comma_expr : simple_identifier_type local_name_list2",
"comma_expr : simple_identifier_type local_function",
"comma_expr : simple_type2 local_function2",
"comma_expr2 : expr0",
"comma_expr2 : comma_expr2 ',' expr0",
"expr00 : expr0",
"expr00 : '@' expr0",
"expr0 : expr01",
"expr0 : expr4 '=' expr0",
"expr0 : expr4 '=' error",
"expr0 : bad_expr_ident '=' expr0",
"expr0 : open_bracket_with_line_info low_lvalue_list ']' '=' expr0",
"expr0 : expr4 assign expr0",
"expr0 : expr4 assign error",
"expr0 : bad_expr_ident assign expr0",
"expr0 : open_bracket_with_line_info low_lvalue_list ']' assign expr0",
"expr0 : open_bracket_with_line_info low_lvalue_list ']' error",
"expr01 : expr1",
"expr01 : expr1 '?' expr01 ':' expr01",
"assign : TOK_AND_EQ",
"assign : TOK_OR_EQ",
"assign : TOK_XOR_EQ",
"assign : TOK_LSH_EQ",
"assign : TOK_RSH_EQ",
"assign : TOK_ADD_EQ",
"assign : TOK_SUB_EQ",
"assign : TOK_MULT_EQ",
"assign : TOK_MOD_EQ",
"assign : TOK_DIV_EQ",
"optional_comma :",
"optional_comma : ','",
"expr_list :",
"expr_list : expr_list2 optional_comma",
"expr_list2 : expr00",
"expr_list2 : expr_list2 ',' expr00",
"m_expr_list :",
"m_expr_list : m_expr_list2 optional_comma",
"m_expr_list2 : assoc_pair",
"m_expr_list2 : m_expr_list2 ',' assoc_pair",
"m_expr_list2 : m_expr_list2 ',' error",
"assoc_pair : expr0 expected_colon expr0",
"assoc_pair : expr0 expected_colon error",
"expr1 : expr2",
"expr1 : expr1 TOK_LOR expr1",
"expr1 : expr1 TOK_LAND expr1",
"expr1 : expr1 '|' expr1",
"expr1 : expr1 '^' expr1",
"expr1 : expr1 '&' expr1",
"expr1 : expr1 TOK_EQ expr1",
"expr1 : expr1 TOK_NE expr1",
"expr1 : expr1 '>' expr1",
"expr1 : expr1 TOK_GE expr1",
"expr1 : expr1 '<' expr1",
"expr1 : expr1 TOK_LE expr1",
"expr1 : expr1 TOK_LSH expr1",
"expr1 : expr1 TOK_RSH expr1",
"expr1 : expr1 '+' expr1",
"expr1 : expr1 '-' expr1",
"expr1 : expr1 '*' expr1",
"expr1 : expr1 '%' expr1",
"expr1 : expr1 '/' expr1",
"expr1 : expr1 TOK_LOR error",
"expr1 : expr1 TOK_LAND error",
"expr1 : expr1 '|' error",
"expr1 : expr1 '^' error",
"expr1 : expr1 '&' error",
"expr1 : expr1 TOK_EQ error",
"expr1 : expr1 TOK_NE error",
"expr1 : expr1 '>' error",
"expr1 : expr1 TOK_GE error",
"expr1 : expr1 '<' error",
"expr1 : expr1 TOK_LE error",
"expr1 : expr1 TOK_LSH error",
"expr1 : expr1 TOK_RSH error",
"expr1 : expr1 '+' error",
"expr1 : expr1 '-' error",
"expr1 : expr1 '*' error",
"expr1 : expr1 '%' error",
"expr1 : expr1 '/' error",
"expr2 : expr3",
"expr2 : cast expr2",
"expr2 : soft_cast expr2",
"expr2 : TOK_INC expr4",
"expr2 : TOK_DEC expr4",
"expr2 : TOK_NOT expr2",
"expr2 : '~' expr2",
"expr2 : '-' expr2",
"expr3 : expr4",
"expr3 : expr4 TOK_INC",
"expr3 : expr4 TOK_DEC",
"optional_block :",
"$$38 :",
"optional_block : '{' line_number_info push_compiler_frame1 $$38 statements end_block",
"apply : expr4 open_paren_with_line_info expr_list ')' optional_block",
"apply : expr4 open_paren_with_line_info error ')' optional_block",
"apply : expr4 open_paren_with_line_info error TOK_LEX_EOF",
"apply : expr4 open_paren_with_line_info error ';'",
"apply : expr4 open_paren_with_line_info error '}'",
"implicit_modifiers :",
"expr4 : string",
"expr4 : TOK_NUMBER",
"expr4 : TOK_FLOAT",
"expr4 : catch",
"expr4 : gauge",
"expr4 : typeof",
"expr4 : sscanf",
"expr4 : lambda",
"expr4 : implicit_modifiers class",
"expr4 : implicit_modifiers enum",
"expr4 : idents2",
"expr4 : apply",
"expr4 : expr4 open_bracket_with_line_info '*' ']'",
"expr4 : expr4 open_bracket_with_line_info expr0 ']'",
"expr4 : expr4 open_bracket_with_line_info range_bound expected_dot_dot range_bound ']'",
"expr4 : expr4 TOK_SAFE_START_INDEX line_number_info expr0 ']'",
"expr4 : expr4 TOK_SAFE_START_INDEX line_number_info range_bound expected_dot_dot range_bound ']'",
"expr4 : expr4 open_bracket_with_line_info error ']'",
"expr4 : expr4 open_bracket_with_line_info error TOK_LEX_EOF",
"expr4 : expr4 open_bracket_with_line_info error ';'",
"expr4 : expr4 open_bracket_with_line_info error '}'",
"expr4 : expr4 open_bracket_with_line_info error ')'",
"expr4 : open_paren_with_line_info comma_expr2 ')'",
"expr4 : open_paren_with_line_info '{' expr_list close_brace_or_missing ')'",
"expr4 : open_paren_with_line_info open_bracket_with_line_info m_expr_list close_bracket_or_missing ')'",
"expr4 : TOK_MULTISET_START line_number_info expr_list TOK_MULTISET_END",
"expr4 : TOK_MULTISET_START line_number_info expr_list ')'",
"expr4 : open_paren_with_line_info error ')'",
"expr4 : open_paren_with_line_info error TOK_LEX_EOF",
"expr4 : open_paren_with_line_info error ';'",
"expr4 : open_paren_with_line_info error '}'",
"expr4 : TOK_MULTISET_START line_number_info error TOK_MULTISET_END",
"expr4 : TOK_MULTISET_START line_number_info error ')'",
"expr4 : TOK_MULTISET_START line_number_info error TOK_LEX_EOF",
"expr4 : TOK_MULTISET_START line_number_info error ';'",
"expr4 : TOK_MULTISET_START line_number_info error '}'",
"expr4 : expr4 TOK_ARROW line_number_info magic_identifier",
"expr4 : expr4 TOK_SAFE_INDEX line_number_info TOK_IDENTIFIER",
"expr4 : expr4 '.' line_number_info TOK_IDENTIFIER",
"expr4 : expr4 TOK_ARROW line_number_info error",
"idents2 : idents",
"idents2 : TOK_LOCAL_ID TOK_COLON_COLON TOK_IDENTIFIER",
"idents2 : TOK_LOCAL_ID TOK_COLON_COLON bad_identifier",
"idents : low_idents",
"idents : idents '.' TOK_IDENTIFIER",
"idents : idents '.' bad_identifier",
"idents : idents '.' error",
"string_or_identifier : TOK_IDENTIFIER",
"string_or_identifier : string",
"inherit_specifier : string_or_identifier TOK_COLON_COLON",
"inherit_specifier : TOK_GLOBAL TOK_COLON_COLON",
"inherit_specifier : inherit_specifier TOK_IDENTIFIER TOK_COLON_COLON",
"inherit_specifier : inherit_specifier bad_identifier TOK_COLON_COLON",
"low_idents : TOK_IDENTIFIER",
"low_idents : '.' TOK_IDENTIFIER",
"low_idents : TOK_GLOBAL '.' TOK_IDENTIFIER",
"low_idents : TOK_RESERVED",
"low_idents : TOK_PREDEF TOK_COLON_COLON TOK_IDENTIFIER",
"low_idents : TOK_PREDEF TOK_COLON_COLON bad_identifier",
"low_idents : TOK_VERSION TOK_COLON_COLON TOK_IDENTIFIER",
"low_idents : TOK_VERSION TOK_COLON_COLON bad_identifier",
"low_idents : inherit_specifier TOK_IDENTIFIER",
"low_idents : inherit_specifier bad_identifier",
"low_idents : inherit_specifier error",
"low_idents : TOK_COLON_COLON TOK_IDENTIFIER",
"low_idents : TOK_COLON_COLON bad_identifier",
"range_bound :",
"range_bound : comma_expr",
"range_bound : '<' comma_expr",
"range_bound : TOK_LEX_EOF",
"range_bound : '<' TOK_LEX_EOF",
"gauge : TOK_GAUGE catch_arg",
"typeof : TOK_TYPEOF '(' expr0 ')'",
"typeof : TOK_TYPEOF '(' error ')'",
"typeof : TOK_TYPEOF '(' error '}'",
"typeof : TOK_TYPEOF '(' error TOK_LEX_EOF",
"typeof : TOK_TYPEOF '(' error ';'",
"catch_arg : '(' comma_expr ')'",
"catch_arg : '(' error ')'",
"catch_arg : '(' error TOK_LEX_EOF",
"catch_arg : '(' error '}'",
"catch_arg : '(' error ';'",
"catch_arg : block",
"catch_arg : error",
"$$39 :",
"catch : TOK_CATCH $$39 catch_arg",
"sscanf : TOK_SSCANF '(' expr0 ',' expr0 lvalue_list ')'",
"sscanf : TOK_SSCANF '(' expr0 ',' expr0 error ')'",
"sscanf : TOK_SSCANF '(' expr0 ',' expr0 error TOK_LEX_EOF",
"sscanf : TOK_SSCANF '(' expr0 ',' expr0 error '}'",
"sscanf : TOK_SSCANF '(' expr0 ',' expr0 error ';'",
"sscanf : TOK_SSCANF '(' expr0 error ')'",
"sscanf : TOK_SSCANF '(' expr0 error TOK_LEX_EOF",
"sscanf : TOK_SSCANF '(' expr0 error '}'",
"sscanf : TOK_SSCANF '(' expr0 error ';'",
"sscanf : TOK_SSCANF '(' error ')'",
"sscanf : TOK_SSCANF '(' error TOK_LEX_EOF",
"sscanf : TOK_SSCANF '(' error '}'",
"sscanf : TOK_SSCANF '(' error ';'",
"lvalue : expr4",
"lvalue : open_bracket_with_line_info low_lvalue_list ']'",
"lvalue : type2 TOK_IDENTIFIER",
"lvalue : bad_expr_ident",
"low_lvalue_list : lvalue lvalue_list",
"lvalue_list :",
"lvalue_list : ',' lvalue lvalue_list",
"string_segment : TOK_STRING",
"string_segment : TOK_FUNCTION_NAME",
"string : string_segment",
"string : string string_segment",
"string_constant : string",
"string_constant : string_constant '+' string",
"real_string_constant : TOK_STRING",
"real_string_constant : real_string_constant TOK_STRING",
"real_string_constant : real_string_constant '+' TOK_STRING",
"bad_identifier : bad_expr_ident",
"bad_identifier : TOK_ARRAY_ID",
"bad_identifier : TOK_ATTRIBUTE_ID",
"bad_identifier : TOK_CLASS",
"bad_identifier : TOK_DEPRECATED_ID",
"bad_identifier : TOK_ENUM",
"bad_identifier : TOK_FLOAT_ID",
"bad_identifier : TOK_FUNCTION_ID",
"bad_identifier : TOK_FUNCTION_NAME",
"bad_identifier : TOK_INT_ID",
"bad_identifier : TOK_MAPPING_ID",
"bad_identifier : TOK_MIXED_ID",
"bad_identifier : TOK_MULTISET_ID",
"bad_identifier : TOK_OBJECT_ID",
"bad_identifier : TOK_PROGRAM_ID",
"bad_identifier : TOK_STRING_ID",
"bad_identifier : TOK_TYPEDEF",
"bad_identifier : TOK_VOID_ID",
"bad_identifier : TOK_RESERVED",
"bad_expr_ident : TOK_INLINE",
"bad_expr_ident : TOK_LOCAL_ID",
"bad_expr_ident : TOK_NO_MASK",
"bad_expr_ident : TOK_PREDEF",
"bad_expr_ident : TOK_PRIVATE",
"bad_expr_ident : TOK_PROTECTED",
"bad_expr_ident : TOK_PUBLIC",
"bad_expr_ident : TOK_OPTIONAL",
"bad_expr_ident : TOK_VARIANT",
"bad_expr_ident : TOK_STATIC",
"bad_expr_ident : TOK_EXTERN",
"bad_expr_ident : TOK_FINAL_ID",
"bad_expr_ident : TOK_DO",
"bad_expr_ident : TOK_ELSE",
"bad_expr_ident : TOK_RETURN",
"bad_expr_ident : TOK_IMPORT",
"bad_expr_ident : TOK_INHERIT",
"bad_expr_ident : TOK_CATCH",
"bad_expr_ident : TOK_GAUGE",
"bad_expr_ident : TOK_LAMBDA",
"bad_expr_ident : TOK_SSCANF",
"bad_expr_ident : TOK_SWITCH",
"bad_expr_ident : TOK_TYPEOF",
"bad_expr_ident : TOK_BREAK",
"bad_expr_ident : TOK_CASE",
"bad_expr_ident : TOK_CONTINUE",
"bad_expr_ident : TOK_DEFAULT",
"bad_expr_ident : TOK_FOR",
"bad_expr_ident : TOK_FOREACH",
"bad_expr_ident : TOK_IF",

};
#endif

#if YYDEBUG
int      yydebug;
#endif

/* define the initial stack-sizes */
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH  YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 10000
#define YYMAXDEPTH  10000
#endif
#endif

#define YYINITSTACKSIZE 200

typedef struct {
    unsigned stacksize;
    YYINT    *s_base;
    YYINT    *s_mark;
    YYINT    *s_last;
    YYSTYPE  *l_base;
    YYSTYPE  *l_mark;
} YYSTACKDATA;
#line 4591 "language.yacc"

static void yyerror_reserved(const char *keyword)
{
  my_yyerror("%s is a reserved word.", keyword);
}

static struct pike_string *get_new_name(struct pike_string *prefix)
{
  char buf[40];
  /* Generate a name for a global symbol... */
  sprintf(buf,"__lambda_%ld_%ld_line_%d",
	  (long)Pike_compiler->new_program->id,
	  (long)(Pike_compiler->local_class_counter++ & 0xffffffff), /* OSF/1 cc bug. */
	  (int) THIS_COMPILATION->lex.current_line);
  if (prefix) {
    struct string_builder sb;
    init_string_builder_alloc(&sb, prefix->len + strlen(buf) + 1,
			      prefix->size_shift);
    string_builder_shared_strcat(&sb, prefix);
    string_builder_putchar(&sb, 0);
    string_builder_strcat(&sb, buf);
    return finish_string_builder(&sb);
  }
  return make_shared_string(buf);
}


static int low_islocal(struct compiler_frame *f,
		       struct pike_string *str)
{
  int e;
  for(e=f->current_number_of_locals-1;e>=0;e--)
    if(f->variable[e].name==str) {
      f->variable[e].flags |= LOCAL_VAR_IS_USED;
      return e;
    }
  return -1;
}


/* Add a local variable to the current function in frame.
 * NOTE: Steals the references to type and def, but not to str.
 */
int low_add_local_name(struct compiler_frame *frame,
		       struct pike_string *str,
		       struct pike_type *type,
		       node *def)
{

  if (str->len) {
    int tmp=low_islocal(frame,str);
    if(tmp>=0 && tmp >= frame->last_block_level)
    {
      my_yyerror("Duplicate local variable %S, "
		 "previous declaration on line %d\n",
		 str, frame->variable[tmp].line);
    }

    if(type == void_type_string)
    {
      my_yyerror("Local variable %S is void.\n", str);
    }
  }

  debug_malloc_touch(def);
  debug_malloc_touch(type);
  debug_malloc_touch(str);
  /* NOTE: The number of locals can be 0..255 (not 256), due to
   *       the use of READ_INCR_BYTE() in apply_low.h.
   */
  if (frame->current_number_of_locals == MAX_LOCAL-1)
  {
    my_yyerror("Too many local variables: no space for local variable %S.",
	       str);
    free_type(type);
    if (def) free_node(def);
    return -1;
  } else {
    int var = frame->current_number_of_locals;

#ifdef PIKE_DEBUG
    check_type_string(type);
#endif /* PIKE_DEBUG */
    if (pike_types_le(type, void_type_string)) {
      if (Pike_compiler->compiler_pass != 1) {
	yywarning("Declaring local variable %S with type void "
		  "(converted to type zero).", str);
      }
      free_type(type);
      copy_pike_type(type, zero_type_string);
    }
    frame->variable[var].type = type;
    frame->variable[var].name = str;
    reference_shared_string(str);
    frame->variable[var].def = def;

    frame->variable[var].line = THIS_COMPILATION->lex.current_line;
    copy_shared_string(frame->variable[var].file,
		       THIS_COMPILATION->lex.current_file);

    if (pike_types_le(void_type_string, type)) {
      /* Don't warn about unused voidable variables. */
      frame->variable[var].flags = LOCAL_VAR_IS_USED;
    } else {
      frame->variable[var].flags = 0;
    }

    frame->current_number_of_locals++;
    if(frame->current_number_of_locals > frame->max_number_of_locals)
    {
      frame->max_number_of_locals = frame->current_number_of_locals;
    }

    return var;
  }
}


/* argument must be a shared string */
/* Note that this function eats a reference to 'type' */
/* If def is nonzero, it also eats a ref to def */
int add_local_name(struct pike_string *str,
		   struct pike_type *type,
		   node *def)
{
  return low_add_local_name(Pike_compiler->compiler_frame,
			    str,
			    type,
			    def);
}

/* Mark local variables declared in a multi-assign or sscanf expression
 * as used. */
static void mark_lvalues_as_used(node *n)
{
  while (n && n->token == F_LVALUE_LIST) {
    if (!CAR(n)) {
      /* Can happen if a variable hasn't been declared. */
    } else if (CAR(n)->token == F_ARRAY_LVALUE) {
      mark_lvalues_as_used(CAAR(n));
    } else if ((CAR(n)->token == F_LOCAL) && !(CAR(n)->u.integer.b)) {
      Pike_compiler->compiler_frame->variable[CAR(n)->u.integer.a].flags |=
	LOCAL_VAR_IS_USED;
    }
    n = CDR(n);
  }
}

#if 0
/* Note that this function eats a reference to each of
 * 'type' and 'initializer', but not to 'name'.
 * Note also that 'initializer' may be NULL.
 */
static node *add_protected_variable(struct pike_string *name,
				    struct pike_type *type,
				    int depth,
				    node *initializer)
{
  struct compiler_frame *f = Pike_compiler->compiler_frame;
  int i;
  int id;
  node *n = NULL;

  if (initializer) {
    /* FIXME: We need to pop levels off local and external variables here. */
  }

  for(i = depth; f && i; i--) {
    f->lexical_scope |= SCOPE_SCOPED;
    f = f->previous;
  }
  if (!f) {
    int parent_depth = i;
    struct program_state *p = Pike_compiler;
    struct pike_string *tmp_name;
    while (i--) {
      if (!p->previous) {
	my_yyerror("Too many levels of protected (%d, max:%d).",
		   depth, depth - (i+1));
	parent_depth -= i+1;
	break;
      }
      p->new_program->flags |= PROGRAM_USES_PARENT;
      p = p->previous;
    }
    
    tmp_name = get_new_name(name);
    id = define_parent_variable(p, tmp_name, type,
				ID_PROTECTED|ID_PRIVATE|ID_INLINE);
    free_string(tmp_name);
    if (id >= 0) {
      if (def) {
	p->init_node =
	  mknode(F_COMMA_EXPR, Pike_compiler->init_node,
		 mkcastnode(void_type_string,
			    mknode(F_ASSIGN, initializer,
				   mkidentifiernode(id))));
	initializer = NULL;
      }
      n = mkexternalnode(id, parent_depth);
    }
  } else if (depth) {
    f->lexical_scope|=SCOPE_SCOPE_USED;
    tmp_name = get_new_name(name);
    id = low_add_local_name(f, tmp_name, type, NULL);
    free_string(tmp_name);
    if(f->min_number_of_locals < id+1)
      f->min_number_of_locals = id+1;
    if (initializer) {
      /* FIXME! */
      yyerror("Initializers not yet supported for protected variables with function scope.");
    }
    n = mklocalnode(id, depth);
  }
  id = add_local_name(name, type, n);
  if (id >= 0) {
    if (initializer) {
      return mknode(F_ASSIGN, initializer, mklocalnode(id,0));
    }
    return mklocalnode(id, 0);
  }
  if (initializer) {
    free_node(initializer);
  }
  return NULL;
}
#endif /* 0 */

int islocal(struct pike_string *str)
{
  return low_islocal(Pike_compiler->compiler_frame, str);
}

/* argument must be a shared string */
static node *lexical_islocal(struct pike_string *str)
{
  int e,depth=0;
  struct compiler_frame *f=Pike_compiler->compiler_frame;
  
  while(1)
  {
    for(e=f->current_number_of_locals-1;e>=0;e--)
    {
      if(f->variable[e].name==str)
      {
	struct compiler_frame *q=Pike_compiler->compiler_frame;

	f->variable[e].flags |= LOCAL_VAR_IS_USED;

	while(q!=f) 
	{
	  q->lexical_scope|=SCOPE_SCOPED;
	  q=q->previous;
	}

	if(depth) {
	  q->lexical_scope|=SCOPE_SCOPE_USED;

	  if(q->min_number_of_locals < e+1)
	    q->min_number_of_locals = e+1;
	}

	if(f->variable[e].def) {
	  /*fprintf(stderr, "Found prior definition of \"%s\"\n", str->str); */
	  return copy_node(f->variable[e].def);
	}

	return mklocalnode(e,depth);
      }
    }
    if(!(f->lexical_scope & SCOPE_LOCAL)) return 0;
    depth++;
    f=f->previous;
  }
}

static node *safe_inc_enum(node *n)
{
  JMP_BUF recovery;
  STACK_LEVEL_START(0);

  if (SETJMP(recovery)) {
    handle_compile_exception ("Bad implicit enum value (failed to add 1).");
    push_int(0);
  } else {
    if (n->token != F_CONSTANT) Pike_fatal("Bad node to safe_inc_enum().\n");
    push_svalue(&n->u.sval);
    push_int(1);
    f_add(2);
  }
  UNSETJMP(recovery);
  STACK_LEVEL_DONE(1);
  free_node(n);
  n = mkconstantsvaluenode(Pike_sp-1);
  pop_stack();
  return n;
}

static node *find_versioned_identifier(struct pike_string *identifier,
				       int major, int minor)
{
  struct compilation *c = THIS_COMPILATION;
  int old_major = Pike_compiler->compat_major;
  int old_minor = Pike_compiler->compat_minor;
  struct svalue *efun = NULL;
  node *res = NULL;

  change_compiler_compatibility(major, minor);

  if(Pike_compiler->last_identifier)
    free_string(Pike_compiler->last_identifier);
  copy_shared_string(Pike_compiler->last_identifier, identifier);

  /* Check predef:: first, and then the modules. */

  if (TYPEOF(c->default_module) == T_MAPPING) {
    if ((efun = low_mapping_string_lookup(c->default_module.u.mapping,
					  identifier)))
      res = mkconstantsvaluenode(efun);
  }
  else if (TYPEOF(c->default_module) != T_INT) {
    JMP_BUF tmp;
    if (SETJMP (tmp)) {
      handle_compile_exception ("Couldn't index %d.%d "
				"default module with \"%S\".",
				major, minor, identifier);
    } else {
      push_svalue(&c->default_module);
      ref_push_string(identifier);
      f_index (2);
      if (!IS_UNDEFINED(Pike_sp - 1))
	res = mkconstantsvaluenode(Pike_sp - 1);
      pop_stack();
    }
    UNSETJMP(tmp);
  }

  if (!res && !(res = resolve_identifier(identifier))) {
    if((Pike_compiler->flags & COMPILATION_FORCE_RESOLVE) ||
       (Pike_compiler->compiler_pass==2)) {
      my_yyerror("Undefined identifier %d.%d::%S.",
		 major, minor, identifier);
    }else{
      res = mknode(F_UNDEFINED, 0, 0);
    }
  }

  change_compiler_compatibility(old_major, old_minor);

  return res;
}

static int call_handle_import(struct pike_string *s)
{
  struct compilation *c = THIS_COMPILATION;
  int args;

  ref_push_string(s);
  ref_push_string(c->lex.current_file);
  if (c->handler && c->handler->prog) {
    ref_push_object(c->handler);
    args = 3;
  }
  else args = 2;

  if (safe_apply_handler("handle_import", c->handler, c->compat_handler,
			 args, BIT_MAPPING|BIT_OBJECT|BIT_PROGRAM|BIT_ZERO))
    if (TYPEOF(Pike_sp[-1]) != T_INT)
      return 1;
    else {
      pop_stack();
      my_yyerror("Couldn't find module to import: %S", s);
    }
  else
    handle_compile_exception ("Error finding module to import");

  return 0;
}

void cleanup_compiler(void)
{
}
#line 4242 "y.tab.c"

#if YYDEBUG
#include <stdio.h>	/* needed for printf */
#endif

#include <stdlib.h>	/* needed for malloc, etc */
#include <string.h>	/* needed for memset */

/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack(YYSTACKDATA *data)
{
    int i;
    unsigned newsize;
    YYINT *newss;
    YYSTYPE *newvs;

    if ((newsize = data->stacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return YYENOMEM;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;

    i = (int) (data->s_mark - data->s_base);
    newss = (YYINT *)realloc(data->s_base, newsize * sizeof(*newss));
    if (newss == 0)
        return YYENOMEM;

    data->s_base = newss;
    data->s_mark = newss + i;

    newvs = (YYSTYPE *)realloc(data->l_base, newsize * sizeof(*newvs));
    if (newvs == 0)
        return YYENOMEM;

    data->l_base = newvs;
    data->l_mark = newvs + i;

    data->stacksize = newsize;
    data->s_last = data->s_base + newsize - 1;
    return 0;
}

#if YYPURE || defined(YY_NO_LEAKS)
static void yyfreestack(YYSTACKDATA *data)
{
    free(data->s_base);
    free(data->l_base);
    memset(data, 0, sizeof(*data));
}
#else
#define yyfreestack(data) /* nothing */
#endif

#define YYABORT  goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR  goto yyerrlab

int
YYPARSE_DECL()
{
    int      yyerrflag;
    int      yychar;
    YYSTYPE  yyval;
    YYSTYPE  yylval;
    int      yynerrs;

    /* variables for the parser stack */
    YYSTACKDATA yystack;
    int yym, yyn, yystate;
#if YYDEBUG
    const char *yys;

    if ((yys = getenv("YYDEBUG")) != 0)
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    memset(&yyval,  0, sizeof(yyval));
    memset(&yylval, 0, sizeof(yylval));

    yym = 0;
    yyn = 0;
    yynerrs = 0;
    yyerrflag = 0;
    yychar = YYEMPTY;
    yystate = 0;

#if YYPURE
    memset(&yystack, 0, sizeof(yystack));
#endif

    if (yystack.s_base == NULL && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
    yystack.s_mark = yystack.s_base;
    yystack.l_mark = yystack.l_base;
    yystate = 0;
    *yystack.s_mark = 0;

yyloop:
    if ((yyn = yydefred[yystate]) != 0) goto yyreduce;
    if (yychar < 0)
    {
        yychar = YYLEX;
        if (yychar < 0) yychar = YYEOF;
#if YYDEBUG
        if (yydebug)
        {
            if ((yys = yyname[YYTRANSLATE(yychar)]) == NULL) yys = yyname[YYUNDFTOKEN];
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if (((yyn = yysindex[yystate]) != 0) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
        yystate = yytable[yyn];
        *++yystack.s_mark = yytable[yyn];
        *++yystack.l_mark = yylval;
        yychar = YYEMPTY;
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if (((yyn = yyrindex[yystate]) != 0) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag != 0) goto yyinrecovery;

    YYERROR_CALL("syntax error");

    goto yyerrlab; /* redundant goto avoids 'unused label' warning */
yyerrlab:
    ++yynerrs;

yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if (((yyn = yysindex[*yystack.s_mark]) != 0) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yystack.s_mark, yytable[yyn]);
#endif
                if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
                yystate = yytable[yyn];
                *++yystack.s_mark = yytable[yyn];
                *++yystack.l_mark = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yystack.s_mark);
#endif
                if (yystack.s_mark <= yystack.s_base) goto yyabort;
                --yystack.s_mark;
                --yystack.l_mark;
            }
        }
    }
    else
    {
        if (yychar == YYEOF) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            if ((yys = yyname[YYTRANSLATE(yychar)]) == NULL) yys = yyname[YYUNDFTOKEN];
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = YYEMPTY;
        goto yyloop;
    }

yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    if (yym > 0)
        yyval = yystack.l_mark[1-yym];
    else
        memset(&yyval, 0, sizeof yyval);

    switch (yyn)
    {
case 1:
#line 385 "language.yacc"
	{ YYACCEPT; }
break;
case 2:
#line 386 "language.yacc"
	{ YYACCEPT; }
break;
case 8:
#line 399 "language.yacc"
	{ yyval.n=yystack.l_mark[0].n; }
break;
case 9:
#line 400 "language.yacc"
	{ yyval.n=0; }
break;
case 10:
#line 401 "language.yacc"
	{ yyval.n=0; }
break;
case 11:
#line 402 "language.yacc"
	{ yyval.n=0; }
break;
case 12:
#line 409 "language.yacc"
	{
    STACK_LEVEL_START(0);

    ref_push_string(yystack.l_mark[0].n->u.sval.u.string);
    if (call_handle_inherit(yystack.l_mark[0].n->u.sval.u.string)) {
      STACK_LEVEL_CHECK(2);
      yyval.n=mksvaluenode(Pike_sp-1);
      pop_stack();
    }
    else
      yyval.n=mknewintnode(0);
    STACK_LEVEL_CHECK(1);
    if(yyval.n->name) free_string(yyval.n->name);
#ifdef PIKE_DEBUG
    if (TYPEOF(Pike_sp[-1]) != T_STRING) {
      Pike_fatal("Compiler lost track of program name.\n");
    }
#endif /* PIKE_DEBUG */
    /* FIXME: Why not use $1->u.sval.u.string here? */
    add_ref( yyval.n->name=Pike_sp[-1].u.string );
    free_node(yystack.l_mark[0].n);

    STACK_LEVEL_DONE(1);
  }
break;
case 13:
#line 434 "language.yacc"
	{
    STACK_LEVEL_START(0);

    if(Pike_compiler->last_identifier)
    {
      ref_push_string(Pike_compiler->last_identifier);
    }else{
      push_empty_string();
    }
    yyval.n=yystack.l_mark[0].n;

    STACK_LEVEL_DONE(1);
  }
break;
case 14:
#line 451 "language.yacc"
	{
    STACK_LEVEL_START(0);

    resolv_program(yystack.l_mark[0].n);
    free_node(yystack.l_mark[0].n);

    STACK_LEVEL_DONE(1);
  }
break;
case 15:
#line 462 "language.yacc"
	{
    SET_FORCE_RESOLVE(yyval.number);
  }
break;
case 16:
#line 466 "language.yacc"
	{
    UNSET_FORCE_RESOLVE(yystack.l_mark[-1].number);
    yyval.n = yystack.l_mark[0].n;
  }
break;
case 17:
#line 473 "language.yacc"
	{
    if ((yystack.l_mark[-4].number & ID_EXTERN) && (Pike_compiler->compiler_pass == 1)) {
      yywarning("Extern declared inherit.");
    }
    if(yystack.l_mark[-2].n)
    {
      struct pike_string *s=Pike_sp[-1].u.string;
      if(yystack.l_mark[-1].n) s=yystack.l_mark[-1].n->u.sval.u.string;
      compiler_do_inherit(yystack.l_mark[-2].n,yystack.l_mark[-4].number,s);
    }
    if(yystack.l_mark[-1].n) free_node(yystack.l_mark[-1].n);
    pop_stack();
    if (yystack.l_mark[-2].n) free_node(yystack.l_mark[-2].n);
  }
break;
case 18:
#line 488 "language.yacc"
	{
    if (yystack.l_mark[-2].n) free_node(yystack.l_mark[-2].n);
    pop_stack();
    yyerrok;
  }
break;
case 19:
#line 494 "language.yacc"
	{
    if (yystack.l_mark[-2].n) free_node(yystack.l_mark[-2].n);
    pop_stack();
    yyerror("Missing ';'.");
    yyerror("Unexpected end of file.");
  }
break;
case 20:
#line 501 "language.yacc"
	{
    if (yystack.l_mark[-2].n) free_node(yystack.l_mark[-2].n);
    pop_stack();
    yyerror("Missing ';'.");
  }
break;
case 21:
#line 506 "language.yacc"
	{ yyerrok; }
break;
case 22:
#line 508 "language.yacc"
	{
    yyerror("Missing ';'.");
    yyerror("Unexpected end of file.");
  }
break;
case 23:
#line 512 "language.yacc"
	{ yyerror("Missing ';'."); }
break;
case 24:
#line 516 "language.yacc"
	{
    resolv_constant(yystack.l_mark[-1].n);
    free_node(yystack.l_mark[-1].n);
    use_module(Pike_sp-1);
    pop_stack();
  }
break;
case 25:
#line 523 "language.yacc"
	{
    if (call_handle_import(yystack.l_mark[-1].n->u.sval.u.string)) {
      use_module(Pike_sp-1);
      pop_stack();
    }
    free_node(yystack.l_mark[-1].n);
  }
break;
case 26:
#line 530 "language.yacc"
	{ yyerrok; }
break;
case 27:
#line 532 "language.yacc"
	{
    yyerror("Missing ';'.");
    yyerror("Unexpected end of file.");
  }
break;
case 28:
#line 536 "language.yacc"
	{ yyerror("Missing ';'."); }
break;
case 29:
#line 540 "language.yacc"
	{
    /* This can be made more lenient in the future */

    /* Ugly hack to make sure that $3 is optimized */
    {
      int tmp=Pike_compiler->compiler_pass;
      yystack.l_mark[0].n=mknode(F_COMMA_EXPR,yystack.l_mark[0].n,0);
      Pike_compiler->compiler_pass=tmp;
    }

    if (!TEST_COMPAT(7, 6) && (Pike_compiler->current_modifiers & ID_EXTERN)) {
      int depth = 0;
      struct program_state *state = Pike_compiler;
      node *n = yystack.l_mark[0].n;
      while (((n->token == F_COMMA_EXPR) || (n->token == F_ARG_LIST)) &&
	     ((!CAR(n)) ^ (!CDR(n)))) {
	if (CAR(n)) n = CAR(n);
	else n = CDR(n);
      }
      if (n->token == F_EXTERNAL) {
	while (state && (state->new_program->id != n->u.integer.a)) {
	  depth++;
	  state = state->previous;
	}
      }
      if (depth && state) {
	/* Alias for a symbol in a surrounding scope. */
	int id = really_low_reference_inherited_identifier(state, 0,
							   n->u.integer.b);
	define_alias(yystack.l_mark[-2].n->u.sval.u.string, n->type,
		     Pike_compiler->current_modifiers & ~ID_EXTERN,
		     depth, id);
      } else if (Pike_compiler->compiler_pass == 1) {
	yyerror("Invalid extern declared constant.");
	add_constant(yystack.l_mark[-2].n->u.sval.u.string, &svalue_undefined,
		     Pike_compiler->current_modifiers & ~ID_EXTERN);
      }
    } else {
      if (TEST_COMPAT(7, 6) &&
	  (Pike_compiler->current_modifiers & ID_EXTERN) &&
	  (Pike_compiler->compiler_pass == 1)) {
	yywarning("Extern declared constant.");
      }
      if(!is_const(yystack.l_mark[0].n)) {
	if (Pike_compiler->compiler_pass == 2) {
	  yyerror("Constant definition is not constant.");
	}
	add_constant(yystack.l_mark[-2].n->u.sval.u.string, 0,
		     Pike_compiler->current_modifiers & ~ID_EXTERN);
      } else {
	if(!Pike_compiler->num_parse_error)
	{
	  ptrdiff_t tmp=eval_low(yystack.l_mark[0].n,1);
	  if(tmp < 1)
	  {
	    yyerror("Error in constant definition.");
	    push_undefined();
	  }else{
	    pop_n_elems(DO_NOT_WARN((INT32)(tmp - 1)));
	  }
	} else {
	  push_undefined();
	}
	add_constant(yystack.l_mark[-2].n->u.sval.u.string, Pike_sp-1,
		     Pike_compiler->current_modifiers & ~ID_EXTERN);
	pop_stack();
      }
    }
  const_def_ok:
    if(yystack.l_mark[0].n) free_node(yystack.l_mark[0].n);
    free_node(yystack.l_mark[-2].n);
  }
break;
case 30:
#line 612 "language.yacc"
	{ if (yystack.l_mark[0].n) free_node(yystack.l_mark[0].n); }
break;
case 31:
#line 613 "language.yacc"
	{ if (yystack.l_mark[0].n) free_node(yystack.l_mark[0].n); }
break;
case 34:
#line 620 "language.yacc"
	{}
break;
case 35:
#line 621 "language.yacc"
	{ yyerrok; }
break;
case 36:
#line 623 "language.yacc"
	{
    yyerror("Missing ';'.");
    yyerror("Unexpected end of file.");
  }
break;
case 37:
#line 627 "language.yacc"
	{ yyerror("Missing ';'."); }
break;
case 38:
#line 631 "language.yacc"
	{
    yyval.n = mknode(F_COMMA_EXPR,yystack.l_mark[0].n,mknode(F_RETURN,mkintnode(0),0));
    COPY_LINE_NUMBER_INFO(yyval.n, yystack.l_mark[0].n);
  }
break;
case 39:
#line 635 "language.yacc"
	{ yyval.n = NULL; }
break;
case 40:
#line 636 "language.yacc"
	{ yyerror("Expected ';'."); yyval.n = NULL; }
break;
case 41:
#line 637 "language.yacc"
	{ yyval.n = NULL; }
break;
case 42:
#line 642 "language.yacc"
	{
#ifdef PIKE_DEBUG
    check_type_string(yystack.l_mark[0].n->u.sval.u.type);
#endif /* PIKE_DEBUG */
    if(Pike_compiler->compiler_frame->current_type)
      free_type(Pike_compiler->compiler_frame->current_type);
    copy_pike_type(Pike_compiler->compiler_frame->current_type,
		   yystack.l_mark[0].n->u.sval.u.type);
    free_node(yystack.l_mark[0].n);
  }
break;
case 43:
#line 655 "language.yacc"
	{
    /* Used to hold line-number info */
    yyval.n = mkintnode(0);
  }
break;
case 44:
#line 662 "language.yacc"
	{
    /* Used to hold line-number info */
    yyval.n = mkintnode(0);
  }
break;
case 45:
#line 667 "language.yacc"
	{
    yyerror("Missing ')'.");
    /* Used to hold line-number info */
    yyval.n = mkintnode(0);
  }
break;
case 47:
#line 676 "language.yacc"
	{
    yyerror("Missing '}'.");
  }
break;
case 49:
#line 683 "language.yacc"
	{
    yyerror("Missing '}'.");
  }
break;
case 50:
#line 689 "language.yacc"
	{
    /* Used to hold line-number info */
    yyval.n = mkintnode(0);
  }
break;
case 52:
#line 697 "language.yacc"
	{
    yyerror("Missing ']'.");
  }
break;
case 53:
#line 703 "language.yacc"
	{
    push_compiler_frame(SCOPE_LOCAL);

    if(!Pike_compiler->compiler_frame->previous ||
       !Pike_compiler->compiler_frame->previous->current_type)
    {
      yyerror("Internal compiler error (push_compiler_frame0).");
      copy_pike_type(Pike_compiler->compiler_frame->current_type,
		mixed_type_string);
    }else{
      copy_pike_type(Pike_compiler->compiler_frame->current_type,
		Pike_compiler->compiler_frame->previous->current_type);
    }

    yyval.ptr = Pike_compiler->compiler_frame;
  }
break;
case 54:
#line 722 "language.yacc"
	{
    yyval.number = OPT_EXTERNAL_DEPEND|OPT_SIDE_EFFECT;
  }
break;
case 55:
#line 726 "language.yacc"
	{
    yyval.number = 0;
  }
break;
case 56:
#line 734 "language.yacc"
	{
    yyval.number = 0;
    /* Check for the (very special) case of create and create_args. */
    if (Pike_compiler->num_create_args) {
      struct pike_string *create_string = NULL;
      int e;
      MAKE_CONST_STRING(create_string, "create");
      if (yystack.l_mark[-2].n->u.sval.u.string == create_string) {
	if (TEST_COMPAT(7, 6)) {
	  yywarning("Having both an implicit and an explicit create() "
		    "was not supported in Pike 7.6 and before.");
	}
	/* Prepend the create arguments. */
	if (Pike_compiler->num_create_args < 0) {
	  Pike_compiler->varargs = 1;
	  for (e = 0; e < -Pike_compiler->num_create_args; e++) {
	    struct identifier *id =
	      Pike_compiler->new_program->identifiers + e;
	    add_ref(id->type);
	    add_local_name(empty_pike_string, id->type, 0);
	    /* Note: add_local_name() above will return e. */
	    Pike_compiler->compiler_frame->variable[e].flags |=
	      LOCAL_VAR_IS_USED;
	  }
	} else {
	  for (e = 0; e < Pike_compiler->num_create_args; e++) {
	    struct identifier *id =
	      Pike_compiler->new_program->identifiers + e;
	    add_ref(id->type);
	    add_local_name(empty_pike_string, id->type, 0);
	    /* Note: add_local_name() above will return e. */
	    Pike_compiler->compiler_frame->variable[e].flags |=
	      LOCAL_VAR_IS_USED;
	  }
	}
	yyval.number = e;
      }
    }
  }
break;
case 57:
#line 774 "language.yacc"
	{
    int e;

    /* Adjust opt_flags in case we've got an optional_constant. */
    Pike_compiler->compiler_frame->opt_flags = yystack.l_mark[-7].number;

    /* construct the function type */
    push_finished_type(Pike_compiler->compiler_frame->current_type);

    if(Pike_compiler->compiler_frame->current_return_type)
      free_type(Pike_compiler->compiler_frame->current_return_type);
    Pike_compiler->compiler_frame->current_return_type = compiler_pop_type();

    push_finished_type(Pike_compiler->compiler_frame->current_return_type);

    e = yystack.l_mark[-2].number + yystack.l_mark[-1].number - 1;
    if(Pike_compiler->varargs &&
       (!yystack.l_mark[-2].number || (Pike_compiler->num_create_args >= 0)))
    {
      push_finished_type(Pike_compiler->compiler_frame->variable[e].type);
      e--;
      pop_type_stack(T_ARRAY);
    }else{
      push_type(T_VOID);
    }
    push_type(T_MANY);
    for(; e>=0; e--)
    {
      push_finished_type(Pike_compiler->compiler_frame->variable[e].type);
      push_type(T_FUNCTION);
    }

    if (Pike_compiler->current_attributes) {
      node *n = Pike_compiler->current_attributes;
      while (n) {
	push_type_attribute(CDR(n)->u.sval.u.string);
	n = CAR(n);
      }
    }

    {
      struct pike_type *s=compiler_pop_type();
      int i = isidentifier(yystack.l_mark[-5].n->u.sval.u.string);

      if (Pike_compiler->compiler_pass != 1) {
	if (i < 0) {
	  my_yyerror("Identifier %S lost after first pass.",
		     yystack.l_mark[-5].n->u.sval.u.string);
	}
      }

      yyval.n = mktypenode(s);
      free_type(s);
    }


/*    if(Pike_compiler->compiler_pass==1) */
    {
      /* FIXME:
       * set current_function_number for local functions as well
       */
      Pike_compiler->compiler_frame->current_function_number=
	define_function(yystack.l_mark[-5].n->u.sval.u.string,
			yyval.n->u.sval.u.type,
			yystack.l_mark[-10].number & (~ID_EXTERN),
			IDENTIFIER_PIKE_FUNCTION |
			(Pike_compiler->varargs?IDENTIFIER_VARARGS:0),
			0,
			yystack.l_mark[-7].number);

      Pike_compiler->varargs=0;
    }
  }
break;
case 58:
#line 848 "language.yacc"
	{
    int e;
    if(yystack.l_mark[0].n)
    {
      int f;
      node *check_args = NULL;
      struct compilation *c = THIS_COMPILATION;
      struct pike_string *save_file = c->lex.current_file;
      int save_line  = c->lex.current_line;
      int num_required_args = 0;
      struct identifier *i;
      c->lex.current_file = yystack.l_mark[-7].n->current_file;
      c->lex.current_line = yystack.l_mark[-7].n->line_number;

      if ((yystack.l_mark[-12].number & ID_EXTERN) && (Pike_compiler->compiler_pass == 1)) {
	yywarning("Extern declared function definition.");
      }

      for(e=0; e<yystack.l_mark[-4].number+yystack.l_mark[-3].number; e++)
      {
	if((e >= yystack.l_mark[-4].number) &&
	   (!Pike_compiler->compiler_frame->variable[e].name ||
	    !Pike_compiler->compiler_frame->variable[e].name->len))
	{
	  my_yyerror("Missing name for argument %d.", e - yystack.l_mark[-4].number);
	} else {
	  if (Pike_compiler->compiler_pass == 2) {
	      /* FIXME: Should probably use some other flag. */
	      if ((runtime_options & RUNTIME_CHECK_TYPES) &&
		  (Pike_compiler->compiler_frame->variable[e].type !=
		   mixed_type_string)) {
		node *local_node;

		/* fprintf(stderr, "Creating soft cast node for local #%d\n", e);*/

		local_node = mkcastnode(mixed_type_string, mklocalnode(e, 0));

		/* NOTE: The cast to mixed above is needed to avoid generating
		 *       compilation errors, as well as avoiding optimizations
		 *       in mksoftcastnode().
		 */
		check_args =
		  mknode(F_COMMA_EXPR, check_args,
			 mksoftcastnode(Pike_compiler->compiler_frame->variable[e].type,
					local_node));
	      }
	  }
	}
      }

      if (yystack.l_mark[-4].number) {
	/* Hook in the initializers for the create arguments. */
	for (e = yystack.l_mark[-4].number; e--;) {
	  yystack.l_mark[0].n = mknode(F_COMMA_EXPR,
		       mknode(F_POP_VALUE,
			      mknode(F_ASSIGN, mklocalnode(e, 0),
				     mkidentifiernode(e)), NULL),
		       yystack.l_mark[0].n);
	}
      }

      {
	int l = yystack.l_mark[0].n->line_number;
	struct pike_string *f = yystack.l_mark[0].n->current_file;
	if (check_args) {
	  /* Prepend the arg checking code. */
	  yystack.l_mark[0].n = mknode(F_COMMA_EXPR, mknode(F_POP_VALUE, check_args, NULL), yystack.l_mark[0].n);
	}
	c->lex.current_line = l;
	c->lex.current_file = f;
      }

      f=dooptcode(yystack.l_mark[-7].n->u.sval.u.string, yystack.l_mark[0].n, yystack.l_mark[-1].n->u.sval.u.type, yystack.l_mark[-12].number);

      i = ID_FROM_INT(Pike_compiler->new_program, f);
      i->opt_flags = Pike_compiler->compiler_frame->opt_flags;

#ifdef PIKE_DEBUG
      if(Pike_interpreter.recoveries &&
	 ((Pike_sp - Pike_interpreter.evaluator_stack) <
	  Pike_interpreter.recoveries->stack_pointer))
	Pike_fatal("Stack error (underflow)\n");

      if((Pike_compiler->compiler_pass == 1) &&
	 (f != Pike_compiler->compiler_frame->current_function_number)) {
	fprintf(stderr, "define_function()/do_opt_code() failed for symbol %s\n",
		yystack.l_mark[-7].n->u.sval.u.string->str);
	dump_program_desc(Pike_compiler->new_program);
	Pike_fatal("define_function screwed up! %d != %d\n",
	      f, Pike_compiler->compiler_frame->current_function_number);
      }
#endif

      c->lex.current_line = save_line;
      c->lex.current_file = save_file;
    } else {
      /* Prototype; don't warn about unused arguments. */
      for (e = Pike_compiler->compiler_frame->current_number_of_locals; e--;) {
	Pike_compiler->compiler_frame->variable[e].flags |= LOCAL_VAR_IS_USED;
      }
    }
#ifdef PIKE_DEBUG
    if (Pike_compiler->compiler_frame != yystack.l_mark[-6].ptr) {
      Pike_fatal("Lost track of compiler_frame!\n"
		 "  Got: %p (Expected: %p) Previous: %p\n",
		 Pike_compiler->compiler_frame, yystack.l_mark[-6].ptr,
		 Pike_compiler->compiler_frame->previous);
    }
#endif
    pop_compiler_frame();
    free_node(yystack.l_mark[-7].n);
    free_node(yystack.l_mark[-2].n);
    free_node(yystack.l_mark[-1].n);
  }
break;
case 59:
#line 965 "language.yacc"
	{
#ifdef PIKE_DEBUG
    if (Pike_compiler->compiler_frame != yystack.l_mark[-1].ptr) {
      Pike_fatal("Lost track of compiler_frame!\n"
		 "  Got: %p (Expected: %p) Previous: %p\n",
		 Pike_compiler->compiler_frame, yystack.l_mark[-1].ptr,
		 Pike_compiler->compiler_frame->previous);
    }
#endif
    pop_compiler_frame();
    free_node(yystack.l_mark[-2].n);
  }
break;
case 60:
#line 978 "language.yacc"
	{
    compiler_discard_type();
  }
break;
case 61:
#line 982 "language.yacc"
	{
    if (yystack.l_mark[0].n) free_node(yystack.l_mark[0].n);
  }
break;
case 63:
#line 986 "language.yacc"
	{}
break;
case 64:
#line 987 "language.yacc"
	{}
break;
case 65:
#line 988 "language.yacc"
	{}
break;
case 66:
#line 989 "language.yacc"
	{ free_node(yystack.l_mark[0].n); }
break;
case 67:
#line 990 "language.yacc"
	{ free_node(yystack.l_mark[0].n); }
break;
case 68:
#line 991 "language.yacc"
	{}
break;
case 69:
#line 993 "language.yacc"
	{
    reset_type_stack();
    yyerror("Missing ';'.");
    yyerror("Unexpected end of file");
  }
break;
case 70:
#line 999 "language.yacc"
	{
    reset_type_stack();
    yyerrok;
/*     if(Pike_compiler->num_parse_error>5) YYACCEPT; */
  }
break;
case 71:
#line 1005 "language.yacc"
	{
    reset_type_stack();
    yyerror("Missing ';'.");
   /* yychar = '}';	*/ /* Put the '}' back on the input stream */
  }
break;
case 72:
#line 1012 "language.yacc"
	{
      yyval.number=THIS_COMPILATION->lex.pragmas;
      THIS_COMPILATION->lex.pragmas|=yystack.l_mark[-1].number;
    }
break;
case 73:
#line 1018 "language.yacc"
	{
      THIS_COMPILATION->lex.pragmas=yystack.l_mark[-2].number;
    }
break;
case 74:
#line 1023 "language.yacc"
	{ yyval.number=1; }
break;
case 75:
#line 1025 "language.yacc"
	{
    yyerror("Range indicator ('..') where elipsis ('...') expected.");
    yyval.number=1;
  }
break;
case 76:
#line 1029 "language.yacc"
	{ yyval.number=0; }
break;
case 78:
#line 1033 "language.yacc"
	{ yyval.n=0; }
break;
case 79:
#line 1034 "language.yacc"
	{ yyval.n=0; }
break;
case 80:
#line 1038 "language.yacc"
	{
    int i;
    if(Pike_compiler->varargs) yyerror("Can't define more arguments after ...");

    if(yystack.l_mark[-1].number)
    {
      push_type(T_ARRAY);
      Pike_compiler->varargs=1;
    }

    if(!yystack.l_mark[0].n)
    {
      yystack.l_mark[0].n=mkstrnode(empty_pike_string);
    }

    if(yystack.l_mark[0].n->u.sval.u.string->len &&
       islocal(yystack.l_mark[0].n->u.sval.u.string) >= 0)
      my_yyerror("Variable %S appears twice in argument list.",
		 yystack.l_mark[0].n->u.sval.u.string);

    i = add_local_name(yystack.l_mark[0].n->u.sval.u.string, compiler_pop_type(),0);
    if (i >= 0) {
      /* Don't warn about unused arguments. */
      Pike_compiler->compiler_frame->variable[i].flags |= LOCAL_VAR_IS_USED;
    }
    free_node(yystack.l_mark[0].n);
  }
break;
case 81:
#line 1068 "language.yacc"
	{
    free_node(yystack.l_mark[0].n);
    yyval.number=yystack.l_mark[-1].number;
  }
break;
case 82:
#line 1074 "language.yacc"
	{ yyval.number=0; }
break;
case 84:
#line 1078 "language.yacc"
	{ yyval.number = 1; }
break;
case 85:
#line 1079 "language.yacc"
	{ yyval.number = yystack.l_mark[-2].number + 1; }
break;
case 86:
#line 1081 "language.yacc"
	{
    yyerror("Unexpected ':' in argument list.");
    yyval.number = yystack.l_mark[-2].number + 1;
  }
break;
case 87:
#line 1089 "language.yacc"
	{
      yyval.number = ID_FINAL | ID_INLINE;
      if( !(THIS_COMPILATION->lex.pragmas & ID_NO_DEPRECATION_WARNINGS) &&
          !TEST_COMPAT(7, 6) && Pike_compiler->compiler_pass==1 )
        yywarning("Keyword nomask is deprecated in favour of 'final'.");
    }
break;
case 88:
#line 1095 "language.yacc"
	{ yyval.number = ID_FINAL | ID_INLINE; }
break;
case 89:
#line 1096 "language.yacc"
	{
    yyval.number = ID_PROTECTED;
    if( !(THIS_COMPILATION->lex.pragmas & ID_NO_DEPRECATION_WARNINGS) &&
        !TEST_COMPAT(7, 8) && Pike_compiler->compiler_pass==1 )
      yywarning("Keyword static is deprecated in favour of 'protected'.");
    }
break;
case 90:
#line 1102 "language.yacc"
	{ yyval.number = ID_EXTERN; }
break;
case 91:
#line 1103 "language.yacc"
	{ yyval.number = ID_OPTIONAL; }
break;
case 92:
#line 1104 "language.yacc"
	{ yyval.number = ID_PRIVATE | ID_PROTECTED; }
break;
case 93:
#line 1105 "language.yacc"
	{ yyval.number = ID_INLINE; }
break;
case 94:
#line 1106 "language.yacc"
	{ yyval.number = ID_PUBLIC; }
break;
case 95:
#line 1107 "language.yacc"
	{ yyval.number = ID_PROTECTED; }
break;
case 96:
#line 1108 "language.yacc"
	{ yyval.number = ID_INLINE; }
break;
case 97:
#line 1109 "language.yacc"
	{ yyval.number = ID_VARIANT; }
break;
case 98:
#line 1113 "language.yacc"
	{ yyval.str = "nomask"; }
break;
case 99:
#line 1114 "language.yacc"
	{ yyval.str = "final"; }
break;
case 100:
#line 1115 "language.yacc"
	{ yyval.str = "static"; }
break;
case 101:
#line 1116 "language.yacc"
	{ yyval.str = "extern"; }
break;
case 102:
#line 1117 "language.yacc"
	{ yyval.str = "private"; }
break;
case 103:
#line 1118 "language.yacc"
	{ yyval.str = "local"; }
break;
case 104:
#line 1119 "language.yacc"
	{ yyval.str = "public"; }
break;
case 105:
#line 1120 "language.yacc"
	{ yyval.str = "protected"; }
break;
case 106:
#line 1121 "language.yacc"
	{ yyval.str = "inline"; }
break;
case 107:
#line 1122 "language.yacc"
	{ yyval.str = "optional"; }
break;
case 108:
#line 1123 "language.yacc"
	{ yyval.str = "variant"; }
break;
case 109:
#line 1127 "language.yacc"
	{ yyval.str = "void"; }
break;
case 110:
#line 1128 "language.yacc"
	{ yyval.str = "mixed"; }
break;
case 111:
#line 1129 "language.yacc"
	{ yyval.str = "array"; }
break;
case 112:
#line 1130 "language.yacc"
	{ yyval.str = "__attribute__"; }
break;
case 113:
#line 1131 "language.yacc"
	{ yyval.str = "__deprecated__"; }
break;
case 114:
#line 1132 "language.yacc"
	{ yyval.str = "mapping"; }
break;
case 115:
#line 1133 "language.yacc"
	{ yyval.str = "multiset"; }
break;
case 116:
#line 1134 "language.yacc"
	{ yyval.str = "object"; }
break;
case 117:
#line 1135 "language.yacc"
	{ yyval.str = "function"; }
break;
case 118:
#line 1136 "language.yacc"
	{ yyval.str = "__func__"; }
break;
case 119:
#line 1137 "language.yacc"
	{ yyval.str = "program"; }
break;
case 120:
#line 1138 "language.yacc"
	{ yyval.str = "string"; }
break;
case 121:
#line 1139 "language.yacc"
	{ yyval.str = "float"; }
break;
case 122:
#line 1140 "language.yacc"
	{ yyval.str = "int"; }
break;
case 123:
#line 1141 "language.yacc"
	{ yyval.str = "enum"; }
break;
case 124:
#line 1142 "language.yacc"
	{ yyval.str = "typedef"; }
break;
case 125:
#line 1146 "language.yacc"
	{ yyval.str = "if"; }
break;
case 126:
#line 1147 "language.yacc"
	{ yyval.str = "do"; }
break;
case 127:
#line 1148 "language.yacc"
	{ yyval.str = "for"; }
break;
case 128:
#line 1149 "language.yacc"
	{ yyval.str = "while"; }
break;
case 129:
#line 1150 "language.yacc"
	{ yyval.str = "else"; }
break;
case 130:
#line 1151 "language.yacc"
	{ yyval.str = "foreach"; }
break;
case 131:
#line 1152 "language.yacc"
	{ yyval.str = "catch"; }
break;
case 132:
#line 1153 "language.yacc"
	{ yyval.str = "gauge"; }
break;
case 133:
#line 1154 "language.yacc"
	{ yyval.str = "class"; }
break;
case 134:
#line 1155 "language.yacc"
	{ yyval.str = "break"; }
break;
case 135:
#line 1156 "language.yacc"
	{ yyval.str = "case"; }
break;
case 136:
#line 1157 "language.yacc"
	{ yyval.str = "constant"; }
break;
case 137:
#line 1158 "language.yacc"
	{ yyval.str = "continue"; }
break;
case 138:
#line 1159 "language.yacc"
	{ yyval.str = "default"; }
break;
case 139:
#line 1160 "language.yacc"
	{ yyval.str = "import"; }
break;
case 140:
#line 1161 "language.yacc"
	{ yyval.str = "inherit"; }
break;
case 141:
#line 1162 "language.yacc"
	{ yyval.str = "lambda"; }
break;
case 142:
#line 1163 "language.yacc"
	{ yyval.str = "predef"; }
break;
case 143:
#line 1164 "language.yacc"
	{ yyval.str = "return"; }
break;
case 144:
#line 1165 "language.yacc"
	{ yyval.str = "sscanf"; }
break;
case 145:
#line 1166 "language.yacc"
	{ yyval.str = "switch"; }
break;
case 146:
#line 1167 "language.yacc"
	{ yyval.str = "typeof"; }
break;
case 147:
#line 1168 "language.yacc"
	{ yyval.str = "global"; }
break;
case 153:
#line 1175 "language.yacc"
	{
    struct pike_string *tmp=make_shared_string(yystack.l_mark[0].str);
    yyval.n=mkstrnode(tmp);
    free_string(tmp);
  }
break;
case 154:
#line 1183 "language.yacc"
	{
   yyval.number=Pike_compiler->current_modifiers=yystack.l_mark[0].number |
     (THIS_COMPILATION->lex.pragmas & ID_MODIFIER_MASK);
 }
break;
case 155:
#line 1189 "language.yacc"
	{ yyval.number = 0; }
break;
case 156:
#line 1190 "language.yacc"
	{ yyval.number = yystack.l_mark[-1].number | yystack.l_mark[0].number; }
break;
case 157:
#line 1194 "language.yacc"
	{
    yyval.n = yystack.l_mark[-2].n;
  }
break;
case 158:
#line 1198 "language.yacc"
	{
    struct pike_string *deprecated_string;
    MAKE_CONST_STRING(deprecated_string, "deprecated");
    yyval.n = mkstrnode(deprecated_string);
  }
break;
case 159:
#line 1204 "language.yacc"
	{
    struct pike_string *deprecated_string;
    MAKE_CONST_STRING(deprecated_string, "deprecated");
    yyval.n = mkstrnode(deprecated_string);
  }
break;
case 160:
#line 1212 "language.yacc"
	{
    if (Pike_compiler->current_attributes) {
      free_node(Pike_compiler->current_attributes);
    }
    if ((Pike_compiler->current_attributes =
	 THIS_COMPILATION->lex.attributes)) {
      add_ref(Pike_compiler->current_attributes);
    }
  }
break;
case 161:
#line 1222 "language.yacc"
	{
    if (yystack.l_mark[0].n) {
      Pike_compiler->current_attributes =
	mknode(F_ARG_LIST, Pike_compiler->current_attributes, yystack.l_mark[0].n);
    }
  }
break;
case 162:
#line 1230 "language.yacc"
	{ yyval.number=0; }
break;
case 163:
#line 1234 "language.yacc"
	{
      struct pike_type *s = compiler_pop_type();
      yyval.n = mktypenode(s);
      free_type(s);
      COPY_LINE_NUMBER_INFO(yyval.n, yystack.l_mark[-2].n);
      free_node (yystack.l_mark[-2].n);
    }
break;
case 164:
#line 1244 "language.yacc"
	{
      struct pike_type *s = compiler_pop_type();
      yyval.n = mktypenode(s);
      free_type(s);
      COPY_LINE_NUMBER_INFO(yyval.n, yystack.l_mark[-2].n);
      free_node (yystack.l_mark[-2].n);
    }
break;
case 167:
#line 1256 "language.yacc"
	{
    struct pike_type *s = compiler_pop_type();
    yyval.n = mktypenode(s);
#ifdef PIKE_DEBUG
    if (yyval.n->u.sval.u.type != s) {
      Pike_fatal("mktypenode(%p) created node with %p\n", s, yyval.n->u.sval.u.type);
    }
#endif /* PIKE_DEBUG */
    free_type(s);
  }
break;
case 168:
#line 1269 "language.yacc"
	{
    struct pike_type *s = compiler_pop_type();
    yyval.n = mktypenode(s);
#ifdef PIKE_DEBUG
    if (yyval.n->u.sval.u.type != s) {
      Pike_fatal("mktypenode(%p) created node with %p\n", s, yyval.n->u.sval.u.type);
    }
#endif /* PIKE_DEBUG */
    free_type(s);
  }
break;
case 169:
#line 1282 "language.yacc"
	{
    struct pike_type *s = compiler_pop_type();
    yyval.n = mktypenode(s);
#ifdef PIKE_DEBUG
    if (yyval.n->u.sval.u.type != s) {
      Pike_fatal("mktypenode(%p) created node with %p\n", s, yyval.n->u.sval.u.type);
    }
#endif /* PIKE_DEBUG */
    free_type(s);
  }
break;
case 170:
#line 1294 "language.yacc"
	{ push_type(T_OR); }
break;
case 172:
#line 1298 "language.yacc"
	{ push_type(T_OR); }
break;
case 176:
#line 1305 "language.yacc"
	{ push_type(T_FLOAT); }
break;
case 177:
#line 1306 "language.yacc"
	{ push_type(T_VOID); }
break;
case 178:
#line 1307 "language.yacc"
	{ push_type(T_MIXED); }
break;
case 179:
#line 1308 "language.yacc"
	{}
break;
case 180:
#line 1309 "language.yacc"
	{}
break;
case 181:
#line 1310 "language.yacc"
	{}
break;
case 182:
#line 1311 "language.yacc"
	{}
break;
case 183:
#line 1312 "language.yacc"
	{}
break;
case 184:
#line 1313 "language.yacc"
	{ push_type(T_PROGRAM); }
break;
case 185:
#line 1314 "language.yacc"
	{ push_type(T_ARRAY); }
break;
case 186:
#line 1315 "language.yacc"
	{ push_type(T_MULTISET); }
break;
case 187:
#line 1317 "language.yacc"
	{
    push_type_attribute(yystack.l_mark[-3].n->u.sval.u.string);
    free_node(yystack.l_mark[-3].n);
  }
break;
case 188:
#line 1322 "language.yacc"
	{
    push_type(T_MIXED);
    push_type_attribute(yystack.l_mark[-2].n->u.sval.u.string);
    free_node(yystack.l_mark[-2].n);
  }
break;
case 189:
#line 1328 "language.yacc"
	{
    push_type(T_MIXED);
  }
break;
case 190:
#line 1332 "language.yacc"
	{
    struct pike_string *deprecated_string;
    MAKE_CONST_STRING(deprecated_string, "deprecated");
    push_type_attribute(deprecated_string);
  }
break;
case 191:
#line 1338 "language.yacc"
	{
    struct pike_string *deprecated_string;
    MAKE_CONST_STRING(deprecated_string, "deprecated");
    push_type(T_MIXED);
    push_type_attribute(deprecated_string);
  }
break;
case 192:
#line 1347 "language.yacc"
	{
    if (yystack.l_mark[0].n) {
      fix_type_field(yystack.l_mark[0].n);

      if (!pike_types_le(yystack.l_mark[0].n->type, typeable_type_string) &&
	  (THIS_COMPILATION->lex.pragmas & ID_STRICT_TYPES)) {
	yytype_report(REPORT_WARNING,
		      yystack.l_mark[0].n->current_file, yystack.l_mark[0].n->line_number, typeable_type_string,
		      yystack.l_mark[0].n->current_file, yystack.l_mark[0].n->line_number, yystack.l_mark[0].n->type,
		      0, "Invalid type.");
      }
    }

    resolv_constant(yystack.l_mark[0].n);

    if (TYPEOF(Pike_sp[-1]) == T_TYPE) {
      /* "typedef" */
      push_finished_type(Pike_sp[-1].u.type);
    } else {
      /* object type */
      struct program *p = NULL;

      if (TYPEOF(Pike_sp[-1]) == T_OBJECT) {
	if(!(p = Pike_sp[-1].u.object->prog))
	{
	  pop_stack();
	  push_int(0);
	  yyerror("Destructed object used as program identifier.");
	}else{
	  int f = FIND_LFUN(p->inherits[SUBTYPEOF(Pike_sp[-1])].prog,
			    LFUN_CALL);
	  if(f!=-1)
	  {
	    SET_SVAL_SUBTYPE(Pike_sp[-1],
			     f + p->inherits[SUBTYPEOF(Pike_sp[-1])].
			     identifier_level);
	    SET_SVAL_TYPE(Pike_sp[-1], T_FUNCTION);
	  }else{
	    extern void f_object_program(INT32);
	    if (Pike_compiler->compiler_pass == 2)
	      yywarning("Using object as program identifier.");
	    f_object_program(1);
	  }
	}
      }

      switch(TYPEOF(Pike_sp[-1])) {
	case T_FUNCTION:
	if((p = program_from_function(Pike_sp-1))) {
	  push_object_type(0, p?(p->id):0);
	  break;
	} else {
	  /* Attempt to get the return type for the function. */
	  struct pike_type *a, *b;
	  a = get_type_of_svalue(Pike_sp-1);
	  /* Note: check_splice_call() below eats a reference from a.
	   * Note: CALL_INHIBIT_WARNINGS is needed since we don't
	   *       provide a function name (and we don't want
	   *       warnings here anyway).
	   */
	  a = check_splice_call(NULL, a, 0, mixed_type_string, NULL,
				CALL_INHIBIT_WARNINGS);
	  if (a) {
	    b = new_get_return_type(a, 0);
	    free_type(a);
	    if (b) {
	      push_finished_type(b);
	      free_type(b);
	      break;
	    }
	  }
	}
	/* FALL_THROUGH */

      default:
	if (Pike_compiler->compiler_pass!=1)
	  my_yyerror("Illegal program identifier: %O.", Pike_sp-1);
	pop_stack();
	push_int(0);
	push_object_type(0, 0);
	break;

      case T_PROGRAM:
	p = Pike_sp[-1].u.program;
	push_object_type(0, p?(p->id):0);
	break;
      }
    }
    /* Attempt to name the type. */
    if (Pike_compiler->last_identifier) {
      push_type_name(Pike_compiler->last_identifier);
    }
    pop_stack();
    free_node(yystack.l_mark[0].n);
  }
break;
case 193:
#line 1445 "language.yacc"
	{
    yyval.n = mkintnode(MAX_INT_TYPE);
  }
break;
case 195:
#line 1450 "language.yacc"
	{
#ifdef PIKE_DEBUG
    if ((yystack.l_mark[0].n->token != F_CONSTANT) || (TYPEOF(yystack.l_mark[0].n->u.sval) != T_INT)) {
      Pike_fatal("Unexpected number in negative int-range.\n");
    }
#endif /* PIKE_DEBUG */
    yyval.n = mkintnode(-(yystack.l_mark[0].n->u.sval.u.integer));
    free_node(yystack.l_mark[0].n);
  }
break;
case 196:
#line 1462 "language.yacc"
	{
    yyval.n = mkintnode(MIN_INT_TYPE);
  }
break;
case 198:
#line 1467 "language.yacc"
	{
#ifdef PIKE_DEBUG
    if ((yystack.l_mark[0].n->token != F_CONSTANT) || (TYPEOF(yystack.l_mark[0].n->u.sval) != T_INT)) {
      Pike_fatal("Unexpected number in negative int-range.\n");
    }
#endif /* PIKE_DEBUG */
    yyval.n = mkintnode(-(yystack.l_mark[0].n->u.sval.u.integer));
    free_node(yystack.l_mark[0].n);
  }
break;
case 200:
#line 1480 "language.yacc"
	{
    yyerror("Elipsis ('...') where range indicator ('..') expected.");
  }
break;
case 201:
#line 1486 "language.yacc"
	{
    push_int_type(MIN_INT_TYPE, MAX_INT_TYPE);
  }
break;
case 202:
#line 1490 "language.yacc"
	{
      push_int_type( 0, (1<<yystack.l_mark[-1].n->u.sval.u.integer)-1 );
      free_node( yystack.l_mark[-1].n );
  }
break;
case 203:
#line 1495 "language.yacc"
	{
    INT_TYPE min = MIN_INT_TYPE;
    INT_TYPE max = MAX_INT_TYPE;

    /* FIXME: Check that $4 is >= $2. */
    if(yystack.l_mark[-1].n->token == F_CONSTANT) {
      if (TYPEOF(yystack.l_mark[-1].n->u.sval) == T_INT) {
	max = yystack.l_mark[-1].n->u.sval.u.integer;
      } else if (is_bignum_object_in_svalue(&yystack.l_mark[-1].n->u.sval)) {
	push_int(0);
	if (is_lt(&yystack.l_mark[-1].n->u.sval, Pike_sp-1)) {
	  max = MIN_INT_TYPE;
	}
	pop_stack();
      }
    }

    if(yystack.l_mark[-3].n->token == F_CONSTANT) {
      if (TYPEOF(yystack.l_mark[-3].n->u.sval) == T_INT) {
	min = yystack.l_mark[-3].n->u.sval.u.integer;
      } else if (is_bignum_object_in_svalue(&yystack.l_mark[-3].n->u.sval)) {
	push_int(0);
	if (is_lt(Pike_sp-1, &yystack.l_mark[-3].n->u.sval)) {
	  min = MAX_INT_TYPE;
	}
	pop_stack();
      }
    }

    push_int_type(min, max);

    free_node(yystack.l_mark[-3].n);
    free_node(yystack.l_mark[-1].n);
  }
break;
case 204:
#line 1530 "language.yacc"
	{
    push_int_type(MIN_INT32, MAX_INT32);
    yyerror("Expected integer range.");
  }
break;
case 205:
#line 1537 "language.yacc"
	{
    push_type(T_STRING);
  }
break;
case 206:
#line 1542 "language.yacc"
	{ push_object_type(0, 0); }
break;
case 207:
#line 1543 "language.yacc"
	{
#ifdef PIKE_DEBUG
      yyval.ptr = Pike_sp;
#endif /* PIKE_DEBUG */
    }
break;
case 208:
#line 1549 "language.yacc"
	{
    /* NOTE: On entry, there are two items on the stack:
     *   Pike_sp-2:	Name of the program reference (string).
     *   Pike_sp-1:	The resolved program (program|function|zero).
     */
    struct program *p=program_from_svalue(Pike_sp-1);

#ifdef PIKE_DEBUG
    if (yystack.l_mark[-3].ptr != (Pike_sp - 2)) {
      Pike_fatal("Unexpected stack depth: %p != %p\n",
		 yystack.l_mark[-3].n, Pike_sp-2);
    }
#endif /* PIKE_DEBUG */

    if(!p) {
      if (Pike_compiler->compiler_pass!=1) {
	my_yyerror("Not a valid program specifier: %S", Pike_sp[-2].u.string);
      }
    }
    push_object_type(0, p?(p->id):0);
    /* Attempt to name the type. */
    if (TYPEOF(Pike_sp[-2]) == T_STRING) {
      push_type_name(Pike_sp[-2].u.string);
    }
    pop_n_elems(2);
  }
break;
case 209:
#line 1577 "language.yacc"
	{ push_object_type(0, 0); }
break;
case 211:
#line 1580 "language.yacc"
	{
    push_object_type(0, 0);
    yyerror("Invalid program subtype.");
  }
break;
case 212:
#line 1587 "language.yacc"
	{
    type_stack_mark();
  }
break;
case 213:
#line 1591 "language.yacc"
	{
    /* Add the many type if there is none. */
    if (yystack.l_mark[-1].number)
    {
      if (!yystack.l_mark[-2].number) {
	/* function_type_list ends with a comma, or is empty.
	 * FIXME: Should this be a syntax error or not?
	 */
	if (Pike_compiler->compiler_pass == 1) {
	  yyerror("Missing type before ... .");
	}
	push_type(T_MIXED);
      }
    }else{
      push_type(T_VOID);
    }
  }
break;
case 214:
#line 1609 "language.yacc"
	{
    push_reverse_type(T_MANY);
    Pike_compiler->pike_type_mark_stackp--;
    while (*Pike_compiler->pike_type_mark_stackp+1 <
	   Pike_compiler->type_stackp) {
      push_reverse_type(T_FUNCTION);
    }
  }
break;
case 215:
#line 1618 "language.yacc"
	{
   push_type(T_MIXED);
   push_type(T_VOID);
   push_type(T_OR);

   push_type(T_ZERO);
   push_type(T_VOID);
   push_type(T_OR);

   push_type(T_MANY);
  }
break;
case 216:
#line 1631 "language.yacc"
	{ yyval.number=0; }
break;
case 217:
#line 1632 "language.yacc"
	{ yyval.number=!yystack.l_mark[0].number; }
break;
case 218:
#line 1635 "language.yacc"
	{ yyval.number=1; }
break;
case 219:
#line 1637 "language.yacc"
	{
  }
break;
case 222:
#line 1643 "language.yacc"
	{ push_type(T_MIXED); }
break;
case 223:
#line 1647 "language.yacc"
	{
  }
break;
case 224:
#line 1650 "language.yacc"
	{
  }
break;
case 225:
#line 1653 "language.yacc"
	{
    push_reverse_type(T_MAPPING);
  }
break;
case 227:
#line 1658 "language.yacc"
	{
    push_type(T_MIXED);
    push_type(T_MIXED);
    push_type(T_MAPPING);
  }
break;
case 230:
#line 1671 "language.yacc"
	{
    struct pike_type *type;
    node *n;
    push_finished_type(Pike_compiler->compiler_frame->current_type);
    n = Pike_compiler->current_attributes;
    while(n) {
      push_type_attribute(CDR(n)->u.sval.u.string);
      n = CAR(n);
    }
    type=compiler_pop_type();
    define_variable(yystack.l_mark[0].n->u.sval.u.string, type,
		    Pike_compiler->current_modifiers);
    free_type(type);
    free_node(yystack.l_mark[0].n);
  }
break;
case 231:
#line 1686 "language.yacc"
	{}
break;
case 232:
#line 1688 "language.yacc"
	{
    struct pike_type *type;
    node *n;
    push_finished_type(Pike_compiler->compiler_frame->current_type);
    n = Pike_compiler->current_attributes;
    while(n) {
      push_type_attribute(CDR(n)->u.sval.u.string);
      n = CAR(n);
    }
    type=compiler_pop_type();
    if ((Pike_compiler->current_modifiers & ID_EXTERN) &&
	(Pike_compiler->compiler_pass == 1)) {
      yywarning("Extern declared variable has initializer.");
    }
    yyval.number=define_variable(yystack.l_mark[-1].n->u.sval.u.string, type,
			       Pike_compiler->current_modifiers & (~ID_EXTERN));
    free_type(type);
  }
break;
case 233:
#line 1707 "language.yacc"
	{
    if ((Pike_compiler->compiler_pass == 2) &&
	!TEST_COMPAT(7, 8) && (yystack.l_mark[0].n) && (yystack.l_mark[0].n->token == F_CONSTANT) &&
	!Pike_compiler->num_parse_error) {
      /* Check if it is zero, in which case we can throw it away.
       *
       * NB: The compat test is due to that this changes the semantics
       *     of calling __INIT() by hand.
       */
      if ((TYPEOF(yystack.l_mark[0].n->u.sval) == PIKE_T_INT) && !SUBTYPEOF(yystack.l_mark[0].n->u.sval) &&
	  !yystack.l_mark[0].n->u.sval.u.integer &&
	  !IDENTIFIER_IS_ALIAS(ID_FROM_INT(Pike_compiler->new_program,
					   yystack.l_mark[-1].number)->identifier_flags)) {
	/* NB: Inherited variables get converted into aliases by
	 *     define_variable, and we need to support clearing
	 *     of inherited variables.
	 */
#ifdef PIKE_DEBUG
	if (l_flag > 5) {
	  fprintf(stderr,
		  "Ignoring initialization to zero for variable %s.\n",
		  yystack.l_mark[-3].n->u.sval.u.string->str);
	}
#endif /* PIKE_DEBUG */
	free_node(yystack.l_mark[0].n);
	yystack.l_mark[0].n = NULL;
      }
    }
    if (yystack.l_mark[0].n) {
      Pike_compiler->init_node=mknode(F_COMMA_EXPR,Pike_compiler->init_node,
		       mkcastnode(void_type_string,
				  mknode(F_ASSIGN,yystack.l_mark[0].n,
					 mkidentifiernode(yystack.l_mark[-1].number))));
    }
    free_node(yystack.l_mark[-3].n);
  }
break;
case 234:
#line 1744 "language.yacc"
	{
    free_node(yystack.l_mark[-2].n);
  }
break;
case 235:
#line 1748 "language.yacc"
	{
    yyerror("Unexpected end of file in variable definition.");
    free_node(yystack.l_mark[-2].n);
  }
break;
case 236:
#line 1753 "language.yacc"
	{
    free_node(yystack.l_mark[0].n);
  }
break;
case 237:
#line 1760 "language.yacc"
	{
    int id;
    push_finished_type(yystack.l_mark[-2].n->u.sval.u.type);
    id = add_local_name(yystack.l_mark[0].n->u.sval.u.string, compiler_pop_type(),0);
    if (id >= 0) {
      /* FIXME: Consider using mklocalnode(id, -1). */
      yyval.n=mknode(F_ASSIGN,mkintnode(0),mklocalnode(id,0));
    } else
      yyval.n = 0;
    free_node(yystack.l_mark[0].n);
  }
break;
case 238:
#line 1771 "language.yacc"
	{ yyval.n=0; }
break;
case 239:
#line 1773 "language.yacc"
	{
    int id;
    push_finished_type(yystack.l_mark[-4].n->u.sval.u.type);
    id = add_local_name(yystack.l_mark[-2].n->u.sval.u.string, compiler_pop_type(),0);
    if (id >= 0) {
      if (!(THIS_COMPILATION->lex.pragmas & ID_STRICT_TYPES)) {
	/* Only warn about unused initialized variables in strict types mode. */
	Pike_compiler->compiler_frame->variable[id].flags |= LOCAL_VAR_IS_USED;
      }
      yyval.n=mknode(F_ASSIGN,yystack.l_mark[0].n,mklocalnode(id,0));
    } else
      yyval.n = 0;
    free_node(yystack.l_mark[-2].n);
  }
break;
case 240:
#line 1788 "language.yacc"
	{
    free_node(yystack.l_mark[0].n);
    yyval.n=0;
  }
break;
case 241:
#line 1793 "language.yacc"
	{
    free_node(yystack.l_mark[-2].n);
    /* No yyerok here since we aren't done yet. */
    yyval.n=0;
  }
break;
case 242:
#line 1799 "language.yacc"
	{
    yyerror("Unexpected end of file in local variable definition.");
    free_node(yystack.l_mark[-2].n);
    /* No yyerok here since we aren't done yet. */
    yyval.n=0;
  }
break;
case 243:
#line 1808 "language.yacc"
	{
    int id;
    add_ref(yystack.l_mark[-1].n->u.sval.u.type);
    id = add_local_name(yystack.l_mark[0].n->u.sval.u.string, yystack.l_mark[-1].n->u.sval.u.type, 0);
    if (id >= 0) {
      /* FIXME: Consider using mklocalnode(id, -1). */
      yyval.n=mknode(F_ASSIGN,mkintnode(0),mklocalnode(id,0));
    } else
      yyval.n = 0;
    free_node(yystack.l_mark[0].n);
  }
break;
case 244:
#line 1819 "language.yacc"
	{ yyval.n=0; }
break;
case 245:
#line 1821 "language.yacc"
	{
    int id;
    add_ref(yystack.l_mark[-3].n->u.sval.u.type);
    id = add_local_name(yystack.l_mark[-2].n->u.sval.u.string, yystack.l_mark[-3].n->u.sval.u.type, 0);
    if (id >= 0) {
      if (!(THIS_COMPILATION->lex.pragmas & ID_STRICT_TYPES)) {
	/* Only warn about unused initialized variables in strict types mode. */
	Pike_compiler->compiler_frame->variable[id].flags |= LOCAL_VAR_IS_USED;
      }
      yyval.n=mknode(F_ASSIGN,yystack.l_mark[0].n, mklocalnode(id,0));
    } else
      yyval.n = 0;
    free_node(yystack.l_mark[-2].n);
  }
break;
case 246:
#line 1835 "language.yacc"
	{ yyval.n=yystack.l_mark[0].n; }
break;
case 247:
#line 1839 "language.yacc"
	{
    /* Used to hold line-number info */
    yyval.n = mkintnode(0);
  }
break;
case 248:
#line 1846 "language.yacc"
	{
    yystack.l_mark[0].number=Pike_compiler->num_used_modules;
    yyval.number=Pike_compiler->compiler_frame->current_number_of_locals;
  }
break;
case 249:
#line 1851 "language.yacc"
	{
    /* Trick to store more than one number on compiler stack - Hubbe */
    yyval.number=Pike_compiler->compiler_frame->last_block_level;

    if(yyval.number == -1) /* if 'first block' */
      Pike_compiler->compiler_frame->last_block_level=0; /* all variables */
    else
      Pike_compiler->compiler_frame->last_block_level=yystack.l_mark[-1].number;
  }
break;
case 250:
#line 1860 "language.yacc"
	{
    yyval.ptr = Pike_compiler;
  }
break;
case 251:
#line 1864 "language.yacc"
	{
    /* Recover compilation context on syntax errors. */
    while (Pike_compiler != yystack.l_mark[-2].ptr) {
      struct program *p;
      /* fprintf(stderr, "Compiler context out of sync. Attempting to recover...\n"); */
      if(Pike_compiler->compiler_pass == 1)
	p = end_first_pass(0);
      else
	p=end_first_pass(1);

      if (p) free_program(p);
    }

    unuse_modules(Pike_compiler->num_used_modules - yystack.l_mark[-6].number);
    yystack.l_mark[-1].n = pop_local_variables(yystack.l_mark[-5].number, yystack.l_mark[-1].n);
    Pike_compiler->compiler_frame->last_block_level=yystack.l_mark[-3].number;
    if (yystack.l_mark[-1].n) COPY_LINE_NUMBER_INFO(yystack.l_mark[-1].n, yystack.l_mark[-4].n);
    free_node (yystack.l_mark[-4].n);
    yyval.n=yystack.l_mark[-1].n;
  }
break;
case 253:
#line 1889 "language.yacc"
	{
    yyerror("Missing '}'.");
    if (yystack.l_mark[-1].n) {
      low_yyreport(REPORT_ERROR, yystack.l_mark[-1].n->current_file, yystack.l_mark[-1].n->line_number,
		   parser_system_string, 0, "Opening '{' was here.");
    }
    yyerror("Unexpected end of file.");
  }
break;
case 255:
#line 1900 "language.yacc"
	{ yyval.n=0; }
break;
case 256:
#line 1901 "language.yacc"
	{ yyerror("Unexpected end of file."); yyval.n=0; }
break;
case 257:
#line 1906 "language.yacc"
	{
    yyval.n = yystack.l_mark[-2].n;
  }
break;
case 259:
#line 1914 "language.yacc"
	{ yyval.n = mknode(F_COMMA_EXPR, mkcastnode(void_type_string, yystack.l_mark[-3].n), yystack.l_mark[0].n); }
break;
case 261:
#line 1920 "language.yacc"
	{ yyval.n = mknode(F_COMMA_EXPR, mkcastnode(void_type_string, yystack.l_mark[-3].n), yystack.l_mark[0].n); }
break;
case 262:
#line 1925 "language.yacc"
	{
    struct pike_type *type;

    /* Ugly hack to make sure that $3 is optimized */
    {
      int tmp=Pike_compiler->compiler_pass;
      yystack.l_mark[0].n=mknode(F_COMMA_EXPR,yystack.l_mark[0].n,0);
      optimize_node(yystack.l_mark[0].n);
      Pike_compiler->compiler_pass=tmp;
      type=yystack.l_mark[0].n->u.node.a->type;
    }

    if(!is_const(yystack.l_mark[0].n))
    {
      if(Pike_compiler->compiler_pass==2)
	yyerror("Constant definition is not constant.");
    }else{
      ptrdiff_t tmp=eval_low(yystack.l_mark[0].n,1);
      if(tmp < 1)
      {
	yyerror("Error in constant definition.");
      }else{
	pop_n_elems(DO_NOT_WARN((INT32)(tmp - 1)));
	if(yystack.l_mark[0].n) free_node(yystack.l_mark[0].n);
	yystack.l_mark[0].n=mksvaluenode(Pike_sp-1);
	type=yystack.l_mark[0].n->type;
	pop_stack();
      }
    }
    if(!type) type = mixed_type_string;
    add_ref(type);
    low_add_local_name(Pike_compiler->compiler_frame, /*->previous,*/
		       yystack.l_mark[-2].n->u.sval.u.string,
		       type, yystack.l_mark[0].n);
    /* Note: Intentionally not marked as used. */
    free_node(yystack.l_mark[-2].n);
  }
break;
case 263:
#line 1962 "language.yacc"
	{ if (yystack.l_mark[0].n) free_node(yystack.l_mark[0].n); }
break;
case 264:
#line 1963 "language.yacc"
	{ if (yystack.l_mark[0].n) free_node(yystack.l_mark[0].n); }
break;
case 268:
#line 1971 "language.yacc"
	{ yyerrok; }
break;
case 269:
#line 1973 "language.yacc"
	{
    yyerror("Missing ';'.");
    yyerror("Unexpected end of file.");
  }
break;
case 270:
#line 1977 "language.yacc"
	{ yyerror("Missing ';'."); }
break;
case 271:
#line 1981 "language.yacc"
	{ yyval.n=0; }
break;
case 272:
#line 1983 "language.yacc"
	{
    yyval.n = mknode(F_COMMA_EXPR, yystack.l_mark[-1].n, mkcastnode(void_type_string, yystack.l_mark[0].n));
  }
break;
case 275:
#line 1991 "language.yacc"
	{ yyval.n=0; }
break;
case 278:
#line 1994 "language.yacc"
	{ yyval.n=0; }
break;
case 282:
#line 1998 "language.yacc"
	{ reset_type_stack(); yyval.n=0; yyerrok; }
break;
case 283:
#line 2000 "language.yacc"
	{
    reset_type_stack();
    yyerror("Missing ';'.");
    yyerror("Unexpected end of file.");
    yyval.n=0;
  }
break;
case 284:
#line 2007 "language.yacc"
	{
    reset_type_stack();
    yyerror("Missing ';'.");
/*    yychar = '}'; */	/* Put the '}' back on the input stream. */
    yyval.n=0;
  }
break;
case 285:
#line 2013 "language.yacc"
	{ yyval.n=0; }
break;
case 286:
#line 2017 "language.yacc"
	{
    Pike_compiler->compiler_frame->opt_flags &= ~OPT_CUSTOM_LABELS;
  }
break;
case 295:
#line 2031 "language.yacc"
	{
    Pike_compiler->compiler_frame->opt_flags &= ~OPT_CUSTOM_LABELS;
  }
break;
case 296:
#line 2035 "language.yacc"
	{
    yyval.n = mknode(Pike_compiler->compiler_frame->opt_flags & OPT_CUSTOM_LABELS ?
		F_CUSTOM_STMT_LABEL : F_NORMAL_STMT_LABEL,
		yystack.l_mark[-3].n, yystack.l_mark[0].n);

    /* FIXME: This won't be correct if the node happens to be shared.
     * That's an issue to be solved with shared nodes in general,
     * though. */
    COPY_LINE_NUMBER_INFO(yyval.n, yystack.l_mark[-3].n);
  }
break;
case 298:
#line 2048 "language.yacc"
	{yyval.n = 0;}
break;
case 299:
#line 2051 "language.yacc"
	{ yyval.n=mknode(F_BREAK,yystack.l_mark[0].n,0); }
break;
case 300:
#line 2052 "language.yacc"
	{ yyval.n=mknode(F_DEFAULT,0,0); }
break;
case 301:
#line 2054 "language.yacc"
	{
    yyval.n=mknode(F_DEFAULT,0,0); yyerror("Expected ':' after default.");
  }
break;
case 302:
#line 2059 "language.yacc"
	{ yyval.n=mknode(F_CONTINUE,yystack.l_mark[0].n,0); }
break;
case 303:
#line 2062 "language.yacc"
	{
    push_compiler_frame(SCOPE_LOCAL);

    yyval.ptr = Pike_compiler->compiler_frame;
  }
break;
case 304:
#line 2070 "language.yacc"
	{
    struct pike_string *name;
    yyval.n=mkstrnode(name = get_new_name(NULL));
    free_string(name);
  }
break;
case 305:
#line 2078 "language.yacc"
	{
    debug_malloc_touch(Pike_compiler->compiler_frame->current_return_type);
    if(Pike_compiler->compiler_frame->current_return_type)
      free_type(Pike_compiler->compiler_frame->current_return_type);
    copy_pike_type(Pike_compiler->compiler_frame->current_return_type,
		   any_type_string);
  }
break;
case 306:
#line 2086 "language.yacc"
	{
    struct pike_string *name = yystack.l_mark[-3].n->u.sval.u.string;
    struct pike_type *type;
    int e;

    yyval.number = Pike_compiler->varargs;
    Pike_compiler->varargs = 0;

    if (Pike_compiler->compiler_pass == 1) {
      /* Define a tentative prototype for the lambda. */
      push_finished_type(mixed_type_string);
      e=yystack.l_mark[0].number-1;
      if(yyval.number)
      {
	push_finished_type(Pike_compiler->compiler_frame->variable[e].type);
	e--;
	pop_type_stack(T_ARRAY);
      }else{
	push_type(T_VOID);
      }
      Pike_compiler->varargs=0;
      push_type(T_MANY);
      for(; e>=0; e--) {
	push_finished_type(Pike_compiler->compiler_frame->variable[e].type);
	push_type(T_FUNCTION);
      }
      type=compiler_pop_type();
      Pike_compiler->compiler_frame->current_function_number =
	define_function(name, type,
			ID_PROTECTED | ID_PRIVATE | ID_INLINE | ID_USED,
			IDENTIFIER_PIKE_FUNCTION, NULL,
			(unsigned INT16)
			(Pike_compiler->compiler_frame->opt_flags));
      free_type(type);
    } else {
      /* In pass 2 we just reuse the type from pass 1. */
      Pike_compiler->compiler_frame->current_function_number =
	isidentifier(name);
    }
  }
break;
case 307:
#line 2127 "language.yacc"
	{
    struct pike_type *type;
    int f,e;
    struct pike_string *name;
    struct compilation *c = THIS_COMPILATION;
    struct pike_string *save_file = c->lex.current_file;
    int save_line = c->lex.current_line;
    c->lex.current_file = yystack.l_mark[-6].n->current_file;
    c->lex.current_line = yystack.l_mark[-6].n->line_number;

    debug_malloc_touch(yystack.l_mark[0].n);
    yystack.l_mark[0].n=mknode(F_COMMA_EXPR,yystack.l_mark[0].n,mknode(F_RETURN,mkintnode(0),0));
    if (Pike_compiler->compiler_pass == 2) {
      /* Doing this in pass 1 might induce too strict checks on types
       * in cases where we got placeholders. */
      type=find_return_type(yystack.l_mark[0].n);
      if (type) {
	push_finished_type(type);
	free_type(type);
      } else {
	yywarning("Failed to determine return type for lambda.");
	push_type(T_ZERO);
      }
    } else {
      /* Tentative return type. */
      push_type(T_MIXED);
    }

    e=yystack.l_mark[-2].number-1;
    if(yystack.l_mark[-1].number)
    {
      push_finished_type(Pike_compiler->compiler_frame->variable[e].type);
      e--;
      pop_type_stack(T_ARRAY);
    }else{
      push_type(T_VOID);
    }
    Pike_compiler->varargs=0;
    push_type(T_MANY);
    for(; e>=0; e--) {
      push_finished_type(Pike_compiler->compiler_frame->variable[e].type);
      push_type(T_FUNCTION);
    }

    type=compiler_pop_type();

    name = yystack.l_mark[-5].n->u.sval.u.string;

#ifdef LAMBDA_DEBUG
    fprintf(stderr, "%d: LAMBDA: %s 0x%08lx 0x%08lx\n%d:   type: ",
	    Pike_compiler->compiler_pass, name->str,
	    (long)Pike_compiler->new_program->id,
	    Pike_compiler->local_class_counter-1,
	    Pike_compiler->compiler_pass);
    simple_describe_type(type);
    fprintf(stderr, "\n");
#endif /* LAMBDA_DEBUG */

    f=dooptcode(name,
		yystack.l_mark[0].n,
		type,
		ID_PROTECTED | ID_PRIVATE | ID_INLINE | ID_USED);

#ifdef PIKE_DEBUG
    if (f != Pike_compiler->compiler_frame->current_function_number) {
      Pike_fatal("Lost track of lambda %s.\n", name->str);
    }
#endif /* PIKE_DEBUG */

#ifdef LAMBDA_DEBUG
    fprintf(stderr, "%d:   lexical_scope: 0x%08x\n",
	    Pike_compiler->compiler_pass,
	    Pike_compiler->compiler_frame->lexical_scope);
#endif /* LAMBDA_DEBUG */

    if(Pike_compiler->compiler_frame->lexical_scope & SCOPE_SCOPED) {
      yyval.n = mktrampolinenode(f, Pike_compiler->compiler_frame->previous);
    } else {
      yyval.n = mkidentifiernode(f);
    }
    free_type(type);
    c->lex.current_line = save_line;
    c->lex.current_file = save_file;
    free_node(yystack.l_mark[-5].n);
    free_node (yystack.l_mark[-6].n);
#ifdef PIKE_DEBUG
    if (Pike_compiler->compiler_frame != yystack.l_mark[-4].ptr) {
      Pike_fatal("Lost track of compiler_frame!\n"
		 "  Got: %p (Expected: %p) Previous: %p\n",
		 Pike_compiler->compiler_frame, yystack.l_mark[-4].ptr,
		 Pike_compiler->compiler_frame->previous);
    }
#endif
    pop_compiler_frame();
  }
break;
case 308:
#line 2223 "language.yacc"
	{
#ifdef PIKE_DEBUG
    if (Pike_compiler->compiler_frame != yystack.l_mark[-1].ptr) {
      Pike_fatal("Lost track of compiler_frame!\n"
		 "  Got: %p (Expected: %p) Previous: %p\n",
		 Pike_compiler->compiler_frame, yystack.l_mark[-1].ptr,
		 Pike_compiler->compiler_frame->previous);
    }
#endif
    pop_compiler_frame();
    yyval.n = mkintnode(0);
    COPY_LINE_NUMBER_INFO(yyval.n, yystack.l_mark[-3].n);
    free_node(yystack.l_mark[-2].n);
    free_node(yystack.l_mark[-3].n);
  }
break;
case 309:
#line 2241 "language.yacc"
	{
    struct pike_string *name;
    struct pike_type *type;
    int id,e;
    node *n;
    struct identifier *i=0;

    debug_malloc_touch(Pike_compiler->compiler_frame->current_return_type);
    if(Pike_compiler->compiler_frame->current_return_type)
      free_type(Pike_compiler->compiler_frame->current_return_type);
    copy_pike_type(Pike_compiler->compiler_frame->current_return_type,
		   yystack.l_mark[-3].n->u.sval.u.type);


    /***/
    push_finished_type(Pike_compiler->compiler_frame->current_return_type);

    e=yystack.l_mark[0].number-1;
    if(Pike_compiler->varargs)
    {
      push_finished_type(Pike_compiler->compiler_frame->variable[e].type);
      e--;
      pop_type_stack(T_ARRAY);
    }else{
      push_type(T_VOID);
    }
    push_type(T_MANY);
    for(; e>=0; e--) {
      push_finished_type(Pike_compiler->compiler_frame->variable[e].type);
    push_type(T_FUNCTION);
    }

    type=compiler_pop_type();
    /***/

    name = get_new_name(yystack.l_mark[-2].n->u.sval.u.string);

#ifdef LAMBDA_DEBUG
    fprintf(stderr, "%d: LAMBDA: %s 0x%08lx 0x%08lx\n",
	    Pike_compiler->compiler_pass, name->str,
	    (long)Pike_compiler->new_program->id,
	    Pike_compiler->local_class_counter-1);
#endif /* LAMBDA_DEBUG */

    if(Pike_compiler->compiler_pass > 1)
    {
      id=isidentifier(name);
    }else{
      id=define_function(name,
			 type,
			 ID_PROTECTED | ID_PRIVATE | ID_INLINE | ID_USED,
			 IDENTIFIER_PIKE_FUNCTION |
			 (Pike_compiler->varargs?IDENTIFIER_VARARGS:0),
			 0,
			 OPT_SIDE_EFFECT|OPT_EXTERNAL_DEPEND);
    }
    Pike_compiler->varargs=0;
    Pike_compiler->compiler_frame->current_function_number=id;

    n=0;
    if(Pike_compiler->compiler_pass > 1 &&
       (i=ID_FROM_INT(Pike_compiler->new_program, id)))
    {
      if(i->identifier_flags & IDENTIFIER_SCOPED)
	n = mktrampolinenode(id, Pike_compiler->compiler_frame->previous);
      else
	n = mkidentifiernode(id);
    }

    low_add_local_name(Pike_compiler->compiler_frame->previous,
		       yystack.l_mark[-2].n->u.sval.u.string, type, n);

    yyval.number=id;
    free_string(name);
  }
break;
case 310:
#line 2317 "language.yacc"
	{
    int localid;
    struct identifier *i=ID_FROM_INT(Pike_compiler->new_program, yystack.l_mark[-1].number);
    struct compilation *c = THIS_COMPILATION;
    struct pike_string *save_file = c->lex.current_file;
    int save_line = c->lex.current_line;
    c->lex.current_file = yystack.l_mark[-4].n->current_file;
    c->lex.current_line = yystack.l_mark[-4].n->line_number;

    yystack.l_mark[0].n=mknode(F_COMMA_EXPR,yystack.l_mark[0].n,mknode(F_RETURN,mkintnode(0),0));

    debug_malloc_touch(yystack.l_mark[0].n);
    dooptcode(i->name,
	      yystack.l_mark[0].n,
	      i->type,
	      ID_PROTECTED | ID_PRIVATE | ID_INLINE);

    i->opt_flags = Pike_compiler->compiler_frame->opt_flags;

    c->lex.current_line = save_line;
    c->lex.current_file = save_file;
#ifdef PIKE_DEBUG
    if (Pike_compiler->compiler_frame != yystack.l_mark[-3].ptr) {
      Pike_fatal("Lost track of compiler_frame!\n"
		 "  Got: %p (Expected: %p) Previous: %p\n",
		 Pike_compiler->compiler_frame, yystack.l_mark[-3].ptr,
		 Pike_compiler->compiler_frame->previous);
    }
#endif
    pop_compiler_frame();
    free_node(yystack.l_mark[-4].n);

    /* WARNING: If the local function adds more variables we are screwed */
    /* WARNING2: if add_local_name stops adding local variables at the end,
     *           this has to be fixed.
     */

    localid=Pike_compiler->compiler_frame->current_number_of_locals-1;
    if(Pike_compiler->compiler_frame->variable[localid].def)
    {
      yyval.n=copy_node(Pike_compiler->compiler_frame->variable[localid].def);
    }else{
      if(Pike_compiler->compiler_frame->lexical_scope &
	 (SCOPE_SCOPE_USED | SCOPE_SCOPED))
      {
	yyval.n = mktrampolinenode(yystack.l_mark[-1].number,Pike_compiler->compiler_frame);
      }else{
	yyval.n = mkidentifiernode(yystack.l_mark[-1].number);
      }
    }
  }
break;
case 311:
#line 2369 "language.yacc"
	{
#ifdef PIKE_DEBUG
    if (Pike_compiler->compiler_frame != yystack.l_mark[-1].ptr) {
      Pike_fatal("Lost track of compiler_frame!\n"
		 "  Got: %p (Expected: %p) Previous: %p\n",
		 Pike_compiler->compiler_frame, yystack.l_mark[-1].ptr,
		 Pike_compiler->compiler_frame->previous);
    }
#endif
    pop_compiler_frame();
    yyval.n=mkintnode(0);
  }
break;
case 312:
#line 2384 "language.yacc"
	{
    struct pike_string *name;
    struct pike_type *type;
    int id,e;
    node *n;
    struct identifier *i=0;

    /***/
    debug_malloc_touch(Pike_compiler->compiler_frame->current_return_type);

    push_finished_type(yystack.l_mark[-4].n->u.sval.u.type);

    if(Pike_compiler->compiler_frame->current_return_type)
      free_type(Pike_compiler->compiler_frame->current_return_type);
    Pike_compiler->compiler_frame->current_return_type=compiler_pop_type();

    /***/
    push_finished_type(Pike_compiler->compiler_frame->current_return_type);

    e=yystack.l_mark[0].number-1;
    if(Pike_compiler->varargs)
    {
      push_finished_type(Pike_compiler->compiler_frame->variable[e].type);
      e--;
      pop_type_stack(T_ARRAY);
    }else{
      push_type(T_VOID);
    }
    push_type(T_MANY);
    for(; e>=0; e--) {
      push_finished_type(Pike_compiler->compiler_frame->variable[e].type);
      push_type(T_FUNCTION);
    }

    type=compiler_pop_type();
    /***/

    name = get_new_name(yystack.l_mark[-2].n->u.sval.u.string);

#ifdef LAMBDA_DEBUG
    fprintf(stderr, "%d: LAMBDA: %s 0x%08lx 0x%08lx\n",
	    Pike_compiler->compiler_pass, name->str,
	    (long)Pike_compiler->new_program->id,
	    Pike_compiler->local_class_counter-1);
#endif /* LAMBDA_DEBUG */

    if(Pike_compiler->compiler_pass > 1)
    {
      id=isidentifier(name);
    }else{
      id=define_function(name,
			 type,
			 ID_PROTECTED | ID_PRIVATE | ID_INLINE | ID_USED,
			 IDENTIFIER_PIKE_FUNCTION|
			 (Pike_compiler->varargs?IDENTIFIER_VARARGS:0),
			 0,
			 OPT_SIDE_EFFECT|OPT_EXTERNAL_DEPEND);
    }
    Pike_compiler->varargs=0;
    Pike_compiler->compiler_frame->current_function_number=id;

    n=0;
    if(Pike_compiler->compiler_pass > 1 &&
       (i=ID_FROM_INT(Pike_compiler->new_program, id)))
    {
      if(i->identifier_flags & IDENTIFIER_SCOPED)
	n = mktrampolinenode(id, Pike_compiler->compiler_frame->previous);
      else
	n = mkidentifiernode(id);
    }

    low_add_local_name(Pike_compiler->compiler_frame->previous,
		       yystack.l_mark[-2].n->u.sval.u.string, type, n);
    yyval.number=id;
    free_string(name);
  }
break;
case 313:
#line 2461 "language.yacc"
	{
    int localid;
    struct identifier *i=ID_FROM_INT(Pike_compiler->new_program, yystack.l_mark[-1].number);
    struct compilation *c = THIS_COMPILATION;
    struct pike_string *save_file = c->lex.current_file;
    int save_line = c->lex.current_line;
    c->lex.current_file = yystack.l_mark[-4].n->current_file;
    c->lex.current_line = yystack.l_mark[-4].n->line_number;

    debug_malloc_touch(yystack.l_mark[0].n);
    yystack.l_mark[0].n=mknode(F_COMMA_EXPR,yystack.l_mark[0].n,mknode(F_RETURN,mkintnode(0),0));


    debug_malloc_touch(yystack.l_mark[0].n);
    dooptcode(i->name,
	      yystack.l_mark[0].n,
	      i->type,
	      ID_PROTECTED | ID_PRIVATE | ID_INLINE);

    i->opt_flags = Pike_compiler->compiler_frame->opt_flags;

    c->lex.current_line = save_line;
    c->lex.current_file = save_file;
#ifdef PIKE_DEBUG
    if (Pike_compiler->compiler_frame != yystack.l_mark[-3].ptr) {
      Pike_fatal("Lost track of compiler_frame!\n"
		 "  Got: %p (Expected: %p) Previous: %p\n",
		 Pike_compiler->compiler_frame, yystack.l_mark[-3].ptr,
		 Pike_compiler->compiler_frame->previous);
    }
#endif
    pop_compiler_frame();
    free_node(yystack.l_mark[-4].n);

    /* WARNING: If the local function adds more variables we are screwed */
    /* WARNING2: if add_local_name stops adding local variables at the end,
     *           this has to be fixed.
     */

    localid=Pike_compiler->compiler_frame->current_number_of_locals-1;
    if(Pike_compiler->compiler_frame->variable[localid].def)
    {
      yyval.n=copy_node(Pike_compiler->compiler_frame->variable[localid].def);
    }else{
      if(Pike_compiler->compiler_frame->lexical_scope &
	 (SCOPE_SCOPE_USED | SCOPE_SCOPED))
      {
        yyval.n = mktrampolinenode(yystack.l_mark[-1].number,Pike_compiler->compiler_frame);
      }else{
        yyval.n = mkidentifiernode(yystack.l_mark[-1].number);
      }
    }
  }
break;
case 314:
#line 2515 "language.yacc"
	{
#ifdef PIKE_DEBUG
    if (Pike_compiler->compiler_frame != yystack.l_mark[-1].ptr) {
      Pike_fatal("Lost track of compiler_frame!\n"
		 "  Got: %p (Expected: %p) Previous: %p\n",
		 Pike_compiler->compiler_frame, yystack.l_mark[-1].ptr,
		 Pike_compiler->compiler_frame->previous);
    }
#endif
    pop_compiler_frame();
    free_node(yystack.l_mark[-2].n);
    yyval.n=mkintnode(0);
  }
break;
case 315:
#line 2531 "language.yacc"
	{
    struct pike_type *type;
    int ref_no;

    if (Pike_compiler->num_create_args < 0) {
      yyerror("Can't define more variables after ...");
    }

    push_finished_type(Pike_compiler->compiler_frame->current_type);
    if (yystack.l_mark[-1].number) {
      push_type(T_ARRAY);
    }
    type=compiler_pop_type();

    /* Add the identifier globally.
     * Note: Since these are the first identifiers (and references)
     *       to be added to the program, they will be numbered in
     *       sequence starting at 0 (zero). This means that the
     *       counter num_create_args is sufficient extra information
     *       to be able to keep track of them.
     */
    ref_no = define_variable(yystack.l_mark[0].n->u.sval.u.string, type,
			     Pike_compiler->current_modifiers);
    free_type(type);

    if (Pike_compiler->num_create_args != ref_no) {
      my_yyerror("Multiple definitions of create variable %S (%d != %d).",
		 yystack.l_mark[0].n->u.sval.u.string,
		 Pike_compiler->num_create_args, ref_no);
    }
    if (yystack.l_mark[-1].number) {
      /* Encode varargs marker as negative number of args. */
      Pike_compiler->num_create_args = -(ref_no + 1);
    } else {
      Pike_compiler->num_create_args = ref_no + 1;
    }

    /* free_type(type); */
    free_node(yystack.l_mark[0].n);
    yyval.number=0;
  }
break;
case 316:
#line 2572 "language.yacc"
	{ yyval.number=0; }
break;
case 317:
#line 2575 "language.yacc"
	{ yyval.number = 1; }
break;
case 318:
#line 2576 "language.yacc"
	{ yyval.number = yystack.l_mark[-2].number + 1; }
break;
case 319:
#line 2578 "language.yacc"
	{
    yyerror("Unexpected ':' in create argument list.");
    yyval.number = yystack.l_mark[-2].number + 1;
  }
break;
case 320:
#line 2584 "language.yacc"
	{ yyval.number=0; }
break;
case 322:
#line 2588 "language.yacc"
	{ yyval.number = 0; }
break;
case 323:
#line 2590 "language.yacc"
	{
    /* NOTE: One more than the number of arguments, so that we
<     *       can detect the case of no parenthesis below. */
    yyval.number = yystack.l_mark[-1].number + 1;
    free_node(yystack.l_mark[0].n);
  }
break;
case 324:
#line 2598 "language.yacc"
	{ yyval.n = NULL; }
break;
case 326:
#line 2599 "language.yacc"
	{ yyerrok; }
break;
case 327:
#line 2601 "language.yacc"
	{
		  yyerror("End of file where program definition expected.");
		}
break;
case 328:
#line 2608 "language.yacc"
	{
    if(!yystack.l_mark[0].n)
    {
      struct pike_string *s;
      char buffer[42];
      sprintf(buffer,"__class_%ld_%ld_line_%d",
	      (long)Pike_compiler->new_program->id,
	      (long)Pike_compiler->local_class_counter++,
	      (int) yystack.l_mark[-1].n->line_number);
      s=make_shared_string(buffer);
      yystack.l_mark[0].n=mkstrnode(s);
      free_string(s);
      yystack.l_mark[-3].number|=ID_PROTECTED | ID_PRIVATE | ID_INLINE;
    }
    /* fprintf(stderr, "LANGUAGE.YACC: CLASS start\n"); */
    if(Pike_compiler->compiler_pass==1)
    {
      if (yystack.l_mark[-3].number & ID_EXTERN) {
	yywarning("Extern declared class definition.");
      }
      low_start_new_program(0, 1, yystack.l_mark[0].n->u.sval.u.string,
			    yystack.l_mark[-3].number,
			    &yyval.number);

      /* fprintf(stderr, "Pass 1: Program %s has id %d\n",
	 $4->u.sval.u.string->str, Pike_compiler->new_program->id); */

      store_linenumber(yystack.l_mark[-1].n->line_number, yystack.l_mark[-1].n->current_file);
      debug_malloc_name(Pike_compiler->new_program,
			yystack.l_mark[-1].n->current_file->str,
			yystack.l_mark[-1].n->line_number);
    }else{
      int i;
      struct identifier *id;
      int tmp=Pike_compiler->compiler_pass;
      i=isidentifier(yystack.l_mark[0].n->u.sval.u.string);
      if(i<0)
      {
	/* Seriously broken... */
	yyerror("Pass 2: program not defined!");
	low_start_new_program(0, 2, 0,
			      yystack.l_mark[-3].number,
			      &yyval.number);
      }else{
	id=ID_FROM_INT(Pike_compiler->new_program, i);
	if(IDENTIFIER_IS_CONSTANT(id->identifier_flags))
	{
	  struct svalue *s;
	  if ((id->func.const_info.offset >= 0) &&
	      (TYPEOF(*(s = &PROG_FROM_INT(Pike_compiler->new_program,i)->
			constants[id->func.const_info.offset].sval)) ==
	       T_PROGRAM))
	  {
	    low_start_new_program(s->u.program, 2,
				  yystack.l_mark[0].n->u.sval.u.string,
				  yystack.l_mark[-3].number,
				  &yyval.number);

	    /* fprintf(stderr, "Pass 2: Program %s has id %d\n",
	       $4->u.sval.u.string->str, Pike_compiler->new_program->id); */

	  }else{
	    yyerror("Pass 2: constant redefined!");
	    low_start_new_program(0, 2, 0,
				  yystack.l_mark[-3].number,
				  &yyval.number);
	  }
	}else{
	  yyerror("Pass 2: class constant no longer constant!");
	  low_start_new_program(0, 2, 0,
				yystack.l_mark[-3].number,
				&yyval.number);
	}
      }
      Pike_compiler->compiler_pass=tmp;
    }
  }
break;
case 329:
#line 2685 "language.yacc"
	{
    /* Clear scoped modifiers. */
    yyval.number = THIS_COMPILATION->lex.pragmas;
    THIS_COMPILATION->lex.pragmas &= ~ID_MODIFIER_MASK;
  }
break;
case 330:
#line 2691 "language.yacc"
	{
    struct program *p;

    /* Check if we have create arguments but no locally defined create(). */
    if (yystack.l_mark[-1].number) {
      struct pike_string *create_string = NULL;
      struct reference *ref = NULL;
      struct identifier *id = NULL;
      int ref_id;
      MAKE_CONST_STRING(create_string, "create");
      if (((ref_id = isidentifier(create_string)) < 0) ||
	  (ref = PTR_FROM_INT(Pike_compiler->new_program, ref_id))->inherit_offset ||
	  ((id = ID_FROM_PTR(Pike_compiler->new_program, ref))->func.offset == -1)) {
	int e;
	struct pike_type *type = NULL;
	int nargs = Pike_compiler->num_create_args;

	push_compiler_frame(SCOPE_LOCAL);

	/* Init: Prepend the create arguments. */
	if (Pike_compiler->num_create_args < 0) {
	  for (e = 0; e < -Pike_compiler->num_create_args; e++) {
	    id = Pike_compiler->new_program->identifiers + e;
	    add_ref(id->type);
	    add_local_name(id->name, id->type, 0);
	    /* Note: add_local_name() above will return e. */
	    Pike_compiler->compiler_frame->variable[e].flags |=
	      LOCAL_VAR_IS_USED;
	  }
	} else {
	  for (e = 0; e < Pike_compiler->num_create_args; e++) {
	    id = Pike_compiler->new_program->identifiers + e;
	    add_ref(id->type);
	    add_local_name(id->name, id->type, 0);
	    /* Note: add_local_name() above will return e. */
	    Pike_compiler->compiler_frame->variable[e].flags |=
	      LOCAL_VAR_IS_USED;
	  }
	}

	/* First: Deduce the type for the create() function. */
	push_type(T_VOID); /* Return type. */

	if ((e = nargs) < 0) {
	  /* Varargs */
	  e = nargs = -nargs;
	  push_finished_type(Pike_compiler->compiler_frame->variable[--e].type);
	  pop_type_stack(T_ARRAY); /* Pop one level of array. */
	} else {
	  /* Not varargs. */
	  push_type(T_VOID);
	}
	push_type(T_MANY);
	while(e--) {
	  push_finished_type(Pike_compiler->compiler_frame->variable[e].type);
	  push_type(T_FUNCTION);
	}

	type = compiler_pop_type();

	/* Second: Declare the function. */

	Pike_compiler->compiler_frame->current_function_number=
	  define_function(create_string, type,
			  ID_INLINE | ID_PROTECTED,
			  IDENTIFIER_PIKE_FUNCTION |
			  (Pike_compiler->num_create_args < 0?IDENTIFIER_VARARGS:0),
			  0,
			  OPT_SIDE_EFFECT);

	if (Pike_compiler->compiler_pass == 2) {
	  node *create_code = NULL;
	  int f;

	  /* Third: Generate the initialization code.
	   *
	   * global_arg = [type]local_arg;
	   * [,..]
	   */

	  for(e=0; e<nargs; e++)
	  {
	    if(!Pike_compiler->compiler_frame->variable[e].name ||
	       !Pike_compiler->compiler_frame->variable[e].name->len)
	    {
	      my_yyerror("Missing name for argument %d.",e);
	    } else {
	      node *local_node = mklocalnode(e, 0);

	      /* FIXME: Should probably use some other flag. */
	      if ((runtime_options & RUNTIME_CHECK_TYPES) &&
		  (Pike_compiler->compiler_pass == 2) &&
		  (Pike_compiler->compiler_frame->variable[e].type !=
		   mixed_type_string)) {
		/* fprintf(stderr, "Creating soft cast node for local #%d\n", e);*/

		local_node = mkcastnode(mixed_type_string, local_node);

		/* NOTE: The cast to mixed above is needed to avoid generating
		 *       compilation errors, as well as avoiding optimizations
		 *       in mksoftcastnode().
		 */
		local_node = mksoftcastnode(Pike_compiler->compiler_frame->
					    variable[e].type, local_node);
	      }
	      create_code =
		mknode(F_COMMA_EXPR, create_code,
		       mknode(F_ASSIGN, local_node,
			      mkidentifiernode(e)));
	    }
	  }

	  /* Fourth: Add a return 0; at the end. */

	  create_code = mknode(F_COMMA_EXPR,
			       mknode(F_POP_VALUE, create_code, NULL),
			       mknode(F_RETURN, mkintnode(0), NULL));

	  /* Fifth: Define the function. */

	  f=dooptcode(create_string, create_code, type, ID_PROTECTED);

#ifdef PIKE_DEBUG
	  if(Pike_interpreter.recoveries &&
	     Pike_sp-Pike_interpreter.evaluator_stack < Pike_interpreter.recoveries->stack_pointer)
	    Pike_fatal("Stack error (underflow)\n");

	  if(Pike_compiler->compiler_pass == 1 &&
	     f!=Pike_compiler->compiler_frame->current_function_number)
	    Pike_fatal("define_function screwed up! %d != %d\n",
		       f, Pike_compiler->compiler_frame->current_function_number);
#endif
	}

	/* Done. */

	free_type(type);
	pop_compiler_frame();
      }
    }

    if(Pike_compiler->compiler_pass == 1)
      p=end_first_pass(0);
    else
      p=end_first_pass(1);

    /* fprintf(stderr, "LANGUAGE.YACC: CLASS end\n"); */

    if(p) {
      /* Update the type for the program constant,
       * since we might have a lfun::create(). */
      struct identifier *i;
      struct svalue sv;
      SET_SVAL(sv, T_PROGRAM, 0, program, p);
      i = ID_FROM_INT(Pike_compiler->new_program, yystack.l_mark[-3].number);
      free_type(i->type);
      i->type = get_type_of_svalue(&sv);
      free_program(p);
    } else if (!Pike_compiler->num_parse_error) {
      /* Make sure code in this class is aware that something went wrong. */
      Pike_compiler->num_parse_error = 1;
    }

    yyval.n=mkidentifiernode(yystack.l_mark[-3].number);

    free_node(yystack.l_mark[-5].n);
    free_node(yystack.l_mark[-4].n);
    check_tree(yyval.n,0);
    THIS_COMPILATION->lex.pragmas = yystack.l_mark[-2].number;
  }
break;
case 332:
#line 2864 "language.yacc"
	{ yyval.n = 0; }
break;
case 333:
#line 2867 "language.yacc"
	{ yyval.n = 0; }
break;
case 334:
#line 2868 "language.yacc"
	{ yyval.n = yystack.l_mark[0].n; }
break;
case 336:
#line 2874 "language.yacc"
	{
    if (yystack.l_mark[-1].n) {
      if (yystack.l_mark[0].n) {
	/* Explicit enum value. */

	/* This can be made more lenient in the future */

	/* Ugly hack to make sure that $2 is optimized */
	{
	  int tmp=Pike_compiler->compiler_pass;
	  yystack.l_mark[0].n=mknode(F_COMMA_EXPR,yystack.l_mark[0].n,0);
	  Pike_compiler->compiler_pass=tmp;
	}

	if(!is_const(yystack.l_mark[0].n))
	{
	  if(Pike_compiler->compiler_pass==2)
	    yyerror("Enum definition is not constant.");
	  push_int(0);
	} else {
	  if(!Pike_compiler->num_parse_error)
	  {
	    ptrdiff_t tmp=eval_low(yystack.l_mark[0].n,1);
	    if(tmp < 1)
	    {
	      yyerror("Error in enum definition.");
	      push_int(0);
	    }else{
	      pop_n_elems(DO_NOT_WARN((INT32)(tmp - 1)));
	    }
	  } else {
	    push_int(0);
	  }
	}
	free_node(yystack.l_mark[0].n);
	free_node(yystack.l_mark[-2].n);
	yystack.l_mark[-2].n = mkconstantsvaluenode(Pike_sp-1);
      } else {
	/* Implicit enum value. */
	yystack.l_mark[-2].n = safe_inc_enum(yystack.l_mark[-2].n);
	push_svalue(&yystack.l_mark[-2].n->u.sval);
      }
      add_constant(yystack.l_mark[-1].n->u.sval.u.string, Pike_sp-1,
		   (Pike_compiler->current_modifiers & ~ID_EXTERN) | ID_INLINE);
      /* Update the type. */
      {
	struct pike_type *current = pop_unfinished_type();
	struct pike_type *new = get_type_of_svalue(Pike_sp-1);
	struct pike_type *res = or_pike_types(new, current, 3);
	free_type(current);
	free_type(new);
	type_stack_mark();
	push_finished_type(res);
	free_type(res);
      }
      pop_stack();
      free_node(yystack.l_mark[-1].n);
    } else if (yystack.l_mark[0].n) {
      free_node(yystack.l_mark[0].n);
    }
  }
break;
case 337:
#line 2939 "language.yacc"
	{
    yyval.n = yystack.l_mark[-2].n;
  }
break;
case 339:
#line 2946 "language.yacc"
	{ yystack.l_mark[-4].n = yystack.l_mark[-1].n; }
break;
case 341:
#line 2952 "language.yacc"
	{
    if ((Pike_compiler->current_modifiers & ID_EXTERN) &&
	(Pike_compiler->compiler_pass == 1)) {
      yywarning("Extern declared enum.");
    }

    type_stack_mark();
    push_type(T_ZERO);	/* Joined type so far. */
  }
break;
case 342:
#line 2962 "language.yacc"
	{
    push_int(-1);	/* Previous value. */
    yyval.n = mkconstantsvaluenode(Pike_sp-1);
    pop_stack();
  }
break;
case 343:
#line 2967 "language.yacc"
	{ yyval.n = NULL; }
break;
case 344:
#line 2968 "language.yacc"
	{
    struct pike_type *t = pop_unfinished_type();
    free_node(yystack.l_mark[-3].n);
    if (yystack.l_mark[-5].n) {
      ref_push_type_value(t);
      add_constant(yystack.l_mark[-5].n->u.sval.u.string, Pike_sp-1,
		   (Pike_compiler->current_modifiers & ~ID_EXTERN) | ID_INLINE);
      pop_stack();
      free_node(yystack.l_mark[-5].n);
    }
    yyval.n = mktypenode(t);
    free_type(t);
  }
break;
case 345:
#line 2984 "language.yacc"
	{
    struct pike_type *t = compiler_pop_type();

    if ((Pike_compiler->current_modifiers & ID_EXTERN) &&
	(Pike_compiler->compiler_pass == 1)) {
      yywarning("Extern declared typedef.");
    }

    if (yystack.l_mark[-1].n) {
      ref_push_type_value(t);
      add_constant(yystack.l_mark[-1].n->u.sval.u.string, Pike_sp-1,
		   (Pike_compiler->current_modifiers & ~ID_EXTERN) | ID_INLINE);
      pop_stack();
      free_node(yystack.l_mark[-1].n);
    }
    free_type(t);
  }
break;
case 346:
#line 3004 "language.yacc"
	{
    yyval.number=Pike_compiler->compiler_frame->current_number_of_locals;
  }
break;
case 347:
#line 3008 "language.yacc"
	{
    /* Trick to store more than one number on compiler stack - Hubbe */
    yyval.number=Pike_compiler->compiler_frame->last_block_level;
    Pike_compiler->compiler_frame->last_block_level=yystack.l_mark[-1].number;
  }
break;
case 348:
#line 3014 "language.yacc"
	{
    yyval.n = mknode('?', yystack.l_mark[-3].n,
		mknode(':',
		       mkcastnode(void_type_string, yystack.l_mark[-1].n),
		       mkcastnode(void_type_string, yystack.l_mark[0].n)));
    COPY_LINE_NUMBER_INFO(yyval.n, yystack.l_mark[-6].n);
    yyval.n = mkcastnode(void_type_string, yyval.n);
    COPY_LINE_NUMBER_INFO(yyval.n, yystack.l_mark[-6].n);
    free_node (yystack.l_mark[-6].n);
    yyval.n = pop_local_variables(yystack.l_mark[-7].number, yyval.n);
    Pike_compiler->compiler_frame->last_block_level=yystack.l_mark[-5].number;
  }
break;
case 350:
#line 3029 "language.yacc"
	{ yyerror("Missing ')'."); }
break;
case 351:
#line 3031 "language.yacc"
	{
    yyerror("Missing ')'.");
    yyerror("Unexpected end of file.");
  }
break;
case 352:
#line 3037 "language.yacc"
	{ yyval.n=0; }
break;
case 353:
#line 3038 "language.yacc"
	{ yyval.n=yystack.l_mark[0].n; }
break;
case 354:
#line 3042 "language.yacc"
	{
    if (!(THIS_COMPILATION->lex.pragmas & ID_STRICT_TYPES) && yystack.l_mark[0].n) {
      if (yystack.l_mark[0].n->token == F_ARRAY_LVALUE) {
	mark_lvalues_as_used(CAR(yystack.l_mark[0].n));
      } else if ((yystack.l_mark[0].n->token == F_LOCAL) && !(yystack.l_mark[0].n->u.integer.b)) {
	Pike_compiler->compiler_frame->variable[yystack.l_mark[0].n->u.integer.a].flags |=
	  LOCAL_VAR_IS_USED;
      }
    }
  }
break;
case 355:
#line 3052 "language.yacc"
	{ yyval.n=0; }
break;
case 357:
#line 3056 "language.yacc"
	{ yyerror("Unexpected end of file."); yyval.n=0; }
break;
case 358:
#line 3057 "language.yacc"
	{ yyval.n=0; }
break;
case 359:
#line 3061 "language.yacc"
	{ yyval.n=0; }
break;
case 361:
#line 3065 "language.yacc"
	{ yyval.n=yystack.l_mark[0].n; }
break;
case 362:
#line 3067 "language.yacc"
	{ yyval.n=mknode(':',yystack.l_mark[-2].n,yystack.l_mark[0].n); }
break;
case 363:
#line 3071 "language.yacc"
	{
    yyval.number=Pike_compiler->compiler_frame->current_number_of_locals;
  }
break;
case 364:
#line 3075 "language.yacc"
	{
    /* Trick to store more than one number on compiler stack - Hubbe */
    yyval.number=Pike_compiler->compiler_frame->last_block_level;
    Pike_compiler->compiler_frame->last_block_level=yystack.l_mark[-1].number;
  }
break;
case 365:
#line 3081 "language.yacc"
	{
    if (yystack.l_mark[-2].n) {
      yyval.n=mknode(F_FOREACH,
		mknode(F_VAL_LVAL,yystack.l_mark[-3].n,yystack.l_mark[-2].n),
		yystack.l_mark[0].n);
    } else {
      /* Error in lvalue */
      yyval.n=mknode(F_COMMA_EXPR, mkcastnode(void_type_string, yystack.l_mark[-3].n), yystack.l_mark[0].n);
    }
    COPY_LINE_NUMBER_INFO(yyval.n, yystack.l_mark[-6].n);
    free_node (yystack.l_mark[-6].n);
    yyval.n = pop_local_variables(yystack.l_mark[-7].number, yyval.n);
    Pike_compiler->compiler_frame->last_block_level=yystack.l_mark[-5].number;
    Pike_compiler->compiler_frame->opt_flags |= OPT_CUSTOM_LABELS;
  }
break;
case 366:
#line 3100 "language.yacc"
	{
    yyval.n=mknode(F_DO,yystack.l_mark[-5].n,yystack.l_mark[-2].n);
    COPY_LINE_NUMBER_INFO(yyval.n, yystack.l_mark[-6].n);
    free_node (yystack.l_mark[-6].n);
    Pike_compiler->compiler_frame->opt_flags |= OPT_CUSTOM_LABELS;
  }
break;
case 367:
#line 3107 "language.yacc"
	{
    free_node (yystack.l_mark[-3].n);
    yyval.n=0;
    yyerror("Missing '(' in do-while loop.");
    yyerror("Unexpected end of file.");
  }
break;
case 368:
#line 3114 "language.yacc"
	{
    free_node (yystack.l_mark[-2].n);
    yyval.n=0;
    yyerror("Missing 'while' in do-while loop.");
    yyerror("Unexpected end of file.");
  }
break;
case 370:
#line 3124 "language.yacc"
	{
    yyerror("Missing ';'.");
    yyerror("Unexpected end of file.");
  }
break;
case 371:
#line 3131 "language.yacc"
	{
    yyval.number=Pike_compiler->compiler_frame->current_number_of_locals;
  }
break;
case 372:
#line 3135 "language.yacc"
	{
    /* Trick to store more than one number on compiler stack - Hubbe */
    yyval.number=Pike_compiler->compiler_frame->last_block_level;
    Pike_compiler->compiler_frame->last_block_level=yystack.l_mark[-1].number;
  }
break;
case 373:
#line 3142 "language.yacc"
	{
    yyval.n=mknode(F_COMMA_EXPR, mkcastnode(void_type_string, yystack.l_mark[-6].n),
	      mknode(F_FOR,yystack.l_mark[-4].n,mknode(':',yystack.l_mark[0].n,yystack.l_mark[-2].n)));
    COPY_LINE_NUMBER_INFO(yyval.n, yystack.l_mark[-9].n);
    free_node (yystack.l_mark[-9].n);
    yyval.n = pop_local_variables(yystack.l_mark[-10].number, yyval.n);
    Pike_compiler->compiler_frame->last_block_level=yystack.l_mark[-8].number;
    Pike_compiler->compiler_frame->opt_flags |= OPT_CUSTOM_LABELS;
  }
break;
case 374:
#line 3155 "language.yacc"
	{
    yyval.number=Pike_compiler->compiler_frame->current_number_of_locals;
  }
break;
case 375:
#line 3159 "language.yacc"
	{
    /* Trick to store more than one number on compiler stack - Hubbe */
    yyval.number=Pike_compiler->compiler_frame->last_block_level;
    Pike_compiler->compiler_frame->last_block_level=yystack.l_mark[-1].number;
  }
break;
case 376:
#line 3165 "language.yacc"
	{
    yyval.n=mknode(F_FOR,yystack.l_mark[-2].n,mknode(':',yystack.l_mark[0].n,NULL));
    COPY_LINE_NUMBER_INFO(yyval.n, yystack.l_mark[-5].n);
    free_node (yystack.l_mark[-5].n);
    yyval.n = pop_local_variables(yystack.l_mark[-6].number, yyval.n);
    Pike_compiler->compiler_frame->last_block_level=yystack.l_mark[-4].number;
    Pike_compiler->compiler_frame->opt_flags |= OPT_CUSTOM_LABELS;
  }
break;
case 377:
#line 3175 "language.yacc"
	{ yyval.n=mkintnode(1); }
break;
case 379:
#line 3180 "language.yacc"
	{
    yyval.number=Pike_compiler->compiler_frame->current_number_of_locals;
  }
break;
case 380:
#line 3184 "language.yacc"
	{
    /* Trick to store more than one number on compiler stack - Hubbe */
    yyval.number=Pike_compiler->compiler_frame->last_block_level;
    Pike_compiler->compiler_frame->last_block_level=yystack.l_mark[-1].number;
  }
break;
case 381:
#line 3190 "language.yacc"
	{
    yyval.n=mknode(F_SWITCH,yystack.l_mark[-2].n,yystack.l_mark[0].n);
    COPY_LINE_NUMBER_INFO(yyval.n, yystack.l_mark[-5].n);
    free_node (yystack.l_mark[-5].n);
    yyval.n = pop_local_variables(yystack.l_mark[-6].number, yyval.n);
    Pike_compiler->compiler_frame->last_block_level=yystack.l_mark[-4].number;
  }
break;
case 382:
#line 3200 "language.yacc"
	{
    yyval.n=mknode(F_CASE,yystack.l_mark[-1].n,0);
  }
break;
case 383:
#line 3204 "language.yacc"
	{
     yyval.n=mknode(F_CASE_RANGE,yystack.l_mark[-3].n,yystack.l_mark[-1].n);
  }
break;
case 384:
#line 3208 "language.yacc"
	{
     yyval.n=mknode(F_CASE_RANGE,0,yystack.l_mark[-1].n);
  }
break;
case 386:
#line 3215 "language.yacc"
	{
    yyerror("Missing ':'.");
  }
break;
case 387:
#line 3219 "language.yacc"
	{
    yyerror("Missing ':'.");
  }
break;
case 388:
#line 3223 "language.yacc"
	{
    yyerror("Missing ':'.");
    yyerror("Unexpected end of file.");
  }
break;
case 389:
#line 3230 "language.yacc"
	{
    if(!match_types(Pike_compiler->compiler_frame->current_return_type,
		    void_type_string))
    {
      yytype_error("Must return a value for a non-void function.",
		   Pike_compiler->compiler_frame->current_return_type,
		   void_type_string, 0);
    }
    yyval.n=mknode(F_RETURN,mkintnode(0),0);
  }
break;
case 390:
#line 3241 "language.yacc"
	{
    yyval.n=mknode(F_RETURN,yystack.l_mark[-1].n,0);
  }
break;
case 391:
#line 3246 "language.yacc"
	{ yyval.n=0; }
break;
case 392:
#line 3247 "language.yacc"
	{ yyval.n=mkcastnode(void_type_string, yystack.l_mark[0].n);  }
break;
case 393:
#line 3250 "language.yacc"
	{ yyval.n=mkcastnode(void_type_string, yystack.l_mark[0].n);  }
break;
case 394:
#line 3252 "language.yacc"
	{ yyval.n=0; }
break;
case 397:
#line 3257 "language.yacc"
	{ yyval.n=0; }
break;
case 399:
#line 3261 "language.yacc"
	{ yyval.n=yystack.l_mark[0].n; free_node(yystack.l_mark[-1].n); }
break;
case 400:
#line 3262 "language.yacc"
	{ yyval.n=yystack.l_mark[0].n; free_node(yystack.l_mark[-1].n); }
break;
case 401:
#line 3263 "language.yacc"
	{ yyval.n=yystack.l_mark[0].n; free_node(yystack.l_mark[-1].n); }
break;
case 402:
#line 3264 "language.yacc"
	{ yyval.n=yystack.l_mark[0].n; free_node(yystack.l_mark[-1].n); }
break;
case 404:
#line 3270 "language.yacc"
	{
    yyval.n = mknode(F_COMMA_EXPR, mkcastnode(void_type_string, yystack.l_mark[-2].n), yystack.l_mark[0].n);
  }
break;
case 406:
#line 3276 "language.yacc"
	{ yyval.n=mknode(F_PUSH_ARRAY,yystack.l_mark[0].n,0); }
break;
case 408:
#line 3279 "language.yacc"
	{ yyval.n=mknode(F_ASSIGN,yystack.l_mark[0].n,yystack.l_mark[-2].n); }
break;
case 409:
#line 3280 "language.yacc"
	{ yyval.n=yystack.l_mark[-2].n; reset_type_stack(); yyerrok; }
break;
case 410:
#line 3281 "language.yacc"
	{ yyval.n=yystack.l_mark[0].n; }
break;
case 411:
#line 3283 "language.yacc"
	{
    if (!(THIS_COMPILATION->lex.pragmas & ID_STRICT_TYPES)) {
      mark_lvalues_as_used(yystack.l_mark[-3].n);
    }
    yyval.n=mknode(F_ASSIGN,yystack.l_mark[0].n,mknode(F_ARRAY_LVALUE,yystack.l_mark[-3].n,0));
    COPY_LINE_NUMBER_INFO(yyval.n, yystack.l_mark[-4].n);
    free_node (yystack.l_mark[-4].n);
  }
break;
case 412:
#line 3291 "language.yacc"
	{ yyval.n=mknode(yystack.l_mark[-1].number,yystack.l_mark[-2].n,yystack.l_mark[0].n); }
break;
case 413:
#line 3292 "language.yacc"
	{ yyval.n=yystack.l_mark[-2].n; reset_type_stack(); yyerrok; }
break;
case 414:
#line 3293 "language.yacc"
	{ yyval.n=yystack.l_mark[0].n; }
break;
case 415:
#line 3295 "language.yacc"
	{
    yyval.n=mknode(yystack.l_mark[-1].number,mknode(F_ARRAY_LVALUE,yystack.l_mark[-3].n,0),yystack.l_mark[0].n);
    COPY_LINE_NUMBER_INFO(yyval.n, yystack.l_mark[-4].n);
    free_node (yystack.l_mark[-4].n);
  }
break;
case 416:
#line 3301 "language.yacc"
	{
      yyval.n=yystack.l_mark[-2].n; free_node (yystack.l_mark[-3].n); reset_type_stack(); yyerrok;
    }
break;
case 418:
#line 3308 "language.yacc"
	{ yyval.n=mknode('?',yystack.l_mark[-4].n,mknode(':',yystack.l_mark[-2].n,yystack.l_mark[0].n)); }
break;
case 419:
#line 3311 "language.yacc"
	{ yyval.number=F_AND_EQ; }
break;
case 420:
#line 3312 "language.yacc"
	{ yyval.number=F_OR_EQ; }
break;
case 421:
#line 3313 "language.yacc"
	{ yyval.number=F_XOR_EQ; }
break;
case 422:
#line 3314 "language.yacc"
	{ yyval.number=F_LSH_EQ; }
break;
case 423:
#line 3315 "language.yacc"
	{ yyval.number=F_RSH_EQ; }
break;
case 424:
#line 3316 "language.yacc"
	{ yyval.number=F_ADD_EQ; }
break;
case 425:
#line 3317 "language.yacc"
	{ yyval.number=F_SUB_EQ; }
break;
case 426:
#line 3318 "language.yacc"
	{ yyval.number=F_MULT_EQ; }
break;
case 427:
#line 3319 "language.yacc"
	{ yyval.number=F_MOD_EQ; }
break;
case 428:
#line 3320 "language.yacc"
	{ yyval.number=F_DIV_EQ; }
break;
case 429:
#line 3323 "language.yacc"
	{ yyval.number=0; }
break;
case 430:
#line 3323 "language.yacc"
	{ yyval.number=1; }
break;
case 431:
#line 3325 "language.yacc"
	{ yyval.n=0; }
break;
case 434:
#line 3331 "language.yacc"
	{ yyval.n=mknode(F_ARG_LIST,yystack.l_mark[-2].n,yystack.l_mark[0].n); }
break;
case 435:
#line 3334 "language.yacc"
	{ yyval.n=0; }
break;
case 438:
#line 3340 "language.yacc"
	{
    if (yystack.l_mark[0].n) {
      yyval.n=mknode(F_ARG_LIST,yystack.l_mark[-2].n,yystack.l_mark[0].n);
    } else {
      /* Error in assoc_pair */
      yyval.n=yystack.l_mark[-2].n;
    }
  }
break;
case 440:
#line 3352 "language.yacc"
	{
    yyval.n=mknode(F_ARG_LIST,yystack.l_mark[-2].n,yystack.l_mark[0].n);
  }
break;
case 441:
#line 3355 "language.yacc"
	{ free_node(yystack.l_mark[-2].n); yyval.n=0; }
break;
case 443:
#line 3359 "language.yacc"
	{ yyval.n=mknode(F_LOR,yystack.l_mark[-2].n,yystack.l_mark[0].n); }
break;
case 444:
#line 3360 "language.yacc"
	{ yyval.n=mknode(F_LAND,yystack.l_mark[-2].n,yystack.l_mark[0].n); }
break;
case 445:
#line 3361 "language.yacc"
	{ yyval.n=mkopernode("`|",yystack.l_mark[-2].n,yystack.l_mark[0].n); }
break;
case 446:
#line 3362 "language.yacc"
	{ yyval.n=mkopernode("`^",yystack.l_mark[-2].n,yystack.l_mark[0].n); }
break;
case 447:
#line 3363 "language.yacc"
	{ yyval.n=mkopernode("`&",yystack.l_mark[-2].n,yystack.l_mark[0].n); }
break;
case 448:
#line 3364 "language.yacc"
	{ yyval.n=mkopernode("`==",yystack.l_mark[-2].n,yystack.l_mark[0].n); }
break;
case 449:
#line 3365 "language.yacc"
	{ yyval.n=mkopernode("`!=",yystack.l_mark[-2].n,yystack.l_mark[0].n); }
break;
case 450:
#line 3366 "language.yacc"
	{ yyval.n=mkopernode("`>",yystack.l_mark[-2].n,yystack.l_mark[0].n); }
break;
case 451:
#line 3367 "language.yacc"
	{ yyval.n=mkopernode("`>=",yystack.l_mark[-2].n,yystack.l_mark[0].n); }
break;
case 452:
#line 3368 "language.yacc"
	{ yyval.n=mkopernode("`<",yystack.l_mark[-2].n,yystack.l_mark[0].n); }
break;
case 453:
#line 3369 "language.yacc"
	{ yyval.n=mkopernode("`<=",yystack.l_mark[-2].n,yystack.l_mark[0].n); }
break;
case 454:
#line 3370 "language.yacc"
	{ yyval.n=mkopernode("`<<",yystack.l_mark[-2].n,yystack.l_mark[0].n); }
break;
case 455:
#line 3371 "language.yacc"
	{ yyval.n=mkopernode("`>>",yystack.l_mark[-2].n,yystack.l_mark[0].n); }
break;
case 456:
#line 3372 "language.yacc"
	{ yyval.n=mkopernode("`+",yystack.l_mark[-2].n,yystack.l_mark[0].n); }
break;
case 457:
#line 3373 "language.yacc"
	{ yyval.n=mkopernode("`-",yystack.l_mark[-2].n,yystack.l_mark[0].n); }
break;
case 458:
#line 3374 "language.yacc"
	{ yyval.n=mkopernode("`*",yystack.l_mark[-2].n,yystack.l_mark[0].n); }
break;
case 459:
#line 3375 "language.yacc"
	{ yyval.n=mkopernode("`%",yystack.l_mark[-2].n,yystack.l_mark[0].n); }
break;
case 460:
#line 3376 "language.yacc"
	{ yyval.n=mkopernode("`/",yystack.l_mark[-2].n,yystack.l_mark[0].n); }
break;
case 480:
#line 3399 "language.yacc"
	{
    yyval.n = mkcastnode(yystack.l_mark[-1].n->u.sval.u.type, yystack.l_mark[0].n);
    free_node(yystack.l_mark[-1].n);
  }
break;
case 481:
#line 3404 "language.yacc"
	{
    yyval.n = mksoftcastnode(yystack.l_mark[-1].n->u.sval.u.type, yystack.l_mark[0].n);
    free_node(yystack.l_mark[-1].n);
  }
break;
case 482:
#line 3408 "language.yacc"
	{ yyval.n=mknode(F_INC,yystack.l_mark[0].n,0); }
break;
case 483:
#line 3409 "language.yacc"
	{ yyval.n=mknode(F_DEC,yystack.l_mark[0].n,0); }
break;
case 484:
#line 3410 "language.yacc"
	{ yyval.n=mkopernode("`!",yystack.l_mark[0].n,0); }
break;
case 485:
#line 3411 "language.yacc"
	{ yyval.n=mkopernode("`~",yystack.l_mark[0].n,0); }
break;
case 486:
#line 3412 "language.yacc"
	{ yyval.n=mkopernode("`-",yystack.l_mark[0].n,0); }
break;
case 488:
#line 3416 "language.yacc"
	{ yyval.n=mknode(F_POST_INC,yystack.l_mark[-1].n,0); }
break;
case 489:
#line 3417 "language.yacc"
	{ yyval.n=mknode(F_POST_DEC,yystack.l_mark[-1].n,0); }
break;
case 490:
#line 3439 "language.yacc"
	{ yyval.n=0; }
break;
case 491:
#line 3443 "language.yacc"
	{
    debug_malloc_touch(Pike_compiler->compiler_frame->current_return_type);
    if(Pike_compiler->compiler_frame->current_return_type)
      free_type(Pike_compiler->compiler_frame->current_return_type);
    copy_pike_type(Pike_compiler->compiler_frame->current_return_type,
		   any_type_string);

    /* block code */
    yystack.l_mark[-2].number=Pike_compiler->num_used_modules;
    yyval.number=Pike_compiler->compiler_frame->current_number_of_locals;
  }
break;
case 492:
#line 3455 "language.yacc"
	{
    struct pike_type *type;
    int f/*, e */;
    struct pike_string *name;
    struct compilation *c = THIS_COMPILATION;
    struct pike_string *save_file = c->lex.current_file;
    int save_line = c->lex.current_line;
    c->lex.current_file = yystack.l_mark[-4].n->current_file;
    c->lex.current_line = yystack.l_mark[-4].n->line_number;

    /* block code */
    unuse_modules(Pike_compiler->num_used_modules - yystack.l_mark[-5].number);
    yystack.l_mark[-1].n = pop_local_variables(yystack.l_mark[-2].number, yystack.l_mark[-1].n);

    debug_malloc_touch(yystack.l_mark[-1].n);
    yystack.l_mark[-1].n=mknode(F_COMMA_EXPR,yystack.l_mark[-1].n,mknode(F_RETURN,mkintnode(0),0));
    if (Pike_compiler->compiler_pass == 2) {
      /* Doing this in pass 1 might induce too strict checks on types
       * in cases where we got placeholders. */
      type=find_return_type(yystack.l_mark[-1].n);
      if (type) {
	push_finished_type(type);
	free_type(type);
      } else {
	yywarning("Failed to determine return type for implicit lambda.");
	push_type(T_ZERO);
      }
    } else {
      /* Tentative return type. */
      push_type(T_MIXED);
    }

    push_type(T_VOID);
    push_type(T_MANY);
/*
    e=$5-1;
    for(; e>=0; e--)
      push_finished_type(Pike_compiler->compiler_frame->variable[e].type);
*/

    type=compiler_pop_type();

    name = get_new_name(NULL);

#ifdef LAMBDA_DEBUG
    fprintf(stderr, "%d: IMPLICIT LAMBDA: %s 0x%08lx 0x%08lx\n",
	    Pike_compiler->compiler_pass, name->str,
	    (long)Pike_compiler->new_program->id,
	    Pike_compiler->local_class_counter-1);
#endif /* LAMBDA_DEBUG */

    f=dooptcode(name,
		yystack.l_mark[-1].n,
		type,
		ID_PROTECTED | ID_PRIVATE | ID_INLINE | ID_USED);

    if(Pike_compiler->compiler_frame->lexical_scope & SCOPE_SCOPED) {
      yyval.n = mktrampolinenode(f,Pike_compiler->compiler_frame->previous);
    } else {
      yyval.n = mkidentifiernode(f);
    }

    c->lex.current_line = save_line;
    c->lex.current_file = save_file;
    free_node (yystack.l_mark[-4].n);
    free_string(name);
    free_type(type);
#ifdef PIKE_DEBUG
    if (Pike_compiler->compiler_frame != yystack.l_mark[-3].ptr) {
      Pike_fatal("Lost track of compiler_frame!\n"
		 "  Got: %p (Expected: %p) Previous: %p\n",
		 Pike_compiler->compiler_frame, yystack.l_mark[-3].ptr,
		 Pike_compiler->compiler_frame->previous);
    }
#endif
    pop_compiler_frame();
  }
break;
case 493:
#line 3536 "language.yacc"
	{
    yyval.n = mkapplynode(yystack.l_mark[-4].n, mknode(F_ARG_LIST, yystack.l_mark[-2].n, yystack.l_mark[0].n));
    COPY_LINE_NUMBER_INFO(yyval.n, yystack.l_mark[-3].n);
    free_node (yystack.l_mark[-3].n);
  }
break;
case 494:
#line 3542 "language.yacc"
	{
    yyval.n=mkapplynode(yystack.l_mark[-4].n, yystack.l_mark[0].n);
    free_node (yystack.l_mark[-3].n);
    yyerrok;
  }
break;
case 495:
#line 3548 "language.yacc"
	{
    yyerror("Missing ')'.");
    yyerror("Unexpected end of file.");
    yyval.n=mkapplynode(yystack.l_mark[-3].n, NULL);
    free_node (yystack.l_mark[-2].n);
  }
break;
case 496:
#line 3555 "language.yacc"
	{
    yyerror("Missing ')'.");
    yyval.n=mkapplynode(yystack.l_mark[-3].n, NULL);
    free_node (yystack.l_mark[-2].n);
  }
break;
case 497:
#line 3561 "language.yacc"
	{
    yyerror("Missing ')'.");
    yyval.n=mkapplynode(yystack.l_mark[-3].n, NULL);
    free_node (yystack.l_mark[-2].n);
  }
break;
case 498:
#line 3569 "language.yacc"
	{
    if (TEST_COMPAT(7, 6)) {
      yyval.number = Pike_compiler->current_modifiers =
	(THIS_COMPILATION->lex.pragmas & ID_MODIFIER_MASK);
    } else {
      yyval.number = Pike_compiler->current_modifiers = ID_PROTECTED|ID_INLINE|ID_PRIVATE |
	(THIS_COMPILATION->lex.pragmas & ID_MODIFIER_MASK);
    }
  }
break;
case 501:
#line 3582 "language.yacc"
	{ yyval.n=mkfloatnode((FLOAT_TYPE)yystack.l_mark[0].fnum); }
break;
case 507:
#line 3588 "language.yacc"
	{ yyval.n = yystack.l_mark[0].n; }
break;
case 508:
#line 3589 "language.yacc"
	{ yyval.n = yystack.l_mark[0].n; }
break;
case 511:
#line 3593 "language.yacc"
	{
    yyval.n=mknode(F_AUTO_MAP_MARKER, yystack.l_mark[-3].n, 0);
    COPY_LINE_NUMBER_INFO(yyval.n, yystack.l_mark[-2].n);
    free_node (yystack.l_mark[-2].n);
  }
break;
case 512:
#line 3599 "language.yacc"
	{
    yyval.n=mknode(F_INDEX,yystack.l_mark[-3].n,yystack.l_mark[-1].n);
    COPY_LINE_NUMBER_INFO(yyval.n, yystack.l_mark[-2].n);
    free_node (yystack.l_mark[-2].n);
  }
break;
case 513:
#line 3606 "language.yacc"
	{
    yyval.n=mknode(F_RANGE,yystack.l_mark[-5].n,mknode(':',yystack.l_mark[-3].n,yystack.l_mark[-1].n));
    COPY_LINE_NUMBER_INFO(yyval.n, yystack.l_mark[-4].n);
    free_node (yystack.l_mark[-4].n);
  }
break;
case 514:
#line 3612 "language.yacc"
	{
    /* A[?X] to ((tmp=A) && tmp[X]) */
    if( yystack.l_mark[-4].n && (yystack.l_mark[-4].n->token == F_LOCAL) )
    {
      yyval.n=mknode(F_LAND, copy_node(yystack.l_mark[-4].n), mknode(F_INDEX,  yystack.l_mark[-4].n, yystack.l_mark[-1].n));
    }
    else
    {
      fix_type_field( yystack.l_mark[-4].n );
      if( yystack.l_mark[-4].n && yystack.l_mark[-4].n->type )
      {
        int temporary;
        yystack.l_mark[-4].n->type->refs++;

        temporary = add_local_name(empty_pike_string, yystack.l_mark[-4].n->type, 0);
        Pike_compiler->compiler_frame->variable[temporary].flags |= LOCAL_VAR_IS_USED;
        yyval.n=mknode(F_LAND,
                  mknode(F_ASSIGN, yystack.l_mark[-4].n, mklocalnode(temporary,0)),
                  mknode(F_INDEX,  mklocalnode(temporary,0), yystack.l_mark[-1].n));
      }
      else
      {
        yyval.n=mknode(F_INDEX, yystack.l_mark[-4].n,yystack.l_mark[-1].n);
        yyerror("Indexing unexpected value.");
      }
    }
    COPY_LINE_NUMBER_INFO(yyval.n, yystack.l_mark[-2].n);
    free_node (yystack.l_mark[-2].n);
  }
break;
case 515:
#line 3643 "language.yacc"
	{
    /* A[?X..Y] to ((tmp=A) && tmp[X..Y]) */
    node *range = mknode(':',yystack.l_mark[-3].n,yystack.l_mark[-1].n);
    if( yystack.l_mark[-6].n && (yystack.l_mark[-6].n->token == F_LOCAL ) )
    {
      yyval.n = mknode( F_LAND, copy_node(yystack.l_mark[-6].n), mknode(F_RANGE, yystack.l_mark[-6].n, range) );
    }
    else
    {
      fix_type_field( yystack.l_mark[-6].n );
      if( yystack.l_mark[-6].n && yystack.l_mark[-6].n->type )
      {
        int temporary;
        yystack.l_mark[-6].n->type->refs++;

        temporary = add_local_name(empty_pike_string, yystack.l_mark[-6].n->type, 0);
        Pike_compiler->compiler_frame->variable[temporary].flags |= LOCAL_VAR_IS_USED;
        yyval.n=mknode(F_LAND,
                  mknode(F_ASSIGN, yystack.l_mark[-6].n, mklocalnode(temporary,0) ),
                  mknode(F_RANGE,  mklocalnode(temporary,0), range) );
      }
      else
      {
        yyval.n = mknode( F_LAND, yystack.l_mark[-6].n, mknode(F_RANGE,yystack.l_mark[-6].n,range) );
        yyerror("Indexing unexpected value.");
      }
    }
    COPY_LINE_NUMBER_INFO(yyval.n, yystack.l_mark[-4].n);
    free_node (yystack.l_mark[-4].n);
  }
break;
case 516:
#line 3674 "language.yacc"
	{
    yyval.n=yystack.l_mark[-3].n;
    free_node (yystack.l_mark[-2].n);
    yyerrok;
  }
break;
case 517:
#line 3680 "language.yacc"
	{
    yyval.n=yystack.l_mark[-3].n; yyerror("Missing ']'.");
    yyerror("Unexpected end of file.");
    free_node (yystack.l_mark[-2].n);
  }
break;
case 518:
#line 3686 "language.yacc"
	{yyval.n=yystack.l_mark[-3].n; yyerror("Missing ']'."); free_node (yystack.l_mark[-2].n);}
break;
case 519:
#line 3688 "language.yacc"
	{yyval.n=yystack.l_mark[-3].n; yyerror("Missing ']'."); free_node (yystack.l_mark[-2].n);}
break;
case 520:
#line 3690 "language.yacc"
	{yyval.n=yystack.l_mark[-3].n; yyerror("Missing ']'."); free_node (yystack.l_mark[-2].n);}
break;
case 521:
#line 3692 "language.yacc"
	{
      yyval.n=yystack.l_mark[-1].n;
      if (yyval.n) {
	COPY_LINE_NUMBER_INFO(yyval.n, yystack.l_mark[-2].n);
      }
      free_node (yystack.l_mark[-2].n);
    }
break;
case 522:
#line 3700 "language.yacc"
	{
      /* FIXME: May eat lots of stack; cf Standards.FIPS10_4.divisions */
      yyval.n=mkefuncallnode("aggregate",yystack.l_mark[-2].n);
      COPY_LINE_NUMBER_INFO(yyval.n, yystack.l_mark[-4].n);
      free_node (yystack.l_mark[-4].n);
    }
break;
case 523:
#line 3709 "language.yacc"
	{
      /* FIXME: May eat lots of stack; cf Standards.FIPS10_4.divisions */
      yyval.n=mkefuncallnode("aggregate_mapping",yystack.l_mark[-2].n);
      COPY_LINE_NUMBER_INFO(yyval.n, yystack.l_mark[-4].n);
      free_node (yystack.l_mark[-4].n);
      free_node (yystack.l_mark[-3].n);
    }
break;
case 524:
#line 3717 "language.yacc"
	{
      /* FIXME: May eat lots of stack; cf Standards.FIPS10_4.divisions */
      yyval.n=mkefuncallnode("aggregate_multiset",yystack.l_mark[-1].n);
      COPY_LINE_NUMBER_INFO(yyval.n, yystack.l_mark[-2].n);
      free_node (yystack.l_mark[-2].n);
    }
break;
case 525:
#line 3724 "language.yacc"
	{
      yyerror("Missing '>'.");
      yyval.n=mkefuncallnode("aggregate_multiset",yystack.l_mark[-1].n);
      COPY_LINE_NUMBER_INFO(yyval.n, yystack.l_mark[-2].n);
      free_node (yystack.l_mark[-2].n);
    }
break;
case 526:
#line 3730 "language.yacc"
	{ yyval.n=yystack.l_mark[-2].n; yyerrok; }
break;
case 527:
#line 3732 "language.yacc"
	{
    yyval.n=yystack.l_mark[-2].n; yyerror("Missing ')'.");
    yyerror("Unexpected end of file.");
  }
break;
case 528:
#line 3736 "language.yacc"
	{ yyval.n=yystack.l_mark[-2].n; yyerror("Missing ')'."); }
break;
case 529:
#line 3737 "language.yacc"
	{ yyval.n=yystack.l_mark[-2].n; yyerror("Missing ')'."); }
break;
case 530:
#line 3738 "language.yacc"
	{ yyval.n=yystack.l_mark[-2].n; yyerrok; }
break;
case 531:
#line 3739 "language.yacc"
	{
    yyerror("Missing '>'.");
    yyval.n=yystack.l_mark[-2].n; yyerrok;
  }
break;
case 532:
#line 3744 "language.yacc"
	{
    yyval.n=yystack.l_mark[-2].n; yyerror("Missing '>)'.");
    yyerror("Unexpected end of file.");
  }
break;
case 533:
#line 3748 "language.yacc"
	{ yyval.n=yystack.l_mark[-2].n; yyerror("Missing '>)'."); }
break;
case 534:
#line 3749 "language.yacc"
	{ yyval.n=yystack.l_mark[-2].n; yyerror("Missing '>)'."); }
break;
case 535:
#line 3751 "language.yacc"
	{
    yyval.n=mknode(F_ARROW,yystack.l_mark[-3].n,yystack.l_mark[0].n);
    COPY_LINE_NUMBER_INFO(yyval.n, yystack.l_mark[-1].n);
    free_node (yystack.l_mark[-1].n);
  }
break;
case 536:
#line 3757 "language.yacc"
	{
    /* A->?B to ((tmp=A) && tmp->B) */
    int temporary;
    if( yystack.l_mark[-3].n && (yystack.l_mark[-3].n->token == F_LOCAL) )
    {
      yyval.n=mknode(F_LAND, copy_node(yystack.l_mark[-3].n), mknode(F_ARROW, yystack.l_mark[-3].n, yystack.l_mark[0].n));
    }
    else
    {
      fix_type_field( yystack.l_mark[-3].n );
      if( yystack.l_mark[-3].n && yystack.l_mark[-3].n->type )
      {
        yystack.l_mark[-3].n->type->refs++;

        temporary = add_local_name(empty_pike_string, yystack.l_mark[-3].n->type, 0);
        Pike_compiler->compiler_frame->variable[temporary].flags |= LOCAL_VAR_IS_USED;
        yyval.n=mknode(F_LAND,
                  mknode(F_ASSIGN, yystack.l_mark[-3].n, mklocalnode(temporary,0)),
                  mknode(F_ARROW,  mklocalnode(temporary,0), yystack.l_mark[0].n));
      }
      else
      {
        yyval.n=mknode(F_ARROW, yystack.l_mark[-3].n,yystack.l_mark[0].n);
        yyerror("Indexing unexpected value.");
      }
    }
    COPY_LINE_NUMBER_INFO(yyval.n, yystack.l_mark[-1].n);
    free_node (yystack.l_mark[-1].n);
  }
break;
case 537:
#line 3787 "language.yacc"
	{
    yyval.n=index_node(yystack.l_mark[-3].n,".",yystack.l_mark[0].n->u.sval.u.string);
    COPY_LINE_NUMBER_INFO(yyval.n, yystack.l_mark[-1].n);
    free_node (yystack.l_mark[-3].n);
    free_node (yystack.l_mark[-1].n);
    free_node (yystack.l_mark[0].n);
  }
break;
case 538:
#line 3794 "language.yacc"
	{yyval.n=yystack.l_mark[-3].n; free_node (yystack.l_mark[-1].n);}
break;
case 540:
#line 3799 "language.yacc"
	{
    int i;

    if(Pike_compiler->last_identifier) free_string(Pike_compiler->last_identifier);
    copy_shared_string(Pike_compiler->last_identifier, yystack.l_mark[0].n->u.sval.u.string);

    if (((i = find_shared_string_identifier(Pike_compiler->last_identifier,
					    Pike_compiler->new_program)) >= 0) ||
	((i = really_low_find_shared_string_identifier(Pike_compiler->last_identifier,
						       Pike_compiler->new_program,
						       SEE_PROTECTED|
						       SEE_PRIVATE)) >= 0)) {
      struct reference *ref = Pike_compiler->new_program->identifier_references + i;
      if (IDENTIFIER_IS_VARIABLE (
	    ID_FROM_PTR (Pike_compiler->new_program, ref)->identifier_flags)) {
	/* Allowing local:: on variables would lead to pathological
	 * behavior: If a non-local variable in a class is referenced
	 * both with and without local::, both references would
	 * address the same variable in all cases except where an
	 * inheriting program overrides it (c.f. [bug 1252]).
	 *
	 * Furthermore, that's not how it works currently; if this
	 * error is removed then local:: will do nothing on variables
	 * except forcing a lookup in the closest surrounding class
	 * scope. */
	yyerror ("Cannot make local references to variables.");
	yyval.n = 0;
      }
      else {
	if (!(ref->id_flags & ID_LOCAL)) {
	  /* We need to generate a new reference. */
	  int d;
	  struct reference funp = *ref;
	  funp.id_flags = (funp.id_flags & ~ID_INHERITED) | ID_INLINE|ID_HIDDEN;
	  i = -1;
	  for(d = 0; d < (int)Pike_compiler->new_program->num_identifier_references; d++) {
	    struct reference *refp;
	    refp = Pike_compiler->new_program->identifier_references + d;

	    if (!(refp->id_flags & ID_LOCAL)) continue;

	    if((refp->inherit_offset == funp.inherit_offset) &&
	       (refp->identifier_offset == funp.identifier_offset)) {
	      i = d;
	      break;
	    }
	  }
	  if (i < 0) {
	    add_to_identifier_references(funp);
	    i = Pike_compiler->new_program->num_identifier_references - 1;
	  }
	}
	yyval.n = mkidentifiernode(i);
      }
    } else {
      if (Pike_compiler->compiler_pass == 2) {
	my_yyerror("%S not defined in local scope.",
		   Pike_compiler->last_identifier);
	yyval.n = 0;
      } else {
	yyval.n = mknode(F_UNDEFINED, 0, 0);
      }
    }

    free_node(yystack.l_mark[0].n);
  }
break;
case 541:
#line 3866 "language.yacc"
	{
    yyval.n=0;
  }
break;
case 543:
#line 3873 "language.yacc"
	{
    yyval.n=index_node(yystack.l_mark[-2].n, Pike_compiler->last_identifier?Pike_compiler->last_identifier->str:NULL,
		  yystack.l_mark[0].n->u.sval.u.string);
    free_node(yystack.l_mark[-2].n);
    if(Pike_compiler->last_identifier) free_string(Pike_compiler->last_identifier);
    copy_shared_string(Pike_compiler->last_identifier, yystack.l_mark[0].n->u.sval.u.string);
    free_node(yystack.l_mark[0].n);
  }
break;
case 544:
#line 3881 "language.yacc"
	{}
break;
case 545:
#line 3882 "language.yacc"
	{}
break;
case 548:
#line 3896 "language.yacc"
	{
    struct compilation *c = THIS_COMPILATION;
    struct program_state *state = Pike_compiler;
    int depth;
    int e = -1;

    inherit_state = NULL;
    inherit_depth = 0;

    /* NB: The heuristics here are a bit strange
     *     (all to make it as backward compatible as possible).
     *
     *     The priority order is as follows:
     *
     *     1: Direct inherits in the current class.
     *
     *     2: The name of the current class.
     *
     *     3: 1 & 2 recursively for surrounding parent classes.
     *
     *     4: Indirect inherits in the current class.
     *
     *     5: 4 recursively for surrounding parent classes.
     *
     *     6: this_program.
     *
     * Note that a deep inherit in the current class trumphs
     * a not so deep inherit in a parent class (but not a
     * direct inherit in a parent class). To select the deep
     * inherit in the parent class in this case, prefix it
     * with the name of the parent class.
     */
    for (depth = 0;; depth++, state = state->previous) {
      int inh = find_inherit(state->new_program, yystack.l_mark[-1].n->u.sval.u.string);
      if (inh &&
	  (!inherit_state ||
	   (state->new_program->inherits[inh].inherit_level == 1))) {
	/* Found, and we've either not found anything earlier,
	 * or this is a direct inherit (and the previous
	 * wasn't since we didn't break out of the loop).
	 */
	e = inh;
	inherit_state = state;
	inherit_depth = depth;
	if (state->new_program->inherits[inh].inherit_level == 1) {
	  /* Name of direct inherit ==> Done. */
	  break;
	}
      }
      /* The top-level class does not have a name, so break here. */
      if (depth == c->compilation_depth) break;
      if (ID_FROM_INT (state->previous->new_program,
		       state->parent_identifier)->name ==
	  yystack.l_mark[-1].n->u.sval.u.string) {
	/* Name of surrounding class ==> Done. */
	e = 0;
	inherit_state = state;
	inherit_depth = depth;
	break;
      }
    }
    if (e == -1) {
      inherit_state = state;
      inherit_depth = depth;
      if (yystack.l_mark[-1].n->u.sval.u.string == this_program_string || yystack.l_mark[-1].n->u.sval.u.string == this_string) {
        inherit_state = Pike_compiler;
        inherit_depth = 0;
        e = 0;
      }
      else
        my_yyerror("No inherit or surrounding class %S.",
                   yystack.l_mark[-1].n->u.sval.u.string);
    }
    free_node(yystack.l_mark[-1].n);
    yyval.number = e;
  }
break;
case 549:
#line 3973 "language.yacc"
	{
    struct compilation *c = THIS_COMPILATION;
    inherit_state = Pike_compiler;
    for (inherit_depth = 0; inherit_depth < c->compilation_depth;
	 inherit_depth++, inherit_state = inherit_state->previous) {}
    yyval.number = -1;
  }
break;
case 550:
#line 3981 "language.yacc"
	{
    int e = 0;
    if (yystack.l_mark[-2].number < 0) {
      yystack.l_mark[-2].number = 0;
    }
#if 0
    /* FIXME: The inherit modifiers aren't kept. */
    if (!(inherit_state->new_program->inherits[yystack.l_mark[-2].number].flags & ID_PRIVATE)) {
#endif /* 0 */
      e = find_inherit(inherit_state->new_program->inherits[yystack.l_mark[-2].number].prog,
		       yystack.l_mark[-1].n->u.sval.u.string);
#if 0
    }
#endif /* 0 */
    if (!e) {
      if (inherit_state->new_program->inherits[yystack.l_mark[-2].number].name) {
	my_yyerror("No such inherit %S::%S.",
		   inherit_state->new_program->inherits[yystack.l_mark[-2].number].name,
		   yystack.l_mark[-1].n->u.sval.u.string);
      } else {
	my_yyerror("No such inherit %S.", yystack.l_mark[-1].n->u.sval.u.string);
      }
      yyval.number = -1;
    } else {
      /* We know stuff about the inherit structure... */
      yyval.number = e + yystack.l_mark[-2].number;
    }
    free_node(yystack.l_mark[-1].n);
  }
break;
case 551:
#line 4010 "language.yacc"
	{ yyval.number = -1; }
break;
case 552:
#line 4014 "language.yacc"
	{
    if(Pike_compiler->last_identifier) free_string(Pike_compiler->last_identifier);
    copy_shared_string(Pike_compiler->last_identifier, yystack.l_mark[0].n->u.sval.u.string);

    if((yyval.n=lexical_islocal(Pike_compiler->last_identifier)))
    {
      /* done, nothing to do here */
    }else if(!(yyval.n=find_module_identifier(Pike_compiler->last_identifier,1)) &&
	     !(yyval.n = program_magic_identifier (Pike_compiler, 0, -1,
					      Pike_compiler->last_identifier, 0))) {
      if((Pike_compiler->flags & COMPILATION_FORCE_RESOLVE) ||
	 (Pike_compiler->compiler_pass==2)) {
	my_yyerror("Undefined identifier %S.",
		   Pike_compiler->last_identifier);
	/* FIXME: Add this identifier as a constant in the current program to
	 *        avoid multiple reporting of the same identifier.
	 * NOTE: This should then only be done in the second pass.
	 */	
	yyval.n=0;
      }else{
	yyval.n=mknode(F_UNDEFINED,0,0);
      }
    }
    free_node(yystack.l_mark[0].n);
  }
break;
case 553:
#line 4040 "language.yacc"
	{
    struct pike_string *dot;
    MAKE_CONST_STRING(dot, ".");
    if (call_handle_import(dot)) {
      node *tmp=mkconstantsvaluenode(Pike_sp-1);
      pop_stack();
      yyval.n=index_node(tmp, ".", yystack.l_mark[0].n->u.sval.u.string);
      free_node(tmp);
    }
    else
      yyval.n=mknewintnode(0);
    if(Pike_compiler->last_identifier) free_string(Pike_compiler->last_identifier);
    copy_shared_string(Pike_compiler->last_identifier, yystack.l_mark[0].n->u.sval.u.string);
    free_node(yystack.l_mark[0].n);
  }
break;
case 554:
#line 4056 "language.yacc"
	{
    yyval.n = resolve_identifier (yystack.l_mark[0].n->u.sval.u.string);
    if(Pike_compiler->last_identifier) free_string(Pike_compiler->last_identifier);
    copy_shared_string(Pike_compiler->last_identifier, yystack.l_mark[0].n->u.sval.u.string);
    free_node (yystack.l_mark[0].n);
  }
break;
case 555:
#line 4063 "language.yacc"
	{
    ref_push_string(yystack.l_mark[0].n->u.sval.u.string);
    low_yyreport(REPORT_ERROR, NULL, 0, parser_system_string,
		 1, "Unknown reserved symbol %s.");
    free_node(yystack.l_mark[0].n);
    yyval.n = 0;
  }
break;
case 556:
#line 4071 "language.yacc"
	{
    struct compilation *c = THIS_COMPILATION;
    node *tmp2;

    if(Pike_compiler->last_identifier)
      free_string(Pike_compiler->last_identifier);
    copy_shared_string(Pike_compiler->last_identifier, yystack.l_mark[0].n->u.sval.u.string);

    tmp2 = mkconstantsvaluenode(&c->default_module);
    yyval.n = index_node(tmp2, "predef", yystack.l_mark[0].n->u.sval.u.string);
    if(!yyval.n->name)
      add_ref( yyval.n->name=yystack.l_mark[0].n->u.sval.u.string );
    free_node(tmp2);
    free_node(yystack.l_mark[0].n);
  }
break;
case 557:
#line 4087 "language.yacc"
	{
    yyval.n=0;
  }
break;
case 558:
#line 4091 "language.yacc"
	{
    yyval.n = find_versioned_identifier(yystack.l_mark[0].n->u.sval.u.string,
				   yystack.l_mark[-2].n->u.integer.a, yystack.l_mark[-2].n->u.integer.b);
    free_node(yystack.l_mark[-2].n);
    free_node(yystack.l_mark[0].n);
  }
break;
case 559:
#line 4098 "language.yacc"
	{
    free_node(yystack.l_mark[-2].n);
    yyval.n=0;
  }
break;
case 560:
#line 4103 "language.yacc"
	{
    int id;

    if(Pike_compiler->last_identifier) free_string(Pike_compiler->last_identifier);
    copy_shared_string(Pike_compiler->last_identifier, yystack.l_mark[0].n->u.sval.u.string);

    if (yystack.l_mark[-1].number > 0)
      id = low_reference_inherited_identifier(inherit_state,
					      yystack.l_mark[-1].number,
					      Pike_compiler->last_identifier,
					      SEE_PROTECTED);
    else
      id = really_low_find_shared_string_identifier(Pike_compiler->last_identifier,
						    inherit_state->new_program,
						    SEE_PROTECTED|SEE_PRIVATE);

    if (id != -1) {
      if (inherit_depth > 0) {
	yyval.n = mkexternalnode(inherit_state->new_program, id);
      } else {
	yyval.n = mkidentifiernode(id);
      }
    } else if ((yyval.n = program_magic_identifier (inherit_state, inherit_depth, yystack.l_mark[-1].number,
					       Pike_compiler->last_identifier, 1))) {
      /* All done. */
    }
    else {
      if ((Pike_compiler->flags & COMPILATION_FORCE_RESOLVE) ||
	  (Pike_compiler->compiler_pass == 2)) {
	if ((yystack.l_mark[-1].number >= 0) && inherit_state->new_program->inherits[yystack.l_mark[-1].number].name) {
	  my_yyerror("Undefined identifier %S::%S.",
		     inherit_state->new_program->inherits[yystack.l_mark[-1].number].name,
		     Pike_compiler->last_identifier);
	} else {
	  my_yyerror("Undefined identifier %S.",
		     Pike_compiler->last_identifier);
	}
	yyval.n=0;
      }
      else
	yyval.n=mknode(F_UNDEFINED,0,0);
    }

    free_node(yystack.l_mark[0].n);
  }
break;
case 561:
#line 4148 "language.yacc"
	{ yyval.n=0; }
break;
case 562:
#line 4149 "language.yacc"
	{ yyval.n=0; }
break;
case 563:
#line 4151 "language.yacc"
	{
    int e,i;

    if(Pike_compiler->last_identifier) free_string(Pike_compiler->last_identifier);
    copy_shared_string(Pike_compiler->last_identifier, yystack.l_mark[0].n->u.sval.u.string);

    yyval.n=0;
    for(e=1;e<(int)Pike_compiler->new_program->num_inherits;e++)
    {
      if(Pike_compiler->new_program->inherits[e].inherit_level!=1) continue;
      i=low_reference_inherited_identifier(0,e,yystack.l_mark[0].n->u.sval.u.string,SEE_PROTECTED);
      if(i==-1) continue;
      if(yyval.n)
      {
	yyval.n=mknode(F_ARG_LIST,yyval.n,mkidentifiernode(i));
      }else{
	yyval.n=mkidentifiernode(i);
      }
    }
    if(!yyval.n)
    {
      if (!(yyval.n = program_magic_identifier (Pike_compiler, 0, -1,
					   yystack.l_mark[0].n->u.sval.u.string, 1)))
      {
	if (Pike_compiler->compiler_pass == 2) {
          my_yyerror("Undefined identifier ::%S.", yystack.l_mark[0].n->u.sval.u.string);
	}
	yyval.n=mkintnode(0);
      }
    }else{
      if(yyval.n->token==F_ARG_LIST) yyval.n=mkefuncallnode("aggregate",yyval.n);
    }
    free_node(yystack.l_mark[0].n);
  }
break;
case 564:
#line 4186 "language.yacc"
	{
    yyval.n=0;
  }
break;
case 565:
#line 4193 "language.yacc"
	{yyval.n = mknode (F_RANGE_OPEN, NULL, NULL);}
break;
case 566:
#line 4195 "language.yacc"
	{yyval.n = mknode (F_RANGE_FROM_BEG, yystack.l_mark[0].n, NULL);}
break;
case 567:
#line 4197 "language.yacc"
	{yyval.n = mknode (F_RANGE_FROM_END, yystack.l_mark[0].n, NULL);}
break;
case 568:
#line 4199 "language.yacc"
	{
    yyerror("Unexpected end of file.");
    yyval.n = mknode (F_RANGE_OPEN, NULL, NULL);
  }
break;
case 569:
#line 4204 "language.yacc"
	{
    yyerror("Unexpected end of file.");
    yyval.n = mknode (F_RANGE_OPEN, NULL, NULL);
  }
break;
case 570:
#line 4211 "language.yacc"
	{
    yyval.n=mkopernode("`/",
		  mkopernode("`-",
			     mkopernode("`-",
					mkefuncallnode("gethrvtime",
						       mkintnode(1)),
					mknode(F_COMMA_EXPR,
					       mknode(F_POP_VALUE, yystack.l_mark[0].n, NULL),
					       mkefuncallnode("gethrvtime",
							      mkintnode(1)))),
			     NULL),
		  mkfloatnode((FLOAT_TYPE)1e9));
  }
break;
case 571:
#line 4226 "language.yacc"
	{
    struct pike_type *t;
    node *tmp;

    /* FIXME: Why build the node at all? */
    /* Because the optimizer cannot optimize the root node of the
     * tree properly -Hubbe
     */
    tmp=mknode(F_COMMA_EXPR, yystack.l_mark[-1].n, 0);
    optimize_node(tmp);

    t=(tmp && CAR(tmp) && CAR(tmp)->type ? CAR(tmp)->type : mixed_type_string);
    yyval.n = mktypenode(t);
    free_node(tmp);
  }
break;
case 572:
#line 4241 "language.yacc"
	{ yyval.n=0; yyerrok; }
break;
case 573:
#line 4242 "language.yacc"
	{ yyval.n=0; yyerror("Missing ')'."); }
break;
case 574:
#line 4244 "language.yacc"
	{
    yyval.n=0; yyerror("Missing ')'.");
    yyerror("Unexpected end of file.");
  }
break;
case 575:
#line 4248 "language.yacc"
	{ yyval.n=0; yyerror("Missing ')'."); }
break;
case 576:
#line 4251 "language.yacc"
	{ yyval.n=yystack.l_mark[-1].n; }
break;
case 577:
#line 4252 "language.yacc"
	{ yyval.n=0; yyerrok; }
break;
case 578:
#line 4254 "language.yacc"
	{
    yyval.n=0; yyerror("Missing ')'.");
    yyerror("Unexpected end of file.");
  }
break;
case 579:
#line 4258 "language.yacc"
	{ yyval.n=0; yyerror("Missing ')'."); }
break;
case 580:
#line 4259 "language.yacc"
	{ yyval.n=0; yyerror("Missing ')'."); }
break;
case 582:
#line 4261 "language.yacc"
	{ yyval.n=0; yyerror("Bad expression for catch."); }
break;
case 583:
#line 4265 "language.yacc"
	{
       Pike_compiler->catch_level++;
     }
break;
case 584:
#line 4269 "language.yacc"
	{
       yyval.n=mknode(F_CATCH,yystack.l_mark[0].n,NULL);
       Pike_compiler->catch_level--;
     }
break;
case 585:
#line 4276 "language.yacc"
	{
    if (yystack.l_mark[-1].n && !(THIS_COMPILATION->lex.pragmas & ID_STRICT_TYPES)) {
      mark_lvalues_as_used(yystack.l_mark[-1].n);
    }
    yyval.n=mknode(F_SSCANF,mknode(':', mkintnode(TEST_COMPAT(7, 6)? SSCANF_FLAG_76_COMPAT : 0), mknode(F_ARG_LIST,yystack.l_mark[-4].n,yystack.l_mark[-2].n)),yystack.l_mark[-1].n);
  }
break;
case 586:
#line 4283 "language.yacc"
	{
    yyval.n=0;
    free_node(yystack.l_mark[-4].n);
    free_node(yystack.l_mark[-2].n);
    yyerrok;
  }
break;
case 587:
#line 4290 "language.yacc"
	{
    yyval.n=0;
    free_node(yystack.l_mark[-4].n);
    free_node(yystack.l_mark[-2].n);
    yyerror("Missing ')'.");
    yyerror("Unexpected end of file.");
  }
break;
case 588:
#line 4298 "language.yacc"
	{
    yyval.n=0;
    free_node(yystack.l_mark[-4].n);
    free_node(yystack.l_mark[-2].n);
    yyerror("Missing ')'.");
  }
break;
case 589:
#line 4305 "language.yacc"
	{
    yyval.n=0;
    free_node(yystack.l_mark[-4].n);
    free_node(yystack.l_mark[-2].n);
    yyerror("Missing ')'.");
  }
break;
case 590:
#line 4312 "language.yacc"
	{
    yyval.n=0;
    free_node(yystack.l_mark[-2].n);
    yyerrok;
  }
break;
case 591:
#line 4318 "language.yacc"
	{
    yyval.n=0;
    free_node(yystack.l_mark[-2].n);
    yyerror("Missing ')'.");
    yyerror("Unexpected end of file.");
  }
break;
case 592:
#line 4325 "language.yacc"
	{
    yyval.n=0;
    free_node(yystack.l_mark[-2].n);
    yyerror("Missing ')'.");
  }
break;
case 593:
#line 4331 "language.yacc"
	{
    yyval.n=0;
    free_node(yystack.l_mark[-2].n);
    yyerror("Missing ')'.");
  }
break;
case 594:
#line 4336 "language.yacc"
	{ yyval.n=0; yyerrok; }
break;
case 595:
#line 4338 "language.yacc"
	{
    yyval.n=0; yyerror("Missing ')'.");
    yyerror("Unexpected end of file.");
  }
break;
case 596:
#line 4342 "language.yacc"
	{ yyval.n=0; yyerror("Missing ')'."); }
break;
case 597:
#line 4343 "language.yacc"
	{ yyval.n=0; yyerror("Missing ')'."); }
break;
case 599:
#line 4348 "language.yacc"
	{
    yyval.n=mknode(F_ARRAY_LVALUE, yystack.l_mark[-1].n,0);
    COPY_LINE_NUMBER_INFO(yyval.n, yystack.l_mark[-2].n);
    free_node(yystack.l_mark[-2].n);
  }
break;
case 600:
#line 4354 "language.yacc"
	{
    int id = add_local_name(yystack.l_mark[0].n->u.sval.u.string,compiler_pop_type(),0);
    /* Note: Variable intentionally not marked as used. */
    if (id >= 0)
      yyval.n=mklocalnode(id,-1);
    else
      yyval.n = 0;
    free_node(yystack.l_mark[0].n);
  }
break;
case 601:
#line 4365 "language.yacc"
	{ yyval.n=mknewintnode(0); }
break;
case 602:
#line 4369 "language.yacc"
	{
    yyval.n=mknode(F_LVALUE_LIST,yystack.l_mark[-1].n,yystack.l_mark[0].n);
  }
break;
case 603:
#line 4374 "language.yacc"
	{ yyval.n = 0; }
break;
case 604:
#line 4376 "language.yacc"
	{
    yyval.n = mknode(F_LVALUE_LIST,yystack.l_mark[-1].n,yystack.l_mark[0].n);
  }
break;
case 606:
#line 4383 "language.yacc"
	{
    struct compiler_frame *f = Pike_compiler->compiler_frame;
    if (!f || (f->current_function_number < 0)) {
      yyval.n = mkstrnode(lfun_strings[LFUN___INIT]);
    } else {
      struct identifier *id =
	ID_FROM_INT(Pike_compiler->new_program, f->current_function_number);
      if (!id->name->size_shift) {
	int len;
	if ((len = strlen(id->name->str)) == id->name->len) {
	  /* Most common case. */
	  yyval.n = mkstrnode(id->name);
	} else {
	  struct pike_string *str =
	    make_shared_binary_string(id->name->str, len);
	  yyval.n = mkstrnode(str);
	  free_string(str);
	}
      } else {
	struct pike_string *str;
	struct array *split;
	MAKE_CONST_STRING(str, "\0");
	split = explode(id->name, str);
	yyval.n = mkstrnode(split->item->u.string);
	free_array(split);
      }
    }
  }
break;
case 608:
#line 4415 "language.yacc"
	{
    struct pike_string *a,*b;
    copy_shared_string(a,yystack.l_mark[-1].n->u.sval.u.string);
    copy_shared_string(b,yystack.l_mark[0].n->u.sval.u.string);
    free_node(yystack.l_mark[-1].n);
    free_node(yystack.l_mark[0].n);
    a=add_and_free_shared_strings(a,b);
    yyval.n=mkstrnode(a);
    free_string(a);
  }
break;
case 610:
#line 4429 "language.yacc"
	{
    struct pike_string *a,*b;
    copy_shared_string(a,yystack.l_mark[-2].n->u.sval.u.string);
    copy_shared_string(b,yystack.l_mark[0].n->u.sval.u.string);
    free_node(yystack.l_mark[-2].n);
    free_node(yystack.l_mark[0].n);
    a=add_and_free_shared_strings(a,b);
    yyval.n=mkstrnode(a);
    free_string(a);
  }
break;
case 612:
#line 4444 "language.yacc"
	{
    struct pike_string *a,*b;
    copy_shared_string(a,yystack.l_mark[-1].n->u.sval.u.string);
    copy_shared_string(b,yystack.l_mark[0].n->u.sval.u.string);
    free_node(yystack.l_mark[-1].n);
    free_node(yystack.l_mark[0].n);
    a=add_and_free_shared_strings(a,b);
    yyval.n=mkstrnode(a);
    free_string(a);
  }
break;
case 613:
#line 4455 "language.yacc"
	{
    struct pike_string *a,*b;
    copy_shared_string(a,yystack.l_mark[-2].n->u.sval.u.string);
    copy_shared_string(b,yystack.l_mark[0].n->u.sval.u.string);
    free_node(yystack.l_mark[-2].n);
    free_node(yystack.l_mark[0].n);
    a=add_and_free_shared_strings(a,b);
    yyval.n=mkstrnode(a);
    free_string(a);
  }
break;
case 615:
#line 4475 "language.yacc"
	{ yyerror_reserved("array"); }
break;
case 616:
#line 4477 "language.yacc"
	{ yyerror_reserved("__attribute__"); }
break;
case 617:
#line 4479 "language.yacc"
	{ yyerror_reserved("class"); }
break;
case 618:
#line 4481 "language.yacc"
	{ yyerror_reserved("__deprecated__"); }
break;
case 619:
#line 4483 "language.yacc"
	{ yyerror_reserved("enum"); }
break;
case 620:
#line 4485 "language.yacc"
	{ yyerror_reserved("float");}
break;
case 621:
#line 4487 "language.yacc"
	{ yyerror_reserved("function");}
break;
case 622:
#line 4489 "language.yacc"
	{ yyerror_reserved("__FUNCTION__");}
break;
case 623:
#line 4491 "language.yacc"
	{ yyerror_reserved("int"); }
break;
case 624:
#line 4493 "language.yacc"
	{ yyerror_reserved("mapping"); }
break;
case 625:
#line 4495 "language.yacc"
	{ yyerror_reserved("mixed"); }
break;
case 626:
#line 4497 "language.yacc"
	{ yyerror_reserved("multiset"); }
break;
case 627:
#line 4499 "language.yacc"
	{ yyerror_reserved("object"); }
break;
case 628:
#line 4501 "language.yacc"
	{ yyerror_reserved("program"); }
break;
case 629:
#line 4503 "language.yacc"
	{ yyerror_reserved("string"); }
break;
case 630:
#line 4505 "language.yacc"
	{ yyerror_reserved("typedef"); }
break;
case 631:
#line 4507 "language.yacc"
	{ yyerror_reserved("void"); }
break;
case 632:
#line 4509 "language.yacc"
	{
    ref_push_string(yystack.l_mark[0].n->u.sval.u.string);
    low_yyreport(REPORT_ERROR, NULL, 0, parser_system_string,
		 1, "Unknown reserved symbol %s.");
    free_node(yystack.l_mark[0].n);
  }
break;
case 633:
#line 4519 "language.yacc"
	{ yyerror_reserved("inline"); }
break;
case 634:
#line 4521 "language.yacc"
	{ yyerror_reserved("local"); }
break;
case 635:
#line 4523 "language.yacc"
	{ yyerror_reserved("nomask"); }
break;
case 636:
#line 4525 "language.yacc"
	{ yyerror_reserved("predef"); }
break;
case 637:
#line 4527 "language.yacc"
	{ yyerror_reserved("private"); }
break;
case 638:
#line 4529 "language.yacc"
	{ yyerror_reserved("protected"); }
break;
case 639:
#line 4531 "language.yacc"
	{ yyerror_reserved("public"); }
break;
case 640:
#line 4533 "language.yacc"
	{ yyerror_reserved("optional"); }
break;
case 641:
#line 4535 "language.yacc"
	{ yyerror_reserved("variant"); }
break;
case 642:
#line 4537 "language.yacc"
	{ yyerror_reserved("static"); }
break;
case 643:
#line 4539 "language.yacc"
	{ yyerror_reserved("extern"); }
break;
case 644:
#line 4541 "language.yacc"
	{ yyerror_reserved("final");}
break;
case 645:
#line 4543 "language.yacc"
	{ yyerror_reserved("do"); }
break;
case 646:
#line 4545 "language.yacc"
	{ yyerror("else without if."); }
break;
case 647:
#line 4547 "language.yacc"
	{ yyerror_reserved("return"); }
break;
case 648:
#line 4549 "language.yacc"
	{ yyerror_reserved("import"); }
break;
case 649:
#line 4551 "language.yacc"
	{ yyerror_reserved("inherit"); }
break;
case 650:
#line 4553 "language.yacc"
	{ yyerror_reserved("catch"); }
break;
case 651:
#line 4555 "language.yacc"
	{ yyerror_reserved("gauge"); }
break;
case 652:
#line 4557 "language.yacc"
	{ yyerror_reserved("lambda"); }
break;
case 653:
#line 4559 "language.yacc"
	{ yyerror_reserved("sscanf"); }
break;
case 654:
#line 4561 "language.yacc"
	{ yyerror_reserved("switch"); }
break;
case 655:
#line 4563 "language.yacc"
	{ yyerror_reserved("typeof"); }
break;
case 656:
#line 4565 "language.yacc"
	{ yyerror_reserved("break"); }
break;
case 657:
#line 4567 "language.yacc"
	{ yyerror_reserved("case"); }
break;
case 658:
#line 4569 "language.yacc"
	{ yyerror_reserved("continue"); }
break;
case 659:
#line 4571 "language.yacc"
	{ yyerror_reserved("default"); }
break;
case 660:
#line 4573 "language.yacc"
	{ yyerror_reserved("for"); }
break;
case 661:
#line 4575 "language.yacc"
	{ yyerror_reserved("foreach"); }
break;
case 662:
#line 4577 "language.yacc"
	{ yyerror_reserved("if"); }
break;
#line 9463 "y.tab.c"
    }
    yystack.s_mark -= yym;
    yystate = *yystack.s_mark;
    yystack.l_mark -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yystack.s_mark = YYFINAL;
        *++yystack.l_mark = yyval;
        if (yychar < 0)
        {
            yychar = YYLEX;
            if (yychar < 0) yychar = YYEOF;
#if YYDEBUG
            if (yydebug)
            {
                if ((yys = yyname[YYTRANSLATE(yychar)]) == NULL) yys = yyname[YYUNDFTOKEN];
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == YYEOF) goto yyaccept;
        goto yyloop;
    }
    if (((yyn = yygindex[yym]) != 0) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yystack.s_mark, yystate);
#endif
    if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
    *++yystack.s_mark = (YYINT) yystate;
    *++yystack.l_mark = yyval;
    goto yyloop;

yyoverflow:
    YYERROR_CALL("yacc stack overflow");

yyabort:
    yyfreestack(&yystack);
    return (1);

yyaccept:
    yyfreestack(&yystack);
    return (0);
}
